#pragma comment(linker, "/STACK:1000000000")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <vector>
#include <ctime>
#include <map>
#include <climits>
#include <bitset>
#include <set>
#include <string>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef double dbl;

#define sz(x) (int)x.size()
#define pb push_back
#define all(x) x.begin(),x.end()
#define X first
#define Y second
#define mp make_pair

#define TASK "cactus"

vector <vector <int> > g;
vector <vector <int> > start_cycles;
vector <int> color_find_cycles;
vector <int> par_find_cycles;

vector <bool> construct;

void dfs_find_cycles(int v, int p = -1) {
	par_find_cycles[v] = p;
	color_find_cycles[v] = 1;
	for (int i = 0; i < sz(g[v]); i++) {
		int to = g[v][i];
		if (to == p)
			continue;
		if (color_find_cycles[to] == 0)
			dfs_find_cycles(to, v);
		else if (color_find_cycles[to] == 1)
			start_cycles[to].pb(v);
	}
	color_find_cycles[v] = 2;
}

void recolor(int v, int a, int b) {
	printf("r %d %d %d\n", v + 1, a, b);
}

void join(int v, int u) {
	printf("j %d %d\n", v + 1, u + 1);
}

void connect(int v, int a, int b) {
	printf("c %d %d %d\n", v + 1, a, b);
}

void rec(int v) {
	construct[v] = true;
	
	vector <vector <int> > cycles;
	for (int i = 0; i < sz(start_cycles[v]); i++) {
		int cur = start_cycles[v][i];
		cycles.pb({});
		while (cur != v) {
			cycles.back().pb(cur);
			cur = par_find_cycles[cur];
		};
	}
	for (int i = 0; i < sz(cycles); i++) {
		for (int j = 0; j < sz(cycles[i]); j++) {
			construct[cycles[i][j]] = true;
		}
	}

	vector <int> adj;
	for (int i = 0; i < sz(g[v]); i++) {
		int to = g[v][i];
		if (!construct[to]) 
			adj.pb(to);
	}
	for (int i = 0; i < sz(adj); i++)
		construct[adj[i]] = true;
		

	for (int i = 0; i < sz(adj); i++) {
		construct[adj[i]] = false;
		rec(adj[i]);
	}
	for (int i = 0; i < sz(cycles); i++) {
		for (int j = 0; j < sz(cycles[i]); j++) {
			construct[cycles[i][j]] = false;
			rec(cycles[i][i]);
		}
	}

	recolor(v, 1, 4);

	for (int i = 0; i < sz(adj); i++)
		join(v, adj[i]);
	if (sz(adj)) {
		connect(v, 2, 4);
		recolor(v, 2, 1);
	}

	for (int i = 0; i < sz(cycles); i++) {
		int cur = cycles[i][0];

		join(v, cur);
		recolor(v, 2, 3);
		connect(v, 3, 4);

		for (int j = 1; j < sz(cycles[i]); j++) {
			join(cur, cycles[i][j]);
			connect(cur, 2, 3);
			recolor(cur, 3, 1);
			recolor(cur, 2, 3);
			cur = cycles[i][j];
		}
		connect(v, 3, 4);
		recolor(v, 3, 1);
	}
	recolor(v, 4, 2);
}

void solveC() {
	int n, m;
	scanf("%d%d", &n, &m);
	g.resize(n);

	for (int i = 0; i < m; i++) {
		int k;
		scanf("%d", &k);
		vector <int> path(k);
		for (int j = 0; j < k; j++)
			scanf("%d", &path[j]);
		for (int i = 1; i < sz(path); i++) {
			int a = path[i - 1], b = path[i];
			a--; b--;
			g[a].pb(b);
			g[b].pb(a);
		}
	}

	color_find_cycles.assign(n, 0);
	par_find_cycles.assign(n, -1);
	start_cycles.resize(n);
	dfs_find_cycles(0);

	construct.assign(n, false);
	rec(0);

}

int main() {
#ifdef NSU
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif

	solveC();

	/*vector <bool> prime(N, true);
	for (int i = 2; i < N; i++) {
		if (prime[i]) {
			primes.pb(i);
			for (int k = 2 * i; k < N; k += i)
				prime[k] = false;
		}
	}

	vector <pair <int, vector <int> > > sets;

	for (int mask = 0; mask < (1 << M); mask++) {
		pair <int, vector <int> > curset;
		for (int i = 0; i < M; i++) {
			if ((mask >> i) & 1) {
				curset.Y.pb(primes[i]);
				curset.X += primes[i];
			}
		}
		sets.pb(curset);
	}

	sort(all(sets));

	ll len = 0;
	for (int i = 0; i < sz(sets); i++) {
		len++;
		//printf("[");
		for (int j = 0; j < sz(sets[i].Y); j++) {
			if (j != 0) {
				len += 2;
				//printf(", ");
			}
			len += getsz(sets[i].Y[j]);
			//printf("%d", sets[i].Y[j]);
		}
		len += 2;
		//printf("], ");
	}

	for (int i = 0; i < sz(sets); i++) {
		cerr << sets[i].X << endl;
	}

	cerr << len << endl;*/

#ifdef NSU
	cerr << "Time: " << (double)clock() / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}
