#pragma comment(linker, "/STACK:1000000000")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <vector>
#include <ctime>
#include <map>
#include <climits>
#include <set>
#include <string>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef double dbl;

#define sz(x) (int)x.size()
#define pb push_back
#define all(x) x.begin(),x.end()
#define X first
#define Y second
#define mp make_pair

struct segment {
	ll y;
	ll l, r;
	segment(ll l, ll r, ll y) : l(l), r(r), y(y) {}
};

void solveE() {
	int n, q;
	scanf("%d%d\n", &n, &q);

	ll lastT = -1, lastY = 0;
	vector <segment> segs;

	for (int i = 0; i < n; i++) {
		char sign;
		ll t, k;
		scanf("%c %lld %lld\n", &sign, &t, &k);

		if (sign == '-')
			k *= -1;

		if (lastT != -1) {
			segs.pb({ lastT, t, lastY });
		}
		lastT = t;
		lastY += k;		
	}

	vector <pair <ll, int> > b(q);
	vector <ll> ans(q);
	for (int i = 0; i < q; i++) {
		scanf("%lld", &b[i].X);
		b[i].Y = i;
	}
	sort(all(b));
	reverse(all(b));

	sort(all(segs), [](segment a, segment b) {
		return a.y < b.y;
	});

	ll bcur = INT_MAX;
	ll len = 0;

	int cur = 0;

	ll integral = 0;

	for (int i = 0; i < q; i++) {
		if (b[i].X + lastY < 0)
			ans[b[i].Y] = -1;
		else {
			while (cur < sz(segs) && -b[i].X >= segs[cur].y) {
				integral += (segs[cur].y + bcur) * len;
				bcur = -segs[cur].y;
				len += segs[cur].r - segs[cur].l;
				cur++;
			}
			ans[b[i].Y] = integral + (bcur - b[i].X) * len;
		}
	}

	for (int i = 0; i < q; i++) {
		if (ans[i] == -1)
			puts("INFINITY");
		else
			printf("%lld\n", ans[i]);
	}
}

#define TASK "expect"
int main() {
#ifdef NSU
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif

	solveE();

#ifdef NSU
	cerr << "Time: " << (double)clock() / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}
