#pragma (linker, "/STACK:1000000000")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <vector>
#include <ctime>
#include <map>
#include <climits>
#include <set>
#include <string>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef double dbl;

#define sz(x) (int)x.size()
#define pb push_back
#define all(x) x.begin(),x.end()
#define X first
#define Y second
#define mp make_pair


const int MIN = -32768;
const int MAX = 32767;

int str2int(string s) {
	int x = 0;
	bool minus = false;
	for (int i = 0; i < sz(s); i++) {
		if (s[i] == '-')
			minus = true;
		else {
			x *= 10;
			x += (s[i] - '0');
		}
	}
	if (minus)
		x *= -1;
	return x;
}

pair <int, int> get_seg(string ineq) {
	int num = str2int(ineq.substr(5, sz(ineq) - 5));
	if (ineq[2] == '<')
		return mp(MIN, num);
	else
		return mp(num, MAX);
}

void print(pair <int, int> seg) {
	if (seg.X != MIN)
		printf("x >= %d", seg.X);
	if (seg.Y != MAX) {
		if (seg.X != MIN)
			printf(" && ");
		printf("x <= %d", seg.Y);
	}
}

#define TASK "hard"
int main() {
#ifdef NSU
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif

	vector <pair <int, int> > segs;

	bool false_flag = false;

	string s;
	while (getline(cin, s)) {
		int i = s.find("||");
		if (i != -1)
			s = s.substr(0, i - 1);
		i = s.find("&&");
		if (i != -1) {
			string fir = s.substr(0, i - 1);
			string sec = s.substr(i + 3, sz(s) - (i + 3));
			pair <int, int> fseg = get_seg(fir);
			pair <int, int> sseg = get_seg(sec);

			pair <int, int> seg = mp(max(fseg.X, sseg.X), min(fseg.Y, sseg.Y));
			if (seg.X > seg.Y) {
				puts("false");
				return 0;
			}
			segs.pb(seg);
		}
		else {
			pair <int, int> seg = get_seg(s);
			segs.pb(seg);
		}
	}

	vector <pair <int, int> > ps;
	for (int i = 0; i < sz(segs); i++) {
		ps.pb(mp(segs[i].X, 0));
		ps.pb(mp(segs[i].Y + 1, 1));
	}

	sort(all(ps));


	vector <pair <int, int> > comp_segs;

	int cnt = 0;
	int left, right;
	for (int i = 0; i < sz(ps); i++) {
		if (ps[i].Y == 0) {
			if (cnt == 0)
				left = ps[i].X;
			cnt++;
		}
		else {
			cnt--;
			if (cnt == 0)
				comp_segs.pb(mp(left, ps[i].X - 1));
		}
	}

	if (sz(comp_segs) == 1 && comp_segs[0] == mp(MIN, MAX))
		puts("true");
	else {
		for (int i = 0; i < sz(comp_segs); i++) {
			print(comp_segs[i]);
			if (i < sz(comp_segs) - 1)
				printf(" ||\n");
		}
	}
	

#ifdef NSU
	cerr << "Time: " << (double)clock() / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}
