#pragma warning (disable : 4996)

#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <vector>
#include <iomanip>
#include <cassert>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;
#define mp make_pair
#define NAME string("abbreviation")

string s;

bool is_upper(char c) {
	return c >= 'A' && c <= 'Z';
}

bool is_lower(char c) {
	return c >= 'a' && c <= 'z';
}

bool is_letter(char c) {
	return is_lower(c) || is_upper(c);
}

bool is_not_letter(char c) {
	return !is_upper(c) && !is_lower(c);
}

vector<string> find_abbr(int &pos, bool &is_space) {
	vector<string> res;
	int num = 0;
	is_space = false;
	while (1) {
		if (pos == int(s.size())) {
			return res;
		}

		if (!is_upper(s[pos])) {
			return res;
		}

		int spos = pos;
		string temp = "";
		temp = temp + s[pos];
		++pos;
		while (pos < s.size() && is_letter(s[pos])) {
			if (!is_lower(s[pos])) {
				pos = spos;
				return res;
			}
			temp = temp + s[pos];
			++pos;
		}
		if (int(temp.size()) == 1) {
			pos = spos;
			return res;
		}

		res.push_back(temp);
		
		is_space = false;
		if (pos == (int)s.size()) {
			return res;
		}
		if (s[pos] != ' ') {
			return res;
		}

		is_space = true;
		++pos;
	}
}

string handle_abbr(vector<string> vs) {
	string res1 = "";
	for (int i = 0; i < vs.size(); ++i) {
		res1 = res1 + vs[i][0];
	}
	res1 = res1;
	
	string res2 = "(";
	for (int i = 0; i < vs.size(); ++i) {
		res2 = res2 + vs[i];
		if (i != int(vs.size()) - 1) {
			res2 = res2 + ' ';
		}
	}
	res2 = res2 + ')';
	return res1 + " " + res2;
}

string solve() {
	string ans = "";
	string temp = "";
	bool flag = true;
	for (int i = 0; i < s.size(); ++i) {
		if (!is_letter(s[i])) {
			flag = true;
			ans = ans + s[i];
			continue;
		}
		if (is_lower(s[i]) || !flag) {
			flag = false;
			ans = ans + s[i];
			continue;
		}
		if (is_upper(s[i])) {
			int pos = i;
			bool is_space = false;
			vector<string> vs = find_abbr(pos, is_space);
			if (int(vs.size()) > 1) {
				ans = ans + handle_abbr(vs);
				if (is_space) {
					ans = ans + ' ';
				}
				if (pos == s.size()) {
					break;
				}
				if (is_letter(s[pos])) {
					flag = false;
					ans = ans + s[pos];
					i = pos;
				}
				else {
					flag = true;
					ans = ans + s[pos];
					i = pos;
				}
			}
			else {
				flag = false;
				ans = ans + s[i];
				continue;
			}
		}
	}
	return ans;
}

int main() {
#ifdef LOCAL
	freopen("input.txt","r",stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen((NAME + ".in").c_str(),"r",stdin);
	freopen((NAME + ".out").c_str(), "w", stdout);
#endif

	while (getline(cin, s)) {
		cout << solve() << '\n';
	}

	return 0;
}