import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

public class Main {
	
	public static final int INF = 32767;
	public static final int MINF = -32768;
	
	public static class Pair {
		
		public int first, second;
		public Pair(int a, int b) {
			first = a; second = b;
		}
		
	}
	
	public static boolean num(String s) {
		for (char c : s.toCharArray())
			if (!(c >= '0' && c <= '9') && c != '-')
				return false;
		return true;
	}
	
	public static void FAIL(PrintWriter out) {
		out.println("false");
		out.close();
		System.exit(0);
	}
	
	public static void main(String[] args) throws Exception {
		BufferedReader in = new BufferedReader(new FileReader("hard.in"));
		PrintWriter out = new PrintWriter(new FileWriter("hard.out"));
		
		ArrayList<Pair> vv = new ArrayList<Pair>();
		
		String ss = in.readLine();
		for(;;) {
			String[] data = ss.split(" ");
			
			String sig = "";
			int x = -1, y = -1;
			boolean f = false;
			
			for(String s : data) {
				if (s.equals("<=") || s.equals(">="))
					sig += s;
				else {
					if (num(s)) {
						if (x == -1)
							x = Integer.parseInt(s);
						else
							y = Integer.parseInt(s);
					}
				}
				if (s.equals("||"))
					f = true;
			}
			if (sig.length() == 4) {
				vv.add(new Pair( x, 1 ));
				vv.add(new Pair( Math.min(y + 1, INF), -1 ));
			}
			else {
				if (sig.equals(">=")) {
					vv.add(new Pair( x, 1 ));
					vv.add(new Pair( INF, -1 ));
				}
				else {
					vv.add(new Pair( MINF, 1 ));
					vv.add(new Pair( Math.min(x + 1, INF), -1 ));
				}
			}
			if (!f)
				break;
			ss = in.readLine();
		}
		
		Collections.sort(vv, new Comparator<Pair> () {
			@Override
			public int compare(Pair a, Pair b) {
				if (a.first < b.first || (a.first == b.first && a.second > b.second))
					return -1;
				else
					return 1;
			}
		});
		
		int bal = 0, l = 0;
		ArrayList<Pair> ans = new ArrayList<Pair>();
		for (int i = 0; i < vv.size(); i++) {
			if (bal == 0) {
				l = vv.get(i).first;
			}
	        bal += vv.get(i).second;
			if (bal < 0) {
				FAIL(out);
			}
			if (bal == 0) {
				ans.add(new Pair( l, vv.get(i).first ));
			}
		}
		if (bal != 0){
			out.println("false");
			out.close();
			in.close();
			return;
		}
		if ((ans.size() == 1 && (ans.get(0).first == -32768 && ans.get(0).second == 32767))) {
			out.println("true");
			out.close();
			in.close();
			return;
		}
		else {
			for (int i = 0; i < ans.size(); i++) {
				if (ans.get(i).first == MINF) {
					out.print("x <= " + (ans.get(i).second - 1));
				}
				else {
					if (ans.get(i).second == INF) {
						out.print("x >= " + (ans.get(i).first));
					}
					else {
						out.print("x >= " + ans.get(i).first + " && x <= " + (ans.get(i).second - 1));
					}
				}
				if (i < ans.size() - 1)
					out.println(" ||");
				else
					out.println();
			}
		}
		
		
		in.close();
		out.close();
	}
	
}
