import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        new Main().run();
    }

    BufferedReader in;
    PrintWriter out;
    StringTokenizer st = new StringTokenizer("");

    final String fileIn = "abbreviation.in";
    final String fileOut = "abbreviation.out";

    private void run() throws IOException {
        in = new BufferedReader(new FileReader(new File(fileIn)));
        out = new PrintWriter(fileOut);

//        in = new BufferedReader(new InputStreamReader(System.in));
//        out = new PrintWriter(System.out, true);

        solve();

        in.close();
        out.close();
    }

    boolean isBigLetter(char ch) {
        return isLetter(ch) && Character.isUpperCase(ch);
    }

    boolean isSmallLetter(char ch) {
        return isLetter(ch) && Character.isLowerCase(ch);
    }

    boolean isLetter(char ch) {
        return Character.isLetter(ch);
    }

    boolean isCorrect(String str) {
        boolean correct = isBigLetter(str.charAt(0)) && str.length() > 1;
        for (int i = 1; i < str.length() && correct; i++) {
            correct = correct && isSmallLetter(str.charAt(i));
        }
        return correct;
    }

    void printList(StringBuilder builder, List<String> list) {
        if (list.size() == 1) {
            out.print(list.get(0));
        }
        if (list.size() > 1) {
//            System.err.println("HERE!");
            out.print(builder + " (");
            for (int i = 0; i < list.size() - 1; i++) {
                out.print(list.get(i) + " ");
            }
            out.print(list.get(list.size() - 1) + ")");
        }
    }

    final String stopWord = "fckngStop";

    private void solve() throws IOException {
        while (true) {
            String str = in.readLine();
            if (str == null) {
                break;
            }
            str += " " + stopWord + " ";
            boolean startWord = true;
            int ptr1 = -1, ptr2 = -1;
            StringBuilder builder = new StringBuilder();
            StringBuilder delimeters = new StringBuilder();
            StringBuilder prevAbbr = new StringBuilder();
            List<String> list = new ArrayList<>();
            for (int i = 0; i < str.length(); i++) {
                if (startWord && isLetter(str.charAt(i))) {
                    startWord = false;
                    ptr1 = i;
                }
                if (!isLetter(str.charAt(i)) && !startWord) {
                    StringBuilder tempDelim = delimeters;
                    delimeters = new StringBuilder();
                    ptr2 = i;
                    startWord = true;

                    String subStr = str.substring(ptr1, ptr2);
//                    if (subStr.equals("stop")) {
//                        break;
//                    }

//                    System.err.println(subStr);

                    boolean is_correct = isCorrect(subStr);
                    if (is_correct && list.isEmpty()) {
                        prevAbbr = tempDelim;
                        list.add(subStr);
                        builder.append(subStr.charAt(0));
                    }
                    else if (is_correct && !list.isEmpty()) {
                        if (tempDelim.toString().equals(" ")) {
                            list.add(subStr);
                            builder.append(subStr.charAt(0));
                        } else {
                            out.print(prevAbbr);
                            prevAbbr = new StringBuilder();
                            printList(builder, list);
                            builder = new StringBuilder();
                            list.clear();
//                            out.print(tempDelim);

                            boolean is_correct_tmp = isCorrect(subStr);
                            if (is_correct_tmp && list.isEmpty()) {
                                prevAbbr = tempDelim;
                                list.add(subStr);
                                builder.append(subStr.charAt(0));
                            } else {

                                if (!subStr.equals(stopWord)) {
                                    out.print(tempDelim);
                                    out.print(subStr);
                                } else {
                                    String s = tempDelim.toString();
                                    out.print(((String) s).substring(0, s.length() - 1));
                                }
                            }
                        }
                    }
                    else if (!is_correct) {
                        out.print(prevAbbr);
                        prevAbbr = new StringBuilder();
                        printList(builder, list);
                        builder = new StringBuilder();
                        list.clear();
                        if (!subStr.equals(stopWord)) {
                            out.print(tempDelim);
                            out.print(subStr);
                        } else {
                            String s = tempDelim.toString();
                            out.print(((String) s).substring(0, s.length()-1));
                        }
                    }

                }
                if (!isLetter(str.charAt(i))) {
                    delimeters.append(str.charAt(i));
                }
            }
            out.println();
        }
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    String nextToken() throws IOException {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }

    boolean EOF() throws IOException{
        while (st.hasMoreTokens()) {
            String line = in.readLine();
            if (line == null) return true;
            st = new StringTokenizer(line);
        }
        return false;
    }

}