#pragma comment(linker, "/STACK:256000000")

#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>
#include <time.h>
#include <memory.h>
#include <fstream>
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <utility>
#include <algorithm>
#include <functional>
#include <random>

using namespace std;

typedef long long int64;
typedef unsigned long long uint64;
typedef pair<int, int> pii;
typedef pair<int64, int64> pll;
const int INF = (int)(1e9 + 1e7);
const int64 LINF = (int64)(4e18);
const double EPS = 1e-11;
const double PI = acos(-1);
#define sq(x) ((x)*(x))
#define FAIL() ((*(int*)(0))++)

char buf[1005];

struct rectangle
{
	int h, w;

	vector <string> f;

	void read()
	{
		scanf("%d%d", &h, &w);
		f.resize(h);
		for (int i = 0; i < h; i++)
		{
			scanf("%s", &buf);
			f[i] = buf;
		}
	}

	void flip(int x, int y)
	{
		if (f[x][y] == '.')
		{
			f[x][y] = '*';
		}
		else
		{
			f[x][y] = '.';
		}
	}

	pii cut()
	{
		while (h)
		{
			int ptr = h - 1;
			bool emp = true;
			for (int j = 0; j < w; j++)
			{
				if (f[ptr][j] == '*')
				{
					emp = false;
					break;
				}
			}
			if (emp)
			{
				f.pop_back();
				h--;
			}
			else
			{
				break;
			}
		}
		while (w)
		{
			int ptr = w - 1;
			bool emp = true;
			for (int j = 0; j < h; j++)
			{
				if (f[j][ptr] == '*')
				{
					emp = false;
					break;
				}
			}
			if (emp)
			{
				for (int i = 0; i < h; i++)
				{
					f[i].pop_back();
				}
				w--;
			}
			else
			{
				break;
			}
		}
		int x1 = 0, y1 = 0;
		for (; x1 < h; x1++)
		{
			bool emp = true;
			for (int j = 0; j < w; j++)
			{
				if (f[x1][j] == '*')
				{
					emp = false;
					break;
				}
			}
			if (!emp)
			{
				break;
			}
		}
		for (; y1 < w; y1++)
		{
			bool emp = true;
			for (int i = 0; i < h; i++)
			{
				if (f[i][y1] == '*')
				{
					emp = false;
					break;
				}
			}
			if (!emp)
			{
				break;
			}
		}
		for (int i = 0; i + x1 < h; i++)
		{
			for (int j = 0; j + y1 < w; j++)
			{
				f[i][j] = f[i + x1][j + y1];
			}
		}
		f.erase(f.end() - x1, f.end());
		h -= x1;
		w -= y1;
		for (int i = 0; i < h; i++)
		{
			f[i].erase(f[i].end() - y1, f[i].end());
		}
		return pii(x1, y1);
	}

	bool operator == (const rectangle &oth) const
	{
		if (h != oth.h || w != oth.w)
		{
			return false;
		}
		for (int i = 0; i < h; i++)
		{
			for (int j = 0; j < w; j++)
			{
				if (f[i][j] != oth.f[i][j])
				{
					return false;
				}
			}
		}
		return true;
	}

	int get_first_y(int x)
	{
		int ptr1 = 0;
		while (ptr1 < w && f[x][ptr1] == '.')
		{
			ptr1++;
		}
		return ptr1;
	}

	int get_first_x(int y)
	{
		int ptr1 = 0;
		while (ptr1 < h && f[ptr1][y] == '.')
		{
			ptr1++;
		}
		return ptr1;
	}
};

int get_shift_row(rectangle &r1, int num1, rectangle &r2, int num2)
{
	int ptr1 = r1.get_first_y(num1);
	int ptr2 = r2.get_first_y(num2);
	if ((ptr1 >= r1.w) ^ (ptr2 >= r2.w))
	{
		return INF;
	}
	if ((ptr1 >= r1.w) && (ptr2 >= r2.w))
	{
		return 0;
	}
	while (ptr1 < r1.w && ptr2 < r2.w)
	{
		if (r1.f[num1][ptr1] != r2.f[num2][ptr2])
		{
			return INF;
		}
		ptr1++;
		ptr2++;
	}
	while (ptr1 < r1.w)
	{
		if (r1.f[num1][ptr1] == '*')
		{
			return INF;
		}
		ptr1++;
	}
	while (ptr2 < r2.w)
	{
		if (r2.f[num2][ptr2] == '*')
		{
			return INF;
		}
		ptr2++;
	}
	return ptr1 - ptr2;
}

int get_shift_col(rectangle &r1, int num1, rectangle &r2, int num2)
{
	int ptr1 = r1.get_first_x(num1);
	int ptr2 = r2.get_first_x(num2);
	if ((ptr1 >= r1.h) ^ (ptr2 >= r2.h))
	{
		return INF;
	}
	if ((ptr1 >= r1.h) && (ptr2 >= r2.h))
	{
		return 0;
	}
	while (ptr1 < r1.h && ptr2 < r2.h)
	{
		if (r1.f[ptr1][num1] != r2.f[ptr2][num2])
		{
			return INF;
		}
		ptr1++;
		ptr2++;
	}
	while (ptr1 < r1.h)
	{
		if (r1.f[ptr1][num1] == '*')
		{
			return INF;
		}
		ptr1++;
	}
	while (ptr2 < r2.h)
	{
		if (r2.f[ptr2][num2] == '*')
		{
			return INF;
		}
		ptr1++;
	}
	return ptr1 - ptr2;
}

bool check(rectangle &r1, rectangle &r2, rectangle &r3, int dx, int dy)
{
	rectangle res;
	res.f.resize(max(r1.h, dx + r2.h));
	for (int i = 0; i < (int)res.f.size(); i++)
	{
		res.f[i].resize(max(r1.w, dy + r2.w), '.');
	}
	res.h = res.f.size();
	res.w = res.f[0].size();
	for (int i = 0; i < r1.h; i++)
	{
		for (int j = 0; j < r1.w; j++)
		{
			if (r1.f[i][j] == '*')
			{
				res.flip(i, j);
			}
		}
	}
	for (int i = 0; i < r2.h; i++)
	{
		for (int j = 0; j < r2.w; j++)
		{
			if (r2.f[i][j] == '*')
			{
				res.flip(i + dx, j + dy);
			}
		}
	}
	res.cut();
	return res == r3;
}

pii check_insert(rectangle &r1, rectangle &r2, rectangle &r3)
{
	assert(r1.h == r3.h && r1.w == r3.w);
	int yl = 0;
	while (yl < r1.w && get_shift_col(r1, yl, r3, yl) == 0)
	{
		yl++;
	}
	int yr = r1.w - 1;
	while (yr >= 0 && get_shift_col(r1, yr, r3, yr) == 0)
	{
		yr--;
	}
	int xl = 0;
	while (xl < r1.h && get_shift_row(r1, xl, r3, xl) == 0)
	{
		xl++;
	}
	int xr = r1.h - 1;
	while (xr >= 0 && get_shift_row(r1, xr, r3, xr) == 0)
	{
		xr--;
	}
	if (xr - xl + 1 != r2.h || yr - yl + 1 != r2.w)
	{
		return pii(INF, INF);
	}
	if (check(r1, r2, r3, xl, yl))
	{
		return pii(xl, yl);
	}
	else
	{
		return pii(INF, INF);
	}
}

rectangle r1, r2, r3;
pii c1, c2;
int ansx, ansy;
int mx, my;

void answer(int dx, int dy, bool swaped)
{
	if (swaped)
	{
		dx *= -1;
		dy *= -1;
	}
	ansx += dx;
	ansy += dy;
	printf("YES\n%d %d\n", ansx, ansy);
	exit(0);
}

void solve()
{
	r1.read();
	r2.read();
	r3.read();
	c1 = r1.cut();
	c2 = r2.cut();
	r3.cut();
	ansx = c1.first - c2.first; ansy = c1.second - c2.second;
	mx = max(r1.h, r2.h);
	my = max(r1.w, r2.w);
	if (mx == r3.h && my == r3.w)
	{
		if (r1.h >= r2.h && r1.w >= r2.w)
		{
			pii p = check_insert(r1, r2, r3);
			if (p.first != INF)
			{
				ansx += p.first;
				ansy += p.second;
				printf("YES\n%d %d\n", ansx, ansy);
				return;
			}
		}
		else if (r1.h <= r2.h && r1.w <= r2.w)
		{
			pii p = check_insert(r2, r1, r3);
			if (p.first != INF)
			{
				p.first *= -1;
				p.second *= -1;
				ansx += p.first;
				ansy += p.second;
				printf("YES\n%d %d\n", ansx, ansy);
				return;
			}
		}
		else
		{
			bool swaped = false;
			if (r1.h < r2.h)
			{
				swap(r1, r2);
				swaped = true;
			}
			int yl = get_shift_row(r3, 0, r1, 0);
			int yr = get_shift_row(r3, r3.h - 1, r1, r1.h - 1);
			int xl = get_shift_col(r3, 0, r1, 0);
			int xr = get_shift_col(r3, r3.w - 1, r1, r1.w - 1);
			vector <int> dx, dy;
			dx.push_back(xl);
			dx.push_back(xr);
			dy.push_back(yl);
			dy.push_back(yr);
			for (int i = 0; i < 2; i++)
			{
				for (int j = 0; j < 2; j++)
				{
					if (dy[j] + r2.w <= r3.w && dx[i] + r2.h <= r3.h)
					{
						if (check(r1, r2, r3, dx[i], -dy[j]))
						{
							answer(dx[i], -dy[j], swaped);
						}
					}
				}
			}
		}
	}
	else
	{
		vector <int> dx, dy;
		if (r1.h < mx)
		{
			dx.push_back(0);
			dx.push_back(r1.h - r2.h);
		}
		else
		{
			dx.push_back(r1.h - r3.h);
			dx.push_back(r3.h - r2.h);
		}
		if (r1.w < my)
		{
			dy.push_back(0);
			dy.push_back(r1.w - r2.w);
		}
		else
		{
			dy.push_back(r1.w - r3.w);
			dy.push_back(r3.w - r2.w);
		}
		for (int i = 0; i < 2; i++)
		{
			for (int j = 0; j < 2; j++)
			{
					if (check(r1, r2, r3, dx[i], -dy[j]))
					{
						answer(dx[i], -dy[j], false);
					}
			}
		}
	}
	printf("NO\n");
}

#define TASK "kids"

int main()
{
	cin.tie(0); ios_base::sync_with_stdio(false);
#ifdef _MY_DEBUG
	freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
#else
	freopen(TASK ".in", "rt", stdin); freopen(TASK ".out", "wt", stdout);
#endif
	srand(88);

	solve();

	return 0;
}