#pragma comment(linker, "/STACK:256000000")

#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>
#include <time.h>
#include <memory.h>
#include <fstream>
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <utility>
#include <algorithm>
#include <functional>
#include <random>

using namespace std;

typedef long long int64;
typedef unsigned long long uint64;
typedef pair<int, int> pii;
typedef pair<int64, int64> pll;
const int INF = (int)(1e9 + 1e7);
const int64 LINF = (int64)(4e18);
const double EPS = 1e-11;
const double PI = acos(-1);
#define sq(x) ((x)*(x))
#define FAIL() ((*(int*)(0))++)

vector<int> pr;
vector<int> psz;
vector<string> pstr;
const int MAXV = 10010;
int lp[MAXV];

void sieve()
{
	for (int i = 2; i < MAXV; i++)
	{
		if (lp[i] == 0)
		{
			lp[i] = i;
			pr.push_back(i);
			string tt = to_string(i);
			psz.push_back(tt.size() + 2);
			pstr.push_back(tt);
		}
		for (int j = 0; j < (int)pr.size() && pr[j] <= lp[i] && i * 1ll * pr[j] < MAXV; j++)
			lp[i * pr[j]] = pr[j];
	}
}

int64 A, B;
unordered_map<int64, int64> f;

inline int64 hsh(int sm, int ctr, int num)
{
	return ((int64)sm) | ((int64)ctr << 16) | ((int64)num << 32);
}

int64 dyn(int sm, int ctr, int num)
{
	if (sm == 0)
		return ctr == 2;
	int64 hs = hsh(sm, ctr, num);
	if (f.count(hs))
		return f[hs];

	int64 res = 0;
	for (int i = num + 1; i < (int)pr.size() && res <= B + 10 && psz[i] <= ctr && pr[i] <= sm; i++)
	{
		int64 tres = dyn(sm - pr[i], ctr - psz[i], i);
		res += tres;
	}
    
	return f[hs] = res;
}

int asz;
string ans = "";
string st = "";
int64 gctr;

void dfs(int sm, int ctr, int num, int64 pos)
{
	if (ans.size() == asz)
		return;
	if (num == -1)
	{
		st += "[";
	}
	else
	{
		st += pstr[num] + ", ";
	}

	if (sm == 0)
	{
		st.pop_back();
		st.pop_back();
		st += "], ";
		for (int i = 0; i < (int)st.size() && (int)ans.size() < asz; i++)
		{
			if (pos + i >= A)
				ans += st[i];
		}
		st.resize((int)st.size() - 1 - psz[num]);
		return;
	}

	for (int i = num + 1; i < (int)pr.size() && psz[i] <= ctr && pr[i] <= sm && (int)ans.size() < asz; i++)
	{
		int64 tres = dyn(sm - pr[i], ctr - psz[i], i) * gctr;
		if (tres == 0)
			continue;
		if (pos + tres > A)
			dfs(sm - pr[i], ctr - psz[i], i, pos);
		pos += tres;
	}

	if (num == -1)
	{
		st.pop_back();
	}
	else
	{
		st.resize((int)st.size() - psz[num]);
	}
}

const int MAXCTR = 200;

void solve()
{
	cin >> A >> B;
	asz = (int)(B - A + 1);
	A--;
	B--;
	int64 cur = 0;
	for (int sm = 2; (int)ans.size() < asz; sm++)
	{
		for (int ctr = MAXCTR; ctr >= 5 && (int)ans.size() < asz; ctr--)
		{
			int64 total = (int64)dyn(sm, ctr, -1) * ctr;
			if (total == 0)
				continue;
			if (cur + total >= A)
			{
				gctr = ctr;
				dfs(sm, ctr, -1, cur);
			}
			cur += total;
		}
	}
	cout << ans;
}

#define TASK "list"
int main()
{
	cin.tie(0); ios_base::sync_with_stdio(false);
#ifdef _MY_DEBUG
	freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
#else
	freopen(TASK ".in", "rt", stdin); freopen(TASK ".out", "wt", stdout);
#endif
	srand(88);

	sieve();
	solve();

	return 0;
}