#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

bool is_suitable(unsigned char *p) {
	if (!isupper(*p) || !isalpha(p[1])) {
		return false;
	}
	++p;
	while (isalpha(*p)) {
		if (isupper(*p)) {
			return false;
		}
		++p;
	}
	return true;
}

bool look_ahead(unsigned char *p, unsigned char **next) {
	int i = 0;
	while (isalpha(p[i])) {
		++i;
	}
	if (p[i] != ' ' || !isalpha(p[i + 1]) || islower(p[i + 1]))  {
		return false;
	}
	++i;	// to the next word

	*next = p + i;
	return is_suitable(p + i);
}

void task1() {
	unsigned char str[130];
	unsigned char out[1000];
	int out_idx = 0;
	while (gets((char *)str)!=NULL) {
		unsigned char *next;
		int i = 0;
		while (str[i] != '\0') {
			bool flag = true;
			if (is_suitable(str + i)) {
				next = str + i;
				while (look_ahead(next, &next)) {
					if (flag) {
						out[out_idx++] = str[i];
						flag = false;
					}
					out[out_idx++] = *next;
				}
			}
			if (!flag) {
				out[out_idx++] = ' ';
				out[out_idx++] = '(';
				unsigned char *last;
				if (is_suitable(next)) {
					last = next;
				}
				else {
					last = next - 1;
				}
				for (; str + i < last || isalpha(str[i]); ++i) {
					out[out_idx++] = str[i];
				}
				out[out_idx++] = ')';
				if (ispunct(str[i])) {
					out[out_idx++] = str[i];
					++i;
				} else {
					if (isalpha(str[i])) {
						out[out_idx++] = ' ';
						++i;
					}
				}
			}
			else {
				for (; isalpha(str[i]); ++i) {
					out[out_idx++] = str[i];
				}
				if (str[i] != '\0') {
					out[out_idx++] = str[i++];
				}
			}
			
		}
		out[out_idx++] = '\n';
		out[out_idx] = '\0';
		printf("%s", out);
		out_idx = 0;
	}

}

int main() {
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
	task1();
	return 0;
}