#include <iostream>
#include "list"
#include "string"

using namespace std;

struct range{
	int from;
	int to;
};

const int MIN = -32768;
const int MAX = 32767;

bool arr[MAX - MIN + 1];

int aind(int index){
	return index - MIN;
}

bool arr_at(int index) {
	return arr[aind(index)];
}

void arr_set(int index, bool value) {
	arr[aind(index)] = value;
}

void add_range(range r) {
	for (int i = r.from; i <= r.to; i++)
		arr_set(i, true);
}


char _range_to_str_buf[5];
string range_to_str(range r){
	string res;
	if (r.from == MIN) {
		res = "x <= ";
		res += itoa(r.to, _range_to_str_buf, 10);
	}
	else if (r.to == MAX) {
		res = "x >= ";
		res += itoa(r.from, _range_to_str_buf, 10);
	}
	else {
		res = "x >= ";
		res += itoa(r.from, _range_to_str_buf, 10);
		res += " && x <= ";
		res += itoa(r.to, _range_to_str_buf, 10);
	}
	return res;
}


bool check_res_true(){
	for (int i = MIN; i <= MAX; i++)
		if (!arr_at(i)) return false;
	return true;
}

bool check_res_false(){
	for (int i = MIN; i <= MAX; i++)
		if (arr_at(i)) return false;
	return true;
}

void print_range(){
	list<range> ranges;

	int range_first = MIN - 1, range_last = MIN - 1;
	for (int i = MIN; i < MAX; i++){
		if (range_first >= MIN) {
			if (arr_at(i)) {
				// move right restriction
				range_last = i;
			}
			else {
				// close range
				range r;
				r.from = range_first;
				r.to = range_last;
				ranges.push_back(r);

				range_first = MIN - 1;
				range_last = MIN - 1;
			}
		}
		else if (arr_at(i)) {
			// open range
			range_first = i;
		}
	}
	if (range_first >= MIN) {
		range r;
		r.from = range_first;
		r.to = MAX;
		ranges.push_back(r);
	}

	//print ranges
	while (ranges.size() > 1){
		cout << range_to_str(ranges.front()) << " ||\n";
		ranges.pop_front();
	}

	cout << range_to_str(ranges.front());
}


int main() {
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);

	range r;
	char buf[6];

	while (true) {
		cin >> buf >> buf;
		if (buf[0] == '>') {
			cin >> r.from;
			cin >> buf;
			if (buf[0] == '|') {
				r.from = MAX;
				add_range(r);
				continue;
			}
			else if (buf[0] == '&') {
				cin >> buf >> buf >> r.to;
				add_range(r);
				cin >> buf;
				if (buf[0] != '|') break;
			}
			else {
				r.to = MAX;
				add_range(r);
				break;
			}
		}
		else {
			r.from = MIN;
			cin >> r.to;
			add_range(r);
			cin >> buf;
			if (buf[0] != '|') break;
		}
	}

	if (check_res_false()) {
		cout << "false";
		return 0;
	}

	if (check_res_true()) {
		cout << "true";
		return 0;
	}

	print_range();

	return 0;
}