import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Scanner;

public class Main {

    public static final int LBOUND = -32768;
    public static final int RBOUND = 32767;

    public static void main(String[] args) throws FileNotFoundException {
        Scanner sc = new Scanner(new File("hard.in"));

        boolean[] nums = new boolean[65537];

        for (String line = sc.nextLine(); ; line = sc.nextLine()) {
            boolean last = !line.endsWith("|");
            String[] t = line.split(" ");
            int n = last ? t.length : (t.length - 1);
            int a = LBOUND;
            int b = RBOUND;
            if (n == 7) {
                a = Integer.parseInt(t[2]);
                b = Integer.parseInt(t[6]);
            } else {
                int x = Integer.parseInt(t[2]);
                if (">=".equals(t[1])) {
                    a = x;
                } else {
                    b = x;
                }
            }

            a -= LBOUND;
            b -= LBOUND;

            for (int i = a; i <= b; ++i) {
                nums[i] = true;
            }

            if (last) {
                break;
            }
        }
        PrintWriter pw = new PrintWriter(new File("hard.out"));
//        PrintWriter pw = new PrintWriter(System.out);

        ArrayList<Integer> aaa = new ArrayList<>();
        ArrayList<Integer> bbb = new ArrayList<>();

        int k = 0;
        for (; k < 65536; ) {
            int a = -1;
            int b = -1;

            for (; k < 65536; ++k) {
                if (nums[k]) {
                    a = k;
                    break;
                }
            }

            for (; k <= 65536; ++k) {
                if (!nums[k]) {
                    b = k - 1;
                    break;
                }
            }

            if (a != -1) {
                aaa.add(a + LBOUND);
                bbb.add(b + LBOUND);
            }
        }

        int len = aaa.size();
        if (len == 0) {
            pw.print("false");
            pw.flush();
            pw.close();
            sc.close();
            return;
        }
        if (len == 1 && aaa.get(0) == LBOUND && bbb.get(0) == RBOUND) {
            pw.print("true");
            pw.flush();
            pw.close();
            sc.close();
            return;
        }

        for (int i = 0; i < len; ++i) {
            if (aaa.get(i) == LBOUND) {
                pw.print("x <= " + bbb.get(i));
            } else if (bbb.get(i) == RBOUND) {
                pw.print("x >= " + aaa.get(i));
            } else {
                pw.print("x >= " + aaa.get(i) + " && " + "x <= " + bbb.get(i));
            }
            if (i < len - 1) {
                pw.print(" ||\n");
            }
        }

        pw.flush();
        pw.close();
        sc.close();
    }

}