import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

/**
 * Created by neerc on 05.12.2016.
 */
public class H {
    static List<Border> borders = new LinkedList<>();

    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new FileReader("hard.in"));
        FileWriter wrt = new FileWriter("hard.out");
        String line = br.readLine();
        while (line != null) {
            parseLine(line);
            line = br.readLine();
        }
        refactor();
        if (borders.isEmpty()) {
            wrt.append("false");
            wrt.close();
            return;
        }
        if (borders.size() == 1) {
            if (borders.get(0).a == -32768 && borders.get(0).b == 32767) {
                wrt.append("true");
                wrt.close();
                return;
            }
        }
        for (int i = 0; i < borders.size(); i++) {
            Border border = borders.get(i);
            if (border.a != -32768 && border.b != 32767) {
                wrt.append("x >= " + border.a + " && x <= " + border.b);
            } else if (border.a != -32768) {
                wrt.append("x >= " + border.a);
            } else if (border.b != 32767) {
                wrt.append("x <= " + border.b);
            }
            if (i == borders.size() - 1) {

            } else {
                wrt.append(" ||\n");
            }
        }
        wrt.close();

    }

    public static void parseLine(String line) {
        String[] par = line.split(" ");
        int left, right;
        if (par.length > 4) {
            left = Integer.valueOf(par[2]);
            right = Integer.valueOf(par[6]);
        } else {
            if (par[1].equals("<=")) {
                left = -32768;
                right = Integer.valueOf(par[2]);
            } else {
                left = Integer.valueOf(par[2]);
                right = 32767;
            }
        }
        if (left > right) {
            return;
        }
        Border border = new Border(left, right);
        borders.add(border);
    }

    public static void refactor() {
        Collections.sort(borders);
        for (int i = 0; i < borders.size() - 1; i++) {
            Border a = borders.get(i);
            Border b = borders.get(i + 1);
            if (b.a <= a.b + 1) {
                a.b = Math.max(a.b, b.b);
                borders.remove(b);
                i--;
            }

        }

    }

    public static class Border implements Comparable<Border> {
        int a, b;

        Border(int a, int b) {
            this.a = a;
            this.b = b;
        }

        @Override
        public int compareTo(Border o) {
            return this.a < o.a ? -1 : 1;
        }
    }
}

