#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
using namespace std;

string sub_string(const string& str, int start, int end) {
	string result = "";
	for (size_t i = start, pos = 0; i <= end; i++, pos++) {
		result += str[i];
	}
	return result;
}

vector< pair< pair<int, int>, int> > positions_and_capitalize_of_words(const string& text) {
	vector< pair< pair<int, int>, int> > v;

	bool inWord = false, capitalized = false;
	int start_word = -1, end_word = -1;
	for (size_t i = 0; i < text.size(); i++) {
		if (('a' <= text[i] && text[i] <= 'z') ||
			('A' <= text[i] && text[i] <= 'Z')) {
			if (!inWord) {
				start_word = i;
				inWord = true;
				if ('A' <= text[i] && text[i] <= 'Z') {
					capitalized = true;
				}
				else {
					capitalized = false;
				}
			}
			else {
				if ('A' <= text[i] && text[i] <= 'Z') {
					capitalized = false;
				}
			}
		}

		if (text[i] == ' ' || text[i] == '.' || text[i] == ',' || i == text.size()-1) {
			if (inWord) {
				end_word = i - 1;
				inWord = false;

				if (start_word == end_word) {
					capitalized = false;
				}
				v.push_back(make_pair(make_pair(start_word, end_word), (capitalized ? 1 : 0)));
			}

			int res = -1;
			switch (text[i]) {
				case ' ': res = 2; break;
				case '.': res = 3; break;
				case ',': res = 4; break;
			}
			v.push_back(make_pair(make_pair(i, i), res));
		}
	}

	return v;
}

string text_with_abbr(const string& text) {
	const vector< pair< pair<int, int>, int> > words(positions_and_capitalize_of_words(text));

	string result = "";
	int start = 0, end = 0;
	for (size_t i = 0; i < words.size(); i++) {
		//cout << "[" << words[i].first.first << ", " << words[i].first.second << "] = " << words[i].second << '\n';

		switch (words[i].second) {
			case 1: {
				start = i, end = i;
				int cur_pos = start + 1;

				while (true) {
					if (cur_pos < words.size() && words[cur_pos].second == 2) {
						cur_pos++;
					}
					else break;

					if (cur_pos < words.size() && words[cur_pos].second == 1) {
						end = cur_pos;
						cur_pos++;
					}
					else break;
				}

				if (start != end) {
					string abbr = "";
					for (size_t pos = start; pos <= end; pos += 2) {
						int index = words[pos].first.first;
						abbr += text[index];
					}

					start = words[start].first.first, end = words[end].first.second;
					result += abbr + " (" + sub_string(text, start, end) + ")"; //text.substr(start, end) + ")";

					i = end;
				}
				else {
					start = words[i].first.first, end = words[i].first.second;
					result += sub_string(text, start, end); //text.substr(start, end + 1);
				}
			}
			break;

			default: { // 0, 2, 3, 4
				start = words[i].first.first, end = words[i].first.second;
				result += sub_string(text, start, end);  text.substr(start, end + 1);
			}
			break;
		}
	}

	return result;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);

	string str;
	while (getline(cin, str)) {
		//cout << str << '\n';
		cout << text_with_abbr(str) << '\n';
	}

	return 0;
}