#include <stdio.h>
#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#define INF 10000000

using namespace std;

struct point{
	double  x, y, z;

	point(){
		this->x = 0;
		this->y = 0;
		this->z = 0;
	}

	point(double x, double y, double z){
		this->x = x;
		this->y = y;
		this->z = z;
	}

	point getMiddle(point value){
		return point((this->x + value.x) / 2, (this->y + value.y) / 2, (this->z + value.z) / 2);
	}
};

struct block{
	point zero, center, end;
	bool exist = true;

	block(int w, int h, int d, point zero){
		end = point(zero.x + w, zero.y + h, zero.z + d);
		this->zero = zero;
		center = point(w / 2, h / 2, d / 2);
	}
};

vector<vector<block> > blocks;

struct rect{
	point lb, rt;
	rect(point l, point r){
		lb = l;
		rt = r;
	}
		
	rect(vector<block> value){
		lb = point(INF, INF, INF);
		rt = point(0, 0, 0);
		for (int i = 0; i < value.size(); i++)
			if (value[i].exist){
				lb.x = min(lb.x, value[i].zero.x);
				lb.z = min(lb.z, value[i].zero.z);

				rt.x = max(rt.x, value[i].end.x);
				rt.z = max(rt.z, value[i].end.z);
			}
	}

	bool contains(point value){
		return (lb.x < value.x && lb.z < value.z) && (rt.x > value.x && rt.z > value.z);
	}
};

point getCenter(int level){
	point center = blocks[level][0].center;
	for (int k = 1; k < blocks[level].size(); k++){
		if (blocks[level][k].exist)
			center.getMiddle(blocks[level][k].center);
	}
	return center;
}

bool checkFall(){
	point prevCenter = getCenter(0);
	for (int stage = 1; stage < blocks.size(); stage++){
		if (!(rect(blocks[stage]).contains(prevCenter)))
			return true;
		else{
			prevCenter = getCenter(stage);
		}
	}
	return false;
}

void removeBlock(int stage, int position){
	blocks[blocks.size() - stage][blocks[blocks.size() - stage].size() - position].exist = false;
}



int main(){

	freopen("jenga.in","r",stdin);
	freopen("jenga.out", "w", stdout);

	int w, n, h, req;
	scanf("%d %d\n%d %d\n", &n, &w, &h, &req);
	for (int stage = 0; stage < h; stage++){
		blocks.push_back(vector<block>());

		for (int pos = 0; pos < n; pos++){
			if (stage % 2 == 0)
				blocks[stage].push_back(block(w, 1, w*n, point(pos*w, pos, 0)));
			else
				blocks[stage].push_back(block(w*n, 1, w, point(0, pos, pos*w)));
		}
	}

	for (int curReq = 0; curReq < req; curReq++){
		int stage, position;
		scanf("%d %d", &stage, &position);
		removeBlock(stage, position);
		if (checkFall()){
			printf("yes\n%d", curReq + 1);
			return 0;
		}
	}
	printf("no");

	//system("pause");
	return 0;
}
