#include <iostream>
#include <algorithm>
#include <string>
#include <map>
#include <vector>
#include <set>
#include <fstream>
#include <iterator>
#include <cstdint>
#include <iomanip>
using namespace std;

bool is_capital(const string& s)
{
	if (!s.size() || s.size() == 1) return false;
	if (!isupper(s[0]))
		return false;

	for (size_t i = 1; i < s.size(); i++)
		if (isupper(s[i])) return false;

	return true;
}

bool is_norm_delim(const string& s) { return s == " "; }

int main()
{
	ifstream in("abbreviation.in");
	ofstream out("abbreviation.out");

	vector <string> words;
	vector <string> delims;
	{
		string word = "";
		string delim = "";
		bool isWord = true;
		char c = 0;
		while (in.get(c))
		{
			if (isalpha(c))
			{
				if (!isWord)
				{
					delims.push_back(delim);

					isWord = true;
					delim = "";
				}
				word += c;
			}
			else
			{
				if (isWord)
				{
					words.push_back(word);
					isWord = false;
					word = "";
				}
				delim += c;
			}
		}
		if (isWord) words.push_back(word);
		else delims.push_back(delim);
	}

	int begin_w = -1;
	int end_w = -1;

	delims.push_back("");

	for (int i = 0; i < words.size(); ++i)
	{
		if (is_capital(words[i]) && begin_w == -1)
		{
			begin_w = i;
			end_w = i;
			for (int j = i; j < words.size() - 1; ++j)
				if (is_norm_delim(delims[j]) && is_capital(words[j + 1]))
				{
					end_w = j + 1;
				}
				else break;

			if (begin_w == end_w)
			{
				out << words[i] << delims[i];
				i = end_w;
				end_w = -1;
				begin_w = -1;
				continue;
			}

			for (int c = begin_w; c <= end_w; c++)
				out << words[c][0];

			out << " (";
			for (int c = begin_w; c < end_w; c++)
				out << words[c] << " ";
			out << words[end_w] << ")" << delims[end_w];
			i = end_w;
			end_w = -1;
			begin_w = -1;
			continue;
		}
		out << words[i] << delims[i];
	}

	return 0;
}