#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <climits>
#include <cmath>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <deque>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>
#ifdef LOCAL_PROJECT
#   include <conio.h>
#endif

#define eps 1e-8
#define forn(i, n) for (int i = 0; i < (n); i++)
#define fst first
#define snd second
#define mp make_pair
#define pb push_back
#define eb emplace_back
#define pf push_front
#define ef emplace_front
#define sz(x) (int)(x).size()
#define let const auto
#define _ << ' ' <<
#define TIMESTAMP(msg) debug << "[" msg "]: " << clock() / (double)CLOCKS_PER_SEC << '\n'

using namespace std;

struct debug_t {
    template <typename T>
    debug_t& operator<<(const T& value) {
#       ifdef LOCAL_DEBUG
        cout << value << flush;
#       endif
        return *this;
    }

    template <typename T>
    debug_t& write(const char value[ ], streamsize n) {
#       ifdef LOCAL_DEBUG
        cout.write(value, n);
        cout << flush;
#       endif
        return *this;
    }
} debug;

using uchar = unsigned char;
using ustring = basic_string<uchar>;
using llong = long long;
using ullong = unsigned long long;
using ldouble = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using vvi = vector<vector<int>>;

struct Interval {
    ullong qsize;
    int len;

    bool operator<(const Interval& rhs) const {
        return qsize < rhs.qsize;
    }
};

ullong pSums[(int)1e5 + 1], lenSums[(int)1e5 + 1];

int main() {
#   ifdef LOCAL_PROJECT
    freopen("input.txt", "r", stdin);
#   else
    freopen("expect.in", "r", stdin);
    freopen("expect.out", "w", stdout);
#   endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int i, n, q;
    vector<Interval> v;
    while (cin >> n >> q) {
        char c;
        int t, k;
        cin >> c >> t >> k;
        ullong curq;
        if (c == '-')
            curq = k;
        else
            curq = -k;
        int prevt = t;
        v.clear();
        n--;
        v.reserve(n);
        for (i = 0; i < n; i++) {
            cin >> c >> t >> k;
            if (c == '-')
                curq += k;
            else
                curq -= k;
            v.push_back({ curq, t - prevt });
            prevt = t;
        }
        assert((int)v.size() == n);
        let lastQSize = v.back().qsize;
        debug << lastQSize << "\n\n";
        sort(v.begin(), v.end());
        for (const auto& interval : v)
            debug << interval.qsize << ' ' << interval.len << '\n';
        pSums[n] = lenSums[n] = 0;
        for (i = n - 1; i >= 0; i--) {
            pSums[i] = pSums[i + 1] + v[i].len * v[i].qsize;
            lenSums[i] = lenSums[i + 1] + v[i].len;
        }
        debug << '\n';
        for (i = 0; i <= n; i++)
            debug << pSums[i] << ' ' << lenSums[i] << '\n';
        debug << '\n';
        while (q--) {
            int x;
            cin >> x;
            if (x < lastQSize) {
                cout << "INFINITY\n";
                continue;
            }
            let i = upper_bound(v.begin(), v.end(), x,
                [ ](int x, const Interval& y) {
                    return x < y.qsize;
                }
            ) - v.begin();
            cout << pSums[i] - x * lenSums[i] << '\n';
        }
    }

#   ifdef LOCAL_PROJECT
    cout << flush;
    _getch();
#   endif
}
