#define _CRT_SECURE_NO_WARNINGS
#include <array>
#include <climits>
#include <cmath>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <deque>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>
#ifdef LOCAL_PROJECT
#   include <conio.h>
#endif

#define forn(i, n) for (int i = 0; i < (n); i++)
#define fst first
#define snd second
#define mp make_pair
#define pb push_back
#define eb emplace_back
#define pf push_front
#define ef emplace_front
#define sz(x) (int)(x).size()
#define let const auto
#define _ << ' ' <<
#define TIMESTAMP(msg) debug << "[" msg "]: " << clock() / (double)CLOCKS_PER_SEC << '\n'

using namespace std;

struct debug_t {
    template <typename T>
    debug_t& operator<<(const T& value) {
#       ifdef LOCAL_DEBUG
        cout << value << flush;
#       endif
        return *this;
    }

    template <typename T>
    debug_t& write(const char value[ ], streamsize n) {
#       ifdef LOCAL_DEBUG
        cout.write(value, n);
        cout << flush;
#       endif
        return *this;
    }
};

using uchar = unsigned char;
using ustring = basic_string<uchar>;
using llong = long long;
using ullong = unsigned long long;
using ldouble = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using vvi = vector<vector<int>>;

const int LINF = -32768, RINF = 32768;

struct Expr {
    int left, right;
    char constant;
    Expr() {}
    Expr(int a, int b, bool two, bool less = true) {
        if (two) {
            left = a;
            right = b + 1;
        }
        else {
            if (less) {
                left = LINF;
                right = a + 1;
            }
            else {
                left = a;
                right = RINF;
            }
        }
        if (left >= right)
            constant = 'f';
        else if (left == LINF && right == RINF)
            constant = 't';
        else
            constant = 0;
    }
    bool tryMerge(Expr& rhs) {
        if (right >= rhs.right) {
            rhs = *this;
            return true;
        }
        if (rhs.left <= right) {
            rhs.left = left;
            right = rhs.right;
            return true;
        }
        return false;
    }
    friend ostream& print(ostream& os, const Expr& expr, bool last) {
        if (expr.left != LINF) {
            os << "x >= " << expr.left;
            if (expr.right != RINF)
                os << " && ";
        }
        if (expr.right != RINF)
            os << "x <= " << expr.right - 1;
        return os;
    }
};

int main() {
#   ifdef LOCAL_PROJECT
    freopen("input.txt", "r", stdin);
#   else
    freopen("hard.in", "r", stdin);
    freopen("hard.out", "w", stdin);
#   endif

    Expr exprs[1000];

    int cnt = 0;
    char x;
    while (cin >> x >> ws) {
        char op1[2] = "", op2[2] = "", opt[2] = "";
        int a, b = 0;
        cin >> op1[0] >> op1[1] >> ws;
        cin >> a >> ws >> opt[0] >> opt[1] >> ws;
        if (opt[0] == '&')
            cin >> x >> ws >> op2[0] >> op2[1] >>
                ws >> b >> ws >> opt[1] >> opt[1] >> ws;
        exprs[cnt++] = Expr(a, b, opt[0] == '&', op1[0] == '<');
    }

    bool needed[1000];
    memset(needed, 0x01, sizeof needed);
    for (int i = 0; i < cnt; ++i) {
        if (needed[i]) {
            for (int j = i + 1; j < cnt; ++j) {
                if (needed[j]) {
                    bool b;
                    if (exprs[i].left <= exprs[j].left)
                        b = exprs[i].tryMerge(exprs[j]);
                    else
                        b = exprs[j].tryMerge(exprs[i]);
                    if (b)
                        needed[j] = false;
                }
            }
        }
    }

    for (int i = 0; i < cnt; i++)
        if (needed[i] && (exprs[i].left == LINF && exprs[i].right == RINF)) {
            cout << "true\n";
            goto end;
        }
    for (int i = 0; i < cnt; i++)
        if (needed[i] && exprs[i].constant != 'f')
            goto normal;
    cout << "false\n";
    goto end;
normal:
    bool first = true;
    for (int i = 0; i < cnt; ++i) {
        if (needed[i] && !exprs[i].constant) {
            if (first)
                first = false;
            else
                cout << " ||\n";
            print(cout, exprs[i], i == cnt - 1);
        }
    }
    cout << '\n';

end:
    ;
#   ifdef LOCAL_PROJECT
    cout << flush;
    _getch();
#   endif
}
