#define _CRT_SECURE_NO_WARNINGS
#include <array>
#include <bitset>
#include <climits>
#include <cmath>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <deque>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>
#ifdef LOCAL_PROJECT
#   include <conio.h>
#endif

#define eps 1e-8
#define forn(i, n) for (int i = 0; i < (n); i++)
#define fst first
#define snd second
#define mp make_pair
#define pb push_back
#define eb emplace_back
#define pf push_front
#define ef emplace_front
#define sz(x) (int)(x).size()
#define let const auto
#define _ << ' ' <<
#define TIMESTAMP(msg) debug << "[" msg "]: " << clock() / (double)CLOCKS_PER_SEC << '\n'

using namespace std;

struct debug_t {
    template <typename T>
    debug_t& operator<<(const T& value) {
#       ifdef LOCAL_DEBUG
        cout << value << flush;
#       endif
        return *this;
    }

    template <typename T>
    debug_t& write(const char value[ ], streamsize n) {
#       ifdef LOCAL_DEBUG
        cout.write(value, n);
        cout << flush;
#       endif
        return *this;
    }
} debug;

#define DBG(x) debug << "["#x"] = " << x << "\n"

using uchar = unsigned char;
using ustring = basic_string<uchar>;
using llong = long long;
using ullong = unsigned long long;
using ldouble = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using vvi = vector<vector<int>>;

int n, w, h, m;
struct Rect {
    double l, r, u, d;
    bool contains_strictly(double x, double y) const {
        return l + eps < x && x < r - eps && d + eps < y && y < u - eps;
    }
};

Rect get_ch(bitset<10 * 1000>& gone, int parity) {
    double l = 1e200, r = -1e200, u = -1e200, d = 1e200;
    for (int i = 0; i < n; i++) if( !gone.test(i) ) {
        double x, y;
        x = i * w; y = 0;
        if (parity) swap(x, y);
        l = min(l, x); r = max(r, x); u = max(u, y); d = min(d, y);
        x = i * w + w; y = 0;
        if (parity) swap(x, y);
        l = min(l, x); r = max(r, x); u = max(u, y); d = min(d, y);
        x = i * w + w; y = w * n;
        if (parity) swap(x, y);
        l = min(l, x); r = max(r, x); u = max(u, y); d = min(d, y);
        x = i * w; y = w * n;
        if (parity) swap(x, y);
        l = min(l, x); r = max(r, x); u = max(u, y); d = min(d, y);
    }
    return Rect {l, r, u, d};
}



int main() {
#   ifdef LOCAL_PROJECT
    freopen("input.txt", "r", stdin);
#   else
    freopen("jenga.in", "r", stdin);
    freopen("jenga.out", "w", stdout);
#   endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    while (cin >> n >> w >> h >> m) {
        vector< bitset<10 * 1000> > gone(h);
        vector<double> mx(h, w * n / 2.), my(h, w * n / 2.);
        vector<double> MX(h, w * n / 2.), MY(h, w * n / 2.);
        vector<int> CNT(h), cnt(h, n); 
        CNT[h - 1] = n;
        for (int i = h - 2; i >= 0; i--)
            CNT[i] = CNT[i + 1] + cnt[i];
        bool crash = false;
        for (int request = 1; request <= m; request++) {
            int level, id; 
            cin >> level >> id;
            --level;  --id;
            gone[level].set(id);
            Rect ch = get_ch(gone[level], level & 1);
            DBG(level);
            DBG(ch.l);
            DBG(ch.r);
            DBG(ch.u);
            DBG(ch.d);
            if (crash || level < h - 1 && !ch.contains_strictly(MX[level + 1], MY[level + 1])) {
                if( !crash ) 
                    cout << "yes\n" << request << "\n";
                crash = true;
                continue;
            }
            double x = w / 2. + id * w, y = w * n / 2.;
            if (level & 1) swap(x, y);
            MX[level] = MX[level] * CNT[level] - mx[level] * cnt[level];
            mx[level] = mx[level] * cnt[level] - x;
            MX[level] = MX[level] + mx[level];
            MY[level] = MY[level] * CNT[level] - my[level] * cnt[level];
            my[level] = my[level] * cnt[level] - y;
            MY[level] = MY[level] + my[level];
            --cnt[level]; --CNT[level];
            mx[level] = mx[level] / cnt[level];
            MX[level] = MX[level] / CNT[level];
            my[level] = my[level] / cnt[level];
            MY[level] = MY[level] / CNT[level];
            DBG(mx[level]); DBG(my[level]);
            DBG(MX[level]); DBG(MX[level]);
            for (int i = level - 1; i >= 0; i--) {
                MX[i] = mx[i] * cnt[i] + MX[i + 1] * CNT[i + 1];
                MY[i] = my[i] * cnt[i] + MY[i + 1] * CNT[i + 1];
                --CNT[i];
                MX[i] = MX[i] / CNT[i];
                MY[i] = MY[i] / CNT[i];
                DBG(i);
                DBG(mx[i]); DBG(my[i]);
                DBG(MX[i]); DBG(MY[i]);
            }
        }
        if (!crash)
            cout << "no\n";
        debug << "\n";
    }

#   ifdef LOCAL_PROJECT
    cout << flush;
    _getch();
#   endif
}
