#include <iostream>
#include <fstream>
#include <string>
#include <vector>

using namespace std;


ifstream fin("abbreviation.in");
ofstream fout("abbreviation.out");

string line = "", word = "";
vector<string> seq;
vector<int> ind;

bool isCapitalized(const string s) {
    if (islower(s[0])) return false;
    if (s.length() < 2) return false;
    for (int i = 1; i < s.length(); i++)
        if (isupper(s[i])) return false;
    return true;
}

bool isAbbreviatable(int i, int j) {
    if (j - i == 0) return isCapitalized(seq[i]);

    if (j - i == 1) return false;

    return (isCapitalized(seq[j]) && seq[j - 1] == " " && isAbbreviatable(i, j - 2));
}

int doit(string line) {
    // divide line into words
    for (int i = 0; i < line.length(); i++) {
        if (word.length() == 0)
            word = line[i];
        else if (isalpha(line[i]) * isalpha(word[0]))
            word += line[i];
        else {
            seq.push_back(word);
            word = line[i];
        }
    }
    seq.push_back(word);
    word = "";

    int i = 0;
    ind.resize(seq.size());

    while (i < seq.size()) {
        if (isCapitalized(seq[i])) {
            ind[i] = 1;
            if (i > 2 && seq[i - 1] == " ")
                ind[i] = ind[i - 2] + 1;
        }
        else
            ind[i] = 0;
        i++;
    }

    string buff = "";
    i = seq.size() - 1;
    while (i >= 0) {
        if (ind[i] < 2) buff = seq[i] + buff;
        else {
            int j = i;
            while (ind[i] > 1) i -= 2;

            buff = ")" + buff;
            for (int k = j; k >= i; k--) buff = seq[k] + buff;
            buff = " (" + buff;
            for (int k = j; k >= i; k -= 2) buff = seq[k][0]+ buff;
        }
        i--;
    }
    fout << buff << endl;

    word = "";
    seq.clear();
    ind.clear();

    return 0;
}

int main() {
    while (getline(fin, line))
        doit(line);
    return 0;
}
