#define _CRT_SECURE_NO_DEPRECATE

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <string>

using namespace std;
#define FOR(i,n) for(int (i) = 0; (i) < (int)(n); ++(i))
#define forn(i,n) for(int (i) = 0; (i) < (int)(n); ++(i))
#define for1(i,n) for(int (i) = 1; (i) <= (int)(n); ++(i))
#define sz(v) (int)v.size()
#define pb push_back
#define mp make_pair

const int N = 1007;
int type[N];
int a[N], b[N];
int n;

const int L = -(1 << 15);
const int R = +(1 << 15) - 1;

bool ok[R - L + 10];

bool is_digit(char c) {
	return c >= '0' && c <= '9';
}

int get_value(string &st, int i) {
	int ret = 0;
	int sign = 1;
	if (st[i] == '-') {
		sign = -1;
		++i;
	}
	while (i < sz(st) && is_digit(st[i])) {
		ret = 10 * ret + st[i] - '0';
		++i;
	}
	return sign * ret;
}

void parse(int id, string st) {
	int n = sz(st);
	if (st.find('|') != -1) {
		int pos = st.find('|') - 1;
		parse(id, st.substr(0, pos));
		return;
	}
	if (st.find("&") == -1) {
		if (st.find('>') != -1) type[id] = 1;
		else type[id] = 2;
		a[id] = get_value(st, st.find('=') + 2);
	}
	else {
		type[id] = 0;
		a[id] = get_value(st, 5);
		b[id] = get_value(st, st.find('<') + 3);
	}
}

bool get(int x) {
	FOR(i, n) {
		if (type[i] == 0) {
			if (x >= a[i] && x <= b[i]) return true;
		}
		if (type[i] == 1) {
			if (x >= a[i]) return true;
		}
		if (type[i] == 2) {
			if (x <= a[i]) return true;
		}
	}
	return false;
}

string get_str(int x) {
	string ret = "";
	string sign = "";
	if (x < 0) {
		sign = "-";
		x = -x;
	}
	do {
		ret += char('0' + x % 10);
		x /= 10;
	} while (x);
	reverse(ret.begin(), ret.end());
	return sign + ret;
}

string expr(int a, int b) {
	if (a == L) return "x <= " + get_str(b);
	if (b == R) return "x >= " + get_str(a);
	return "x >= " + get_str(a) + " && x <= " + get_str(b);
}

void solve() {
	char buf[256];
	n = 0;
	while (cin.getline(buf, 256)) {
		string st = string(buf, buf + strlen(buf));
		if (sz(st) < 2) break;
		parse(n, st);
		++n;
	}

	for (int i = L; i <= R; ++i) {
		ok[i - L] = get(i);
	}

	bool forall = true;
	for (int i = L; i <= R; ++i) {
		forall &= (ok[i - L]);
	}

	if (forall) {
		puts("true");
		return;
	}

	bool no = true;
	for (int i = L; i <= R; ++i) {
		no &= (!ok[i - L]);
	}
	if (no) {
		puts("false");
		return;
	}

	vector<pair<int, int> > ranges;
	for (int i = L; i <= R;) {
		if (!ok[i-L]) {
			++i;
			continue;
		}
		int j = i;
		while (j <= R && ok[j - L]) {
			++j;
		}
		ranges.pb(mp(i, j-1));
		i = j;
	}

	FOR(i, sz(ranges)) {
		int a = ranges[i].first;
		int b = ranges[i].second;

		printf("%s", expr(a, b).c_str());

		if (i + 1 < sz(ranges)) {
			printf(" ||\n");
		}
		else {
			printf("\n");
		}
	}
}

int main(){
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
#define task "hard"
	freopen(task".in", "r", stdin);
	freopen(task".out", "w", stdout);
#endif
	solve();
	return 0;
}