#define _CRT_SECURE_NO_DEPRECATE

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <string>
#include <cassert>

using namespace std;
#define FOR(i,n) for(int (i) = 0; (i) < (int)(n); ++(i))
#define forn(i,n) for(int (i) = 0; (i) < (int)(n); ++(i))
#define for1(i,n) for(int (i) = 1; (i) <= (int)(n); ++(i))
#define sz(v) (int)v.size()
#define pb push_back
#define mp make_pair

//typedef long long LL;
typedef long double LD;

const LD eps = 1e-8;
const int N = 10007;
int n, h;
int cnt_in[N];

LD x[N], y[N], cnt[N];
LD ax_in[N], ay_in[N], bx_in[N], by_in[N];
LD mass_x_in[N], mass_y_in[N];
bool is[5007][N];

int get_left(int layer) {
	int i = 1;
	while (i <= n && !is[layer][i]) ++i;
	assert(i != n + 1);
	return i;
}

int get_right(int layer) {
	int i = n;
	while (i >= 1 && !is[layer][i]) --i;
	assert(i != 0);
	return i;
}

void update_xy_in(int layer, int id) {
	is[layer][id] = false;
	if (cnt_in[layer] == 0) {
		mass_x_in[layer] = n / 2.0;
		mass_y_in[layer] = n / 2.0;
		ax_in[layer] = 0;
		ay_in[layer] = 0;
		bx_in[layer] = n;
		by_in[layer] = n;
		x[layer] = n / 2.0;
		y[layer] = n / 2.0;
		return;
	}
	int L = get_left(layer);
	int R = get_right(layer);
	LD x_remove, y_remove;
	if (layer % 2 == 1) {
		ax_in[layer] = 0;
		ay_in[layer] = L - 1;
		bx_in[layer] = n;
		by_in[layer] = R;
		x_remove = n / 2.0;
		y_remove = id - 0.5;
	}
	else {
		ax_in[layer] = L - 1;
		ay_in[layer] = 0;
		bx_in[layer] = R;
		by_in[layer] = n;
		x_remove = id - 0.5;
		y_remove = n / 2.0;
	}
	mass_x_in[layer] = ((cnt_in[layer] + 1) * mass_x_in[layer] - x_remove) / cnt_in[layer];
	mass_y_in[layer] = ((cnt_in[layer] + 1) * mass_y_in[layer] - y_remove) / cnt_in[layer];
}

bool out(LD x, LD y, LD ax, LD ay, LD bx, LD by) {
	return (x < ax + eps || x > bx - eps || y < ay + eps || y > by - eps);
}

bool update_mass_center(int layer) {
	LD mass_up = cnt[layer + 1];
	LD mass_here = cnt_in[layer];
	bool ret = !out(x[layer + 1], y[layer + 1], ax_in[layer], ay_in[layer], bx_in[layer], by_in[layer]);
	x[layer] = (mass_x_in[layer] * mass_here + mass_up * x[layer + 1]) / (mass_here + mass_up);
	y[layer] = (mass_y_in[layer] * mass_here + mass_up * y[layer + 1]) / (mass_here + mass_up);
	return ret;
}

void solve() {
	int dummy;
	scanf("%d%d", &n, &dummy);
	int q;
	scanf("%d%d", &h, &q);

	for (int i = 1; i <= h; ++i) {
		cnt_in[i] = n;
		cnt[i] = (h - i + 1) * (LD)n;

		mass_x_in[i] = n / 2.0;
		mass_y_in[i] = n / 2.0;

		ax_in[i] = 0;
		ay_in[i] = 0;
		bx_in[i] = n;
		by_in[i] = n;

		x[i] = n / 2.0;
		y[i] = n / 2.0;

		for (int j = 1; j <= n; ++j) is[i][j] = true;
	}
	int current_move = 0;
	int last_layer = h;
	while (q--) {
		++current_move;
		int layer, id;
		scanf("%d%d", &layer, &id);
		--cnt_in[layer];
		if (cnt_in[layer] == 0) {
			if (layer != last_layer) {
				puts("yes");
				printf("%d\n", current_move);
				return;
			}
			else {
				last_layer--;
			}
		}
		for (int i = 1; i <= layer; ++i) {
			cnt[i] -= 1;
		}
		update_xy_in(layer, id);
		for (int i = last_layer; i >= 1; --i) {
			bool f = update_mass_center(i);
			if (!f && cnt[1 + i] > 0.5) {
				puts("yes");
				printf("%d\n", current_move);
				return;
			}
		}
	}
	puts("no");
}

int main(){
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
#define task "jenga"
	freopen(task".in", "r", stdin);
	freopen(task".out", "w", stdout);
#endif
	solve();
	return 0;
}