import sun.reflect.generics.tree.Tree;

import java.io.*;
import java.util.*;
import java.math.*;

public class Main {
    static HashMap<String, String> mp;

    static boolean isCapitalized(String n) {
        if (n.length() <= 1)
            return false;
        if (Character.isLowerCase(n.charAt(0)))
            return false;
        for (int i = 1; i < n.length(); i++) {
            if (Character.isUpperCase(n.charAt(i))) {
                return false;
            }
        }
        return true;
    }

    static void check(String n) {
        String[] sp = n.split("\\ ");
        if (sp.length < 2) return;
        String abrv = "";
        for (String i : sp) {
            abrv += i.charAt(0);
        }
        mp.put(abrv, n.trim());
    }

    public static void main(String[] args) throws Exception {
        BufferedReader in = new BufferedReader(new FileReader(new File("abbreviation.in")));
        PrintWriter out = new PrintWriter(new File("abbreviation.out"));

        String text = "";
        String line = null;
        String alltext = "";

        while ((line = in.readLine()) != null) {
            mp = new HashMap<>();
            text += line.trim() + " ";
            String[] byDot = line.split("\\.");
            for (String i : byDot) {
                String[] byComma = i.split("\\,");
                for (String j : byComma) {
                    String res = "";
                    for (String k : j.split("\\ ")) {
                        if (isCapitalized(k)) {
                            res += k + " ";
                        } else {
                            check(res.trim());
                            res = "";
                        }
                    }
                    check(res);
                }
            }
            for (Map.Entry<String, String> i : mp.entrySet()) {
               // System.err.println(i.getKey() + " " + i.getValue());
                String repl = i.getKey() + " (" + i.getValue() + ")";
                line = line.replaceFirst(i.getValue(), repl);
            }
            alltext += line + "\n";

        }
        alltext = alltext.trim();


        out.println(alltext);
        out.flush();
        out.close();

    }
}
