#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <string>
#include <fstream>
#include <list>
#include <algorithm>
#include <memory>
#include <sstream>
using namespace std;
#define ll long long
#define ull unsigned long long
#define ld long double
typedef int int32;
#define int ll
typedef pair <int,int> pii;
typedef vector<int> vi;

string file = "jenga";
void run();
int32 main(){
	cout << fixed << setprecision(13);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
#ifdef RAU2
	freopen("in.txt", "r", stdin);
#else
	freopen((file + ".in").c_str(), "r", stdin);
	freopen((file + ".out").c_str(), "w", stdout);
#endif
	run();
	return 0;
}

using data = double;
class vec3
{
public:
	double x, y, z;
	vec3():x(0),y(0),z(0){}
	vec3(data _x, data _y, data _z) : x(_x), y(_y), z(_z) {}

};
vec3 operator+(const vec3& a, const vec3& b) { return vec3(a.x + b.x, a.y + b.y, a.z + b.z); }
vec3 operator-(const vec3& a, const vec3& b) { return vec3(a.x - b.x, a.y - b.y, a.z - b.z); }
vec3 operator*(const vec3& a, const data& t) { return vec3(a.x*t, a.y*t , a.z *t); }
vec3 operator/(const vec3& a, const data& t) { return vec3(a.x/t, a.y/t, a.z / t); }
ostream& operator<<(ostream& os, const vec3& b) { os << "[" << b.x << ", " << b.y << ", " << b.z << "]"; return os; }


data update_mass(double m1, vec3 r1, double m2, vec3 r2) {
	return m1 + m2;
}
vec3 update_coord(double m1, vec3 r1, double& m2, vec3& r2) {
	data m = update_mass(m1, r1, m2, r2);
	vec3 r = ((r1 * m1) + (r2 * m2)) / (m);
	return r;
}

void toR2M2 (double m1, vec3 r1, double& m2, vec3& r2) {

	r2 = ((r1 * m1) + (r2 * m2)) / (m1 + m2);
	m2 += m1;
}



void run() 
{
	double n, h, w, M;

	cin >> n >> w;
	cin >> h >> M;
	
	vector <data> level_mass;
	vector <vec3> level_coord;
	
	vector <pair<int, int> > level_id;
	set<pair<int, int>> removed;

	double cmass = 0;
	vec3 coord(0, 0, 0);

	for (double xi = 0; xi < n; ++xi) {
		vec3 curPoint(0, 0, 0);
		curPoint.x = w / 2.0 + xi*w;
		curPoint.y = (w*n / 2.0);
		curPoint.z = 0;
		toR2M2(1, curPoint, cmass, coord);
	}
	for(int z = 0; z < h; ++z) {
		coord.z = z;
		level_mass.push_back(cmass);
		level_coord.push_back(coord);
		level_id.push_back({0,n-1});
	}


	for (int m = 0; m < M; ++m) {
		int l, k;
		cin >> l >> k;
		
		int z = l - 1;
		int xi = k - 1;
		
		if (xi == level_id[z].first || xi == level_id[z].second) {
			int dir, cur = xi;
			if (xi == level_id[z].first) {
				dir = 1;
			}
			else {
				dir = -1;
			}

			while (removed.find({ z, cur + dir }) != removed.end()) { cur += dir; }
			
			if (xi == level_id[z].first) {
				level_id[z].first = cur;
				dir = 1;
			}
			else {
				level_id[z].second = cur;
				dir = -1;
			}
		}

		removed.insert({ z, xi });

		vec3 curPoint;
		if (int(z) % 2 == 0) {
			curPoint.x = w / 2.0 + xi*w;
			curPoint.y = (w*n / 2.0);
			curPoint.z = z;
		}
		else {
			curPoint.x = (w*n / 2.0);
			curPoint.y = w / 2.0 + xi*w;
			curPoint.z = z;
		}

		data total_mass = level_mass[z];
		vec3 total_coord = level_coord[z];

		total_coord = total_coord * total_mass - curPoint;
		total_mass--;
		total_coord = total_coord / total_mass;
		
		level_mass[z] = total_mass;
		level_coord[z] = total_coord;

		data part_mass = 0;
		vec3 part_coord(0, 0, 0);
		for (z = h - 1; z > 0; z--) {
			toR2M2(level_mass[z], level_coord[z], part_mass, part_coord);

			int xMin, xMax, yMin, yMax;
			if (z % 2 == 0) {
				xMin = level_id[z].first * w + w / 2;
				xMax = level_id[z].second * w + w / 2;
				yMin = 0;
				yMax = n*w;
			}
			else {
				yMin = level_id[z].first * w + w / 2;
				yMax = level_id[z].second * w + w / 2;
				xMin = 0;
				xMax = n*w;
			}

			if ( part_coord.x >= xMax || part_coord.x <= xMin || part_coord.y >= yMax || part_coord.y <= yMin ) {
				cout << "yes" << endl << m + 1 << endl;
				return;
			}


		}


	}
	cout << "no";
}