#include <iostream>
#include <cstdio>
#include <cstring>
#include <string>
#include <algorithm>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <ctime>
#include <sstream>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef double real;

const double pi = 3.1415926535897932384626433832795;

#define FILL(x, v) memset(x, v, sizeof(x))
#define ALL(x) (x).begin(), (x).end()
#define SZ(x) ((int)(x).size())

string S, ANS;

void cleanup(){
	S.clear();
	ANS.clear();
}

bool read(){
	cleanup();
	if (!getline(cin, S)) return false;
	return true;
}

string convert(string s, string from, string to){
	string ans = s;
	while (true){
		int p = ans.find(from);
		if (p == -1) break;
		ans.erase(p, SZ(from));
		ans.insert(p, to);
	}
	return ans;
}

typedef string::iterator sit;

string full, obr, word;

bool isCap(string s){
	if (SZ(s) < 2 || !isupper(s.front())) return false;
	for (int i = 1; i < SZ(s); i++){
		if (!islower(s[i])) return false;
	}
	return true;
}

void transition(sit);

void breakObr(){
	string spaces = "";
	if (SZ(full) > 0 && full.back() == ' '){
		spaces = " ";
		full.pop_back();
	}
	if (SZ(obr) > 1){
		ANS += obr + " (" + full + ")";
	}
	else{
		ANS += full;
	}
	ANS += spaces;
	full = obr = "";
}

void getWord(sit &it){
	string word = "";
	while (isalpha(*it)){
		word += *it;
		it++;
	}
	if (isCap(word)){
		full += word;
		obr += word.front();
	}
	else {
		breakObr();
		ANS += word;
	}
}

void getSpace(sit &it){
	string spaces = "";
	while (*it == ' '){
		spaces += *it;
		it++;
	}
	if (SZ(spaces) > 1 || SZ(obr) == 0){
		breakObr();
		ANS += spaces;
	}
	else{
		full += spaces;
	}
}

void getChar(sit &it){
	breakObr();
	string chars = "";
	while (*it == ',' || *it == '.'){
		chars += *it;
		it++;
	}
	ANS += chars;
}


void solve(){
	S = S + "$";
	sit it = S.begin();
	while (true){
		if (*it == '$') break;
		if (isalpha(*it)) getWord(it);
		else if (*it == ' ') getSpace(it);
		else getChar(it);
	}
	breakObr();
	cout << ANS << endl;
}


int main(){
	int t;
#ifdef RAU1
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	t = 100000;
#else
#define task "abbreviation"
	freopen(task".in", "r", stdin);
	freopen(task".out", "w", stdout);
	t = 100000;
#endif
	while (t--){
		clock_t tm = clock();
		if (!read()) break;
		solve();
		fprintf(stderr, "\n>>>>>>>>>>>>>>>>>>>>TIME: %d\n", tm - clock());
	}
}