#include <iostream>
#include <cstdio>
#include <cstring>
#include <string>
#include <algorithm>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <ctime>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef double real;

const double pi = 3.1415926535897932384626433832795;

#define FILL(x, v) memset(x, v, sizeof(x))
#define ALL(x) (x).begin(), (x).end()
#define SZ(x) ((int)(x).size())

vector <string> V;
vector <pii> R;
int smaller, bigger;

const int low = -32768;
const int up = -low - 1;

void cleanup(){
	V.clear();
	R.clear();
	smaller = up + 1;
	bigger = low - 1;
}

bool read(){
	cleanup();
	string s;
	while (cin >> s){
		V.push_back(s);
	}
	if ( SZ(V) == 0 ) return false;
	return true;
}



string getWord(){
	if (SZ(V) == 0) return "||";
	string ans = V.back();
	V.pop_back();
	return ans;
}

bool getRange(){
	string a;
	int f, s;
	if (getWord() == "||") return false;
	a = getWord();
	f = atoi(getWord().c_str());
	if (getWord() == "||"){
		if (a == "<=") bigger = max(bigger, f); 
		if (a == ">=") smaller = min(smaller, f);
		return true;
	}
	getWord();
	getWord();
	s = atoi(getWord().c_str());
	if (a == "<=") swap(f, s);
	R.push_back({ f, s });
	getWord();
	return true;
}

bool checkPoint(int p){
	if (smaller <= p || bigger >= p) return true;
	for (pii &r : R){
		if (r.first <= p && p <= r.second) return true;
	}
	return false;
}

bool firstTime;
void printPrefix(){
	if (!firstTime) printf(" ||\n");
	firstTime = false;
}

int checkTrue(){
	int cnt = 0;
	for (int p = low; p <= up; p++)
		cnt += checkPoint(p);
	return cnt;
}

void solve(){
	reverse(ALL(V));
	while (getRange()) {}
	if (checkTrue() == (1 << 16)) {
		printf("true\n");
		return;
	}
	if (checkTrue() == 0){
		printf("false\n");
		return;
	}
	while (checkPoint(bigger + 1)) bigger++;
	while (checkPoint(smaller - 1)) smaller--;
	firstTime = true;
	if (smaller <= up){
		printPrefix();
		printf("x >= %d", smaller);
	}
	if (bigger >= low){
		printPrefix();
		printf("x <= %d", bigger);
	}
	int last = 0;
	for (int p = bigger + 2; p <= smaller - 1; p++){
		if (checkPoint(p) && p <= smaller - 2) last++;
		else{
			if (last != 0){
				printPrefix();
				printf("x >= %d && x <= %d", p - last, p - 1);
			}
			last = 0;
		}
	}
}


int main(){
	int t;
#ifdef RAU1
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	t = 100000;
#else
#define task "hard"
	freopen(task".in", "r", stdin);
	freopen(task".out", "w", stdout);
	t = 1;
#endif
	while (t--){
		clock_t tm = clock();
		if (!read()) break;
		solve();
		fprintf(stderr, "\n>>>>>>>>>>>>>>>>>>>>TIME: %d\n", tm - clock());
	}
}