#include <iostream>
#include <cstdio>
#include <cstring>
#include <string>
#include <algorithm>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <ctime>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef double real;

const double pi = 3.1415926535897932384626433832795;

#define FILL(x, v) memset(x, v, sizeof(x))
#define ALL(x) (x).begin(), (x).end()
#define SZ(x) ((int)(x).size())

int n, w, h, m;

const int max_h = 5010;

ll CNT[max_h];
ll MOM[max_h];

pii C[max_h];
set<int> S[max_h];

pii getConvex(int lvl){
	pii &c = C[lvl];
	set <int> &X = S[lvl];
	while (X.find(c.first) != X.end()){
		X.erase(c.first);
		c.first++;
	}
	while (X.find(c.second) != X.end()){
		X.erase(c.second);
		c.second--;
	}
	return c;
}

void removeBlock(int lvl, int id){
	CNT[lvl]--;
	MOM[lvl] -= id;
	S[lvl].insert(id);
}

void cleanup(){
}

bool read(){
	cleanup();
	if (scanf("%d%d%d%d", &n, &w, &h, &m) != 4) return false;
	return true;
}

void query(int q){
	int l, k;
	scanf("%d%d", &l, &k);
	removeBlock(l, k);
	ll mom_x, mom_y, cnt;
	mom_x = mom_y = cnt = 0;
	for (int i = h; i > 1; i--){
		swap(mom_x, mom_y);
		mom_x += MOM[i];
		cnt += CNT[i];
		pii c = getConvex(i - 1);
		if (c.first * cnt <= mom_x && mom_x <= c.second * cnt){
		}
		else{
			printf("yes\n%d\n", q);
			exit(0);
		}
	}
}

void solve(){
	for (int i = 1; i <= h; i++){
		C[i] = { 1, n };
		CNT[i] = n;
		MOM[i] = (n * 1ll * (n + 1)) / 2;
	}
	for (int i = 1; i <= m; i++){
		query(i);
	}
	printf("no\n");
}


int main(){
	int t;
#ifdef RAU1
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	t = 100000;
#else
#define task "jenga"
	freopen(task".in", "r", stdin);
	freopen(task".out", "w", stdout);
	t = 1;
#endif
	while (t--){
		clock_t tm = clock();
		if (!read()) break;
		solve();
		fprintf(stderr, "\n>>>>>>>>>>>>>>>>>>>>TIME: %d\n", tm - clock());
	}
}