//package com.company;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class Main {

    private static boolean isCharC(char a) {
        return a>='A' && a<='Z';
    }

    private static boolean isAbbr(String line){
        if(line.length()<2) {
            return false;
        }

        if(isCharC(line.charAt(0))) {
            for(int i = 1; i<line.length();i++) {
                if(isCharC(line.charAt(i))) {
                    return false;
                }
            }
        } else return false;

        return true;
    }

    private static String makeItLegit(String line) {
        StringBuilder result = new StringBuilder();

        if(line.equals("") || line.length()<5) {
            return line;
        } else {
            String sep[] = line.split(" ");
            if(sep.length<2) {
                return line;
            } else {
                int lastOk = -1;
                StringBuilder brWords = new StringBuilder();
                StringBuilder brCWords = new StringBuilder();

                for(int i =0; i<sep.length; i++) {
                    if(isAbbr(sep[i])) {
                        if(lastOk == -1) {
                            lastOk = i;
                            if(i==sep.length-1){
                                result.append(sep[i]);
                            }
                            brWords.append(sep[i]);
                            brCWords.append(sep[i].charAt(0));
                        } else if(i - lastOk == 1) {
                            brWords.append(" ").append(sep[i]);
                            brCWords.append(sep[i].charAt(0));
                            lastOk = i;
                            if(lastOk==sep.length-1){
                                result.append(brCWords).append(" (").append(brWords).append(")");
                                brCWords = new StringBuilder();
                                brWords = new StringBuilder();
                            }
                        } else if (i - lastOk > 1) {
                            result.append(brCWords).append(" (").append(brWords).append(")");
                            brCWords = new StringBuilder();
                            brWords = new StringBuilder();
                        }
                    } else {


                        if(lastOk!=-1 && brWords.toString().split(" ").length >= 2) {
                            result.append(brCWords).append(" (").append(brWords).append(")");
                            if(i<sep.length) {
                                result.append(" ");
                            }
                            lastOk=-1;
                            brCWords = new StringBuilder();
                            brWords = new StringBuilder();
                        } else if(lastOk!=-1) {
                            result.append(sep[lastOk]).append(" ");
                            lastOk=-1;
                            brCWords = new StringBuilder();
                            brWords = new StringBuilder();
                        }

                        result.append(sep[i]);
                        if(i<sep.length-1) {
                            result.append(" ");
                        }
                    }
                }
            }
        }

        return result.toString();
    }

    public static void main(String[] args) {
        Locale.setDefault(Locale.US);

        try(Scanner in = new Scanner(new File("abbreviation.in"));
            PrintWriter out = new PrintWriter(new File("abbreviation.out"))) {
            String line = null;

            while(in.hasNextLine()) {
                line = in.nextLine();
                if(line!=null) {
                    String [] byDots = line.split("\\.");
                    boolean withDots = line.contains(".");
                    StringBuilder dotsRes = new StringBuilder();

                    for(int i = 0; i<byDots.length; i++) {
                        String byComas[] = byDots[i].split(",");
                        boolean withComas = byDots[i].contains(",");

                        StringBuilder comasRes = new StringBuilder();

                        for(int j =0; j<byComas.length;j++) {
                            //System.out.println("makeItLegit "+byComas[j]);
                            comasRes.append(makeItLegit(byComas[j]));
                            if(j<byComas.length-1 && withComas) {
                                comasRes.append(",");
                            }
                        }
                        dotsRes.append(comasRes);
                        if((byComas[byComas.length-1].equals("")||byDots[i].charAt(byDots[i].length()-1)==',') && withComas) {
                            dotsRes.append(",");
                        }

                        if(i<byDots.length-1 && withDots) {
                            dotsRes.append(".");
                        }
                    }

                    if((byDots[byDots.length-1].equals("") ||line.charAt(line.length()-1)=='.')&& withDots) {
                        dotsRes.append(".");
                    }

                    out.println(dotsRes.toString());
                }
            }

        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }
}
