def is_abbr(word):
    if len(word) <= 1:
        return False
    if len(word) == 2:
        if word[1] < 'a' or word[1] > 'z':
            return False
    
    if word[0] >= 'A' and word[0] <= 'Z':
        for i in range(1, len(word)):
            if word[i] >= 'A' and word[i] <= 'Z':
                return False
    else:
        return False
    return True

def split_list(word, symb):
    spl = word.split(symb)
    res = []
    for s in spl:
        res.append(s)
        res.append(symb)
    return res[:-1]

def split_words(line):
    spl_spaces = split_list(line, ' ')
    spl_point = []
    for word in spl_spaces:
        spl_point += split_list(word, '.')
    
    res = []
    for word in spl_point:
        res += split_list(word, ',')
    
    return res
    
def make_abbr(word_list):
    res = ''
    if len(word_list) == 1:
        return word_list[0]
    abbr = ''
    for word in word_list:
        res += word[0]
        abbr += '{} '.format(word)
    abbr = abbr[:-1]
    res = '{} ({})'.format(res, abbr)
    return res

def print_abbr(words):
    res = ''
    cur_index = 0
    while cur_index < len(words):
        word = words[cur_index]
        if word == '':
            cur_index += 1
            continue
        
        if word == ' ' or word == '.' or word == ',':
            res += word
            cur_index += 1
        else:
            if is_abbr(word):
                cur_abbr = [word]
                last_word = word
                while cur_index < len(words) - 1:
                    cur_word = words[cur_index + 1]
                    if cur_word == ' ':
                        if last_word != ' ':
                            pass
                        else:
                            break
                    else:
                        if last_word == ' ':
                            if not is_abbr(cur_word):
                                #cur_index -= 1
                                break
                            else:
                                cur_abbr.append(cur_word)
                        else:
                            cur_index += 1
                            break
                    last_word = cur_word
                    cur_index += 1
                res += make_abbr(cur_abbr)
            else:
                res += word
                cur_index += 1
    return res

def main():
    #with open('abbreviation.in', 'r') as _f:
        #with open('abbreviation.out', 'w') as out:
    while True:
        line = input()
        if line is None or len(line) == 0:
            return
        
        words = split_words(line)
        words = [word for word in words if len(word) > 0]
        words.append('.')
        
        res = print_abbr(words)[:-1]
        print(res)

if __name__ == '__main__':
    main()