#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <iostream>
using namespace std;

bool IsLower(char c) {
	return c >= 'a' && c <= 'z';
}

bool IsUpper(char c) {
	return c >= 'A' && c <= 'Z';
}

bool IsAlp(char c) {
	return IsUpper(c) || IsLower(c);
}


char s[1000];
string abr;
int aStart = -1, aEnd = -1, n;

void Outp() {
	if (aStart != -1) {
		if (abr.size() > 1) {
			cout << abr << "(" << string(s + aStart, s + aEnd) << ")";
		}
		else {
			cout << string(s + aStart, s + aEnd);
		}
		aStart = -1;
		abr = "";
	}
}

void Find(int i, int& j, int& good) {
	j = i;
	while (j < n && IsAlp(s[j])) j++;
	good = IsUpper(s[i]);
	for (int k = i + 1; k < j; k++) good &= IsLower(s[k]);
}

int main() {
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);

	while (gets(s)) {
		n = 0; while (s[n]) n++;

		int i = 0;
		while (i < n) {
			if (IsAlp(s[i])) {
				int j, good;
				Find(i, j, good);
				if (good) {
					aStart = i;
					aEnd = j;
					abr.push_back(s[i]);
					i = j;
					continue;
				}
				cout << string(s + i, s + j);
				i = j;
				continue;
			}

			if (aStart != -1 && s[i] == ' ' && (i + 1 < n && IsAlp(s[i + 1]))) {
				int j, good;
				Find(i + 1, j, good);
				if (good) {
					aEnd = j;
					abr.push_back(s[i + 1]);
					i = j;
					continue;
				}
			}
			Outp();
			printf("%c", s[i]);
			i++;
		}
		Outp();
		puts("");
	}
	return 0;
}
