#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iostream>
#include <algorithm>
using namespace std;
typedef long long ll;
const int N = 100001;
int m, n, q;
ll t[N], d[N], s[N];

ll h[8 * N], sum[8 * N];
ll qq[N];

void add(int id, int L, int R, int l, int r, ll val) {
	if (l < L) l = L;
	if (r > R) r = R;
	if (l > r) return;
	if (l == L && r == R) {
		h[id] += val;
		return;
	}
	int M = (L + R) / 2;
	add(2 * id, L, M, l, r, val);
	add(2 * id + 1, M + 1, R, l, r, val);
}

ll get(int id, int L, int R, int at) {
	if (at < L || at > R) return 0;
	ll ret = h[id];
	if (L == R) return ret;
	int M = (L + R) / 2;
	ret += get(2 * id, L, M, at);
	ret += get(2 * id + 1, M + 1, R, at);
	return ret;
}

int main() {
	freopen("expect.in", "r", stdin);
	freopen("expect.out", "w", stdout);

	set<ll> all;

	ll total = 0;

	cin >> n >> q;
	for (int i = 1; i <= n; i++) {
		char c; cin >> c;
		cin >> t[i] >> d[i];
		if (c == '-') d[i] = -d[i];
		s[i] = s[i - 1] + d[i];
		if (s[i] < 0)	all.insert(-s[i]);
	}
	
	for (int i = 0; i < q; i++) {
		cin >> qq[i];
	}

	map<ll, int> M;
	all.insert(0);
	m = -1;
	vector<ll> V(all.begin(), all.end());
	for (auto x : all) {
		M[x] = ++m;
	}

	for (int i = 1; i < n; i++) {
		if (s[i] < 0) add(1, 1, m, 1, M[-s[i]], t[i + 1] - t[i]);
		if (s[i] < 0 ) total += -s[i] * (t[i + 1] - t[i]);
	}

	for (int i = 1; i <= m; i++) {
		sum[i] = sum[i - 1] + get(1, 1, m, i) * (V[i] - V[i - 1]);
	}

	for (int i = 0; i < q; i++) {
		ll x = qq[i];
		if (x < -s[n]) cout << "INFINITY" << endl;
		else if (x >= V.back()) cout << 0 << endl;
		else {
			int j = upper_bound(V.begin(), V.end(), x) - V.begin();
			cout << total - (sum[j - 1] + (qq[i] - V[j - 1]) * (get(1, 1, m, j) - get(1, 1, m, j - 1))) << endl;
		}
	}
	return 0;
}
