#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <iostream>
#include <algorithm>
using namespace std;
typedef long long ll;

const int N = 3000;

struct M {
	int si, sj, n, m, top, left;

	char** a;

	char** init() {
		char** a = new char*[N];
		for (int i = 0; i < N; i++) {
			a[i] = new char[N];
			for (int j = 0; j < N; j++) a[i][j] = '.';
		}
		return a;
	}

	M() {
		top = left = 0;
		si = sj = 0;
		n = m = N;
		a = init();
	}

	void trim() {
		while (n > 0 && getTopX() == -1) {
			top++;
			si++;
			n--;
		}
		while (n > 0 && getBottomX() == -1) {
			n--;
		}
		while (m > 0 && getLeftY() == -1) {
			left++;
			sj++;
			m--;
		}
		while (m > 0 && getRightY() == -1) {
			m--;
		}
	}

	void moveTo(int mi, int mj) {
		char** b = init();
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				b[mi + i][mj + j] = a[si + i][sj + j];
			}
		}
		si = mi;
		sj = mj;
		a = b;
	}

	void move(int di, int dj) {
		moveTo(si + di, sj + dj);
	}

	int getTopX() {
		return getX(si);
	}

	int getBottomX() {
		return getX(si + n - 1);
	}

	int getX(int row) {
		for (int j = 0; j < m; j++) if (a[row][sj + j] != '.') return j;
		return -1;
	}

	int getLeftY() {
		return getY(sj);
	}

	int getRightY() {
		return getY(sj + m - 1);
	}

	int getY(int col) {
		for (int i = 0; i < n; i++) if (a[si + i][col] != '.') return i;
		return -1;
	}

	bool equals(M& t) {
		if (n != t.n || m != t.m) return false;
		char** b = t.a;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (a[si + i][sj + j] != b[t.si + i][t.sj + j]) return false;
			}
		}
		return true;
	}

	M xor(M& t) {
		M xor;
		char ** b = t.a;
		for (int i = 0; i < N; i++) {
			for (int j = 0; j < N; j++) {
				xor.a[i][j] = a[i][j] == b[i][j] ? '.' : '*';
			}
		}
		xor.trim();
		return xor;
	}

};

void read(M& f) {
	cin >> f.n >> f.m;
	for (int i = 0; i < f.n; i++) {
		string s;
		cin >> s;
		for (int j = 0; j < f.m; j++) {
			f.a[i][j] = s[j];
		}
	}
	f.trim();
	f.moveTo(1000, 1000);
}

int* solve(M& a, M& b, M& c) {

	// case 0 0
	if (a.xor(b).equals(c)) {
		int* ret = new int[3];
		ret[0] = 1;
		ret[1] = a.left - b.left;
		ret[2] = a.top - b.top;
		return ret;
	}

	// y > 0
	int d1 = a.getTopX();
	int d2 = c.getTopX();

	c.move(0, d1 - d2);
	if (a.xor(c).equals(b)) {
		M xx = a.xor(c);
		int* ret = new int[3];
		ret[0] = 1;
		ret[1] = xx.sj - a.sj + a.left - b.left;
		ret[2] = xx.si - a.si + a.top - b.top;
		return ret;
	}
	c.move(0, d2 - d1);

	// x > 0
	d1 = a.getLeftY();
	d2 = c.getLeftY();

	c.move(d1 - d2, 0);
	if (a.xor(c).equals(b)) {
		M xx = a.xor(c);
		int* ret = new int[3];
		ret[0] = 1;
		ret[1] = xx.sj - a.sj + a.left - b.left;
		ret[2] = xx.si - a.si + a.top - b.top;
		return ret;
	}
	c.move(d2 - d1, 0);

	int* ret = new int[3];
	ret[0] = 0;
	return ret;
}

M a, b, c;

int main() {
	freopen("kids.in", "r", stdin);
	freopen("kids.out", "w", stdout);

	read(a);
	read(b);
	read(c);

	int* f = solve(a, b, c);
	if (f[0] == 1) {
		cout << "YES" << endl;
		cout << f[1] << ' ' << f[2] << endl;
		return 0;
	}

	f = solve(b, a, c);
	if (f[0] == 1) {
		cout << "YES" << endl;
		cout << -f[1] << ' ' << -f[2] << endl;
		return 0;
	}

	cout << "NO" << endl;
	return 0;
}
