import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class Abbreviation {
	static String[] s;
	public static void main(String[] args) throws FileNotFoundException {
		Scanner sc = new Scanner(new File("abbreviation.in"));
		PrintWriter pw = new PrintWriter(new File("abbreviation.out"));
		while (sc.hasNextLine()) {
			String temp = sc.nextLine();
			temp = preProcess(temp);
			String[] toks = temp.split(" ");
			StringBuilder line = new StringBuilder();
			for (int i = 0; i < toks.length; i++) {
				String tok = toks[i];
				if (isWord(toks[i])) {
					int len = 1;
					for (int j = i + 1; j < toks.length; j++) {
						if (isWord(toks[j])) len++;
						else break;
					}
					if (len > 1) {
						StringBuilder abbr = new StringBuilder();
						for (int j = i; j < i + len; j++) {
							abbr.append(toks[j].charAt(0));
						}
						line.append(abbr).append(" (");
						for (int j = i; j < i + len; j++) {
							line.append(toks[j]);
							if (j < i + len - 1) line.append(" ");
						}
						line.append(")");
						i = i + len - 1;
					}
					else {
						line.append(toks[i]);
					}
				}
				else {
					line.append(toks[i]);
				}
				if (i < toks.length - 1 || toks[toks.length - 1].equals(",") || toks[toks.length - 1].equals(".")) line.append(" ");
			}
			pw.println(postProcess(line.toString()));
		}
		pw.close();
	}
	
	public static String preProcess(String s) {
		return s.replace(".", " . ").replace(",", " , ");
	}
	
	public static String postProcess(String s) {
		return s.replace(" . ", ".").replace(" , ", ",");
	}
	
	public static boolean isWord(String s) {
		return !s.contains(",") && !s.contains(".") && s.length() > 1 && 
				Character.isUpperCase(s.charAt(0)) && 
				s.substring(1).equals(s.substring(1).toLowerCase());
	}
}
