#include<bits/stdc++.h>

#ifdef _WIN32
	#define I64 "%I64d"
#else
	#define I64 "%lld"
#endif
	
#define ll long long 
#define mp make_pair
#define pb push_back
#define F first
#define S second
#define fname "expect"

using namespace std;

const int maxn = (1e5) + 12;
const int inf = (1e9);

struct item {
	ll key, prior;
	ll val1, val2;
	ll sum1, sum2;
	int sz;
	item * l, * r;
	item() {
		key = prior = 0;
		val1 = val2 = 0;
		sum1 = sum2 = 0;
		sz = 0;
		l = r = 0;
	}
	item(ll val, ll dt) {
//		printf(I64 "+" I64 "\n", val, dt);
		key = val;
		prior = rand() * 1ll  * rand();
		val1 = val * dt;
		val2 = dt;
		sum1 = val1;
		sum2 = val2;
		sz = 1;
		l = r = 0;
	}
};

typedef item * pitem;

ll sz(pitem t) {
	return t ? t -> sz : 0;
}

ll val1(pitem t) {
	return t ? t -> val1 : 0;
}

ll val2(pitem t) {
	return t ? t -> val2 : 0;
}

ll sum1(pitem t) {
	return t ? t -> sum1 : 0;
}

ll sum2(pitem t) {
	return t ? t -> sum2 : 0;
}

void upd(pitem t) {
	if (!t)
		return;
	t -> sz = 1 + sz(t -> l) + sz(t -> r);
	t -> sum1 = sum1(t -> l) + sum1(t -> r) + val1(t);
	t -> sum2 = sum2(t -> l) + sum2(t -> r) + val2(t);
}

void split(pitem t, pitem & l, pitem & r, int key) {
	if (!t) {
		l = r = 0;
		return;
	}
	if (key <= t -> key)
		split(t -> l, l, t -> l, key), r = t;
	else
		split(t -> r, t -> r, r, key), l = t;
	upd(t);
}

void merge(pitem & t, pitem l, pitem r) {
	if (!l || !r) {
		t = l ? l : r;
		return;
	}
	if (l -> prior > r -> prior)
		merge(l -> r, l -> r, r), t = l;
	else
		merge(r -> l, l, r -> l), t = r;
	upd(t);
}

void out(pitem t) {
	if (!t)
		return;
	out(t -> l);
	printf(I64 " " I64 " " I64 " " I64 " " I64  "\n", t -> key, t -> val1, t -> val2, sum1(t), sum2(t));
	out(t -> r);
}

ll calc(pitem t, int k) {
//	printf("Split by %d\n", -k);
	pitem t1, t2;
	split(t, t1, t2, -k);
//	out(t1);
//	puts("--");
//	out(t2);
	ll s1 = sum1(t1), s2 = sum2(t1);
//	printf("\n==\n" I64 " " I64 "\n", s1, s2);
	merge(t, t1, t2);
	return max(0ll, abs(s1 + s2 * k));
}

void insert(pitem & t, ll x, ll y) {
	pitem it = new item(x, y);
	pitem t1, t2;
	split(t, t1, t2, it -> key);
	merge(t, t1, it);
	merge(t, t, t2);
}

pitem root;
pair <ll, ll> a[maxn];

int main() {
	freopen(fname".in", "r", stdin);
	freopen(fname".out", "w", stdout);
	int n, q, v;
	cin >> n >> q;
	a[0] = {0, 0};
	for(int i = 1; i <= n; ++i) {
		char c;
		int t, k;
		cin >> c >> t >> k;
		if(c == '-')
			a[i] = mp(a[i - 1].F - k, t);
		else
			a[i] = mp(a[i - 1].F + k, t);
		insert(root, a[i].F, a[i].S - a[i - 1].S);
	//	cout << a[i].F << " " << a[i].S << endl;
	}
//	out(root);
//	puts("");
	for(int i = 1; i <= q; ++i) {
		int b;
		cin >> b;
		if (a[n].F < -b)
			puts("INFINITY");
		else
			printf(I64 "\n", calc(root, b));
	}
	return 0;
}

