#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <cstdio>

using namespace std;

struct rec {
	int a, b;
};

string s;
int n;

bool isEnglish(char c) {
	return ('a' <= c && c <= 'z') || ('A' <= c && c <= 'Z');
}

bool isNorm(int l, int r) {
	if (!('A' <= s[l] && s[l] <= 'Z'))
		return false;
	for (int i = l + 1; i <= r; i++)
		if ('A' <= s[i] && s[i] <= 'Z')
			return false;
	return (r - l + 1) > 1;
}

bool isAbbreviation(int l, int r) {
	if (l > 0 && isEnglish(s[l - 1]))
		return false;
	if (r < n - 1  && isEnglish(s[r + 1]))
		return false;
	if (!isEnglish(s[l]) || !isEnglish(s[r]))
		return false;
	for (int i = l + 1; i <= r - 1; i++)
		if (!isEnglish(s[i]) && !isEnglish(s[i - 1]))
			return false;
	for (int i = l + 1; i <= r - 1; i++)
		if (s[i] == ' ' && !isEnglish(s[i - 1]))
			return false;
	int cnt = 0;
	while (l <= r) {
		int i = l;
		while (i <= r && s[i] != ' ')
			i++;
		if (!isNorm(l, i - 1))
			return false;
		l = i + 1;
		cnt++;
	}
	return cnt > 1;
}

int main() {
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);

	while (getline(cin, s)) {
		n = s.length();
		int i = 0, jump;
		bool ok = false;
		while (i < n) {
			ok = false;
			for (int len = n - i; len >= 2; len--) {
				if (isAbbreviation(i, i + len - 1)) {
					ok = true;
					jump = len;
					break;
				}
			}
			if (ok) {
				for (int j = i; j <= i + jump - 1; j++)
					if ('A' <= s[j] && s[j] <= 'Z')
						cout << s[j];
				cout << " (";
				for (int j = i; j <= i + jump - 1; j++)
					cout << s[j];
				cout << ")";
				i += jump;
			} else {
				cout << s[i++];
			}
		}
		cout << endl;
	}

	return 0;
}
