#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <map>
#include <ctype.h>
#include <set>
#include <algorithm>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;

#define _name "jenga"
#define mp make_pair
const int maxlen = 1e5 + 100;

struct T
{
	long long x, y, n;
};

set< pair< int, int > > del;
int n, w, h, m;

vector<T> cm;
vector<ll> l, r;

int test(int i)
{
	if (i >= h)
		return false;
	if (i % 2 == 1)
	{
		ll min_x = l[i-1] * 2*w;
		ll max_x = (r[i - 1]+1) * 2 * w;
		if (cm[i].x <= min_x* cm[i].n || cm[i].x >= max_x * cm[i].n )
		{
			return true;
		}
	}
	else
	{
		ll min_y = l[i - 1] * 2 * w;
		ll max_y = (r[i - 1]+1) * 2 * w;
		if (cm[i].y <= min_y * cm[i].n || cm[i].y >= max_y * cm[i].n )
		{
			return true;
		}
	}
	return false;
}

int main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(_name".in", "r", stdin);
	freopen(_name".out", "w", stdout);
#endif

	scanf("%d %d %d %d", &n, &w, &h, &m);
	cm.resize(h+1);
	l.resize(h+1);
	r.resize(h+1);
	for (int i = 0; i < h; i++)
	{
		l[i] = 0;
		r[i] = n - 1;
	}
	for (int i = h-1; i >= 0; i--)
	{
		cm[i].n = n*(h - i);
		cm[i].x = 1LL * cm[i].n * n * w;
		cm[i].y = 1LL * cm[i].n * n * w;
	}

	for (int i = 0; i < m; i++)
	{
		int cur_h, cur_n;
		scanf("%d %d", &cur_h, &cur_n);
		cur_h--;
		cur_n--;

		del.insert(make_pair(cur_h, cur_n));

		while (l[cur_h] < n && del.count(make_pair(cur_h, l[cur_h])) )
			l[cur_h]++;
		while (r[cur_h] >= 0 && del.count(make_pair(cur_h, r[cur_h])))
			r[cur_h]--;


		ll x, y;
		if (cur_h % 2 == 0)
		{
			x = 2*cur_n*w+w;
			y = n*w;
		}
		else
		{
			x = n*w;
			y = 2*cur_n*w + w;
		}
		bool crash = test(cur_h + 1);
		for (int i = cur_h; i > 0; i--)
		{
			cm[i].x -= x;
			cm[i].y -= y;
			cm[i].n--;

			if (crash)
				continue;
			crash |= test(i);
		}
		if (crash)
		{
			cout << "yes" << endl << i + 1 << endl;
			return 0;
		}
	}
	cout << "no" << endl;
	return 0;
}