#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second
#define mp make_pair
#define pb push_back
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define forn(i, n) for(int i = 0; i < int(n); i++)
#define fore(i, l, r) for(int i = int(l); i < int(r); i++)

template <class A, class B> ostream& operator << (ostream& out, const pair<A, B> &a) {
	return out << "(" << a.x << ", " << a.y << ")";
}

template <class A> ostream& operator << (ostream& out, const vector<A> &a) {
	out << "[";
	forn(i, sz(a)) {
		if(i) out << ", ";
		out << a[i];
	}
	return out << "]";
}

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;
const ld PI = acosl(-1.0);
const int MOD = INF + 7;
mt19937 myrand(time(NULL));

#define FILENAME "jenga"

const int N = 5555;

li sumx[N];
li sumy[N];
li w[N];
vector<int> del[N];

int n, wd, h, m;
pt q[N];

bool read() {
	if(!(cin >> n >> wd))
		return false;
	assert(cin >> h >> m);
	forn(i, m) {
		assert(cin >> q[i].x >> q[i].y);
		q[i].x--, q[i].y--;
	}
	return true;
}

inline bool checkIn(int ch, li xx, li xm) {
	bool hl = false;
	bool hr = false;
	bool in = false;
	if (w[ch] == 0)
		return false;		
	if((xx & 1) || xm > 0) {
		int px = xx;
		if(!(xx & 1))
			px++;
					
		in = true;
		forn(i, sz(del[ch])) {
			if(del[ch][i] != px)
				continue;
			in = false;
			break;
		}
	}
	
	if(del[ch].empty() || del[ch][0] != 1)
		hl = true;
	
	if(del[ch].empty() || del[ch].back() != 2 * n - 1)
		hr = true;
	
	forn(i, sz(del[ch])) {
		int cx = del[ch][i];
				
		for(int dx = -2; dx <= 2; dx += 4) {
			int gx = cx + dx;

			if(gx < 1 || gx > 2 * n - 1)
				continue;
		 	if(i > 0 && del[ch][i - 1] == gx)
		 		continue;
		 	if(i + 1 < sz(del[ch]) && del[ch][i + 1] == gx)
		 		continue;
				 		
		 	if(gx - 1 < xx || ((gx - 1) == xx && xm > 0))
		 		hl = true;
		 	if(gx + 1 > xx)
		 		hr = true;
		}
	}
			
	if(!in && !(hl && hr))
		return false;
	return true;
}

bool check()
{
	li curw = 0;
	li curx = 0;
	li cury = 0;
	for (int ch = h - 1; ch >= 0; ch--)
	{
		curx += sumx[ch + 1];
		cury += sumy[ch + 1];
		curw += w[ch + 1];
		
		if (curw == 0) continue;
		
		li xx, xm;
		if (ch & 1)
		{
			xx = curx / curw;
			xm = curx % curw;
		}
		else
		{
			xx = cury / curw;
			xm = cury % curw;
		}
		
		if(!checkIn(ch, xx, xm))
		{
//		    cerr << xx << " " << xm << endl;
//			cerr << "!" << ch << endl;
			return false;
		}
	}
	return true;
}

inline void ins(int ch, int pos) {
	w[ch]--;
	if(ch & 1) {
		sumx[ch] -= 2 * pos + 1;
		sumy[ch] -= n;
	} else {
		sumx[ch] -= n;
		sumy[ch] -= 2 * pos + 1;
	}
	del[ch].pb(2 * pos + 1);
	int p = sz(del[ch]) - 1;
	while(p > 0 && del[ch][p - 1] > del[ch][p])
		swap(del[ch][p - 1], del[ch][p]), p--;
}

void solve() {
	forn(i, h) {
		w[i] = n;
		sumx[i] = n * 1ll * n;
		sumy[i] = n * 1ll * n;
	}
	
	forn(i, m) {
		int ch = q[i].x;
		int pos = q[i].y;
		
		ins(ch, pos);
		
		if(!check()) {
			cout << "yes\n" << i + 1 << endl;
			return;
		}
	}
	
	cout << "no\n";
}

int main() {

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);

	int tt = clock();

#else
	freopen(FILENAME".in", "r", stdin);
	freopen(FILENAME".out", "w", stdout);
	
#endif

	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);

	while(read()) {
	
		solve();
		
#ifdef _DEBUG

		cerr << "TIME = " << clock() - tt << " ms\n";
		tt = clock();
		
#endif

	}
	
	return 0;
}