#include <vector>
#include <iomanip>
#include <iostream>
#include <fstream>
#include <string>

#define ll long long

using namespace std;

int main() {
	freopen("foreign.in", "r", stdin);
	freopen("foreign.out", "w", stdout);
	string T; cin >> T;
	double curr_ev = 0.0, sum_ev = 0.0;
	string S(T.rbegin(), T.rend());
	vector<ll> corr_sum(S.length() + 1, 0);
	vector<ll> incorr_sum(S.length() + 1, 0);
	for (int i = 1; i <= S.length(); ++i) {
		corr_sum[i] = corr_sum[i - 1] + (S[i - 1] == 'C');
		incorr_sum[i] = incorr_sum[i - 1] + (S[i - 1] == 'W');
	}
	vector<ll> corr_sum_sum(corr_sum.size() + 1, 0);
	vector<ll> incorr_sum_sum(corr_sum.size() + 1, 0);
	for (int i = 1; i <= S.length(); ++i) {
		corr_sum_sum[i] = corr_sum_sum[i - 1] + corr_sum[i - 1];
		incorr_sum_sum[i] = incorr_sum_sum[i - 1] + incorr_sum[i - 1];
	}
	for (int i = 1; i <= S.length(); ++i) {
		double next_ev = sum_ev / i;
		char t = S[i - 1];
		double stack_ev = 0.0;
		/*for (int k = 1; k <= i; ++k) {
			auto& summ_arr = (t == 'C' ? incorr_sum : corr_sum);
			stack_ev += summ_arr[i] - summ_arr[i - k];
		}*/
		auto& summ_arr = (t == 'C' ? incorr_sum : corr_sum);
		auto& summ_summ_arr = (t == 'C' ? incorr_sum_sum : corr_sum_sum);
		stack_ev = i * summ_arr[i] - summ_summ_arr[i];
		stack_ev /= i;
		next_ev += stack_ev;
		curr_ev = next_ev;
		sum_ev += next_ev;
	}
	cout << setprecision(16);
	cout << fixed << curr_ev << "\n";
}
