#include <vector>
#include <iomanip>
#include <iostream>
#include <fstream>
#include <string>
#include <assert.h>

#define ll long long
#define mp make_pair
#define ff first
#define ss second

using namespace std;

const int PINF = 32767, NINF = -32768;

inline int convert(int num) {
	return num+NINF;
}

int main() {
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);
	/* Input & parsing */
	vector<pair<int, int>> constraints;
	while (!cin.eof()) {
		string op;
		cin >> op;
		if (op != "x") break;
		cin >> op;
		int n1, n2;
		cin >> n1;
		if (op == "<=") {
			constraints.push_back(mp(NINF, n1));
			cin >> op;
			if (op != "||") break;
		} else {
			cin >> op;
			if (op == "&&") {
				cin >> op;
				if (op != "x") break;
				cin >> op;
				if (op != "<=") break;
				cin >> n2;
				constraints.push_back(mp(n1, n2));
				cin >> op;
				if (op != "||") break;
			} else {
				constraints.push_back(mp(n1, PINF));
				if (op != "||") break;
			}
		}
	}
	/* Solver */
	const int LEN = PINF - NINF + 1;
	bool ok[LEN] = { false };
	for (auto el : constraints) {
		for (int i = el.ff; i <= el.ss; ++i) {
			ok[i - NINF] = true;
		}
	}
	vector<pair<int, int>> compressed;
	bool prev = false;
	int cur_left = 0;
	for (int i = 0; i < LEN; ++i) {
		if (prev) {
			if (!ok[i]) {
				int cur_right = convert(i - 1);
				compressed.push_back(mp(cur_left, cur_right));
				cur_left = convert(i);
				prev = false;
			}
			else if (i == LEN - 1) {
				int cur_right = convert(i);
				compressed.push_back(mp(cur_left, cur_right));
			}
			else continue;
		}
		else {
			if (ok[i]) {
				prev = true;
				cur_left = convert(i);
				--i;
			}
		}
	}
	if (compressed.size() == 0) {
		cout << "false" << endl;
	}
	else {
		int l = compressed[0].ff, r = compressed[0].ss;
		if (l == NINF && r == PINF) {
			cout << "true" << endl;
		}
		else {
			for (int i = 0; i < compressed.size(); ++i) {
				int l = compressed[i].ff,
						r = compressed[i].ss;
				if (l == NINF) {
					cout << "x <= " << r;
				}
				else if (r == PINF) {
					cout << "x >= " << l;
				}
				else {
					cout << "x >= " << l << " && "
							 << "x <= " << r;
				}

				if (i < compressed.size() - 1) {
					cout << " ||";
					cout << "\n";
				}
			}
		}
	}
}
