#include <iostream>
#include <string>
#include <vector>
#include <cmath>

#define ll long long

using namespace std;

int main() {
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
	int n, w; cin >> n >> w;
	int h, m; cin >> h >> m;
	vector<ll> Sx(h, n*n);
	vector<ll> Sy(h, n*n);
	vector<ll> cnt(h, n);
	vector<ll> Lx(h, 0), Ly(h, 0);
	vector<ll> Rx(h, n), Ry(h, n);
	vector<vector<int>> blocks_left(h, vector<int>(n, true));
	bool found = false;
	int first_layer = 0;
	for (int i = 0; i < m; ++i) {
		int l, k; cin >> l >> k;
		int pos = h - l;
		blocks_left[pos][k - 1] = false;
		cnt[pos]--;
		Sx[pos] -= ((pos + 1) % 2) * (2 * k - 1);
		Sy[pos] -= ((pos) % 2) * (2 * k - 1);

		Sy[pos] -= ((pos + 1) % 2) * (n);
		Sx[pos] -= ((pos) % 2) * (n);
		int new_l = 0, new_r = n - 1;
		for (; new_l < n; ++new_l) {
			if (blocks_left[pos][new_l]) break;
		}
		for (; new_r >= 0; --new_r) {
			if (blocks_left[pos][new_r]) break;
		}
		if (new_r < 0 && pos == first_layer) {
			++first_layer;
			continue;
		}
		if (pos % 2 == 0) {
			Lx[pos] = new_l; Rx[pos] = new_r+1;
		}
		else {
			Ly[pos] = new_l; Ry[pos] = new_r+1;
		}

		ll sum_x = 0, sum_y = 0, sum_cnt = 0;
		for (int layer = first_layer; layer < h-1; ++layer) {
			sum_x += Sx[layer];
			sum_y += Sy[layer];
			sum_cnt += cnt[layer];
			ll left_bound_x = 2 * sum_cnt * Lx[layer + 1];
			ll right_bound_x = 2 * sum_cnt * Rx[layer + 1];
			ll left_bound_y = 2 * sum_cnt * Ly[layer + 1];
			ll right_bound_y = 2 * sum_cnt * Ry[layer + 1];
			if (!(sum_x > left_bound_x &&
					sum_x < right_bound_x &&
					sum_y > left_bound_y &&
					sum_y < right_bound_y)) {
				found = true;
				cout << "yes\n" << i + 1;
				goto finish;
			}
		}
	}
	finish:
	if (!found) cout << "no";
	cout << "\n";
	return 0;
}