#include <iostream>
#include <stdlib.h>
#include <cstdio>
#include <cctype>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
using namespace std;

typedef long long ll;

double eps = 1e-8;
bool LE(double a, double b)
{
    return (a < b + eps);
}

int main() {
#ifndef _CONSOLE
    freopen("jenga.in","r",stdin);
    freopen("jenga.out", "w", stdout);
#else
    freopen("A.in", "r", stdin);
#endif

    ll n, w;
    cin >> n >> w;
    int h, m;
    cin >> h >> m;
    vector<ll> v(h,n);
    for (int i = 1; i < h; ++i)
    {
        v[i] = v[i - 1] + n;
    }
    ll back = v.back();
    for (int i = v.size()-1; i >0 ; --i)
    {
        v[i] = back - v[i - 1];
    }
    vector<pair<double, double> > mid(h);
    
    for (int i = 1; i < h; ++i)
    {
        mid[i] = make_pair((w*n / 2.)*(v[i]), (w*n / 2.)*(v[i]));
    }
    /*vector<set<int> > still(h);
    for (int i = 0; i < h; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            still[i].insert(j);
        }
    }
    */
    
    vector<vector<char> > used(h, vector<char>(n, true));
    vector<int> ptrl(h, 0), ptrr(h, n-1);


    for (int i = 0; i < m; ++i)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        bool fl = a%2 == 0;//check
        for (int j = 1; j <= a; ++j)
        {
         
            if (fl)
            {
                mid[j].first -= w*b + w / 2.;
                mid[j].second -= w*n / 2.;
            }
            else
            {
                mid[j].second -= w*b + w / 2.;
                mid[j].first-= w*n / 2.;
            }
            v[j]--;


        }
        //still[a].erase(b);
        used[a][b] = false;
        while (ptrl[a] < n && !used[a][ptrl[a]])
        {
            ptrl[a]++;
        }

        while (ptrr[a] >= 0 && !used[a][ptrr[a]])
        {
            ptrr[a]--;
        }
        
        for (int j = 1; j < h; ++j)
        {
            int grl = ptrl[j - 1];
            int grr = ptrr[j - 1];
            bool fl2 = (j - 1) % 2 == 0;
            double l = w*grl;
            double r = w*grr + w;
            double mx = mid[j].first / v[j];
            double my = mid[j].second / v[j];

            if (fl2)
            {
                if (LE(mx, l) || LE(r, mx))
                {
                    cout << "yes\n" << i + 1;
                    return 0;
                }
            }
            else
            {
                if (LE(my, l) || LE(r, my))
                {
                    cout << "yes\n" << i + 1;
                    return 0;
                }
            }
        }
        
    }
    
    cout << "no";
    return 0;
}