#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <vector>
#include <functional>
#include <string>
#include <sstream>
#include <iterator>
#include <queue>

#include <cstdlib>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cassert>

typedef long long ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 7;
const ll LINF = (ll)INF * INF;

using namespace std;

#define PROBLEM "abbreviation"

struct TIME___ {
	clock_t start;
	TIME___() : start(clock()) {}
	~TIME___() {
#ifdef _DEBUG
		cout << "\n\nTime: " << (double)(clock() - start) / CLOCKS_PER_SEC << '\n';
#endif
	}
};

TIME___ time____;


bool last_space = false;

void flush(vector<string> &v) {
	if (v.empty()) {
		if (last_space) cout << " ";
		return;
	}

	if (v.size() == 1) {
		cout << v[0];
		v.clear();
		if (last_space) cout << " ";
		return;
	}

	for (auto it = v.begin(); it != v.end(); ++it) {
		cout << (*it)[0];
	}

	cout << " (";
	for (auto it = v.begin(); it != v.end(); ++it) {
		cout << *it;
		if (it + 1 != v.end()) cout << ' ';
	}
	cout << ")";
	v.clear();
	if (last_space) cout << " ";
}

bool check(const string &str) {
	if (str.length() < 2) {
		return false;
	}
	if (str[0] < 'A' || str[0] > 'Z') {
		return false;
	}
	for (auto it = str.begin() + 1; it != str.end(); ++it) {
		if (*it < 'a' || *it > 'z') return false;
	}
	return true;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(PROBLEM ".in", "r", stdin);
	freopen(PROBLEM ".out", "w", stdout);
#endif

	ios_base::sync_with_stdio(false);

	string str;

	while (getline(cin, str)) {
		string curr_word;
		vector<string> words;
		last_space = false;

		str += "\n";

		for (char ch : str) {
			if ((ch >= 'A' && ch <= 'Z') || (ch >= 'a' && ch <= 'z')) {
				curr_word += ch;
				last_space = false;
			} else if (ch == ' ' && !last_space) {
				if (!curr_word.empty()) {
					if (!check(curr_word)) {
						bool space = !words.empty();
						flush(words);
						cout << (space ? " " : "") << curr_word << " ";
					} else {
						words.push_back(curr_word);
						last_space = true;
					}
					curr_word = "";
				} else {
					flush(words);
					cout << ch;
					last_space = false;
				}
			} else {
				if (!check(curr_word)) {
					bool space = !words.empty() && !last_space;
					flush(words);
					cout << (space ? " " : "") << curr_word;
				} else {
					words.push_back(curr_word);
					flush(words);
				}
				curr_word = "";

				cout << ch;
				last_space = false;
			}
		}
	}


	return 0;
}
