#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <vector>
#include <functional>
#include <string>
#include <sstream>
#include <iterator>
#include <queue>

#include <cstdlib>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cassert>

typedef long long ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 7;
const ll LINF = (ll)INF * INF;

using namespace std;

#define PROBLEM "expect"

struct TIME___ {
	clock_t start;
	TIME___() : start(clock()) {}
	~TIME___() {
#ifdef _DEBUG
		cout << "\n\nTime: " << (double)(clock() - start) / CLOCKS_PER_SEC << '\n';
#endif
	}
};

TIME___ time____;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(PROBLEM ".in", "r", stdin);
	freopen(PROBLEM ".out", "w", stdout);
#endif

	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n, q;
	cin >> n >> q;

	vector<ll> prefix_sum(n);
	vector<ll> length(n);
	vector<pair<ll, int>> prefix_events;


	ll answer = 0;
	ll cnt = 0;
	int last_t;

	for (int i = 0; i != n; ++i) {
		char op;
		int t, k;
		cin >> op >> t >> k;

		if (i != 0) {
			length[i - 1] = t - last_t;
			if (prefix_sum[i - 1] < 0) cnt += length[i - 1];
		}
		prefix_sum[i] = (i == 0 ? 0 : prefix_sum[i - 1]) + (op == '+' ? k : -k);

		if (i != 0 && prefix_sum[i - 1] < 0) answer += -prefix_sum[i - 1] * length[i - 1];
		if (prefix_sum[i] < 0 || i == n - 1) prefix_events.emplace_back(prefix_sum[i], i);

		last_t = t;
	}

	sort(prefix_events.rbegin(), prefix_events.rend());

	vector<pair<int, int>> requests(q);
	for (int i = 0; i != q; ++i) {
		cin >> requests[i].first;
		requests[i].second = i;
	}

	sort(requests.begin(), requests.end());
	int prefix_events_pos = 0;

	vector <ll> ret(q);

	ll last = 0;
	bool inf = true;

	for (int i = 0; i != q; ++i) {
		while (prefix_events_pos != prefix_events.size() && prefix_events[prefix_events_pos].first + requests[i].first >= 0) {
			int pos = prefix_events[prefix_events_pos].second;

			if (pos == n - 1) {
				inf = false;
				++prefix_events_pos;
				continue;
			}

			answer -= (-last - prefix_events[prefix_events_pos].first) * length[pos];
			cnt -= length[pos];

  			++prefix_events_pos;
		}

		answer -= (requests[i].first - last) * cnt;
		last = requests[i].first;
		ret[requests[i].second] = inf ? -1 : answer;
	}

	for (int i = 0; i != q; ++i) {
		if (ret[i] == -1) {
			cout << "INFINITY\n";
		} else {
			cout << ret[i] << '\n';
		}
	}

	return 0;
}
