#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <vector>
#include <functional>
#include <string>
#include <sstream>
#include <iterator>
#include <queue>

#include <cstdlib>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cassert>

typedef long long ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 7;
const ll LINF = (ll)INF * INF;

using namespace std;

#define PROBLEM "foreign"

struct TIME___ {
	clock_t start;
	TIME___() : start(clock()) {}
	~TIME___() {
#ifdef _DEBUG
		cout << "\n\nTime: " << (double)(clock() - start) / CLOCKS_PER_SEC << '\n';
#endif
	}
};

TIME___ time____;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(PROBLEM ".in", "r", stdin);
	freopen(PROBLEM ".out", "w", stdout);
#endif

	ios_base::sync_with_stdio(false);
	cin.tie(0);

	string str;
	getline(cin, str);
	reverse(str.begin(), str.end());

	int n = str.size();

	vector<double> dp(n);
	vector<double> dp_sum(n);
	vector<double> c_sum(n);
	vector<double> w_sum(n);

	if (str[0] == 'W') w_sum[0] = 1;
	if (str[0] == 'C') c_sum[0] = 1;

	for (int i = 1; i != n; ++i) {
		dp[i] = dp_sum[i - 1] + (str[i] == 'W' ? c_sum[i - 1] : w_sum[i - 1]);
		dp[i] /= (i + 1);
		dp_sum[i] = dp[i] + dp_sum[i - 1];

		c_sum[i] = c_sum[i - 1];
		w_sum[i] = w_sum[i - 1];
		(str[i] == 'W' ? w_sum : c_sum)[i] += (i + 1);
	}

	cout.precision(30);
	cout << fixed << dp.back() << '\n';

	return 0;
}
