#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <vector>
#include <functional>
#include <string>
#include <sstream>
#include <iterator>
#include <queue>

#include <cstdlib>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cassert>

typedef long long ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 7;
const ll LINF = (ll)INF * INF;

using namespace std;

#define PROBLEM "hard"

struct TIME___ {
	clock_t start;
	TIME___() : start(clock()) {}
	~TIME___() {
#ifdef _DEBUG
		cout << "\n\nTime: " << (double)(clock() - start) / CLOCKS_PER_SEC << '\n';
#endif
	}
};

TIME___ time____;

struct Event {
	int time;
	bool open;

	Event(int time, bool open) : time(time), open(open) {}

	bool operator<(Event const &e) const {
		if (time == e.time) {
			return open > e.open;
		}
		return time < e.time;
	}
};

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(PROBLEM ".in", "r", stdin);
	freopen(PROBLEM ".out", "w", stdout);
#endif

	vector<Event> events;

	int left = -(1 << 15);
	int right = (1 << 15);

	ios_base::sync_with_stdio(false);

	string str;
	while (getline(cin, str)) {
		stringstream ss;
		ss << str;

		vector<string> words;
		while (ss >> str) words.push_back(str);

		if (words.size() <= 4) {
			if (words[1] == ">=") {
				events.emplace_back(stoi(words[2]), true);
				events.emplace_back(right, false);
			} else {
				events.emplace_back(left, true);
				events.emplace_back(stoi(words[2]) + 1, false);
			}
		} else {
			if (stoi(words[2]) > stoi(words[6])) {
				continue;
			}

			events.emplace_back(stoi(words[2]), true);
			events.emplace_back(stoi(words[6]) + 1, false);

			
		}
	}

	if (events.empty()) {
	    cout << "false\n";
	    return 0;
	}

	sort(events.begin(), events.end());

	vector<pair<int, int>> res;
	int curr_left = left;
	int balance = 0;

	for (Event const &e : events) {
		if (e.open) {
			if (!balance++) curr_left = e.time;
		} else {
			if (!--balance) res.emplace_back(curr_left, e.time);
		}
	}

	for (auto it = res.begin(); it != res.end(); ++it) {
		if (it->first == left && it->second == right) {
			cout << "true";
		} else if (it->first == left) {
			cout << "x <= " << it->second - 1;
		} else if (it->second == right) {
			cout << "x >= " << it->first;
		} else {
			cout << "x >= " << it->first << " && x <= " << it->second - 1;
		}

		if (it + 1 != res.end()) {
			cout << " ||";
		}
		cout << '\n';
	}

	return 0;
}
