#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <vector>
#include <functional>
#include <string>
#include <sstream>
#include <iterator>
#include <queue>

#include <cstdlib>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cassert>

typedef long long ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 7;
const ll LINF = (ll)INF * INF;

using namespace std;

#define PROBLEM "jenga"

struct TIME___ {
	clock_t start;
	TIME___() : start(clock()) {}
	~TIME___() {
#ifdef _DEBUG
		cout << "\n\nTime: " << (double)(clock() - start) / CLOCKS_PER_SEC << '\n';
#endif
	}
};

TIME___ time____;

const int N = (int)1e4 + 2;
const int H = (int)5e3 + 5;

bool u[H][N];
int l[H], r[H];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(PROBLEM ".in", "r", stdin);
	freopen(PROBLEM ".out", "w", stdout);
#endif
	int n, w, h, m;
	scanf("%d%d\n%d%d", &n, &w, &h, &m);
	for (int i = 0; i < h; ++i) {
		r[i] = n - 1;
	}
	memset(u, 1, sizeof u);
	for (int i = 0; i < m; ++i) {
		int lv, k;
		scanf("%d%d", &lv, &k);
		--lv, --k;
		u[lv][k] = 0;
		int x = 0;
		int col = 0;
		for (int j = 0; j < m; ++j) {
			x += (u[lv][j] ? j : 0), col += u[lv][j];
		}
		l[lv] = n - 1, r[lv] = 0;
		for (int j = 0; j < m; ++j) {
			if (u[lv][j] && l[lv] > j) {
				l[lv] = j;
			}
			if (u[lv][j] && r[lv] < j) {
				r[lv] = j;
			}
		}
		if (lv > 0 && (x > col * r[lv - 1] || x < col * l[lv - 1])) {
			printf("yes\n%d", i + 1);
			return 0;
		}
		if (lv < h - 1) {
			int xx = 0, coll = 0;
			for (int j = 0; j < m; ++j) {
				xx += (u[lv + 1][j] ? j : 0), coll += u[lv + 1][j];
			}
			if (xx >= coll * r[lv] || xx <= coll * l[lv]) {
				printf("yes\n%d", i + 1);
				return 0;
			}
		}
	}
	puts("no");

		
	return 0;
}
