#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <vector>
#include <functional>
#include <string>
#include <sstream>
#include <iterator>
#include <queue>

#include <cstdlib>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cassert>

typedef long long ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 7;
const ll LINF = (ll)INF * INF;

using namespace std;

#define PROBLEM "jenga"

struct TIME___ {
	clock_t start;
	TIME___() : start(clock()) {}
	~TIME___() {
#ifdef _DEBUG
		cout << "\n\nTime: " << (double)(clock() - start) / CLOCKS_PER_SEC << '\n';
#endif
	}
};

TIME___ time____;

const int N = (int)1e4 + 2;
const int H = (int)5e3 + 5;

bool u[H][N];
int l[H], r[H], sum[H], col[H];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(PROBLEM ".in", "r", stdin);
	freopen(PROBLEM ".out", "w", stdout);
#endif
	int n, w, h, m;
	scanf("%d%d\n%d%d", &n, &w, &h, &m);
	for (int i = 0; i < h; ++i) {
		r[i] = 2 * n - 2;
		sum[i] = n * (n - 1);
		col[i] = n;
	}
	memset(u, 1, sizeof u);
	for (int i = 0; i < m; ++i) {
		int lv, k;
		scanf("%d%d", &lv, &k);
		--lv, --k;
		--col[lv];
		sum[lv] -= 2 * k;
		u[lv][k] = 0;
		l[lv] = 2 * n, r[lv] = -2;
		for (int j = 0; j < n; ++j) {
			if (u[lv][j] && l[lv] > 2 * j) {
				l[lv] = 2 * j;
			}
			if (u[lv][j] && r[lv] < 2 * j) {
				r[lv] = 2 * j;
			}
		}
		long long sx = 0, sy = 0, cnt = 0;
		for (int j = h - 1; j >= 1; --j) {
			if (j % 2 == 1) {
				sx += sum[j], sy += (n - 1) * col[j], cnt += col[j];
				if (sy <= cnt * (l[j - 1] - 1) || sy >= cnt * (r[j - 1] + 1)) {
					puts("yes");
					printf("%d", i + 1);
					return 0;
				}
			} else {
				sx += (n - 1) * col[j], sy += sum[j], cnt += col[j];
				if (sx <= cnt * (l[j - 1] - 1) || sx >= cnt * (r[j - 1] + 1)) {
					puts("yes");
					printf("%d", i + 1);
					return 0;
				}
			}
		}
	}
	puts("no");
	return 0;
}
