import java.io.*;
import java.util.StringTokenizer;

public class A {

    BufferedReader reader;
    StringTokenizer tok;
    PrintWriter out;

    String nextToken() throws IOException {
        if (tok == null || !tok.hasMoreElements()) {
            String line = reader.readLine();
            if (line == null) {
                return null;
            }
            tok = new StringTokenizer(line);
        }
        return tok.nextToken();
    }

    Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    Double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static void main(String[] args) throws IOException {
        A main = new A();
        main.open();
        main.solve();
        main.close();
    }

    private void close() {
        out.flush();
    }

    private void solve() throws IOException {
        while (true) {
            String curWord = reader.readLine();
            if (curWord == null) break;
            StringBuilder lineAnsw = new StringBuilder("");
            StringBuilder abbr = new StringBuilder("");
            int abbrStart = -1, prevEnd = -1, abbrEnd = -1;
            char[] line = curWord.toCharArray();
            int i = 0;
            while (i < line.length && (isSpace(line[i]))) {
                lineAnsw.append(line[i]);
                i++;
            }
            while (i < line.length) {
                int end = parseWord(line, i);
                boolean canBeAbbr = canBeAbbr(line, i, end);
                if (canBeAbbr && (
                        prevEnd == -1 || line[prevEnd] == ' ' && prevEnd + 1 == i)) {
                    if (abbrStart == -1) abbrStart = i;
                    abbr.append(line[i]);
                    abbrEnd = end;
                } else {
                    boolean flushed = flushAbbr(lineAnsw, abbr, abbrStart, abbrEnd, line, i);
                    if (canBeAbbr) {
                        abbrStart = i;
                        abbrEnd = end;
                        abbr = new StringBuilder();
                        abbr.append(line[i]);
                    } else {
                        abbrStart = -1;
                        abbr = new StringBuilder("");
                        int printEnd = end;
                        while (printEnd < line.length && isSpace(line[printEnd]))
                            printEnd++;
                        for (int j =
//                             flushed ? i : (prevEnd > 0 ? prevEnd : 0)
                             i
                             ; j < printEnd; j++) {
                            lineAnsw.append(line[j]);
                        }
                    }
                }
                i = end;
                while (i < line.length && isSpace(line[i])) i++;

                prevEnd = end;
            }
            flushAbbr(lineAnsw, abbr, abbrStart, abbrEnd, line, line.length);
            out.println(lineAnsw.toString());
        }
    }

    private boolean isSpace(char c) {
        return c == ' ' || c == '.' || c == ',';
    }

    private boolean flushAbbr(StringBuilder lineAnsw, StringBuilder abbr, int abbrStart, int abbrEnd, char[] line, int end) {
        int abrLen = abbr.length();
        if (abrLen >= 1) {
            if (abrLen > 1) lineAnsw.append(abbr).append(" (");
            for (int j = abbrStart; j < abbrEnd; j++) {
                lineAnsw.append(line[j]);
            }
            if (abrLen > 1) lineAnsw.append(')');
            for (int i = abbrEnd; i < end; i++) {
                lineAnsw.append(line[i]);
            }
            return true;
        }
        return false;
    }

    private boolean canBeAbbr(char[] line, int i, int end) {
        int len = end - i;
        if (len < 2) return false;
        if (!Character.isUpperCase(line[i])) return false;
        for (i = i + 1; i < end; i++) {
            if (Character.isUpperCase(line[i])) return false;
        }
        return true;
    }

    private int parseWord(char[] line, int i) {
        while (i < line.length && line[i] != ' ' && line[i] != '.' && line[i] != ',')
            i++;
        return i;
    }

    private void open() throws FileNotFoundException {
        reader = new BufferedReader(new InputStreamReader(new FileInputStream("abbreviation.in")));
        out = new PrintWriter("abbreviation.out");
    }

}
