import java.io.*;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

public class F {

    BufferedReader reader;
    StringTokenizer tok;
    PrintWriter out;

    String nextToken() throws IOException {
        if (tok == null || !tok.hasMoreElements()) {
            String line = reader.readLine();
            if (line == null) {
                return null;
            }
            tok = new StringTokenizer(line);
        }
        return tok.nextToken();
    }

    Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    Double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static void main(String[] args) throws IOException {
        F main = new F();
        main.open();
        main.solve();
        main.close();
    }

    private void close() {
        out.flush();
    }

    private void solve() throws IOException {
        String s = nextToken();
        int n = s.length();
//        int[] suffW = new int[n];
//        for (int i = n - 1; i >= 0; i--) {
//            suffW[i] = (s.charAt(i) == 'W' ? 1 : 0);
//            if (i + 1 < n) {
//                suffW[i] += suffW[i + 1];
//            }
//        }
        long[] wQuant = new long[n];
        long[] cQuant = new long[n];
        for (int i = n - 1; i >= 0; i--) {
            if (i == n - 1) {
                cQuant[i] = (s.charAt(i) == 'C' ? 1 : 0);
                wQuant[i] = (s.charAt(i) == 'W' ? 1 : 0);
                continue;
            }
            if (s.charAt(i) == 'C') {
                cQuant[i] = cQuant[i + 1] + (n - i);
                wQuant[i] = wQuant[i + 1];
            } else {
                cQuant[i] = cQuant[i + 1];
                wQuant[i] = wQuant[i + 1] + (n - i);
            }
        }
        double[] prob = new double[n];
        double[] probSuff = new double[n];
//        double probCurrSum = 0.0;
        for (int i = n - 1; i >= 0; i--) {
            if (i == n - 1) {
                prob[i] = 0.0;
//                probCurrSum += prob[i] * (n - i);
            } else {
//                probCurrSum += prob[i] * (n - i);
                double currProb = probSuff[i + 1];
                if (s.charAt(i) == 'C') {
                    currProb += wQuant[i];
                } else {
                    currProb += cQuant[i];
                }
                currProb /= (n - i);
                prob[i] = currProb;
            }
            probSuff[i] = prob[i];
            if (i < n - 1) {
                probSuff[i] += probSuff[i + 1];
            }
        }
        out.println(prob[0]);
    }

    private void open() throws FileNotFoundException {
        reader = new BufferedReader(new InputStreamReader(new FileInputStream("foreign.in")));
        out = new PrintWriter("foreign.out");
    }

}
