import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.StringTokenizer;

public class Main {

    BufferedReader reader;
    StringTokenizer tok;
    PrintWriter out;

    String nextToken() throws IOException {
        if (tok == null || !tok.hasMoreElements()) {
            String line = reader.readLine();
            if (line == null) {
                return null;
            }
            tok = new StringTokenizer(line);
        }
        return tok.nextToken();
    }

    Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    Double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Main main = new Main();
        main.open();
        main.solve();
        main.close();
    }

    private void close() {
        out.flush();
    }

    private void solve() throws IOException {
        int big = 1000000000;
        int delta = 32768;
        int quantity = (1 << 16);
        boolean[] used = new boolean[quantity];
        int[] start = new int[quantity];
        int[] end = new int[quantity];
        while (true) {
            String line = reader.readLine();
            StringTokenizer tokenizer = new StringTokenizer(line);
            tokenizer.nextToken();
            String firstOperator = tokenizer.nextToken();
            int leftEdge = Integer.parseInt(tokenizer.nextToken());
            int rightEdge = big;
            boolean lastLine = (!tokenizer.hasMoreElements());
            String middleToken = null;
            if (!lastLine) {
                if (tokenizer.hasMoreElements()) {
                    middleToken = tokenizer.nextToken();
                    if (!"||".equals(middleToken)) {
                        tokenizer.nextToken();
                        tokenizer.nextToken();
                        rightEdge = Integer.parseInt(tokenizer.nextToken());
                        lastLine = (!tokenizer.hasMoreElements());
                    } else {
                        lastLine = false;
                    }
                } else {
                    lastLine = true;
                }
            }
            if (middleToken != null && "&&".equals(middleToken)) {
                if (leftEdge <= rightEdge) {
                    start[leftEdge + delta]++;
                    end[rightEdge + delta]++;
                }
            } else if (">=".equals(firstOperator)) {
                start[leftEdge + delta]++;
                end[quantity - 1]++;
            } else if ("<=".equals(firstOperator)) {
                start[0]++;
                end[leftEdge + delta]++;
            }
            if (lastLine) {
                break;
            }
        }
        long counter = 0;
        for (int i = 0; i < quantity; i++) {
            counter += start[i];
            if (counter > 0) {
                used[i] = true;
            }
            counter -= end[i];
        }
        boolean hasTrue = false;
        boolean hasFalse = false;
        for (int i = 0; i < quantity; i++) {
            if (used[i]) {
                hasTrue = true;
            } else {
                hasFalse = true;
            }
        }
        if (hasTrue && !hasFalse) {
            out.println("true");
        } else if (hasFalse && !hasTrue) {
            out.println("false");
        } else {
            List<Integer> starts = new ArrayList<>();
            List<Integer> ends = new ArrayList<>();
            int foundStart = -1;
            for (int i = 0; i < quantity; i++) {
                if (foundStart == -1) {
                    if (used[i]) {
                        foundStart = i;
                    }
                } else {
                    if (!used[i]) {
                        starts.add(foundStart);
                        ends.add(i - 1);
                        foundStart = -1;
                    }
                }
            }
            if (foundStart != -1) {
                starts.add(foundStart);
                ends.add(quantity - 1);
            }
            for (int i = 0; i < starts.size(); i++) {
                int currStart = starts.get(i) - delta;
                int currEnd = ends.get(i) - delta;
                if (currStart == -delta) {
                    out.print("x <= " + currEnd);
                } else if (currEnd == delta - 1) {
                    out.print("x >= " + currStart);
                } else {
                    out.print("x >= " + currStart + " && x <= " + currEnd);
                }
                if (i != starts.size() - 1) {
                    out.println(" ||");
                }
            }
        }
    }

    private void flushAbbr(StringBuilder lineAnsw, StringBuilder abbr, int abbrStart, char[] line, int end) {
        int abrLen = abbr.length();
        if (abrLen >= 1) {
            if(abrLen > 1) lineAnsw.append(abbr).append(" (");
            for (int j = abbrStart; j < end; j++) {
                lineAnsw.append(line[j]);
            }
            if(abrLen > 1) lineAnsw.append(')');
        }
    }

    private boolean canBeAbbr(char[] line, int i, int end) {
        int len = end - i;
        if (len < 2) return false;
        if (!Character.isUpperCase(line[i])) return false;
        for (i = i + 1; i < end; i++) {
            if (Character.isUpperCase(line[i])) return false;
        }
        return true;
    }

    private int parseWord(char[] line, int i) {
        while (i < line.length && line[i] != ' ' && line[i] != '.' && line[i] != ',')
            i++;
        return i;
    }

    private void open() throws FileNotFoundException {
        reader = new BufferedReader(new InputStreamReader(new FileInputStream("hard.in")));
        out = new PrintWriter("hard.out");
    }

}
