#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <utility>
#include <fstream>

struct T {
	int sign, t, k;
};

int main() {
	std::ifstream cin("expect.in");
	std::ofstream cout("expect.out");

	int n, q;
	cin >> n >> q;

	std::vector<T> vec(n);
	for (int i = 0; i < n; i++) {
		char ch;
        int t, k;
		cin >> ch >> t >> k;
		vec[i] = T{ ch != '+' ? 1 : -1, t, k };
	}

	std::vector<long long> ans(q, -1);
	std::vector<std::pair<int, int>> b(q);
	for (int i = 0; i < q; i++) {
		cin >> b[i].first;
		b[i].second = i;
	}

	std::sort(b.begin(), b.end());

	std::vector<int> bal(n);
	for (int i = 0; i < n; i++) {
		bal[i] += vec[i].sign * vec[i].k;
		if (i > 0)
			bal[i] += bal[i - 1];
	}

	int min_b = bal[n - 1];

	long long sum_x = 0, sum_wait = 0;
	std::pair<int, int> ind{ 0, 0 };

	while (ind.second < q && b[ind.second].first < min_b) {
		ind.second++;
	}

	struct P {
		int x, id, flag;
		bool operator< (const P& other) const {
			return id < other.id;
		}
    };

	std::vector<std::pair<int, P>> vec_bal;
	min_b = std::max(min_b, 0);
    for (int i = 0; i < n; i++) {
		if (bal[i] - min_b > 0) {
			P p{0, i, 0};
			if (vec[i].sign && i + 1 < n) {
				p.x = vec[i + 1].t - vec[i].t;
				p.flag = 1;
			}
			else if(vec[i].sign == 0) {
				p.x = vec[i].t - vec[i - 1].t;
			}
			vec_bal.push_back({ bal[i], p});
		}
	}

	std::sort(vec_bal.begin(), vec_bal.end());

    for (int i = 0; i < n; i++) {
		if (bal[i] - min_b > 0) {
			long long dist = 0;
			if (i == 0)
				dist = vec[i].t;
			else
				dist = vec[i].t - vec[i - 1].t;
			sum_wait += (bal[i] - min_b) * dist;
			sum_x += dist;
		}
	}

	while (ind.first < vec_bal.size() && ind.second < q) {
		int v1 = vec_bal[ind.first].first,
			v2 = b[ind.second].first;
		if (v2 <= v1) {
			sum_wait -= (v2 - min_b) * sum_x;
            ans[b[ind.second].second] = sum_wait;
            min_b = v2;
			ind.second++;
			continue;
		}

		sum_wait -= (v1 - min_b) * sum_x;
		sum_x -= vec_bal[ind.first].second.x;
		min_b = v1;
		ind.first++;
	}

	while (ind.second < q) {
		ans[b[ind.second].second] = 0;
		ind.second++;
	}

	for (int i = 0; i < q; i++) {
		long long a = ans[i];
		if (a == -1)
			cout << "INFINITY\n";
		else
			cout << a << '\n';
	}

	return 0;
}