#include <iostream>
#include <vector>
#include <set>
#include <utility>
#include <fstream>

int main() {
	std::ifstream in("jenga.in");
	std::ofstream out("jenga.out");

	long long n, w;
	in >> n >> w;
	long long h, m;
	in >> h >> m;
	std::vector<long long> sums1(h / 2), sums0((h + 1) / 2);
	std::vector<long long> mins0((h + 1) / 2), mins1(h / 2);
	std::vector<long long> maxs0((h + 1) / 2), maxs1(h / 2);
	std::vector<long long> counts0((h + 1) / 2), counts1(h / 2);
	std::set<std::pair<long long, long long>> removed0, removed1;
	long long middle = n;
	if (n % 2 == 1) {
		middle += 1;
	}
	for (long long i = 0; i < h; ++i) {
		if (i % 2 == 0) {
			sums0[i / 2] = middle * i * n;
			mins0[i / 2] = 1;
			maxs0[i / 2] = 2 * n - 1;
			counts0[i / 2] = i * n;
		}
		else {
			sums1[i / 2] = middle * i * n;
			mins1[i / 2] = 2 - 1;
			maxs1[i / 2] = 2 * n - 1;
			counts1[i / 2] = i * n;
		}
	}

	for (long long step = 0; step < m; ++step) {
		long long level, index;
		in >> level >> index;
		level = h - level;
		if (level % 2 == 0) {
			level /= 2;
			for (long long i = level + 1; i < sums0.size(); ++i) {
				counts0[i]--;
				sums0[i] -= 2 * index - 1;
			}
			for (long long i = level; i < sums1.size(); ++i) {
				counts1[i]--;
				sums1[i] -= middle;
			}
			removed0.insert(std::make_pair(level, index));
			if (mins0[level] == 2 * index - 1) {
				long long current = index + 1;
				while (removed0.count(std::make_pair(level, current))) {
					current += 1;
				}
				mins0[level] = 2 * current - 1;
			}
			if (maxs0[level] == 2 * index - 1) {
				long long current = index - 1;
				while (removed0.count(std::make_pair(level, current))) {
					current -= 1;
				}
				maxs0[level] = 2 * current - 1;
			}
			if (mins0[level] > maxs0[level] && counts0[level] > 0) {
				out << "yes" << std::endl;
				out << step + 1 << std::endl;
				return 0;
			}
			for (long long i = level; i < sums0.size(); ++i) {
				long long left = mins0[i] * counts0[i];
				long long right = maxs0[i] * counts0[i];
				if (sums0[i] < left || right < sums0[i]) {
					out << "yes" << std::endl;
					out << step + 1 << std::endl;
					return 0;
				}
			}
		}
		else {
			level /= 2;
			for (long long i = level + 1; i < sums1.size(); ++i) {
				counts1[i]--;
				sums1[i] -= 2 * index - 1;
			}
			for (long long i = level + 1; i < sums0.size(); ++i) {
				counts0[i]--;
				sums0[i] -= middle;
			}
			removed1.insert(std::make_pair(level, index));
			if (mins1[level] == 2 * index - 1) {
				long long current = index + 1;
				while (removed1.count(std::make_pair(level, current))) {
					current += 1;
				}
				mins1[level] = 2 * current - 1;
			}
			if (maxs1[level] == 2 * index - 1) {
				long long current = index - 1;
				while (removed1.count(std::make_pair(level, current))) {
					current -= 1;
				}
				maxs1[level] = 2 * current - 1;
			}
			if (mins1[level] > maxs1[level] && counts1[level] > 0) {
				out << "yes" << std::endl;
				out << step + 1 << std::endl;
				return 0;
			}
			for (long long i = level; i < sums1.size(); ++i) {
				long long left = mins1[i] * counts1[i];
				long long right = maxs1[i] * counts1[i];
				if (counts1[i] == 0) {
					continue;
				}
				if (sums1[i] < left || right < sums1[i]) {
					out << "yes" << std::endl;
					out << step + 1 << std::endl;
					return 0;
				}
			}
		}
	}
	out << "no" << std::endl;

	return 0;
}