import sys


FILENAME = 'hard'
sys.stdin = open(FILENAME + '.in')
sys.stdout = open(FILENAME + '.out', 'w')


def main():
    MINUS_INF = -32768
    PLUS_INF = 32767

    text = sys.stdin.read()
    lines = text.replace(' ||', '').splitlines()
    events = []
    for line in lines:
        line = line.strip()
        if not line:
            continue
        conds = [item.split() for item in line.split(' && ')]
        if len(conds) == 1:
            if conds[0][1] == '<=':
                l, r = MINUS_INF, int(conds[0][2])
            elif conds[0][1] == '>=':
                l, r = int(conds[0][2]), PLUS_INF
        else:
            l, r = int(conds[0][2]), int(conds[1][2])

        if l <= r:
            events += [(l, 1), (r, -1)]
    events.sort(key=lambda item: (item[0], -item[1]))

    compressed_events = []
    count = 0
    for coord, event_type in events:
        new_count = count + event_type
        if not count and new_count:
            if compressed_events and compressed_events[-1] == (coord - 1, 'closed'):
                compressed_events.pop()
            else:
                compressed_events.append((coord, 'opened'))
        elif count and not new_count:
            compressed_events.append((coord, 'closed'))
        count = new_count

    if not compressed_events:
        print('false')
        return
    if compressed_events == [(MINUS_INF, 'opened'), (PLUS_INF, 'closed')]:
        print('true')
        return

    answer = []
    for coord, event_type in compressed_events:
        if coord == MINUS_INF or coord == PLUS_INF:
            continue
        if event_type == 'opened':
            answer.append('x >= {} && '.format(coord))
        elif event_type == 'closed':
            answer.append('x <= {} ||\n'.format(coord))

    answer = ''.join(answer) + '$'
    answer = answer.replace(' && $', '')
    answer = answer.replace(' ||\n$', '')
    print(answer.replace('$', ''))


if __name__ == '__main__':
    main()
    sys.stdout.flush()
