#include <iostream>
#include <stdio.h>
#include <string>
#include <vector>
#include <algorithm>
#include <utility>
#include <set>

using namespace std;

typedef long long ll;

const int MAX_H = 2 * 5000;

set<int> removed_blocks[MAX_H];
ll level_k[MAX_H];
ll level_l[MAX_H];
ll level_r[MAX_H];
ll  level_sum[MAX_H];

void init(int n, int h) {
	ll sum = (1 +n) * n / 2;
	for (int i = 0; i <= h; ++i) {
		level_k[i] = n;
		level_l[i] = 1;
		level_r[i] = n;
		level_sum[i] = 2 * sum - n;
	}
}

bool inner_check(int h, int n, int z) {
	ll k = 0;
	ll sum = 0;

	//xmass = sum / k;
	for (int i = h; i >= 0; i--) {
		if (i % 2 != z) {
			ll t = level_k[i];
			k += t;
			sum += n * t;
			continue;
		}

		if (k == 0)
			continue;

		//cerr << "wtf" << " " << i << " " << ((double)sum) / (2 * k) << "\n";
		if ( 2 * (level_l[i] - 1) * k >= sum
            || sum >= 2 * level_r[i] * k) {
			
			return false;
		}
		k += level_k[i];
		sum += level_sum[i];
	}

	return true;
}

bool check(int h, int n) {
	while (h > 0 && level_k[h] == 0)
		--h;

	if (h == 0) return true;
	for (int i = h; i > 0; --i)
		if (level_k[i] == 0)
			return false;

	return inner_check(h, n, 0) && inner_check(h, n, 1);
}

void remove_block(int i, int pos) {
	level_sum[i] -= (pos*2 - 1);
	level_k[i]--;

	removed_blocks[i].insert(pos);

	if (level_k[i] == 0) {
		level_l[i] = level_r[i] = 0;
		return;
	}

	if (level_l[i] == pos) {
		auto it = removed_blocks[i].find(pos);
		it++;
		pos++;
		while (it != removed_blocks[i].end() && (*it == pos) ) {
			pos++;
			it++;
		}
		level_l[i] = pos;
	}
	else if (level_r[i] == pos) {
		auto it = removed_blocks[i].find(pos);
		while (it != removed_blocks[i].begin() && (*it == pos)) {
			pos--;
			it--;
		}
		if (*it == pos)
            pos--;

		level_r[i] = pos;
	}
}

int main() {
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);

	int n, w, h, m;
	cin >> n >> w >> h >> m;

	init(n, h);

	for (int i = 0; i < m; ++i) {
		int l, k;
		cin >> l >> k;
		remove_block(l, k);
		if (!check(h, n)) {
			cout << "yes\n";
			cout << (i + 1) << "\n";
			return 0;
		}
	}

	cout << "no\n";
	return 0;
}