#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>
#include <queue>
#include <fstream>
using namespace std;
typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair<long long, long long> pii;

long long n, q;
long long t[200105], k[200105];
char z[2];
pii query[200105];
pair<long long, ll> res[200105];

int main()
{
    ios_base::sync_with_stdio(false);
    freopen("expect.in", "r", stdin);
    freopen("expect.out", "w", stdout);

    cin >> n >> q;
    for (long long i = 0; i < n; ++i) {
        cin >> z >> t[i] >> k[i];
        if (*z == '-')
            k[i] = -k[i];
    }
    for (long long i = 0; i < q; ++i) {
        cin >> query[i].first;
        query[i].second = i;
    }

//    n = 100000;
//    q = 2;
//    for (long long i = 0; i < n; ++i) {
//        t[i] = i + 1;
//        k[i] = -10000;
//    }
//    query[0] = make_pair(1000000000, 0);
//    query[1] = make_pair(1000000000 - 1, 1);

    sort(query, query + q);
    long long delta = 0;
    for (long long i = 0; i < n; ++i)
        delta += k[i];
    if (delta > 0)
        delta = 0;
    delta = -delta;
    long long curidx = 0;
    while (curidx < q && query[curidx].first < delta)
        res[curidx] = make_pair(query[curidx].second, ll(9e18)), ++curidx;

    long long cycles = delta;
    vector<pair<pii, long long> > v;
    queue< pii > qu; /// TIME/COUNT
    ll ans = 0;
    for (long long i = 0; i < n || qu.size(); ++i) {
        if (i < n) {
            if (k[i] > 0) {
                cycles += k[i];
            } else {
                qu.push(make_pair(t[i], -k[i]));
            }
        }
        while (cycles > 0 && qu.size()) {
            if (qu.front().second <= cycles) {
                v.push_back(make_pair(make_pair(qu.front().first, 0), qu.front().second));
                v.push_back(make_pair(make_pair(t[i], 1), qu.front().second));
                ans += (t[i] - qu.front().first) * 1ll * qu.front().second;
                cycles -= qu.front().second;
                qu.pop();
            } else {
                v.push_back(make_pair(make_pair(qu.front().first, 0), cycles));
                v.push_back(make_pair(make_pair(t[i], 1), cycles));
                ans += (t[i] - qu.front().first) * 1ll * cycles;
                qu.front().second -= cycles;
                cycles = 0;
            }
        }
    }

    sort(v.begin(), v.end());
    vector<long long> stk;
    vector<pair<pii, long long> > st; /// HEIGHT/TYPE/LEN
    long long balance = 0;
    for (long long i = 0; i < v.size(); ++i) {
        if (v[i].first.second == 0) {
            stk.push_back(v[i].first.first);
            balance += v[i].second;
        } else {
            if (stk.back() != v[i].first.first) {
                st.push_back(make_pair(make_pair(delta + balance - v[i].second, 0), v[i].first.first - stk.back()));
                st.push_back(make_pair(make_pair(delta + balance, 1), v[i].first.first - stk.back()));

            }
            balance -= v[i].second;
            stk.pop_back();
        }
    }

    sort(st.begin(), st.end());
    //for (long long i = 0; i < st.size(); ++i)
    //    cerr << st[i].first.first << " "          << st[i].first.second << " " << st[i].second << endl;

    while (curidx < q && query[curidx].first == delta)
        res[curidx] = make_pair(query[curidx].second, ans), ++curidx;

    ll curlen = 0;
    long long stidx = 0;
    long long prevpos = 0;
    while (curidx < q) {
        while (stidx < st.size() && st[stidx].first.first <= query[curidx].first) {
            ans -= (st[stidx].first.first - prevpos) * curlen;
            prevpos = st[stidx].first.first;
            if (st[stidx].first.second == 0)
                curlen += st[stidx].second;
            else
                curlen -= st[stidx].second;
            ++stidx;
        }
        long long nextidx = curidx;
        while (nextidx < q && query[curidx].first == query[nextidx].first)
            res[nextidx] = make_pair(query[nextidx].second, ans - curlen * (query[curidx].first - prevpos)), ++nextidx;
        curidx = nextidx;
    }

    sort(res, res + q);
    for (long long i = 0; i < q; ++i) {
        if (res[i].second == ll(9e18)) cout << "INFINITY\n";
        else cout << res[i].second << "\n";
    }

    return 0;
}
