#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <string>
#include <set>
using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

/*
This is ACM North Eastern European Regional Contest,
sponsored by Internationak Business Machines.
The. Best. Contest. Ever.
A Great Opportunityt for all contestants.
*/
/*
void solve_a() {
	vector<string> a(1, "");
	while (!cin.eof()) {
		string line;
		bool ff = false;
		getline(cin, line);
		string wr = "";
		for (int i = 0; i < line.length(); ++i) {
			if (isalpha(line[i])) {
				wr += line[i];
			}
			else {
				if (isupper(wr[0]) && wr.length() > 1) {
					bool is = true;
					for (int j = 1; j < wr.length(); ++j) {
						if (isupper(wr[j])) {
							is = false;
							break;
						}
					}
					if (is) {
						a[0] += wr[0];
						a.push_back(wr);
					}
					if (line[i] == ' ' && line[i - 1] != ' ') {
						wr = "";
						continue;
					}
					else {
						ff = true;
					}
				}
				else {
					ff = true;
					cout << wr;
				}
				if (ff) {
					if (a.size() > 2) {
						cout << a[0] << " (";
						for (int j = 1; j < a.size() - 1; ++j) {
							cout << a[j] << ' ';
						}
						cout << a[a.size() - 1] << ')';
					}
					a.clear();
					a.resize(1, "");
				}
				wr = "";
			}
		}
		cout << endl;
	}
}
*/

vi tree;
int trsz = (1 << 16);
void updtree(int l, int r, int v, int vl, int vr) {
	if (r < vl || l > vr) return;
	if (l <= vl && r >= vr) {
		tree[v] = 1;
	}
	else {
		int m = (vl + vr) / 2;
		updtree(l, r, v * 2, vl, m);
		updtree(l, r, v * 2 + 1, m + 1, vr);
	}
}

void updbot(int v, int vl, int vr) {
	if (vl == vr) return;
	if (tree[v]) {
		for (int i = vl; i <= vr; ++i) {
			tree[trsz + i] = 1;
		}
	}
	else {
		int m = (vl + vr) / 2;
		updbot(v * 2, vl, m);
		updbot(v * 2 + 1, m + 1, vr);
	}
}

/*
x >= 5 && x <= 10 ||
x >= 7 && x <= 20 ||
x <= 2 ||
x >= 21 && x <= 25 ||
x >= 8 && x <= 10 ||
x >= 100
*/

void solve_h() {
	tree.assign(trsz * 2, 0);
	while (!cin.eof()) {
		string op, tok;
		int l, r;
		cin >> tok >> op >> l;
		if (!cin.eof()) cin >> tok;
		l += 32768;
		if (tok == "&&") {
			cin >> tok >> op >> r;
			if (!cin.eof()) cin >> tok;
			r += 32768;
			updtree(l, r, 1, 0, trsz - 1);
		}
		else if (tok == "||" || cin.eof()) { // cin.eof()
			if (op == "<=") {
				updtree(0, l, 1, 0, trsz - 1);
			}
			else {
				updtree(l, trsz - 1, 1, 0, trsz - 1);
			}
		}
		else{
			break;
		}
	}
	updbot(1, 0, trsz - 1);
	/*
	for (int i = trsz/2; i < trsz/2 + 200; ++i) {
		cout << i-32768 << ' ' << tree[trsz + i] << endl;
	}*/
	int type = 3;
	for (int i = 1; i < trsz; ++i)
		if (tree[trsz] != tree[trsz + i])
			type = 0;
	if (type != 0) {
		type = tree[trsz] == 0 ? 1 : 2;
	}

	if (type == 0) {
		vector<pii> ans;
		int l = 0, r = 0;
		if (tree[trsz] == 1) {
			while (tree[trsz + r] != 0)
				++r;
			//cout << "x <= " << r - 1 - 32768 << " ||" << endl;
			ans.push_back(make_pair(0, r - 1));
			l = r;
		}
		while (l < trsz) {
			while (l < trsz && tree[trsz + l] == 0) ++l;
			if (l == trsz) break;
			r = l;
			while (r < trsz && tree[trsz + r] == 1) ++r;
			if (r == trsz) break;
			//cout << "x >= " << l - 32768 << " && x <= " << r - 1 - 32768 << " ||" << endl;
			ans.push_back(make_pair(l, r - 1));
			l = r;
		}
		if (l != trsz && r == trsz) {
			ans.push_back(make_pair(l, r - 1));
		}
		for (int i = 0; i < ans.size(); ++i) {
			if (ans[i].first == 0) {
				cout << "x <= " << ans[i].second - 32768;
			}
			else if (ans[i].second == trsz - 1) {
				cout << "x >= " << ans[i].first - 32768;
			}
			else{
				cout << "x >= " << ans[i].first - 32768 << " && x <= " << ans[i].second - 32768;
			}
			if (i < ans.size() - 1) {
				cout << " ||" << endl;
			}
		}
	}
	else if (type == 1) {
		cout << "false";
	}
	else {
		cout << "true";
	}
}

int main() {
#define OJFILE "hard"
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else
	freopen(OJFILE".in", "r", stdin);
	freopen(OJFILE".out", "w", stdout);
#endif
	solve_h();
	return 0;
}