#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <string>
#include <set>
using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

void solve_j() {
	int w, n;
	cin >> n >> w;
	int h, m;
	cin >> h >> m;
	int evlen = h / 2, odlen = (h + 1) / 2; // perpendicualr first
	vector<double> cenev(evlen), cenod(odlen);
	vector<ll> evsz(evlen), odsz(odlen);
	vector<set<int> > evleft(evlen), evright(evlen), odleft(odlen), odright(odlen);
	for (int i = evlen - 1; i >= 0; --i) {
		cenev[i] = (n * w * n / 2.0) * (evlen - i);
		evsz[i] = n * (evlen - i);
		for (int j = 0; j < n; ++j) {
			evleft[i].insert(j * w);
			evright[i].insert((j + 1) * w);
		}
	}
	for (int i = odlen - 1; i >= 0; --i) {
		cenod[i] = (n * w * n / 2.0) * (odlen - i);
		odsz[i] = n * (odlen - i);
		for (int j = 0; j < n; ++j) {
			odleft[i].insert(j * w);
			odright[i].insert((j + 1) * w);
		}
	}

	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		if (x % 2 == 0) { // to us
			x = (x - 1) / 2; --y;
			evleft[x].erase(y * w);
			evright[x].erase((y + 1)*w);
			if (evleft[x].size() == 0 && x != evlen - 1) {
				cout << "yes" << endl << i + 1;
				return;
			} else if (evleft[x].size() == 0) {
				evlen -= 1;
				continue;
			}
			if (evlen != odlen && (*evleft[x].begin() >= w*n / 2.0 || *evleft[x].rbegin() <= w*n / 2.0)) {
				cout << "yes" << endl << i + 1;
				return;
			}
			for (int j = x; j >= 0; --j) {
				cenev[j] -= (y + 0.5) * w;
				evsz[j] -= 1;
				// Check for falling from above
				int lfx = *(evleft[j].begin());
				int rtx = *(evright[j].rbegin());
				if (j == evlen - 1) {
					continue;
				}
				double fl = (double)cenev[j + 1] / (double)evsz[j + 1];
				if (fl <= lfx || fl >= rtx) {
					cout << "yes" << endl << i + 1;
					return;
				}
			}
		}
		else { // perpendicular
			x = x / 2; --y;
			odleft[x].erase(y * w);
			odright[x].erase((y + 1)*w);
			if (odleft[x].size() == 0 && x != odlen - 1) {
				cout << "yes" << endl << i + 1;
				return;
			} else if (odleft[x].size() == 0) {
				odlen -= 1;
				continue;
			}
			if (evlen == odlen && (*odleft[x].begin() >= w*n / 2.0 || *odleft[x].rbegin() <= w*n / 2.0)) {
				cout << "yes" << endl << i + 1;
				return;
			}
			for (int j = x; j >= 0; --j) {
				cenod[j] -= (y + 0.5) * w;
				odsz[j] -= 1;
				// Check for falling from above
				int lfx = *(odleft[j].begin());
				int rtx = *(odright[j].rbegin());
				if (j == odlen - 1) {
					continue;
				}
				double fl = (double)cenod[j + 1] / (double)odsz[j + 1];
				if (fl < lfx || fl > rtx) {
					cout << "yes" << endl << i + 1;
					return;
				}
			}
		}
	}
	cout << "no";
}

int main() {
#define OJFILE "jenga"
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else
	freopen(OJFILE".in", "r", stdin);
	freopen(OJFILE".out", "w", stdout);
#endif
	solve_j();
	return 0;
}