import java.io.*;
import java.util.*;

/**
 * Created by neerc on 04.12.2016.
 */
public class H {
    FastScanner in;
    PrintWriter out;

    public static void main(String[] args) {
        new H().run();
    }

    static class Event {
        int number;
        int tp;

        public Event(int number, int tp) {
            this.number = number;
            this.tp = tp;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            Event event = (Event) o;
            return number == event.number &&
                    tp == event.tp;
        }

        @Override
        public int hashCode() {
            return Objects.hash(number, tp);
        }
    }
    public static final int INF = 1 << 15;
    public static final Event left = new Event(-INF, 0);
    public static final Event right = new Event(INF, 1);

    boolean checkTrue(List<Event> ans) {
        if (ans.size() != 2) {
            return false;
        }
        return ans.get(0).equals(left) && ans.get(1).equals(right);
    }

    void solve() {
        Deque<Event> eventsDeque = new ArrayDeque<>();
        String last;
        boolean canBeFalse = false;
        do {
            boolean flag1 = false;
            boolean flag2 = false;
            in.next(); // x
            String sign = in.next();
            int num = in.nextInt();
            eventsDeque.add(new Event(num + (">=".equals(sign) ? 0 : 1), ">=".equals(sign) ? 0 : 1));
            last = in.next();
            flag1 |= "<=".equals(sign);
            flag2 |= ">=".equals(sign);
            if ("&&".equals(last)) {
                in.next(); // x
                sign = in.next();
                int num2 = in.nextInt();
                eventsDeque.add(new Event(num2 + (">=".equals(sign) ? 0 : 1), ">=".equals(sign) ? 0 : 1));
                last = in.next();
                flag1 |= "<=".equals(sign);
                flag2 |= ">=".equals(sign);
                canBeFalse |= num <= num2;
                if (num > num2) {
                    eventsDeque.removeLast();
                    eventsDeque.removeLast();
                }
            } else {
                canBeFalse = true;
            }
            if (!flag2) {
                eventsDeque.add(left);
            }
            if (!flag1) {
                eventsDeque.add(right);
            }
        } while ("||".equals(last));
        List<Event> events = new ArrayList<>(eventsDeque);

        Collections.sort(events, (a, b) -> {
            if (a.number == b.number) {
                return Integer.compare(a.tp, b.tp);
            } else {
                return Integer.compare(a.number, b.number);
            }
        });
        if (!canBeFalse) {
            out.println("false");
            return;
        }
        int bal = 0;
        List<Event> answer = new ArrayList<>();
        for (Event cur : events) {
            if (bal == 0) {
                answer.add(cur);
            }
            if (cur.tp == 0) {
                bal++;
            } else {
                bal--;
            }
            if (bal == 0) {
                answer.add(cur);
            }
        }
        if (checkTrue(answer)) {
            out.println("true");
        } else {
            ass(answer.size() % 2 == 0);
            for (int i = 0; i < answer.size(); i+=2) {
                int from = answer.get(i).number;
                int to = answer.get(i + 1).number;
                if (from == left.number) {
                    out.printf("x <= %d%s\n", to - 1, i == answer.size() - 2 ? "" : " ||");
                } else if (to == right.number) {
                    out.printf("x >= %d%s\n", from, i == answer.size() - 2 ? "" : " ||");
                } else {
                    out.printf("x >= %d && x <= %d%s\n", from, to - 1, i == answer.size() - 2 ? "" : " ||");
                }
            }
        }
    }

    void ass(boolean flag) {
        if (!flag) throw new AssertionError();
    }

    void run() {
        try {
            in = new FastScanner(new File("hard.in"));
            out = new PrintWriter(new File("hard.out"));

            solve();

            out.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    static class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }

        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (Exception e) {
                    return null;
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }
}
