#include <bits/stdc++.h>

using namespace std;
int n, w, h, m;

struct point {
    double x, y, z;
    point() {}
    point(double _x, double _y, int _z) : x(_x), y(_y), z(_z) {};
    point(double _x, double _y, double _z) : x(_x), y(_y), z(_z) {};
};

point operator*(const point& a, double c) {
    return {a.x * c, a.y * c, a.z * c};
}

point operator+(const point& a, const point& b) {
    return {a.x + b.x, a.y + b.y, a.z + b.z};
}

struct pwm {
    point p;
    int m;
    pwm() {}
    pwm(point _p, int _mass) : p(_p), m(_mass) {}    
};

pwm operator+(const pwm& a, const pwm& b) {
    double alpha = (double) a.m / (a.m + b.m);
    return {a.p * alpha + b.p * (1 - alpha), a.m + b.m};
}

pwm operator-(const pwm& a, const pwm& b) {
    return a + pwm(b.p, -b.m);
}

pwm gcm(int l, int k) {
    if (l & 1) {
        return {{n * w * .5, w * k + w * .5, l}, 1};
    } else {
        return {{w * k + w * .5, n * w * .5, l}, 1};
    }
}

int const H = 5050;
double const eps =1e-8;

ostream& operator<<(ostream& a, const point& p) {
    a.precision(3);
    a << fixed << "(" << p.x << ", " << p.y << ", " << p.z << ")";
    return a;
}

ostream& operator<<(ostream& a, const pwm& p) {
    a << "{ " << p.p << ", " << p.m << " }";
    return a;    
}

pwm levels[H];
int mi[H];
int ma[H];
set<int> dropped[H];
    

int main() {    
    freopen("jenga.in", "r", stdin);
    freopen("jenga.out", "w", stdout);
    scanf("%d%d%d%d", &n, &w, &h, &m);
    //cerr << n << " " << w << " " << h << " " << m << endl;
    for (int i = 0; i < h; ++i) {
        levels[i] = {{(double)n * w / 2, (double)n * w / 2, i}, n};
        mi[i] = 0;
        ma[i] = n - 1;
    }
    for (int i = 0; i < m; ++i) {
        int l, k;
        scanf("%d%d", &l, &k);
        l--;
        k--;                              
        levels[l] = levels[l] - gcm(l, k);
        dropped[l].insert(k);
        if (dropped[l].size() == n) {
            if (l != h - 1) {
                printf("yes\n%d\n", i + 1);
                return 0;
            } else {
                h--;
            }
        } else {                        
            while (dropped[l].count(mi[l])) {
                mi[l]++;
            }
            while (dropped[l].count(ma[l])) {
                ma[l]--;
            }
        }
        pwm cur = {{0, 0, 0}, 0};
        for (int j = h - 1; j > 0; j--) {
            cur = cur + levels[j];
            //cerr << levels[j] << endl;
            double x = cur.p.x;
            double y = cur.p.y;
            double ll = mi[j - 1] * w;
            double rr = (ma[j - 1] + 1) * w;
            //cerr.precision(3);
            //cerr << j << " -> " << ll << " " << rr << " " << cur << endl; 
            if ((j - 1) & 1) {
                //cerr << "y " << endl;
                //y
                if (!(ll + eps < y && y < rr - eps)) {
                    printf("yes\n%d\n", i + 1);
                    return 0;    
                }             
            } else {
                //cerr << "x " << endl;
                //x
                if (!(ll + eps < x && x < rr - eps)) {
                    printf("yes\n%d\n", i + 1);
                    return 0;    
                }
            }                                                         
        }                            
    }
    puts("no");
}