#include <iostream>
#include <fstream>
#include <string>
#include <vector>

using namespace std;
const int LMAX = 125;

string rline;
char s[LMAX + 5];

vector<string> v;

bool isCap(char a) {
	return a >= 'A' && a <= 'Z';
}


bool isLower(char a) {
	return a >= 'a' && a <= 'z';
}


bool isLetter(char a) {
	return isLower(a) || isCap(a);
}

bool goodWord(string s) {
	if (s.length() == 1) return false;
	if (!isCap(s[0])) return false;
	for (int i = 1; i < s.length(); i++)
		if (!isLower(s[i])) return false;

	return true;
}

string getWord(int l, int r) {
	return string(s + l, r - l);
}

string abbr(int l, int r) {
	if (r - l == 1) return v[l];

	bool begspace = v[l] == " ", endspace = v[r - 1] == " ";
	string abb = begspace ? " " : "";
	if (r - l - begspace - endspace == 1) {
		abb += v[l + begspace];
		abb += endspace ? " " : "";
		return abb;
	}
	for (int i = l + begspace; i < r; i += 2)
		abb += v[i][0];

	abb += " (";
	for (int i = l + begspace; i < r - endspace; i++) {
		abb += v[i];
	}
	abb += ")";
	if (endspace) abb += " ";
	return abb;
}

void solve() {
	v.clear();
	string rline;
	int l = -1, r = 0;

	bool isWord = true;
	string ss;
	for (int i = 0; s[i] != '\0';) {
		l = i;
		while (s[i] != '\0' && (isWord && isLetter(s[i]) || !isWord && !isLetter(s[i]))) {
			i++;
		}
		v.push_back(getWord(l, i));
		isWord = !isWord;
	}

	vector<bool> vb(v.size());
	for (int i = 0; i < v.size(); i++) {
		if (i & 1) {
			//not w
			vb[i] = v[i] == " ";
		}
		else {
			vb[i] = goodWord(v[i]);
		}
	}
	for (int i = 0; i < vb.size(); i++) {
		if (vb[i]) {
			int j;
			for (j = i + 1; j < vb.size(); j++) {
				if (!vb[j]) break;
			}
			cout << abbr(i, j);
			i = j - 1;
		}
		else {
			cout << v[i];
		}

	}

	cout << endl;
}

int main()
{
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);

	while (cin.getline(s, LMAX, '\n')) {
		solve();
	}

	return 0;
}