#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

const int CCHAR = 105;
const int CMAX = 32767;
const int CMIN = -32768;

typedef pair <int, int> ii;

int numFromStr(string s)
{
	bool negative = s[0] == '-';
	if (negative) s = s.substr(1);
	int res = 0;
	for (int i = 0; i < s.length(); i++)
	{
		res *= 10;
		res += s[i] - '0';
	}
	if (negative) res *= -1;
	return res;
}

bool mas[2 * (CMAX - CMIN) + 10000];

void add(int l, int r, int k = 1, int L = CMIN, int R = CMAX)
{
	//if (k == 1) cout << "L -> " << l << " R -> " << r << endl;

	if (r < l) return;
	if (mas[k]) return;
	if (l <= L && R <= r) { mas[k] = true; return; }
	if (r < L || l > R) return;

	add(l, r, k * 2, L, (L + R - 1) / 2);
	add(l, r, k * 2 + 1, (L + R - 1) / 2 + 1, R);
}

vector <ii> v;

void look(int k = 1, int L = CMIN, int R = CMAX)
{
	//cout << "k -> " << k << " L " << L << " R " << R << endl;

	if (mas[k]) { v.push_back(ii(L, R)); return; }
	if (L == R) return;

	look(k * 2, L, (L + R - 1) / 2);
	look(k * 2 + 1, (L + R - 1) / 2 + 1, R);
}

int main()
{
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);

	bool more;
	string num, sign;
	bool and;
	bool or;

	while (1)
	{
		int l = CMIN;
		int r = CMAX;

		cin >> num >> sign >> num;
		more = sign == ">=";
		cin >> sign;

		if (more) l = numFromStr(num);
		else r = numFromStr(num);

		if (sign == "&&")
		{
			cin >> sign >> sign >> num >> sign;
			r = numFromStr(num);
			add(l, r);
			if (sign == "||") continue;
			else break;
		}
		else
		{
			add(l, r);
			if (sign == "||") continue;
			else break;
		}
	}

	look();

	

	//sort(v.begin(), v.end());

	/*cout << "--------------------" << endl;
	for (int i = 0; i < v.size(); i++) {
		cout << v[i].first << " --- " << v[i].second << endl;
	}
	cout << "--------------------" << endl;*/

	vector <ii> res;

	if (v.size() == 0) { cout << "false" << endl; return 0; }

	for (int i = 0; i < v.size(); i++) {
		ii cur = v[i];
		for (int j = i + 1; j < v.size(); j++) {
			if (v[j].first == cur.second + 1) {
				cur.second = v[j].second;
			}
			else {
				i = j - 1;
				break;
			}
		}
		res.push_back(cur);
		if (cur.second == v.back().second) break;
	}

	/*cout << "----res----------------" << endl;
	for (int i = 0; i < res.size(); i++) {
		cout << res[i].first << " --- " << res[i].second << endl;
	}
	cout << "---res-----------------" << endl;*/

	if (res.size() == 1 && res[0].first == CMIN && res[0].second == CMAX) { cout << "true" << endl; return 0; }

	for (int i = 0; i < res.size(); i++) {
		if (i > 0 && i < res.size() - 1) {
			cout << "x >= " << res[i].first << " && x <= " << res[i].second << " ||" << endl;
			continue;
		}

		if (i == 0) {
			if (res[0].first == CMIN) {
				cout << "x <= " << res[0].second;
				if (res.size() > 1) cout << " ||";
				cout << endl;
			}
			else {
				cout << "x >= " << res[i].first;
				if (res[0].second != CMAX) cout << " && x <= " << res[i].second;
				if (res.size() > 1) cout << " ||";
				cout << endl;
			}
			continue;
		}

		if (i == res.size() - 1) {
			cout << "x >= " << res[i].first;
			if (res[i].second != CMAX) {
				cout << " && x <= " << res[i].second;
			}
			cout << endl;
		}

	}

	return 0;
}