import java.io.*;
import java.util.ArrayDeque;
import java.util.Deque;
import java.util.StringTokenizer;

/**
 * Created by neerc on 04.12.2016.
 */
public class Solution implements Runnable {
  public static void main(String[] args) {
    new Thread(new Solution()).start();
  }

  BufferedReader in;
  PrintWriter out;
  StringTokenizer tok = new StringTokenizer("");
  String fileName = "abbreviation";

  public void init() {
    if (fileName.equals("")) {
      in = new BufferedReader(new InputStreamReader(System.in));
      out = new PrintWriter(System.out);
    } else {
      try {
        in = new BufferedReader(new FileReader(fileName + ".in"));
      } catch (FileNotFoundException e) {
        e.printStackTrace();
      }
      try {
        out = new PrintWriter(fileName + ".out");
      } catch (FileNotFoundException e) {
        e.printStackTrace();
      }
    }
  }

  public String readString() {
    while (!tok.hasMoreTokens()) {
      try {
        tok = new StringTokenizer(in.readLine());
      } catch (IOException e) {
        e.printStackTrace();
      }
    }
    return tok.nextToken();
  }

  int readInt() {
    return Integer.parseInt(readString());
  }

  @Override
  public void run() {
    init();
    try {
      solve();
    } catch (IOException e) {
      e.printStackTrace();
    }
    out.close();
  }

  public void solve() throws IOException {
    Deque<String> deque = new ArrayDeque<>();
    while (in.ready()) {
      String line = in.readLine();
      char[] lineArr = line.toCharArray();
      String word = "";
      for (int i = 0; i < lineArr.length; i++) {
        if (Character.isAlphabetic(lineArr[i])) {
          word += lineArr[i];
        } else if (!Character.isAlphabetic(lineArr[i])) {
          if (word.length() > 0 && Character.isUpperCase(word.charAt(0))) {
            char[] ww = word.toCharArray();
            boolean flag = false;
            for (int j = 1; j < ww.length; j++) {
              if (Character.isUpperCase(ww[j])) {
                flag = true;
              }
            }
            if (!flag && word.length() > 1) {
              deque.add(word);
              word = "";
              if (lineArr[i] != ' ') {
                if (deque.size() <= 1) {
                  for (String s : deque) {
                    if (flag) {
                      out.print(s + " ");
                    } else {
                      out.print(s);
                      out.print(lineArr[i]);
                      deque.clear();
                    }
                  }
                  deque.clear();
                  out.print(word);
                  word = "";
                  continue;
                } else {
                  String abbr = "";
                  for (String s : deque) {
                    abbr += s.charAt(0);
                  }
                  out.print(abbr + " (");
                  int count = deque.size();
                  int index = 0;
                  for (String s : deque) {
                    if (index != count - 1) {
                      out.print(s + " ");
                    } else {
                      out.print(s + ")");
                    }
                    index++;
                  }
                  deque.clear();
                  if (word.length() > 0) {
                    out.print(' ');
                    out.print(word);
                    word = "";
                  }
                  out.print(lineArr[i]);
                  continue;
                }
              }
            } else {
              //плохое слово -- опустошить стек
              if (deque.size() <= 1) {
                for (String s : deque) {
                  out.print(s + " ");
                }
                deque.clear();
                out.print(word);
                word = "";
                out.print(lineArr[i]);
                continue;
              } else {
                String abbr = "";
                for (String s : deque) {
                  abbr += s.charAt(0);
                }
                out.print(abbr + " (");
                int count = deque.size();
                int index = 0;
                for (String s : deque) {
                  if (index != count - 1) {
                    out.print(s + " ");
                  } else {
                    out.print(s + ")");
                  }
                  index++;
                }
                deque.clear();
                if (word.length() > 0) {
                  out.print(' ');
                  out.print(word);
                  word = "";
                }
                out.print(lineArr[i]);
              }
            }
          } else if (word.length() > 0 && !Character.isUpperCase(word.charAt(0))) {
            //плохое слово -- опустошить стек
            if (deque.size() <= 1) {
              for (String s : deque) {
                out.print(s + " ");
              }
              deque.clear();
              out.print(word);
              word = "";
              out.print(lineArr[i]);
              continue;
            } else {
              String abbr = "";
              for (String s : deque) {
                abbr += s.charAt(0);
              }
              out.print(abbr + " (");
              int count = deque.size();
              int index = 0;
              for (String s : deque) {
                if (index != count - 1) {
                  out.print(s + " ");
                } else {
                  out.print(s + ")");
                }
                index++;
              }
              deque.clear();
              if (word.length() > 0) {
                out.print(' ');
                out.print(word);
                word = "";
              }
              out.print(lineArr[i]);
            }
          } else if(word.length() == 0){
            if (deque.size() <= 1) {
              for (String s : deque) {
                out.print(s + " ");
              }
              deque.clear();
              out.print(word);
              word = "";
              out.print(lineArr[i]);
              continue;
            } else {
              String abbr = "";
              for (String s : deque) {
                abbr += s.charAt(0);
              }
              out.print(abbr + " (");
              int count = deque.size();
              int index = 0;
              for (String s : deque) {
                if (index != count - 1) {
                  out.print(s + " ");
                } else {
                  out.print(s + ")");
                }
                index++;
              }
              deque.clear();
              if (word.length() > 0) {
                out.print(' ');
                out.print(word);
                word = "";
              }
              out.print(lineArr[i]);
            }
          }
        }
      }
      if(word.length() > 0){
        char[] ww = word.toCharArray();
        boolean flag = false;
        for (int j = 1; j < ww.length; j++) {
          if (Character.isUpperCase(ww[j])) {
            flag = true;
          }
        }
        if(!flag && word.length() > 1){
          deque.add(word);
          word = "";
        }
        if(deque.size() == 1){
          out.print(deque.peekFirst());
          deque.clear();
        }
        if(deque.size() > 1){
          String abbr = "";
          for (String s : deque) {
            abbr += s.charAt(0);
          }
          out.print(abbr + " (");
          int count = deque.size();
          int index = 0;
          for (String s : deque) {
            if (index != count - 1) {
              out.print(s + " ");
            } else {
              out.print(s + ")");
            }
            index++;
          }
          deque.clear();
        }
        if(word.length() > 0) out.print(" " + word);
      }
      deque.clear();
      out.println();
    }
  }
}


// This is ACM North Eastern European Regional Contest,
// sponsored by International Business Machines.
// The. Best. Contest. Ever.
// A Great Opportunity for all contestants.