import java.io.*;
import java.util.*;

/**
 * Created by neerc on 04.12.2016.
 */
public class H implements Runnable {
  public static void main(String[] args) {
    new Thread(new H()).start();
  }

  BufferedReader in;
  PrintWriter out;
  StringTokenizer tok = new StringTokenizer("");
  String fileName = "hard";

  public void init() {
    if (fileName.equals("")) {
      in = new BufferedReader(new InputStreamReader(System.in));
      out = new PrintWriter(System.out);
    } else {
      try {
        in = new BufferedReader(new FileReader(fileName + ".in"));
      } catch (FileNotFoundException e) {
        e.printStackTrace();
      }
      try {
        out = new PrintWriter(fileName + ".out");
      } catch (FileNotFoundException e) {
        e.printStackTrace();
      }
    }
  }

  public String readString() {
    while (!tok.hasMoreTokens()) {
      try {
        tok = new StringTokenizer(in.readLine());
      } catch (IOException e) {
        e.printStackTrace();
      }
    }
    return tok.nextToken();
  }

  int readInt() {
    return Integer.parseInt(readString());
  }

  @Override
  public void run() {
    init();
    try {
      solve();
    } catch (IOException e) {
      e.printStackTrace();
    }
    out.close();
  }

  public void solve() throws IOException {
    final long MAX = 32767;
    final long MIN = -32768;
    List<Segment> allSegments = new ArrayList<>();
    while (in.ready()) {
      String line = in.readLine();
      String[] expression = line.split(" ");
      if (line.contains("&&")) {
        long left, right;
        if (expression[1].equals(">=")) {
          left = Long.parseLong(expression[2]);
          right = Long.parseLong(expression[6]);
        } else {
          right = Long.parseLong(expression[2]);
          left = Long.parseLong(expression[6]);
        }
        if (right >= left) {
          allSegments.add(new Segment(left, right));
        }
      } else {
        if (expression[1].equals(">=")) {
          allSegments.add(new Segment(Long.parseLong(expression[2]), MAX));
        } else {
          allSegments.add(new Segment(MIN, Long.parseLong(expression[2])));
        }
      }
    }
    Collections.sort(allSegments);
    for (int i = 0; i < allSegments.size() - 1; i++) {
      long currentLeft = allSegments.get(i).left;
      long currentRight = allSegments.get(i).right;
      long nextLeft = allSegments.get(i + 1).left;
      long nextRight = allSegments.get(i + 1).right;
      if (nextLeft - 1 <= currentRight) {
        if (nextRight <= currentRight) {
          allSegments.remove(i + 1);
          i--;
        } else {
          long newLeft = currentLeft;
          long newRight = nextRight;
          allSegments.remove(i);
          allSegments.get(i).left = newLeft;
          allSegments.get(i).right = newRight;
          i--;
        }
      }
    }
    if (allSegments.size() == 0) {
      out.println("false");
      return;
    }
    if (allSegments.size() == 1 && allSegments.get(0).right == MAX && allSegments.get(0).left == MIN) {
      out.println("true");
      return;
    }
    for (int i = 0; i < allSegments.size(); i++) {
      Segment s = allSegments.get(i);
      if (s.left == MIN) {
        out.print("x <= " + s.right);
      } else if (s.right == MAX) {
        out.print("x >= " + s.left);
      } else {
        out.print("x >= " + s.left + " && " + "x <= " + s.right);
      }
      if (i != allSegments.size() - 1) {
        out.print(" ||\n");
      }
    }
  }

  public class Segment implements Comparable<Segment> {
    long left, right;

    public Segment(long l, long r) {
      this.left = l;
      this.right = r;
    }

    @Override
    public int compareTo(Segment o) {
      int r = Long.compare(this.left, o.left);
      if (r == 0) {
        r = Long.compare(o.right, this.right);
      }
      return r;
    }
  }
}

