#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>

using namespace std;

#define eps 1e-8

struct flor
{
	set<int> out;
	double x, y;
	int n;
};

int main()
{
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
	int n, w;
	cin >> n >> w;
	int h, m;
	cin >> h >> m;
	vector<flor> now;
	for (int i = 0; i < h; i++)
	{
		flor X;
		X.x = (double)w * (double)n / 2.0;
		X.y = (double)w * (double)n / 2.0;
		X.n = n * (h - i);
		now.push_back(X);
	}
	for (int i = 0; i < m; i++)
	{
		int fl, del;
		cin >> fl >> del;
		fl--;
		now[fl].out.insert(del);
		double x, y;
		if (fl % 2 == 0)
		{
			x = (double)w / 2.0 + w * (del - 1);
			y = (double)w * (double)n / 2.0;
		}
		else
		{
			y = (double)w / 2.0 + w * (del - 1);
			x = (double)w * (double)n / 2.0;
		}
		for (int j = 0; j <= fl; j++)
		{
			now[j].x = (now[j].n * now[j].x - x) / (now[j].n - 1);
			now[j].y = (now[j].n * now[j].y - y) / (now[j].n - 1);
			now[j].n--;
		}
		for (int j = 0; j <= min(fl, h - 2); j++)
		{
			int l = 1, r = n;
			if (now[j].out.size() > 0)
			{
				for (auto it = now[j].out.begin(); it != now[j].out.end(); it++)
				{
					if ((*it) != l)
						break;
					else
						l++;
				}
				for (auto it = now[j].out.rbegin(); it != now[j].out.rend(); it++)
				{
					if ((*it) != r)
						break;
					else
						r--;
				}
			}
			double coord;
			if (j % 2 == 0)
				coord = now[j + 1].x;
			else
				coord = now[j + 1].y;
			if (coord - eps < (l - 1)*w)
			{
				cout << "yes\n";
				cout << i + 1;
				return 0;
			}
			if (coord + eps > (r - 1)*w)
			{
				cout << "yes\n";
				cout << i + 1;
				return 0;
			}
		}
	}
	cout << "no";
	return 0;
}