#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef long double dbl;

#define mp make_pair
#define pb push_back

const int MAXM = 5005;
const dbl EPS = 1e-8;

int n, w;
int h, m;
int l[MAXM], k[MAXM];
vector<int> onLayer[MAXM];
bool was[MAXM][MAXM];

struct Point {
	dbl x, y;
	Point(dbl x = 0, dbl y = 0) : x(x), y(y) {}
	Point operator*(dbl p) {
		return Point(x * p, y * p);
	}
	Point operator/(dbl p) {
		return Point(x / p, y / p);
	}
	void operator-=(Point p) {
		x -= p.x;
		y -= p.y;
	}
	Point operator-(Point p) {
		return Point(x - p.x, y - p.y);
	}
	void operator+=(Point p) {
		x += p.x;
		y += p.y;
	}
	Point operator+(Point p) {
		return Point(x + p.x, y + p.y);
	}
};

Point getPoint(int idx, int id) {
	if (id % 2) {
		return Point((k[idx] - 0.5) / n, 0.5);	
	} else {
		return Point(0.5, (k[idx] - 0.5) / n);			
	}
}

int main () {
	ios_base::sync_with_stdio (false);
	cin.tie (0);                
	freopen ("jenga.in", "r", stdin);
	freopen ("jenga.out", "w", stdout);
	cin >> n >> w;
	cin >> h >> m;
	for (int i = 0; i < m; ++i) {
		cin >> l[i] >> k[i];
	}
	for (int i = 0; i < m; ++i) {
		Point p(0, 0);
		dbl V = 0;
		onLayer[l[i]].pb(i);
		was[l[i]][k[i]] = true;
		for (int j = h; j > 0; --j) {
			int lt = 1;
			int rt = n;
			while (lt <= n && was[j][lt]) {
				++lt;
			}
			while (rt > 0 && was[j][rt]) {
				--rt;
			}
			if (lt > rt && V > EPS) {
				cout << "yes\n";
				cout << i + 1 << endl;
				return 0;
			}
			if (j % 2) {
				pair<dbl, dbl> xx = mp((lt - 1.) / n, rt * 1. / n);
				if ((p.x < xx.first + EPS || p.x > xx.second - EPS) && V > EPS) {
					cout << "yes\n";
					cout << i + 1 << endl;
					return 0;
				}
			} else {
				pair<dbl, dbl> yy = mp((lt - 1.) / n, rt * 1. / n);
				if ((p.y < yy.first + EPS || p.y > yy.second - EPS) && V > EPS) {
					cout << "yes\n";
					cout << i + 1 << endl;
					return 0;
				}
			}	
			p = ((p * V) + Point(0.5, 0.5)) * (1. / (V + 1));
			V += 1;               
			for (auto it : onLayer[j]) {
				p = (p * V - getPoint(it, j) * (1. / n)) * n / (V * n - 1);
				V -= 1. / n;
			}
		}
	}
	cout << "no\n";
	return 0;
}