#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
using namespace std;

typedef long long int int64;

int ptr;
string text;

void read()
{
	char c;
	while (scanf("%c", &c) == 1)
		text.push_back(c);
}

bool is_alpha(char c)
{
	return ('a' <= c && c <= 'z') || ('A' <= c && c <= 'Z');
}

bool is_cap_word(string word)
{
	if ((int)word.length() < 2)
		return false;
	
	if (!isupper(word[0]))
		return false;

	for (int i = 1; i < (int)word.length(); i++)
		if (!islower(word[i]))
			return false;

	return true;
}

vector<string> parse_tokens()
{
	vector<string> res;

	while (ptr < (int)text.length())
	{
		if (is_alpha(text[ptr]))
		{
			string s;
			while (ptr < (int)text.length() && is_alpha(text[ptr]))
				s.push_back(text[ptr++]);
			res.push_back(s);
		}
		else
		{
			string s;
			s.push_back(text[ptr++]);
			res.push_back(s);
		}
	}

	return res;
}

void print(vector<string> abr_list)
{
	for (string s : abr_list)
		printf("%c", s[0]);
	printf(" (");
	for (int i = 0; i < (int)abr_list.size(); i++)
	{
		if (i != 0)
			printf(" ");
		printf("%s", abr_list[i].c_str());
	}
	printf(")");
}

int main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#else
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
#endif

	read();
	vector<string> tokens = parse_tokens();
	
	int pos = 0;

	while (pos < (int)tokens.size())
	{
		if (pos + 2 < (int)tokens.size() && is_cap_word(tokens[pos]) && tokens[pos + 1] == " " && is_cap_word(tokens[pos + 2]))
		{
			vector<string> abr_list;
			abr_list.push_back(tokens[pos]);
			abr_list.push_back(tokens[pos + 2]);
			pos += 3;

			while (pos + 1 < (int)text.size() && tokens[pos] == " " && is_cap_word(tokens[pos + 1]))
			{
				abr_list.push_back(tokens[pos + 1]);
				pos += 2;
			}

			print(abr_list);
		}
		else
		{
			printf("%s", tokens[pos].c_str());
			pos++;
		}
	}

	return 0;
}