import java.util.*;
import java.io.*;

public class B {

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	
	static final int MAX_SIZE = 1_100_000;
	
	int[][] go = new int[2][MAX_SIZE];
	{
		Arrays.fill(go[0], -1);
		Arrays.fill(go[1], -1);
	}
	int[] len = new int[MAX_SIZE];
	int size = 1;
	int[] par = new int[MAX_SIZE];
	
	ArrayList<Integer>[] whichVars = new ArrayList[MAX_SIZE];
	{
		for (int i = 0; i < MAX_SIZE; i++) {
			whichVars[i] = new ArrayList<>();
		}
	}
	
	void add(String s, int que, int varId) {
		
		int v = 0;
		for (int i = 0; i < s.length(); i++) {
			char c = s.charAt(i);
			int cc = c != '?' ? c - '0' : que;
			int[] nowGo = go[cc];
			
			if (nowGo[v] == -1) {
				par[size] = v;
				len[size] = len[v] + 1;
				nowGo[v] = size++;
			}
			
			v = nowGo[v];
		}
		
		whichVars[v].add(varId);
	}
	
	List<Integer>[] g, gRev;
	
	void addEdge(int from, int to) {
		
//		System.err.println(from + " " + to);
		
		g[from].add(to);
		gRev[to].add(from);
	}
	
	int[] order;
	int ptr;
	
	int[] color;

	void solve() throws IOException {
		int n = nextInt();
		
		String[] ss = new String[n];
		
		for (int i = 0; i < n; i++) {
			ss[i] = nextToken();
			
			add(ss[i], 0, 2 * i);
			add(ss[i], 1, 2 * i + 1);
		}
		
		int vars = 2 * (n + 2 * size);
		g = new List[vars];
		gRev = new List[vars];
		
		for (int i = 0; i < vars; i++) {
			g[i] = new ArrayList<>();
			gRev[i] = new ArrayList<>();
		}
		
		
		for (int v = 0; v < size; v++) {
			for (int j = 0; j < 2; j++) {
				int u = go[j][v];
				if (u != -1) {
					addEdge(2 * (n + v), 2 * (n + u) + 1);
					addEdge(2 * (n + u), 2 * (n + v) + 1);
				}
			}
			
			if (whichVars[v].size() > len[v] + 2) {
				out.println("NO");
				return;
			}
			
			for (int i = 0; i < whichVars[v].size(); i++) {
				int var = whichVars[v].get(i);
				addEdge(var, 2 * (n + v));
				addEdge(2 * (n + v) + 1, var ^ 1);
				
				for (int j = i + 1; j < whichVars[v].size(); j++) {
					int var2 = whichVars[v].get(j);
					
					addEdge(var, var2 ^ 1);
					addEdge(var2, var ^ 1);
				}
				
			}
		}
		
		for (int v = 1; v < size; v++) {
			int u = par[v];
			
			int upU = 2 * (n + size + u);
			int upV = 2 * (n + size + v);
			int orV = 2 * (n + v);
			
			addEdge(upU, orV ^ 1);
			addEdge(orV, upU ^ 1);
			
			addEdge(upU, upV);
			addEdge(orV, upV);
			addEdge(upV ^ 1, upU ^ 1);
			addEdge(upV ^ 1, orV ^ 1);
		}
		
		order = new int[vars];
		ptr = vars;
		color = new int[vars];
		
		for (int i = 0; i < vars; i++) {
			if (color[i] == 0) {
				dfs1(i);
			}
		}
		
//		System.err.println(Arrays.toString(order));
		
		int comps = 0;
		
		for (int v : order) {
			if (color[v] == -1) {
				dfs2(v, comps++);
			}
		}
		
//		System.err.println(Arrays.toString(color));
		
		for (int i = 0; i < n; i++) {
			if (color[2 * i] == color[2 * i + 1]) {
				out.println("NO");
				return;
			}
		}
		
		out.println("YES");
		for (int i = 0; i < n; i++) {
			char which = color[2 * i] > color[2 * i + 1] ? '0' : '1';
			
			for (int j = 0; j < ss[i].length(); j++) {
				
				char now = ss[i].charAt(j);
				if (now == '?') {
					now = which;
				}
				
				out.print(now);
			}
			out.println();
		}
		
//		for (int i = 0; i < size; i++) {
//			if (color[2 * (n + i)] < color[2 * (n + i) + 1]) {
//				System.err.println("take " + i);
//			} else {
//				System.err.println("don't take " + i);
//			}
//		}
	}
	
	void dfs1(int v) {
		color[v] = -1;
		for (int i = 0; i < g[v].size(); i++) {
			int u = g[v].get(i);
			if (color[u] == 0) {
				dfs1(u);
			}
		}
		order[--ptr] = v;
	}
	
	void dfs2(int v, int cur) {
		color[v] = cur;
		for (int i = 0; i < gRev[v].size(); i++) {
			int u = gRev[v].get(i);
			if (color[u] == -1) {
				dfs2(u, cur);
			}
		}
	}

	void run() {
		try {
			br = new BufferedReader(new FileReader("binary.in"));
			out = new PrintWriter("binary.out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public static void main(String[] args) {
		new B().run();
	}
}

