import java.util.*;
import java.io.*;

public class B {
	
	static class Graph {
		int[] head, next, value;
		int[] cntAdj;
		int size;

		public Graph(int n, int maxSize) {
			head = new int[n];
			cntAdj = new int[n];
			next = new int[maxSize];
			value = new int[maxSize];
			
			size = 0;
			
			Arrays.fill(head, -1);
		}
		
		void add(int from, int to) {
			value[size] = to;
			next[size] = head[from];
			head[from] = size;
			cntAdj[from]++;
			size++;
		}
		
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	
	static final int MAX_SIZE = 1_100_000;
	
	int[][] go = new int[2][MAX_SIZE];
	{
		Arrays.fill(go[0], -1);
		Arrays.fill(go[1], -1);
	}
	int[] len = new int[MAX_SIZE];
	int size = 1;
	int[] par = new int[MAX_SIZE];
	
	Graph whichVars;
	
	void add(String s, int que, int varId) {
		
		int v = 0;
		for (int i = 0; i < s.length(); i++) {
			char c = s.charAt(i);
			int cc = c != '?' ? c - '0' : que;
			int[] nowGo = go[cc];
			
			if (nowGo[v] == -1) {
				par[size] = v;
				len[size] = len[v] + 1;
				nowGo[v] = size++;
			}
			
			v = nowGo[v];
		}
		
//		whichVars[v].add(varId);
		whichVars.add(v, varId);
	}
	
	Graph g, gRev;
	
	void addEdge(int from, int to) {
		
//		System.err.println(from + " " + to);
		
//		g[from].add(to);
//		gRev[to].add(from);
		
		g.add(from, to);
		gRev.add(to, from);
	}
	
	int[] order;
	int ptr;
	
	int[] color;

	void solve() throws IOException {
		int n = nextInt();
		
		String[] ss = new String[n];
		
		
		whichVars = new Graph(MAX_SIZE, 2 * n);
		
		for (int i = 0; i < n; i++) {
			ss[i] = nextToken();
			
			add(ss[i], 0, 2 * i);
			add(ss[i], 1, 2 * i + 1);
		}
		
		
		int vars = 2 * (n + 2 * size);
		g = new Graph(vars, 10_000_000);
		gRev = new Graph(vars, 10_000_000);
		
		for (int v = 0; v < size; v++) {
			for (int j = 0; j < 2; j++) {
				int u = go[j][v];
				if (u != -1) {
					addEdge(2 * (n + v), 2 * (n + u) + 1);
					addEdge(2 * (n + u), 2 * (n + v) + 1);
				}
			}
			
			if (whichVars.cntAdj[v] > len[v] + 2) {
				out.println("NO");
				return;
			}
			
			for (int idx = whichVars.head[v]; idx >= 0; idx = whichVars.next[idx]) {
				int var = whichVars.value[idx];
				addEdge(var, 2 * (n + v));
				addEdge(2 * (n + v) + 1, var ^ 1);
				
				for (int jdx = whichVars.next[idx]; jdx >= 0; jdx = whichVars.next[jdx]) {
					int var2 = whichVars.value[jdx];
					
					addEdge(var, var2 ^ 1);
					addEdge(var2, var ^ 1);
				}
				
			}
		}
		
		for (int v = 1; v < size; v++) {
			int u = par[v];
			
			int upU = 2 * (n + size + u);
			int upV = 2 * (n + size + v);
			int orV = 2 * (n + v);
			
			addEdge(upU, orV ^ 1);
			addEdge(orV, upU ^ 1);
			
			addEdge(upU, upV);
			addEdge(orV, upV);
			addEdge(upV ^ 1, upU ^ 1);
			addEdge(upV ^ 1, orV ^ 1);
		}
		
		order = new int[vars];
		ptr = vars;
		color = new int[vars];
		
		for (int i = 0; i < vars; i++) {
			if (color[i] == 0) {
				dfs1(i);
			}
		}
		
//		System.err.println(Arrays.toString(order));
		
		int comps = 0;
		
		for (int v : order) {
			if (color[v] == -1) {
				dfs2(v, comps++);
			}
		}
		
//		System.err.println(Arrays.toString(color));
		
		for (int i = 0; i < n; i++) {
			if (color[2 * i] == color[2 * i + 1]) {
				out.println("NO");
				return;
			}
		}
		
		out.println("YES");
		for (int i = 0; i < n; i++) {
			char which = color[2 * i] > color[2 * i + 1] ? '0' : '1';
			
			for (int j = 0; j < ss[i].length(); j++) {
				
				char now = ss[i].charAt(j);
				if (now == '?') {
					now = which;
				}
				
				out.print(now);
			}
			out.println();
		}
		
//		for (int i = 0; i < size; i++) {
//			if (color[2 * (n + i)] < color[2 * (n + i) + 1]) {
//				System.err.println("take " + i);
//			} else {
//				System.err.println("don't take " + i);
//			}
//		}
	}
	
	void dfs1(int v) {
		color[v] = -1;
		for (int idx = g.head[v]; idx >= 0; idx = g.next[idx]) {
			int u = g.value[idx];
			if (color[u] == 0) {
				dfs1(u);
			}
		}
		order[--ptr] = v;
	}
	
	void dfs2(int v, int cur) {
		color[v] = cur;
		for (int idx = gRev.head[v]; idx >= 0; idx = gRev.next[idx]) {
			int u = gRev.value[idx];
			if (color[u] == -1) {
				dfs2(u, cur);
			}
		}
	}

	void run() {
		try {
			br = new BufferedReader(new FileReader("binary.in"));
			out = new PrintWriter("binary.out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public static void main(String[] args) {
		new B().run();
	}
}

