import java.util.*;
import java.io.*;

public class E {

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	static class Segment implements Comparable<Segment> {
		int len;
		int y;

		public Segment(int len, int y) {
			this.len = len;
			this.y = y;
		}

		@Override
		public int compareTo(Segment o) {
			return Integer.compare(y, o.y);
		}
	}

	void solve() throws IOException {
		int n = nextInt();
		int q = nextInt();

		Segment[] a = new Segment[n];

		int prev = 0;
		int prevTime = 0;
		for (int i = 0; i < n; i++) {
			char type = nextToken().charAt(0);
			int time = nextInt();
			int count = nextInt();

			a[i] = new Segment(time - prevTime, prev);
			prev += (type == '+' ? count : -count);
			prevTime = time;
			
//			System.err.println(a[i].len + " " + a[i].y);
		}

		final int[] qs = new int[q];
		for (int i = 0; i < q; i++) {
			qs[i] = -nextInt();
		}

		Integer[] order = new Integer[q];
		for (int i = 0; i < q; i++) {
			order[i] = i;
		}

		Arrays.sort(order, new Comparator<Integer>() {

			@Override
			public int compare(Integer o1, Integer o2) {
				return Integer.compare(qs[o1], qs[o2]);
			}

		});

		long[] outp = new long[q];

		Arrays.sort(a);

		long totalSumBottom = 0;
		long totalLen = 0;

		int j = 0;

		for (int i = 0; i < q; i++) {

			Integer qId = order[i];
			int qY = qs[qId];
			
//			System.err.println(qId + " " + qY);

			while (j < n && a[j].y <= qY) {
				totalLen += a[j].len;
				totalSumBottom += (long) a[j].len * a[j].y;
				j++;
			}
			
			if (-qY + prev < 0) {
				outp[qId] = -1;
			} else {
				outp[qId] = (long)totalLen * qY - totalSumBottom;
			}
		}
		
		for (long x : outp) {
			if (x == -1) {
				out.println("INFINITY");
			} else {
				out.println(x);
			}
		}
	}

	void run() {
		try {
			br = new BufferedReader(new FileReader("expect.in"));
			out = new PrintWriter("expect.out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public static void main(String[] args) {
		new E().run();
	}
}
