#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include<string>
#include<vector>
#include<time.h>
#include<set>
#include<map>

using namespace std;

typedef long long int int64;


string st;
double ans;

const int N = 100031;

const long double eps = 1e-10;

int n, m, h, w;

//set<int> alive[N];

int lmost[N], rmost[N];

bool alive[10050][10050];

long double total_W[N], total_WWx[N], total_WWy[N];

struct Block
{
	int x1;
	int y1;
	int x2;
	int y2;
};

Block get_block(int lev_id, int block_id)
{
	// to do
	Block ret;
	ret.x1 = w*(block_id - 1);
	ret.x2 = w*block_id;
	ret.y1 = 0;
	ret.y2 = w*n;
	if (lev_id % 2)
		swap(ret.x1, ret.y1),
		swap(ret.x2, ret.y2);
	return ret;
}

long double get_W(Block b)
{
	long double res = 1.0;
	return res*(b.x2 - b.x1)*(b.y2 - b.y1);
}

long double get_WWx(Block b)
{
	long double mid_x = b.x1 + b.x2;
	mid_x /= 2;
	return mid_x*(b.y2 - b.y1)*(b.x2-b.x1);
}

long double get_WWy(Block b)
{
	long double mid_y = b.y1 + b.y2;
	mid_y /= 2;
	return mid_y*(b.x2 - b.x1)*(b.y2-b.y1);
}

void update_lev(int lev_id)
{
	lmost[lev_id] = m + 1;
	rmost[lev_id] = -1;

	for (int i = 1; i <= n; i++)
	{
		if (alive[lev_id][i])
		{
			lmost[lev_id] = min(lmost[lev_id], i);
			rmost[lev_id] = max(rmost[lev_id], i);
		}
	}
}

Block get_box(int lev_id)
{
	Block b1, b2;
	b1 = get_block(lev_id, lmost[lev_id]);
	b2 = get_block(lev_id, rmost[lev_id]);
	Block ret;
	ret.x1 = min(b1.x1, b2.x1);
	ret.x2 = max(b1.x2, b2.x2);
	ret.y1 = min(b1.y1, b2.y1);
	ret.y2 = max(b1.y2, b2.y2);
	return ret;
}

bool is_inside(long double val, long double L, long double R)
{
	return (val > L+eps&&val < R-eps);
}

bool fits(Block b, long double sum_of_WWx, long double sum_of_WWy, long double sum_of_W)
{
	if (sum_of_W == 0)
		return true;

	long double Lx, Rx;
	Lx = b.x1*sum_of_W;
	Rx = b.x2*sum_of_W;
	if (!is_inside(sum_of_WWx, Lx, Rx))
		return false;
	long double Ly, Ry;
	Ly = b.y1*sum_of_W;
	Ry = b.y2*sum_of_W;
	if (!is_inside(sum_of_WWy, Ly, Ry))
		return false;
	return true;
}

void show(Block B)
{
	cout << B.x1 << " " << B.y1 << " " << B.x2 << " " << B.y2 << endl;
}

int main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#else
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
#endif

	cin >> n >> w;
	cin >> h >> m;
	
	w *= 2;
	
	for (int i = 1; i <= h; i++)
	{
		for (int j = 1; j <= n; j++)
		{
			alive[i][j] = 1;
		}
		lmost[i] = 1;
		rmost[i] = n;
		Block B = get_box(i);
		
	//	show(B);
		int lev = i;

		total_W[lev] = get_W(B);
		total_WWx[lev] = get_WWx(B);
		total_WWy[lev] = get_WWy(B);
	}

	//cout << total_WWx[1] << endl;
	//cout << total_W[1] << endl;

	/*for (int i = 1; i <= h; i++)
	{
		cout << total_W[i] << " " << total_WWx[i] << " " << total_WWy[i] << endl;
	}*/

	int found = m+1;

	for (int i = 1; i <= m; i++)
	{
		int lev, ps;

		cin >> lev >> ps;
		Block B = get_block(lev, ps);
		total_W[lev] -= get_W(B);
		total_WWx[lev] -= get_WWx(B);
		total_WWy[lev] -= get_WWy(B);
		alive[lev][ps] = 0;

		update_lev(lev);

		long double sum_of_W, sum_of_WWx, sum_of_WWy;
		sum_of_W = 0;
		sum_of_WWx = 0;
		sum_of_WWy = 0;

		int ok = 1;

		for (int j = h; j >= 1; --j)
		{
			
			Block B = get_box(j);
			//show(B);
			//cout << "!"<<sum_of_WWx << " " << sum_of_WWy << " " << sum_of_W << endl;
			if (lmost[j] > rmost[j] && sum_of_W > eps)
				ok = 0;

			if (!fits(B, sum_of_WWx, sum_of_WWy, sum_of_W))
				ok = 0;
			sum_of_W += total_W[j];
			sum_of_WWx += total_WWx[j];
			sum_of_WWy += total_WWy[j];

		}

		if (ok == 0)
		{
			cout << "yes" << endl;
			cout << i << endl;
			return 0;
		}
	}

	cout << "no" << endl;

	return 0;
}