import sys
from collections import namedtuple

# TODO: CHECK POINTS!!!!

Event = namedtuple('Event', ['x', 'open'])
Segment = namedtuple('Segment', ['l', 'r'])
N_INF = -2**15
P_INF = 2**15 - 1

events = []


def get_num(item, sep):
    number = int(item.split(sep)[-1].strip())
    return number


def evaluate_events(items):
    lb = N_INF
    ub = P_INF
    for item in items:
        if '>=' in item:
            lb = get_num(item, '>=')
        elif '<=' in item:
            ub = get_num(item, '<=')
    # TODO: < or <=? Depends on points.
    if ub < lb:
        return
    events.append(Event(lb, True))
    events.append(Event(ub, False))


def seg_as_str(seg):
    if seg.l == N_INF:
        return 'x <= {} ||'.format(seg.r)
    if seg.r == P_INF:
        return 'x >= {} ||'.format(seg.l)
    return 'x >= {} && x <= {} ||'.format(seg.l, seg.r)


if __name__ == '__main__':
    # sys.stdin = open('hard.in', 'r')
    sys.stdout = open('hard.out', 'w')

    with open('hard.in', 'r') as f:
        data = [line.replace('||', '').strip() for line in f.readlines()]

    for line in data:
        if not line:
            continue
        data_items = line.split('&&')
        evaluate_events(data_items)

    balance = 0
    events = sorted(events, key=lambda x: (x.x, -x.open))
    # TODO: Check comparator (open or -open)
    result = []
    cseg = Segment(None, None)

    for event in events:
        if event.open:
            balance += 1
        else:
            balance -= 1

        if event.open and balance == 1:
            cseg = Segment(event.x, None)
        if not event.open and balance == 0:
            cseg = Segment(cseg.l, event.x)
            result.append(cseg)

    if len(result) == 0:
        print('false')
        exit()

    min_res = [result[0]]

    for seg in result[1:]:
        if min_res[-1].r + 1 == seg.l:
            min_res[-1] = Segment(min_res[-1].l, seg.r)
        else:
            min_res.append(seg)

    if min_res[0].l == N_INF and min_res[0].r == P_INF:
        print('true')
        exit()

    ans = []
    for seg in min_res:
        ans.append(seg_as_str(seg))
    ans[-1] = ans[-1].replace('||', '').strip()

    for i in ans:
        print(i)
