#include <iostream>
#include <string>
using namespace std;
#define ll long long
#define pii pair<int, int>
#define pll pair<ll, ll>
#define ff first
#define ss second
const int maxn = 10010;
const int maxh = 5010;

ll n, w, h, m;
bool levels[maxh][maxn];
ll x_mid[maxh], y_mid[maxh];
pll x_mid_all[maxh], y_mid_all[maxh];

void calc_mid(ll* xm, ll* ym, ll h)
{
	ym[h] = n * w * n;
	xm[h] = 0;
	for (ll j = 0; j < n; ++j)
		if (levels[h][j])
			xm[h] += w * (j * 2 + 1);
}

pll add_avg(pll avg, ll val)
{
	return pll(avg.ff + val, avg.ss + 1);
}

pll create_avg(ll val)
{
	return pll(val, 1);
}

void recalc_all_mid()
{
	x_mid_all[h - 1] = create_avg(x_mid[h - 1]);
	y_mid_all[h - 1] = create_avg(y_mid[h - 1]);
	for (int i = h - 2; i >= 0; --i)
	{
		x_mid_all[i] = add_avg(x_mid_all[i + 1], x_mid[i]);
		y_mid_all[i] = add_avg(y_mid_all[i + 1], y_mid[i]);
    }
}

pll get_convex(int h)
{
	int start = -1;
	int finish = -1;
	for (int i = 0; i < n; ++i)
		if (start == -1 && levels[h][i])
			start = i, finish = i;
		else if (levels[h][i])
			finish = i;
	return pll(start, finish + 1);
}

pll mult(pll p, ll mul)
{
	return pll(p.ff * mul, p.ss * mul);
}

bool is_collapse()
{
	for (ll i = 0; i < h - 1; ++i)
	{
		pll mid;
		if (i % 2 == 0)
			mid = x_mid_all[i];
		else
			mid = y_mid_all[i];
		pll conv = get_convex(i);
		conv = mult(conv, 2 * n * w);
		pll conv_mult = pll(conv.ff * mid.ss, conv.ss * mid.ss);
		if (conv_mult.ff >= mid.ff || conv_mult.ss <= mid.ff)
			return true;
	}
	return false;
}

void calc_mid(int h)
{
	if (h % 2 == 0)
		calc_mid(x_mid, y_mid, h);
	else
		calc_mid(y_mid, x_mid, h);
}

int main() {
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
	cin >> n >> w >> h >> m;
	for (int i = 0; i < h; ++i)
		for (int j = 0; j < n; ++j)
			levels[i][j] = true;
	for (int i = 0; i < h; ++i)
		calc_mid(i);
	for (int i = 0; i < m; ++i)
	{
		int l, k;
		cin >> l >> k;
		--l;
		--k;
		levels[l][k] = false;
		calc_mid(l);
		recalc_all_mid();
		if (is_collapse())
		{
			cout << "yes\n" << i + 1;
			return 0;
		}
	}
	cout << "no";
	return 0;
}
/*
3 3
10 1
10 3

2 2
2 1
1 1

*/