#include <iostream>
#include <string>
using namespace std;
#define ll long long
#define pii pair<int, int>
#define pll pair<ll, ll>
#define ff first
#define ss second
const int maxn = 10010;
const int maxh = 5010;

ll n, w, h, m;
bool levels[maxh][maxn];
pll x_mid[maxh], y_mid[maxh];
pll x_mid_all[maxh], y_mid_all[maxh];

pll add_avg(pll avg, ll val)
{
	return pll(avg.ff + val, avg.ss + 1);
}

pll create_avg(ll val)
{
	return pll(val, 1);
}

pll add_avgs(pll avg1, pll avg2)
{
	return pll(avg1.ff + avg2.ff, avg1.ss + avg2.ss);
}

void calc_mid(pll* xm, pll* ym, ll h)
{
	
	xm[h] = pll(0, 0);
	for (ll j = 0; j < n; ++j)
		if (levels[h][j])
			xm[h] = add_avg(xm[h], w * (j * 2 + 1));
	ym[h] = pll(xm[h].ss * w * n, xm[h].ss);
}

void recalc_all_mid()
{
	x_mid_all[h - 1] = x_mid[h - 1];
	y_mid_all[h - 1] = y_mid[h - 1];
	for (int i = h - 2; i >= 0; --i)
	{
		x_mid_all[i] = add_avgs(x_mid_all[i + 1], x_mid[i]);
		y_mid_all[i] = add_avgs(y_mid_all[i + 1], y_mid[i]);
    }
}

pll get_convex(int h)
{
	int start = -1;
	int finish = -1;
	for (int i = 0; i < n; ++i)
		if (start == -1 && levels[h][i])
			start = i, finish = i;
		else if (levels[h][i])
			finish = i;
	if (start == -1)
		return pll(-1, -1);
	return pll(start, finish + 1);
}

pll mult(pll p, ll mul)
{
	return pll(p.ff * mul, p.ss * mul);
}

bool is_collapse()
{
	for (ll i = 0; i < h - 1; ++i)
	{
		pll mid;
		if (i % 2 == 0)
			mid = x_mid_all[i + 1];
		else
			mid = y_mid_all[i + 1];
		if (mid.ff == 0)
			return false;
		pll conv = get_convex(i);
		conv = mult(conv, 2 * w);
		pll conv_mult = mult(conv, mid.ss);
		if (mid.ff <= conv_mult.ff || conv_mult.ss <= mid.ff)
			return true;
	}
	return false;
}

void calc_mid(int h)
{
	if (h % 2 == 0)
		calc_mid(x_mid, y_mid, h);
	else
		calc_mid(y_mid, x_mid, h);
}

int main() {
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
	cin >> n >> w >> h >> m;
	for (int i = 0; i < h; ++i)
		for (int j = 0; j < n; ++j)
			levels[i][j] = true;
	for (int i = 0; i < h; ++i)
		calc_mid(i);
	for (int i = 0; i < m; ++i)
	{
		int l, k;
		cin >> l >> k;
		--l;
		--k;
		levels[l][k] = false;
		calc_mid(l);
		recalc_all_mid();
		if (is_collapse())
		{
			cout << "yes\n" << i + 1;
			return 0;
		}
	}
	cout << "no";
	return 0;
}
/*
5 2
6 6
4 1
4 2
4 5
5 3
4 3

3 3
10 1
10 3

2 2
2 1
1 1

5 2
5 5
1 1
1 2
1 3
1 4
1 5
yes
1

5 2
6 6
1 1
1 2
1 3
1 4
1 5
1 6
yes
3

5 2
5 5
5 1
5 2
5 3
5 4
5 5
no

3 2
3 9
2 2
1 2
2 1
3 1
3 3
2 3
2 1
1 1
1 3

2 1
3 6
3 1
1 1
2 2
2 1
3 2
1 2
*/