import java.io.*;
import java.util.StringTokenizer;

public class TaskF {
    MyInput in;
    PrintWriter out;

    public void solve() {
//        SumIntervalTree tree = new SumIntervalTree(10);
//        for (int i = 0; i < 10; i++)
//            System.out.println(tree.sum(i, i));
//        tree.add(0, 0, 1);
//        tree.add(5, 7, 2);
//        System.out.println();
//        for (int i = 0; i < 10; i++)
//            System.out.println(tree.sum(i, i));

        char[] s = in.next().toCharArray();
        int n = s.length;
        SumIntervalTree tree = new SumIntervalTree(n + 1);
        SumIntervalTree treeRev = new SumIntervalTree(n + 1);

        for (int i = n - 1; i >= 0; i--) {
            if (s[i] == 'C') {
                double sum = tree.sum(i + 1, n);
                sum /= (n - i);
                tree.add(i, i, sum);
                treeRev.add(i, i, sum);
                treeRev.add(i + 1, n, 1);
            } else {
                double sum = treeRev.sum(i + 1, n);
                sum /= (n - i);
                tree.add(i, i, sum);
                treeRev.add(i, i, sum);
                tree.add(i + 1, n, 1);
            }
//            for (int j = 0; j <= n; j++)
//                System.out.print(tree.sum(j, j) + " ");
//            System.out.println();
//            for (int j = 0; j <= n; j++)
//                System.out.print(treeRev.sum(j, j) + " ");
//            System.out.println();
//            System.out.println();
        }
        out.print(tree.sum(0, 0));
    }

    class SumIntervalTree {
        private int n;
        int sz;
        private double[] tree;
        private double[] add;

        SumIntervalTree(int size) {
            sz = size;
            int log = 0;
            while ((1 << log) < size)
                log++;
            n = 1 << log;
            tree = new double[2 * n];
            add = new double[2 * n];
        }

        public double sum(int from, int to) {
            return sum(1, from, to, 0, sz - 1);
        }

        private double sum(int v, int l, int r, int tl, int tr) {
            if (l > r)
                return 0;
            push(v, tl, tr);
            if (l == tl && r == tr)
                return tree[v];

            int tm = (tl + tr) / 2;
            return sum(v * 2, l, Math.min(tm, r), tl, tm) +
                    sum(v * 2 + 1, Math.max(tm + 1, l), r, tm + 1, tr);
        }

        public void add(int from, int to, double val) {
            add(1, from, to, 0, sz - 1, val);
        }

        private void add(int v, int l, int r, int tl, int tr, double val) {
            if (l > r) return;
            if (l == tl && r == tr) {
                add[v] += val;
                push(v, tl, tr);
                return;
            }

            push(v, tl, tr);

            int tm = (tl + tr) / 2;
            add(v * 2, l, Math.min(r, tm), tl, tm, val);
            add(v * 2 + 1, Math.max(l, tm + 1), r, tm + 1, tr, val);
            tree[v] = tree[v * 2] + tree[v * 2 + 1];
        }

        private void push(int v, int tl, int tr) {
            if (v * 2 < add.length) {
                add[v * 2] += add[v];
                add[v * 2 + 1] += add[v];
                tree[v] += add[v] * (tr - tl + 1);
            } else {
                tree[v] += add[v];
            }
            add[v] = 0;
        }
    }

    public static void main(String[] args) {
        TaskF main = new TaskF();
        main.in = new MyInput();
        try {
            main.out = new PrintWriter(new File("foreign.out"));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        main.solve();
        main.out.close();
    }

    public static class MyInput {
        BufferedReader br;
        StringTokenizer st;

        MyInput() {
            try {
                br = new BufferedReader(new FileReader("foreign.in"));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        String nextLine() {
            try {
                return br.readLine();
            } catch (IOException e) {
                e.printStackTrace();
            }
            throw null;
        }
    }
}
