#include <bits/stdc++.h>

using namespace std;

typedef long double ld;
typedef long long ll;

const int MAX_HEIGHT = 5000;
const int MAX_N = 10000;

ll xsum[MAX_HEIGHT + 1], ysum[MAX_HEIGHT + 1];
ll cnt[MAX_HEIGHT + 1];
ll lbord[MAX_N + 1], rbord[MAX_N + 1];
bool del[MAX_HEIGHT + 1][MAX_N + 1];

int del_level, del_place;

int current, n, h, w, all;

void fail() {
	cout << "yes\n" << current;
	exit(0);
}

void calc_borders(int level) {
	while (lbord[level] < n && del[level][lbord[level] + 1]) {
		lbord[level]++;
	}
	while (rbord[level] > 0 && del[level][rbord[level]]) {
		rbord[level]--;
	}
	if (rbord[level] == 0) {
		if (level == h) {
			h--;
		} else {
			fail();
		}
	}
}

bool if_crash(int level) {
	if (level + 1 > h) {
		return false;
	}
	ll check_coord;
	if (level & 1) {
		check_coord = ysum[level + 1];
	} else {
		check_coord = xsum[level + 1];
	}
	return (check_coord <= lbord[level] * cnt[level + 1] * 2
			|| check_coord >= rbord[level] * cnt[level + 1] * 2);
}

void recalc_weight(int level) {
	int del_x_w = (del_place * 2) - 1;
	int del_y_w = n;
	if (del_level & 1) {
		swap(del_x_w, del_y_w);
	}
	xsum[level] -= del_x_w;
	ysum[level] -= del_y_w;
	cnt[level]--;
}

int main() {
	ios_base::sync_with_stdio(false);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
#endif // KOBRA
	cin >> n >> w >> h >> all;
	for (int i = h; i > 0; i--) {
		cnt[i] = ll(n) * (h + 1 - i);
		xsum[i] = ysum[i] = cnt[i] * n; // n/2 * count[i] * 2
	}
	fill(lbord, lbord + MAX_N + 1, 0);
	fill(rbord, rbord + MAX_N + 1, n);
	for (current = 1; current <= all; current++) {
		cin >> del_level >> del_place;
		del[del_level][del_place] = true;
		calc_borders(del_level);
		for (int check_level = del_level; check_level > 0; check_level--) {
			if (if_crash(check_level)) {
				fail();
			}
			recalc_weight(check_level);
		}
	}
	cout << "no\n";
}
