#include <iostream>
#include <fstream>
#include <vector>
#include <list>
#include <queue>
#include <deque>
#include <stack>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;

string l = "p";

ll s[1001], e[1001];

bool isNorm(string word){
	if (word.size() <= 1) return false;
	if (!isupper(word[0])) return false;
	for (int i = 1; i < word.size(); i++){
		if (isupper(word[i])) return false;
	}
	return true;
}


string getAbr(deque<string> que){
	string ans;
	if (que.size() == 0) return "";
	if (que.size() == 1) return que.front();
	for (auto it = que.begin(); it != que.end(); it++){
		ans += (*it)[0];
	}
	ans += " (";
	for (auto it = que.begin(); it != que.end(); it++){
		ans += (*it) + " ";
	}
	ans.back() = ')';
	return ans;
}

string getNorm(string line){
	string tmp_line;
	string tmp;
	string norm;


	vector<string> words;
	words.reserve(1000);
	for (auto &x : line){
		if (x == ' '){
			words.push_back(tmp);
			words.push_back(" ");
			tmp = "";
			continue;
		} else
		if (!isalpha(x)){
			words.push_back(tmp);
			string t;
			t.push_back(x);
			words.push_back(t);
			tmp = "";
			continue;
		}
		tmp += x;
	}
	words.push_back(tmp);
	words.push_back("");

	deque<string> avt;
	int count = 0;
	for (auto &x : words){
		if (isNorm(x) || x == " " && count == 0){
			if (x == " "){
				count = 1;
				continue;
			}
			if (avt.size() == 0 && count == 1) tmp_line += ' ';
			avt.push_back(x);
			count = 0;
		}
		else{
			tmp_line += getAbr(avt);
			if (count == 1){
				tmp_line += ' ';
				count = 0;
			}
			avt.clear();
			tmp_line += x;
		}
	}
	return tmp_line;
}

int main(){
#if !_DEBUG
	l = "abbreviation";
#endif
	ifstream cin(l + ".in");
	ofstream cout(l + ".out");

	while (!cout.eof()){
		string line;
		getline(cin, line);
		if (line == "") break;
		cout << getNorm(line) << endl;
	}

	return 0;
}