#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <iomanip>
#include <vector>

using namespace std;
typedef long double ld;

const int INF = 32768;
const int N = 1e6 + 1;

bool bad(char ch) {
    return (ch == ' ' || ch == ',' || ch == '.');
}

bool ok(string s) {
    if (s.length() == 1) return false;
    if ('A' > s[0] || s[0] > 'Z') return false;
    for (int i = 1; i < (int)s.length(); i++)
        if ('a' > s[i] || s[i] > 'z') return false;
    return true;
}

void solve(string s) {
    vector <string> v;
    string t;
    int n = s.length();
    t += s[0];
    for (int i = 1; i < n; i++) {
        if (bad(s[i]) || bad(s[i - 1])) {
            v.push_back(t);
            t.clear();
        }
        t += s[i];
    }
    v.push_back(t);

    n = v.size();
    int p = 0;
    int e;
    while (p < n) {
        if (!ok(v[p])) {
            cout << v[p];
            p++;
            continue;
        }

        if (p + 2 < n && v[p + 1] == " " && ok(v[p + 2])) {
            t.clear();
            t += v[p][0];
            t += v[p + 2][0];
            e = p + 2;
            while (e + 2 < n && v[e + 1] == " " && ok(v[e + 2])) {
                e += 2;
                t += v[e][0];
            }
            cout << t << " (";
            for (int i = p; i <= e; i++)
                cout << v[i];
            cout << ")";
            p = e + 1;
            continue;
        }

        cout << v[p++];
    }
    cout << "\n";
}

int main() {
    freopen("abbreviation.in", "r", stdin);
    freopen("abbreviation.out", "w", stdout);
    string s;
    while (getline(cin, s))
        solve(s);


    return 0;
}
