#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <iomanip>
#include <vector>

using namespace std;
typedef long double ld;

const int INF = 32768;
const int N = 10001;
const int H = 5001;
const ld EPS = 1e-13;

bool used[H][N];
ld cx[N], cy[N];
int cnt[N];

int main() {
    freopen("jenga.in", "r", stdin);
    freopen("jenga.out", "w", stdout);
    int n, w;
    cin >> n >> w;
    int h, m;
    cin >> h >> m;

    for (int i = 1; i <= h; i++)
        cnt[i] = i * n;
    fill(cx, cx + n + 1, (ld)n / 2.);
    fill(cy, cy + n + 1, (ld)n / 2.);

    for (int i1 = 0; i1 < m; i1++) {
        int lvl, pos;
        cin >> lvl >> pos;
        used[lvl][pos] = true;
        if (lvl % 2) {
            if (lvl < h && cx[lvl + 1]) {
                bool l1 = false, r1 = false;
                for (int i = 1; i <= n; i++)
                    if (!used[lvl][i]) {
                        if (i - 1 <= cx[lvl + 1] - EPS)
                            l1 = true;
                        if (i >= cx[lvl + 1] + EPS)
                            r1 = true;
                    }
                if (!l1 || !r1) {
                    cout << "yes" << endl << i1 + 1;
                    return 0;
                }
            }
        }
        else {
            if (lvl < h && cy[lvl + 1]) {
                bool l1 = false, r1 = false;
                for (int i = 1; i <= n; i++)
                    if (!used[lvl][i]) {
                        if (i - 1 <= cy[lvl + 1] - EPS)
                            l1 = true;
                        if (i >= cy[lvl + 1] + EPS)
                            r1 = true;
                    }
                if (!l1 || !r1) {
                    cout << "yes" << endl << i1 + 1;
                    return 0;
                }
            }
        }

        if (lvl % 2)
            for (int i = lvl - 1; i >= 1; i--) {
                cx[i] = (cx[i] * cnt[i] - ((ld)pos - 0.5)) / (cnt[i] - 1);
            }
        else
            for (int i = lvl - 1; i >= 1; i--) {
                cy[i] = (cy[i] * cnt[i] - ((ld)pos - 0.5)) / (cnt[i] - 1);
            }
        for (int i = 1; i <= lvl - 1; i++)
            cnt[i]--;
    }
    cout << "no";
}
