//   ,   
//18+
#define _CRT_SECURE_NO_WARNINGS
#define TASK "jenga"

#include <iostream>
#include <string>
#include <vector>
#include <stdio.h>
#include <stack>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <iomanip>

using namespace std;

double workTime()
{
	return (double)clock() / CLOCKS_PER_SEC;
}

void myReturn(int code = 0)
{
#ifdef LOCAL
	cout << "\nTime = " << fixed << setprecision(3) << workTime() << endl;
#endif
	exit(code);
}

int n, h, q;
struct segtree
{
	long long t[20010];
	void update(int v, int tl, int tr, int pos, long long val)
	{
		if (tl == tr)
			t[v] += val;
		else
		{
			int mid = (tl + tr) / 2;
			if (pos <= mid)
				update(2 * v, tl, mid, pos, val);
			else
				update(2 * v + 1, mid + 1, tr, pos, val);
			t[v] = t[2 * v] + t[2 * v + 1];
		}
	}
	long long query(int v, int tl, int tr, int l, int r)
	{
		if (l > r)
			return 0;
		if (tl == l && tr == r)
			return t[v];
		int mid = (tl + tr) / 2;
		return query(2 * v, tl, mid, l, min(r, mid)) + query(2 * v + 1, mid + 1, tr, max(l, mid + 1), r);
	}
} sumX, sumY, cnt;
pair <int, int> blya[5010];
set <int> rem[5010];

int main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif

	cin >> n >> h >> h >> q;
	for (int i = 1; i <= q; ++i)
		cin >> blya[i].first >> blya[i].second;
	for (int i = 1; i <= h; ++i)
	{
		cnt.update(1, 1, h, i, n);
		sumX.update(1, 1, h, i, n * 1ll * n);
		sumY.update(1, 1, h, i, n * 1ll * n);
	}
	for (int i = 0; i <= h; ++i)
	{
		rem[i].insert(1);
		rem[i].insert(n);
	}
	for (int i = 1; i <= q; ++i)
	{
		for (int j = blya[i].second - 1; j <= blya[i].second + 1; ++j)
		{
			if (1 <= j && j <= n)
				rem[blya[i].first].insert(j);
		}
	}

	for (int id = 1; id <= q; ++id)
	{
		int level = blya[id].first, pos = blya[id].second;
		if (level % 2 == 1)
		{
			cnt.update(1, 1, h, level, -1);
			sumX.update(1, 1, h, level, 1 - 2 * pos);
			sumY.update(1, 1, h, level, -n);
			rem[level].erase(pos);

			long long total = cnt.query(1, 1, h, level + 1, h);
			long long curX = sumX.query(1, 1, h, level + 1, h);
			int ll = *rem[level].begin(), rr = *rem[level].rbegin();
			ll = 2 * ll - 2, rr = 2 * rr;
			if (total > 0 && (curX <= ll * 1ll * total || rr * 1ll * total <= curX))
			{
				cout << "yes\n" << id << endl;
				myReturn(0);
			}
		}
		else
		{
			cnt.update(1, 1, h, level, -1);
			sumX.update(1, 1, h, level, -n);
			sumY.update(1, 1, h, level, 1 - 2 * pos);
			rem[level].erase(pos);

			long long total = cnt.query(1, 1, h, level + 1, h);
			long long curY = sumY.query(1, 1, h, level + 1, h);
			int ll = *rem[level].begin(), rr = *rem[level].rbegin();
			ll = 2 * ll - 2, rr = 2 * rr;
			if (total > 0 && (curY <= ll * 1ll * total || rr * 1ll * total <= curY))
			{
				cout << "yes\n" << id << endl;
				myReturn(0);
			}
		}
	}
	cout << "no\n";

	myReturn();
}

//This is ACM Nor Esdfjk Efghkl Radfskjbfe Conted,
//sponsored bi Internatio Busina Mache.
//The.Best.Contest.Eva.
//A Great Opotunity fo al contest.