#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long ll;

#define all(c) (c).begin(), (c).end()

struct Event
{
    ll u, t, len;
    Event(ll u, ll t, ll len)
        :u(u), t(t), len(len)
    {

    }

    bool operator < (const Event &e)
    {
        return u < e.u || (u == e.u && t < e.t);
    }
};

#define taskname "expect"
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    freopen(taskname".in", "r", stdin);
    freopen(taskname".out", "w", stdout);
#endif
    int n, q;
    cin >> n >> q;
  
    ll u = 0;
    ll last_t = 0;
    vector<Event> events;
    for (int i = 0; i < n; ++i) {
        ll du, t;
        char c;
        cin >> c >> t >> du;
        c = (c == '+' ? 1 : -1);
        if (last_t) {
            events.emplace_back(u, 0, t - last_t);
        }
        u += du * (ll)c;
        last_t = t;
    }
    events.emplace_back(u, 0, 1);
    ll max_b = u;
    for (int i = 0, b; i < q; ++i) {
        cin >> b;
        events.emplace_back(-b, i + 1, -1);
    }
    sort(all(events));
    ll cur_len = 0;
    ll area = 0;
    ll last_u = 1;
    vector<ll> ans(q + 1);
    for (int i = 0; i < (int)events.size(); ++i) {
        if (events[i].t == 0) {
            if (events[i].u > 0) {
                break;
            }
            if (last_u != -1)
                area += (events[i].u - last_u) * cur_len;
            cur_len += events[i].len;
            last_u = events[i].u;
        }
        else {
            if (events[i].u > max_b) {
                ans[events[i].t] = -1;
            }
            else {
                ans[events[i].t] = area + cur_len * (events[i].u - last_u);
                if (last_u == 1)
                    ans[events[i].t] = 0;
            }
        }
    }
    for (int i = 1; i <= q; ++i) {
        if (ans[i] == -1)
            cout << "INFINITY" << endl;
        else
            cout << ans[i] << endl;
    }
}