#include <iostream>
#include <fstream>
#include <string>
#include <map>
#include <vector>
#include <iterator>
#include <algorithm>
#include <utility>
#include <cmath>

using namespace std;

void Answer(string & abbr, string & full) {
	if (abbr.size() > 1) {
		cout << abbr << " (" << full << ")";
	}
	else {
		cout << full;
	}
	abbr.clear();
	full.clear();
}

int main()
{
	
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
	/*
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	*/
	const int MESS = 0;
	const int WAIT_UPPER = 1;
	const int WAIT_LOWER = 2;
	const int WAIT_NEXT = 3;
	const int WAIT_SPACE = 4;
	int state = MESS;
	string abbreviation;
	string full;

	while (true) {
		int i = getchar();
		char c = i;

		if (i == -1) {
			Answer(abbreviation, full);
			exit(0);
		}

		if (state == WAIT_SPACE) {
			cout << c;
			if (c == ' ') {
				state = MESS;
			}
			continue;
		}

		if (state == MESS) {
			if (isupper(c)) {
				state = WAIT_LOWER;
				abbreviation.clear();
				full.clear();
				abbreviation += c;
				full += c;
			}
			else {
				state = MESS;
				cout << c;
			}
			continue;
		}

		if (state == WAIT_UPPER) {
			if (isupper(c)) {
				state = WAIT_LOWER;
				abbreviation += c;
				full += c;
			}
			else {
				char space = full.back();
				full.pop_back();
				state = MESS;
				Answer(abbreviation, full);
				cout << space << c;
			}
			continue;
		}

		if (state == WAIT_LOWER) {
			if (islower(c)) {
				state = WAIT_NEXT;
				full += c;
			}
			else {
				string not_a_word;
				int last_space = full.find_last_of(' ');
				if (last_space == -1) {
					abbreviation.clear();
					not_a_word = full;
					full.clear();
				}
				else {
					abbreviation.pop_back();
					not_a_word = full.substr(last_space);
					full.resize(last_space);
				}
				state = MESS;
				Answer(abbreviation, full);
				cout << not_a_word << c;
			}
			continue;
		}

		if (state == WAIT_NEXT) {
			if (islower(c)) {
				state = WAIT_NEXT;
				full += c;
			}
			else if (isupper(c)) {
				string not_a_word;
				int last_space = full.find_last_of(' ');
				if (last_space == -1) {
					abbreviation.clear();
					not_a_word = full;
					full.clear();
				}
				else {
					abbreviation.pop_back();
					not_a_word = full.substr(last_space);
					full.resize(last_space);
				}
				state = WAIT_SPACE;
				Answer(abbreviation, full);
				cout << not_a_word << c;
			}
			else if (c == ' ') {
				state = WAIT_UPPER;
				full += c;
			}
			else {
				state = MESS;
				Answer(abbreviation, full);
				cout << c;
			}
			continue;
		}

	}



	return 0;
}