#include <iostream>
#include <fstream>
#include <string>
#include <map>
#include <vector>
#include <iterator>
#include <algorithm>
#include <utility>
#include <cmath>

using namespace std;

bool isAC(string const& w) {
	if (w.size() < 3) {
		return false;
	}
	if (!isupper(w.front())) {
		return false;
	}
	for (int i = 1; i < w.size() - 1; i++) {
		if (!islower(w[i])) {
			return false;
		}
	}
	return true;
}

void Answer(vector<string>::iterator l, vector<string>::iterator r) {
	if (l + 1 == r) {
		cout << *l;
		return;
	}
	for (vector<string>::iterator i = l; i != r; i++) {
		cout << i->front();
	}
	cout << " (";
	for (vector<string>::iterator i = l; i != r - 1; i++) {
		cout << *i;
	}
	string last = r[-1];
	char e = last.back();
	last.pop_back();
	cout << last << ")" << e;
}

int main()
{
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
	/*/
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	*/
	vector<string> abbr;
	string word;

	while (true) {
		int i = getchar();
		char c = i;

		if (isalpha(c)) {
			word += c;
		}

		else {
			if (i != -1) {
				word += c;
			}
			if (isAC(word)) {
				abbr.push_back(word);
			}
			if (c != ' ' || !isAC(word)) {
				if (abbr.size()) {
					Answer(abbr.begin(), abbr.end());
					abbr.clear();
				}
				if (!isAC(word)) {
					cout << word;
				}
			}
			word.clear();

			if (i == -1) {
				exit(0);
			}
		}

	}

	return 0;
}