#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define mp make_pair
#define pb push_back
#ifdef DEBUG
#define eprintf(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define eprintf(...) ;
#endif
#define TASK "binary"

const int inf = (int) 1.01e9;
const ld eps = 1e-9;
const ld pi = acos((ld) -1);


void precalc() {
}

struct node {
  int go[2];
  vector<int> xs;
};

const int maxn = (int) 5e5 + 5;
int n;
string s[maxn];
char tmp[maxn];

int read() {
  if (scanf("%d", &n) < 1) {
    return 0;
  }
  for (int i = 0; i < n; i++) {
    scanf("%s", tmp);
    s[i] = tmp;
  }
  return 1;
}

node trie[maxn];
int freeNode;
int ids[maxn];
int vs;

int newNode() {
  for (int i = 0; i < 2; i++) {
    trie[freeNode].go[i] = -1;
  }
  trie[freeNode].xs.clear();
  return freeNode++;
}

void add(const string &s, int x) {
  int v = 0;
  for (int i = 0; i < sz(s); i++) {
    if (trie[v].go[s[i] - '0'] == -1) {
      trie[v].go[s[i] - '0'] = newNode();
    }
    v = trie[v].go[s[i] - '0'];
  }
  trie[v].xs.push_back(x);
}

const int maxv = 6 * maxn;
vector<int> g[maxv], gr[maxv];

void addEdge(int v, int u) {
  g[v ^ 1].push_back(u);
  gr[u].push_back(v ^ 1);
  g[u ^ 1].push_back(v);
  gr[v].push_back(u ^ 1);
}

void dfs(int v, int p) {
  for (int i = 0; i < sz(trie[v].xs); i++) {
    int cur = vs;
    vs += 2;
    if (p != -1) {
      addEdge(cur, p + 1);
      addEdge((trie[v].xs[i] ^ 1), p + 1);
    }
    addEdge(cur, (trie[v].xs[i] ^ 1));
    p = cur;
  }
  for (int i = 0; i < 2; i++) {
    int u = trie[v].go[i];
    if (u == -1) {
      continue;
    }
    dfs(u, p);
  }
}

int p[maxv], ps;
int used[maxv], c[maxv];

void dfs0(int v) {
  used[v] = true;
  for (int i = 0; i < sz(g[v]); i++) {
    if (!used[g[v][i]]) {
      dfs0(g[v][i]);
    }
  }
  p[ps++] = v;
}

void dfs1(int v, int col) {
  used[v] = true;
  c[v] = col;
  for (int i = 0; i < sz(gr[v]); i++) {
    if (!used[gr[v][i]]) {
      dfs1(gr[v][i], col);
    }
  }
}

int res[maxv];

void solve() {
  freeNode = 0;
  newNode();
  vs = 0;
  for (int i = 0; i < n; i++) {
    int pos = find(s[i].begin(), s[i].end(), '?') - s[i].begin();
    if (pos == sz(s[i])) {
      ids[i] = -1;
      add(s[i], vs);
      addEdge(vs, vs);
      vs += 2;
    } else {
      ids[i] = vs / 2;
      s[i][pos] = '0';
      add(s[i], vs);
      s[i][pos] = '1';
      add(s[i], vs + 1);
      s[i][pos] = '?';
      vs += 2;
    }
  }
  eprintf("vs = %d\n", vs);
  dfs(0, -1);
  eprintf("vs = %d\n", vs);
  for (int i = 0; i < vs; i++) {
    used[i] = false;
  }
  ps = 0;
  for (int i = 0; i < vs; i++) {
    if (!used[i]) {
      dfs0(i);
    }
  }
  int cs = 0;
  for (int i = 0; i < vs; i++) {
    used[i] = false;
  }
  for (int i = vs - 1; i >= 0; i--) {
    int v = p[i];
    if (!used[v]) {
      dfs1(v, cs++);
    }
  }
  for (int i = 0; i < vs; i++) {
    if (c[i] == c[i ^ 1]) {
      printf("NO\n");
      return;
    }
  }
  printf("YES\n");
  for (int i = 0; i < vs; i++) {
    used[i / 2] = false;
  }
  for (int i = 0; i < vs; i++) {
    int v = p[i];
    if (!used[v / 2]) {
      res[v / 2] = (v & 1);
      used[v / 2] = true;
    }
  }
  for (int i = 0; i < n; i++) {
    if (ids[i] == -1) {
      continue;
    }
    int pos = find(s[i].begin(), s[i].end(), '?') - s[i].begin();
    s[i][pos] = '0' + res[ids[i]];
  }
  for (int i = 0; i < n; i++) {
    printf("%s\n", s[i].c_str());
  }
  for (int i = 0; i < vs; i++) {
    g[i].clear();
    gr[i].clear();
  }
}

int main() {
  precalc();
  
  freopen(TASK ".out", "w", stdout);
  freopen(TASK ".in", "r", stdin);
  
  while (read()) {
    solve();
    eprintf("Time %.2f\n", (double) clock() / CLOCKS_PER_SEC);
  }
  
  return 0;
}