#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define mp make_pair
#define pb push_back
#ifdef DEBUG
#define eprintf(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define eprintf(...) ;
#endif
#define TASK "list"

const int inf = (int) 1.01e9;
const ld eps = 1e-9;
const ld pi = acos((ld) -1);

const long long infll = (long long) 2e18;

const int maxsum = 2e4;
const int maxcntp = 4000;
int cntp;
int primes[maxsum];
bool isprime[maxsum];

ll cnt[maxcntp][maxsum];
ll len[maxcntp][maxsum];

int getlen(int a) {
  int res = 0;
  while (a) {
    res++;
    a /= 10;
  }
  return res;
}

void precalc() {
  for (int i = 2; i < maxsum; i++) {
    isprime[i] = 1;
  }
  for (int i = 2; i < maxsum; i++) {
    if (isprime[i]) {
      for (int j = i * i; j < maxsum; j += i) {
        isprime[j] = 0;
      }
    }
  }
  for (int i = 2; i < maxsum; i++) {
    if (isprime[i]) {
      primes[cntp++] = i;
    }
  }
  assert(cntp < maxcntp);
  cnt[cntp][0] = 1;
  len[cntp][0] = 2;
  for (int i = cntp - 1; i >= 0; i--) {
    int curlen = getlen(primes[i]) + 2;
    for (int sum = 0; sum < maxsum; sum++) {
      cnt[i][sum] = cnt[i + 1][sum];
      len[i][sum] = len[i + 1][sum];
    }
    for (int sum = 0; sum + primes[i] < maxsum; sum++) {
      cnt[i][sum + primes[i]] += cnt[i + 1][sum];
      cnt[i][sum + primes[i]] = min(cnt[i][sum + primes[i]], infll);
      len[i][sum + primes[i]] += len[i + 1][sum] + min(infll / curlen + 1, cnt[i + 1][sum]) * curlen;
      len[i][sum + primes[i]] = min(len[i][sum + primes[i]], infll);
    }
  }
}

ll a;
int anslen;

int read() {
  ll b;
  if (scanf("%lld%lld", &a, &b) < 2) {
    return 0;
  }
  a--;
  eprintf("%lld\n", b - a);
  anslen = b - a;
  return 1;
}

int wantsum;
int st[maxsum];
int szst;

string ans;

void getst(int pos, int sum, int mn) {
  //eprintf("pos = %d, sum = %d, mn = %d\n", pos, sum, mn);
  if (sum == 0) {
    szst = pos;
    return;
  }
  st[pos] = mn;
  for (int & cur = st[pos]; ; cur++) {
    if (cnt[cur + 1][sum - primes[cur]]) {
      break;
    }
  }
  getst(pos + 1, sum - primes[st[pos]], st[pos] + 1);
}

void makenext() {
  for (int i = szst - 1, sum = 0; i >= 0; i--) {
    sum += primes[st[i]];
    int mn = st[i] + 1;
    if (cnt[mn][sum]) {
      getst(i, sum, mn);
      return;
    }
  }
  while (true) {
    wantsum++;
    if (!cnt[0][wantsum]) {
      continue;
    }
    getst(0, wantsum, 0);
    break;
  }
}

void print() {
  ans += "[";
  for (int i = 0; i < szst; i++) {
    int cur = primes[st[i]];
    //eprintf("%d%c", cur, " \n"[i == szst - 1]);
    string s;
    while (cur) {
      s += (cur % 10) + '0';
      cur /= 10;
    }
    reverse(s.begin(), s.end());
    ans += s;
    if (i != szst - 1) {
      ans += ", ";
    }
  }
  ans += "], ";
}

void solve() {
  wantsum = 1;
  while (a >= len[0][wantsum]) {
    a -= len[0][wantsum];
    wantsum++;
  }
  eprintf("anslen = %d\n", anslen);
  szst = 0;
  int cursum = 0, mn = 0;
  int toadd = 0;
  while (cursum < wantsum) {
    int & last = st[szst];
    for (last = mn; ; last++) {
      ll cur = len[last + 1][wantsum - cursum - primes[last]];
      auto tmp = cnt[last + 1][wantsum - cursum - primes[last]];
      if (tmp) {
        cur += tmp * min(infll / tmp + 1, (long long) getlen(primes[last]) + 2 + toadd);
      }
      cur = min(cur, infll);
      //eprintf("%d\n", wantsum - cursum - primes[last]);
      if (cur <= a) {
        a -= cur;
      } else {
        break;
      }
    }
    //eprintf("last = %d\n", last);
    toadd += getlen(primes[last]) + 2;
    mn = last + 1;
    cursum += primes[last];
    szst++;
  }
  ans.clear();
  eprintf("a = %lld\n", a);
  while (sz(ans) < anslen + a) {
    print();
    makenext();
  }
  eprintf("a = %lld, anslen = %d\n", a, anslen);
  while (sz(ans) > a + anslen) {
    ans.pop_back();
  }
  eprintf("?");
  
  printf("%s\n", ans.c_str() + (int) a);
  eprintf("%lld\n", cnt[0][maxsum - 1]);
}

int main() {
  precalc();
  
  freopen(TASK ".out", "w", stdout);
  freopen(TASK ".in", "r", stdin);
  
  while (read()) {
    solve();
    eprintf("Time %.2f\n", (double) clock() / CLOCKS_PER_SEC);
  }
  
  return 0;
}