#include "bits/stdc++.h"

using namespace std;

using LL = long long;

struct vec {
	LL x, y;
	explicit vec() : x(0), y(0) {}
	explicit vec(LL x, LL y) : x(x), y(y) {}
	vec operator - (const vec& b) const {
		return vec(x - b.x, y - b.y);
	}
	vec operator + (const vec& b) const {
		return vec(x + b.x, y + b.y);
	}
	vec operator * (LL val) const {
		return vec(x * val, y * val);
	}
};

const int N = 1e5 + 100;

int n, w, h, q;

int cnt[N];
vec center[N];
int mn[N], mx[N];
set<int> removed[N];
int maxNotBroke;

void init() {
	for (int i = 0; i < h; ++i) {
		center[i] = vec(n, n);
		cnt[i] = n;
		mn[i] = 0;
		mx[i] = n - 1;
	}
	maxNotBroke = h - 1;
}

void rem(int level, int idx) {
	cnt[level]--;
	removed[level].insert(idx);

	if (!cnt[level])
		return;

	if (mn[level] == idx) {
		mn[level]++;
		while (removed[level].count(mn[level])) {
			mn[level]++;
		}
	}

	if (mx[level] == idx) {
		mx[level]--;
		while (removed[level].count(mx[level])) {
			mx[level]--;
		}
	}

	if (level & 1)
        swap(center[level].x, center[level].y);

	center[level].x = (center[level].x * LL(cnt[level] + 1) - (LL(idx) * 2 + 1)) / LL(cnt[level]);

	if (level & 1)
        swap(center[level].x, center[level].y);
}

bool check_collapse(int level, int elem) {
	rem(level, elem);
	if (cnt[level] == 0) {
		if (maxNotBroke != level)
			return true;
		else {
			while (maxNotBroke >= 0 && cnt[maxNotBroke] == 0)
				--maxNotBroke;
			return false;
		}
	}

	vec c(0, 0);
	LL m = 0;
	for (int i = maxNotBroke; i >= 0; --i) {
		if (i != maxNotBroke) {
			vec cur = c;
			if (i & 1) {
				swap(cur.x, cur.y);
			}
       
			const LL left = 2 * mn[i];
			const LL right = 2 * mx[i] + 2;
			if (cur.x <= m * left || cur.x >= right * m) {
				return true;
			}
		}
		c = c + center[i] * LL(cnt[i]);
		m = m + cnt[i];
	}

	return false;
}

void solve() {
	cin >> n >> w >> h >> q;
	init();
	for (int i = 0; i < q; ++i) {
		int level, elem;
		cin >> level >> elem;
		if (check_collapse(level - 1, elem - 1)) {
			cout << "yes" << endl;
			cout << i + 1 << endl;
			return;
		}
	}
	cout << "no" << endl;
}

int main() {
#if ZEBER
	freopen("input.txt", "r", stdin);
#else
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	solve();
}