#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <string>
#include <cstring>
#include <vector>
using namespace std;

bool isalpha(char c)
{
	return ('a' <= c && c <= 'z') || ('A' <= c && c <= 'Z');
}

bool isWord(string s)
{
	if (s.length() <= 1) return false;
	for (char c : s)
		if (!isalpha(c))
			return false;
	if ('a' <= s[0] && s[0] <= 'z') return false;
	for (int i = 1; i < (int)s.length(); i++)
		if ('A' <= s[i] && s[i] <= 'Z')
			return false;
	return true;
}

void printAbbr(vector<string> p)
{
	if (p.size() == 1)
	{
		cout << p[0];
		return;
	}
	for (string s : p)
		cout << s[0];
	cout << " (";
	for (int i = 0; i < (int)p.size(); i++)
	{
		if (i != 0) cout << " ";
		cout << p[i];
	}
	cout << ")";
	return;
}

void solve(string s)
{
	int l = 0;
	while (l < (int)s.length())
	{
		if (!isalpha(s[l]))
		{
			cout << s[l];
			l++;
			continue;
		}
		vector<string> words;
		while (true)
		{
			int r = l;
			while (r < (int)s.length() && isalpha(s[r])) r++;
			string p = s.substr(l, r - l);
			if (!isWord(p))
			{
				if (words.empty())
				{
					cout << p;
					l = r;
					break;
				}
				printAbbr(words);
				cout << " ";
				cout << p;
				l = r;
				break;
			}
			words.push_back(p);
			l = r;
			if (l < (int)s.length() && s[l] == ' ')
			{
				l++;
				continue;
			}
			l = r;
			printAbbr(words);
			break;
		}
	}
	cout << endl;
	return;
}

int main()
{
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);

	string s;
	while (getline(cin, s))
	{
	//	cerr << "!" << s << "!" << endl;
		if (s == "") break;
		solve(s);
	}

	return 0;
}