#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
using namespace std;


const int M = (int)30e7;
char buf[M];
int mpos = 0;
inline void* operator new(size_t n)
{
	mpos += n;
	if (mpos > M) throw;
	return buf + mpos - n;
}
inline void operator delete(void*){}


const int N = (int)1e6 + 100;
const int V = 8 * N;
vector<int> g[V], rg[V];
int col[V], ord[V];
int ordSz;
bool used[V];
int n, m;
int k;
int trie[N][2];
vector<int> verForTrie[N];
string a[N];
bool answer[V];

void addEdge(int v, int u)
{
	g[v].push_back(u);
	rg[u].push_back(v);
}
void addImpl(int v, int u)
{
	addEdge(v, u);
	addEdge(u ^ 1, v ^ 1);
}

int goTrie(int v, int c)
{
	if (trie[v][c] == -1)
		trie[v][c] = k++;
	return trie[v][c];
}

void read()
{
	memset(trie, -1, sizeof trie);
	k++;
	cin >> n;
	for (int it = 0; it < n; it++)
	{
		cin >> a[it];
		int l = a[it].length();
		for (int w = 0; w < 2; w++)
		{
			int v = 0;
			for (int i = 0; i < l; i++)
			{
				if (a[it][i] == '?')
					v = goTrie(v, w);
				else if (a[it][i] == '0')
					v = goTrie(v, 0);
				else if (a[it][i] == '1')
					v = goTrie(v, 1);
			}
			verForTrie[v].push_back(2 * it + w);
		}
	}
	for (int v = 0; v < k; v++)
	{
		for (int t : verForTrie[v])
			addImpl(t, 2 * (n + v) + 1);
		for (int w = 0; w < 2; w++)
		{
			int u = trie[v][w];
			if (u == -1) continue;
			for (int t : verForTrie[u])
				addImpl(2 * (n + v) + 1, t ^ 1);
			addImpl(2 * (n + v) + 1, 2 * (n + u) + 1);
		}
	}
	m = n + k;
	return;
}

void build(int v)
{
	int sz = (int)verForTrie[v].size();
	if (sz <= 1) return;

	int pr = -1;
	for (int i = 0; i < sz; i++)
	{
		int u = verForTrie[v][i];
		if (pr != -1)
		{
			addImpl(2 * m + 1, 2 * pr + 1);
			addImpl(u, 2 * pr + 1);
		}
		if (i + 1 != sz)
    		addImpl(2 * m + 1, u ^ 1);
		pr = m++;
	}
	pr = -1;
	for (int i = sz - 1; i >= 0; i--)
	{
		int u = verForTrie[v][i];
		if (pr != -1)
		{
			addImpl(2 * m + 1, 2 * pr + 1);
			addImpl(u, 2 * pr + 1);
		}
		if (i != 0)
    		addImpl(2 * m + 1, u ^ 1);
		pr = m++;
	}
	return;
}

void dfsOrd(int v)
{
	used[v] = 1;
	for (int u : g[v])
		if (!used[u])
    		dfsOrd(u);
	ord[ordSz++] = v;
	return;
}
void dfsColor(int v, int C)
{
	col[v] = C;
	for (int u : rg[v])
		if (col[u] == -1)
			dfsColor(u, C);
	return;
}
void dfsAns(int v)
{
	used[v / 2] = 1;
	answer[v / 2] = v & 1;
	for (int u : g[v])
		if (!used[v / 2])
			dfsAns(v);
	return;
}

bool solveSat()
{
	for (int i = 0; i < 2 * m; i++)
	{
		if (used[i]) continue;
		dfsOrd(i);
	}
	reverse(ord, ord + ordSz);
	for (int i = 0; i < 2 * m; i++)
		col[i] = -1;
	int C = 0;
	for (int i = 0; i < ordSz; i++)
	{
		int v = ord[i];
		if (col[v] != -1) continue;
		dfsColor(v, C);
		C++;
	}
	for (int i = 0; i < m; i++)
		if (col[2 * i] == col[2 * i + 1])
			return false;
	for (int i = 0; i < m; i++)
		used[i] = 0;
	reverse(ord, ord + ordSz);
	for (int i = 0; i < ordSz; i++)
	{
		int v = ord[i];
		if (used[v / 2]) continue;
		dfsAns(v);
	}
	return true;
}

void solve()
{
	for (int v = 0; v < k; v++)
		build(v);
	if (!solveSat())
		cout << "NO\n";
	else
	{
		cout << "YES\n";
		for (int it = 0; it < n; it++)
		{
			int len = a[it].length();
			for (int i = 0; i < len; i++)
			{
				if (a[it][i] == '?')
					a[it][i] = '0' + answer[it];
			}
			cout << a[it] << "\n";
		}
	}
	return;
}

int main()
{
	freopen("binary.in", "r", stdin);
	freopen("binary.out", "w", stdout);

	
	ios_base::sync_with_stdio(false);
	cin.tie(0);
    

	read();
	solve();

	return 0;
}