#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
using namespace std;

const int N = 200200;
int n;
vector<int> g[N];
int deg[N][2];
int ans[N][2];
bool used1[N][2];
bool used2[N][2];
int q1[N][2];
int q2[N][2];
int topQ1;
int topQ2;

void addQ1(int v, int t)
{
	q1[topQ1][0] = v;
	q1[topQ1][1] = t;
	topQ1++;
	used1[v][t] = 1;
	return;
}
void addQ2(int v, int t)
{
	q2[topQ2][0] = v;
	q2[topQ2][1] = t;
	topQ2++;
	used2[v][t] = 1;
	return;
}

void read()
{
	int m;
	scanf("%d%d", &n, &m);
	while (m--)
	{
		int v, u;
		scanf("%d%d", &v, &u);
		v--; u--;
		g[u].push_back(v);
		deg[v][0]++;
		deg[v][1]++;
	}
	for (int v = 0; v < n; v++)
	{
		ans[v][0] = 0;
		ans[v][1] = 2;
		used1[v][0] = used1[v][1] = 0;
		if (deg[v][0] == 0)
		{
			ans[v][0] = 0;
			ans[v][1] = 1;
			addQ1(v, 0);
			addQ1(v, 1);
		}
	}
	return;
}

int main()
{
	freopen("game.in", "r", stdin);
	freopen("game.out", "w", stdout);

	read();
	for (int i = 0; i < topQ1; i++)
	{
		int v = q1[i][0], t = q1[i][1];
		if (t == 0)
		{
			for (int u : g[v])
			{
				ans[u][1] = min(ans[u][1], ans[v][0]);
				deg[u][1]--;
				if (!used1[u][1])
					addQ1(u, 1);
			}
		}
		else
		{
			for (int u : g[v])
			{
				ans[u][0] = max(ans[u][0], ans[v][1]);
				deg[u][0]--;
				if (!used1[u][0] && deg[u][0] == 0)
					addQ1(u, 0);
			}
		}
	}
	for (int v = 0; v < n; v++)
		for (int t = 0; t < 2; t++)
			if (!used1[v][t])
				ans[v][t] = 2;
	for (int v = 0; v < n; v++)
		deg[v][0] = deg[v][1] = 0;
	for (int v = 0; v < n; v++)
	{
		for (int u : g[v])
		{
			if (used1[v][1])
				deg[u][0]++;
			if (used1[v][0])
				deg[u][1]++;
		}
	}
	for (int v = 0; v < n; v++)
	{
		used2[v][0] = used2[v][1] = 0;
		if (deg[v][0] == 0)
		{
//			ans[v][0] = 0;
//			ans[v][1] = 1;
			addQ2(v, 0);
		}
		if (deg[v][1] == 0)
		{
			addQ2(v, 1);
		}
	}
	for (int i = 0; i < topQ2; i++)
	{
		int v = q2[i][0], t = q2[i][1];
		if (t == 0)
		{
			for (int u : g[v])
			{
				if (!used1[u][1]) continue;
				ans[u][1] = min(ans[u][1], ans[v][0]);
				deg[u][1]--;
				if (!used2[u][1] && (ans[u][1] == 0 || deg[u][1] == 0))
					addQ2(u, 1);
			}
		}
		else
		{
			for (int u : g[v])
			{
				if (!used1[u][0]) continue;
				ans[u][0] = max(ans[u][0], ans[v][1]);
				deg[u][0]--;
				if (!used1[u][0] && (ans[u][0] == 1 || deg[u][0] == 0))
					addQ2(u, 0);
			}
		}
	}
	for (int v = 0; v < n; v++)
	{
		if (ans[v][0] == 0)
			printf("L");
		else if (ans[v][0] == 1)
			printf("W");
		else
			printf("D");
	}
	printf("\n");
	for (int v = 0; v < n; v++)
	{
		if (ans[v][1] == 0)
			printf("W");
		else if (ans[v][1] == 1)
			printf("L");
		else
			printf("D");
	}
	printf("\n");

	return 0;
}