#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
using namespace std;

const int Z = 1004;
const int N = 2 * Z + 3;

char str[N];

struct Item
{
	int w, h;
	bool a[N][N];
	int x0, y0;

	Item() : w(), h(), a(), x0(-1), y0(-1) {}

	void findUpperLeft()
	{
		x0 = y0 = -1;
		for (int i = 0; x0 == -1 && i < w; i++)
		{
			for (int j = 0; x0 == -1 && j < h; j++)
			{
				if (a[i][j])
				{
					x0 = i;
					y0 = j;
				}
			}
		}
	}

	void scan()
	{
		scanf("%d%d", &w, &h);
		for (int i = 0; i < w; i++)
		{
			scanf(" %s ", str);
			for (int j = 0; j < h; j++)
				a[i][j] = str[j] == '*';
		}
		findUpperLeft();
	}

	int getCount()
	{
		int res = 0;
		for (int i = 0; i < w; i++)
			for (int j = 0; j < h; j++)
				res += a[i][j];
		return res;
	}
} A, B, C;

Item XOR(Item A, Item B)
{
	Item R = Item();
	for (int i = A.x0; i < A.w; i++)
		for (int j = 0; j < A.h; j++)
			R.a[i - A.x0][Z + j - A.y0] ^= A.a[i][j];
	for (int i = B.x0; i < B.w; i++)
		for (int j = 0; j < B.h; j++)
			R.a[i - B.x0][Z + j - B.y0] ^= B.a[i][j];
	R.w = R.h = N;
	R.findUpperLeft();
	return R;
}

int main()
{
	freopen("kids.in", "r", stdin);
	freopen("kids.out", "w", stdout);

	A.scan();
	B.scan();
	C.scan();

	if (A.x0 == -1 || B.x0 == -1) throw;

	Item D;

	D = XOR(A, B);

	if (D.x0 == -1)
	{
		if (C.x0 == -1)
		{
			printf("YES\n");
			printf("%d %d\n", A.y0 - B.y0, A.x0 - B.x0);
			return 0;
		}
	}
	else
	{
		if (C.x0 != -1)
		{
			if (C.getCount() == D.getCount())
			{
				bool ok = true;
				for (int i = 0; ok && i < C.w; i++)
				{
					for (int j = 0; ok && j < C.h; j++)
					{
						if (!C.a[i][j]) continue;
						int x = D.x0 + i - C.x0, y = D.y0 + j - C.y0;
						if (x < 0 || x >= D.w || y < 0 || y >= D.h)
							ok = false;
						else
							ok &= D.a[x][y];
					}
				}
				if (ok)
				{
					printf("YES\n");
					printf("%d %d\n", A.y0 - B.y0, A.x0 - B.x0);
					return 0;
				}
			}
		}
	}

	if (C.x0 == -1)
	{
		printf("NO\n");
		return 0;
	}

	D = XOR(A, C);
	if (D.x0 != -1 && B.getCount() == D.getCount())
	{
		bool ok = true;
		for (int i = 0; ok && i < B.w; i++)
		{
			for (int j = 0; ok && j < B.h; j++)
			{
				if (!B.a[i][j]) continue;
				int x = D.x0 + i - B.x0, y = D.y0 + j - B.y0;
				if (x < 0 || x >= D.w || y < 0 || y >= D.h)
					ok = false;
				else
					ok &= D.a[x][y];
			}
		}
		if (ok)
		{
//			printf("HERE\n");
			printf("YES\n");
			printf("%d %d\n", D.y0 - B.y0 - Z + A.y0, D.x0 - B.x0 + A.x0);
			return 0;
		}
	}

	D = XOR(B, C);
	if (D.x0 != -1 && A.getCount() == D.getCount())
	{
		bool ok = true;
		for (int i = 0; ok && i < A.w; i++)
		{
			for (int j = 0; ok && j < A.h; j++)
			{
				if (!A.a[i][j]) continue;
				int x = D.x0 + i - A.x0, y = D.y0 + j - A.y0;
				if (x < 0 || x >= D.w || y < 0 || y >= D.h)
					ok = false;
				else
					ok &= D.a[x][y];
			}
		}
		if (ok)
		{
			printf("YES\n");
			printf("%d %d\n", -D.y0 + A.y0 + Z - B.y0, -D.x0 + A.x0 - B.x0);
			return 0;
		}
	}

	printf("NO\n");

	return 0;
}