#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <queue>
#include <iomanip>
#include <stack>
#include <map>
#include <algorithm>

using namespace std;

typedef long long LL;
typedef pair<int, int> pair_ii;
typedef pair<long long, long long> pair_LL;
typedef pair<string, string> pair_s;

#define fori(i,s,n) for (int i = s; i < n; ++i)
#define forir(i,f) for (int i = f - 1; i >= 0; --i)
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz size()

void set_precise(int n) {
	cout << fixed;
	cout << setprecision(n);
}

int fit[100000] = { 0 };

const int mid = 50000;

const int inf = 35000;

const int min_num = -32768;
const int max_num = 32767;

vector <pair_ii > seg;
vector <pair_ii > ans;

pair_ii get_pair(string &s) {
	pair_ii ans = make_pair(0 - inf, inf);
	s.erase(0, 1);
	bool  rev = 0;
	if (s.find("x") != s.npos) {
		while (!isdigit(s[0]) && (s[0] != '-')) {
			s.erase(0, 1);
		}
		if (s[0] == '-') {
			rev = 1;
			s.erase(0, 1);
		}
		int l = 0;
		while (isdigit(s[0])) {
			l *= 10;
			l += s[0] - '0';
			s.erase(0, 1);
		}
		if (rev) {
			l = 0 - l;
			rev = 0;
		}

		while (!isdigit(s[0]) && (s[0] != '-')) {
			s.erase(0, 1);
		}
		if (s[0] == '-') {
			rev = 1;
			s.erase(0, 1);
		}
		int r = 0;
		while (isdigit(s[0])) {
			r *= 10;
			r += s[0] - '0';
			s.erase(0, 1);
		}
		if (rev) {
			r = 0 - r;
			rev = 0;
		}
		ans.first = l;
		ans.second = r;
	}
	else {
		if (s.find("<") != s.npos) {
			ans.first = 0 - inf;
			while (!isdigit(s[0]) && (s[0] != '-')) {
				s.erase(0, 1);
			}
			if (s[0] == '-') {
				rev = 1;
				s.erase(0, 1);
			}
			int r = 0;
			while (isdigit(s[0])) {
				r *= 10;
				r += s[0] - '0';
				s.erase(0, 1);
			}
			if (rev) {
				r = 0 - r;
				rev = 0;
			}
			ans.second = r;
		}
		else {
			ans.second = inf;
			while (!isdigit(s[0]) && (s[0] != '-')) {
				s.erase(0, 1);
			}
			if (s[0] == '-') {
				rev = 1;
				s.erase(0, 1);
			}
			int l = 0;
			while (isdigit(s[0])) {
				l *= 10;
				l += s[0] - '0';
				s.erase(0, 1);
			}
			if (rev) {
				l = 0 - l;
				rev = 0;
			}
			ans.first = l;
		}
	}
	return ans;
}

bool check_false() {
	for (int i = mid + min_num; i <= mid + max_num; ++i) {
		if (fit[i] != 0) {
			return 0;
		}
	}
	return 1;
}

bool check_true() {
	for (int i = mid + min_num; i <= mid + max_num; ++i) {
		if (fit[i] == 0) {
			return 0;
		}
	}
	return 1;
}

void print(pair_ii p, bool end) {
	int l = p.fs;
	int r = p.sc;
	if (l == min_num) {
		cout << "x <= " << r;
	}
	else if (r == max_num) {
		cout << "x >= " << l;
	}
	else {
		cout << "x >= " << l << " && " << "x <= " << r;
	}
	if (!end) {
		cout << " ||";
	}
	cout << endl;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);
#endif
	string s;
	while (getline(cin, s)) {
		pair_ii p = get_pair(s);
		seg.pb(p);
	}
	fori(i, 0, seg.sz) {
		int l = seg[i].fs;
		int r = seg[i].sc;
		for (int i = mid + l; i <= mid + r; ++i) {
			fit[i] = 1;
		}
	}
	if (check_false()) {
		cout << "false";
		return 0;
	}
	if (check_true()) {
		cout << "true";
		return 0;
	}
	fit[mid + min_num - 1] = 0;
	fit[mid + max_num + 1] = 0;
	for (int i = mid + min_num; i <= mid + max_num + 1; ++i) {
		int l;
		int r;
		/*if (i == mid + min_num) {
			if (fit[i]) {
				l = min_num;
			}
			continue;
		}
		if (i == mid + max_num) {
			if (!fit[i - 1]) {
				l = max_num;
				r = max_num;
				ans.pb(mp(l, r));
			}
			else {
				r = max_num;
				ans.pb(mp(l, r));
			}
		}*/
		if (fit[i]) {
			if (!fit[i - 1]) {
				l = i - mid;		
			}
		}
		else {
			if (fit[i - 1]) {
				r = i - 1 - mid;
				ans.pb(mp(l, r));
			}
		}
	}
	fori(i, 0, ans.sz) {
		if (i != ans.sz - 1) {
			print(ans[i], 0);
		}
		else {
			print(ans[i], 1);
		}
	}
	return 0;
}