#define FNAME "binary"
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int,int> pii;

#define pb push_back
#define mp make_pair
#define fst first
#define snd second
#define all(V) V.begin(), V.end()
#define sz(V) (int)(V.size())
#define forn(i, N) for(int i = 0; i < int(N); ++i)
#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define fornr(i, N) for(int i = int(N) - 1; i >= 0; --i)
#define forit(i, V) for(__typeof(V.begin()) i = V.begin(); i != V.end(); ++i)

const int MAX_N = 2e6+100;
char *S[MAX_N];
int L[MAX_N];
int Pos[MAX_N];
unordered_map<string, int> HSet;
unordered_map<string, vi> HV;

const int MAX_V = 4 * MAX_N;
int Color[MAX_V];
bool Was[MAX_V];
vi topsorted;
vi Edges[MAX_V], REdges[MAX_V];
int Ans[MAX_V], Out[MAX_V];

int cnt = MAX_N;
int addVertex(){
	return cnt++;
}

inline int neg(int v){
	return v < MAX_V/2 ? v + MAX_V/2 : v - MAX_V/2;
}

inline void addEdge(int v, int u){
	Edges[v].pb(u);
	Edges[neg(u)].pb(neg(v));
//	printf("edge %d->%d\n",v,u);
	
	REdges[u].pb(v);
	REdges[neg(v)].pb(neg(u));
}

inline void NO(){
	puts("NO");
	exit(0);
}

int TIME = 0;

void DFS(int v, int c){
	Was[v] = 1;
	Color[v] = c;
	for(int u: REdges[v])
		if(!Was[u])
			DFS(u, c);
	Out[c] = ++TIME;
}

inline int add(char *s, int l, int from){
	int ans = 0;
	for(int i = l - 1; i >= 0; --i){
		if(!HSet.count(s)){
			int newnum = addVertex();
			HSet[s] = newnum;
		}
		if(i < l - 1)
			addEdge(from, neg(HSet[s]));
		else{
			ans = HSet[s];
			addEdge(from, ans);
			HV[s].pb(from);
		}
			
		s[i] = 0;
	}
	return ans;
}

void TopSort(int v){
	Was[v] = 1;
	for(int u:Edges[v])
		if(!Was[u])
			TopSort(u);
	topsorted.pb(v);
}

char s[MAX_N];

int main(){
	assert(freopen(FNAME".in", "r", stdin));
	assert(freopen(FNAME".out", "w", stdout));
	
	int N;
	scanf("%d\n",&N);
	forn(i, N){
		gets(s);
		int l = strlen(s), p = -1;
		L[i] = l;
		forn(j, l)
			if(s[j] == '?'){
				p = j;
				break;
			}

		S[i] = new char[l+2]();
		strcpy(S[i], s);

		if(p > -1){
			int num = i;
			forn(k, 2){
				s[p] = char('0' + k);
				add(s, l, num);
//				puts("\n\n");
				strcpy(s, S[i]);
				num = neg(num);
			}
		}else{
			add(s, l, i);
			addEdge(neg(i), i);
		}
		Pos[i] = p;
	}
	
	vi tmppr, tmpsuf;
	for(const auto &zz: HV){
		const auto &z = zz.snd;
		tmppr.clear();
		tmpsuf.clear();
		int n = sz(z);
		int last = -1;
		forn(i, n){
			int x = addVertex();
			tmppr.pb(x);
			addEdge(x, neg(z[i]));
			if(i)
				addEdge(x, last);
			last = x;
		}
		last = -1;
		fornr(i, n){
			int x = addVertex();
			tmpsuf.pb(x);
			addEdge(x, neg(z[i]));
			if(i != n - 1)
				addEdge(x, last);
			last = x;
		}
		reverse(all(tmpsuf));
		
		forn(i, n){
			if(i)
				addEdge(z[i], tmppr[i - 1]);
			if(i!=n-1)
				addEdge(z[i], tmpsuf[i + 1]);
		}
	}

	int M = sz(HSet);
	vi vs;
	forn(i, M)
		vs.pb(i), vs.pb(neg(i));
	for(int v: vs){
		if(!Was[v])
			TopSort(v);
	}

	for(int v: vs)
		Was[v] = 0;
	reverse(all(topsorted));

	int cc = 0;
	for(int v: topsorted)
		if(!Was[v])
			DFS(v, cc++);

	forn(i, M){
		if(Color[i] == Color[neg(i)]){
			NO();
		}else{
			Ans[i] = (Out[Color[i]] < Out[Color[neg(i)]]);
		}
	}
	
	puts("YES");
	forn(i, N){
		if(Pos[i]!=-1)
			S[i][Pos[i]] = char('0' + Ans[i]);
		puts(S[i]);
	}
	
	return 0;
}