#include <cstdio>
#include <iostream>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <algorithm>
#include <queue>
#define ll long long
#define ld double
#define pii pair <int, int>
#define mp make_pair

using namespace std;

const int maxn = (int)5e4 + 10;

vector <int> ed[maxn];
bool used[maxn];
int lnk[maxn];
vector <int> f[maxn];
vector <pair <pair <char, int>, pii> > ans;
int tin[maxn];
int tt = 0;

void dfs(int v, int p = -1) {
	tt++;
	tin[v] = tt;
	used[v] = true;
	lnk[v] = -1;

	for (int i = 0; i < (int)ed[v].size(); i++) {
		int u = ed[v][i];

		if (u == p) {
			continue;
		}

		if (used[u]) {
			if (tin[u] < tin[v]) {
				f[u].push_back(v);
				lnk[v] = u;
			}
		}
		else {
			dfs(u, v);
		}
	}
}

int par[maxn];

int get_parent(int x) {
	if (par[x] == x) {
		return x;
	}

	return par[x] = get_parent(par[x]);
}

void recol(int a, int b, int c) {
	ans.push_back(mp(mp('r', a), mp(b, c)));
}

void join(int a, int b) {
	int pa = get_parent(a);
	int pb = get_parent(b);

	if (pa != pb) {
		//cout << a << ' ' << b << endl;
		ans.push_back(mp(mp('j', a), mp(b, -1)));
		par[pa] = pb;
	}
}

void con(int a, int b, int c) {
	ans.push_back(mp(mp('c', a), mp(b, c)));
}

void go(int v, int p = -1) {
	used[v] = true;

	for (int i = 0; i < (int)ed[v].size(); i++) {
		int u = ed[v][i];

		if (!used[u]) {
			go(u, v);
		}
	}

	for (int i = 0; i < (int)f[v].size(); i++) {
		join(v, f[v][i]);
	}

	con(v, 1, 4);
	recol(v, 4, 3);

	for (int i = 0; i < (int)ed[v].size(); i++) {
		int u = ed[v][i];

		if (lnk[u] != -1 && u != p && lnk[v] != u) {
			join(v, u);
		}
	}

	con(v, 1, 4);

	for (int i = 0; i < (int)ed[v].size(); i++) {
		int u = ed[v][i];

		if (u != p && lnk[v] != u) {
			join(v, u);
		}
	}

	con(v, 1, 2);

	recol(v, 2, 3);

	if (lnk[v] != -1) {
		recol(v, 1, 4);
	}
	else {
		recol(v, 1, 2);
	}
}

int main() {
	freopen("cactus.in", "r", stdin);
	freopen("cactus.out", "w", stdout);
	int n, m;

	cin >> n >> m;

	for (int i = 1; i <= n; i++) {
		par[i] = i;
	}

	for (int i = 0; i < m; i++) {
		int k;

		scanf("%d", &k);

		int last = -1;

		for (int j = 0; j < k; j++) {
			int x;

			scanf("%d", &x);

			if (last != -1) {
				ed[x].push_back(last);
				ed[last].push_back(x);
			}

			last = x;
		}
	}

	dfs(1);

	memset(used, 0, sizeof used);

	go(1);

	cout << ans.size() << endl;

	for (int i = 0; i < (int)ans.size(); i++) {
		if (ans[i].first.first == 'j') {
			printf("j %d %d\n", ans[i].first.second, ans[i].second.first);
		}
		else {
			printf("%c %d %d %d\n", ans[i].first.first, ans[i].first.second, ans[i].second.first, ans[i].second.second);
		}
	}

	return 0;
}

