#include <cstdio>
#include <iostream>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <algorithm>
#include <queue>
#define ll long long
#define ld double
#define pii pair <int, int>
#define mp make_pair

using namespace std;

const int maxn = 1001;

class Pic{
public:
	pair<int, int> first_;
	int h, w;
	bool m[maxn][maxn];
	Pic(){
		first_ = mp(-2, -2);
    }
	void read() {
		char tmp;
		scanf("%d%d", &h, &w);
		for (int i = 0; i < h; ++i) {
			for (int q = 0; q < w; ++q) {
				scanf(" %c", &tmp);
				if (tmp == '*') m[i][q] = 1;
				else m[i][q] = 0;
            }
		}
	}
	pair<int, int> getF() {
		if (first_ != mp(-2, -2)) return first_;
		for (int i = 0; i < h; ++i)
			for (int q = 0; q < w; ++q)
				if (m[i][q]) return first_ = mp(i, q);
		return first_ = mp(-1, -1);
	}
	bool get(int x, int y) const {
		if (x < 0 || y < 0 || x >= h || y >= w) return 0;
		return m[x][y];
	}
	void construct(const Pic& a, const Pic& b, pair<int, int> d = mp(0, 0)) {
		int dy = d.first;
		int dx = d.second;
		//cerr << "'''''" << dy << ' ' << dx << "\n";
        if (dy < 0) {
			construct(b, a, mp(-dy, -dx));
			return;
		}
		first_ = mp(-2, -2);
		if (dx > 0) w = max(a.w, b.w + dx);
		else w = max(a.w - dx, b.w);
		h = max(a.h, b.h + dy);
		for (int i = 0; i < h; ++i) {
			for (int q = 0; q < w; ++q) {
				if (dx > 0) {
					m[i][q] = (a.get(i, q) ^ b.get(i - dy, q - dx));
					//cout << "(" << i << ' ' << q << ' ' << a.get(i, q) << "\n";
					//cout << i - dy << ' ' << q - dx << ' ' << b.get(i - dy, q - dx) << ")\n";
				}
				else {
					m[i][q] = (a.get(i, q + dx) ^ b.get(i - dy, q));
					//cout << "(" << i << ' ' << q + dx << ' ' << a.get(i, q + dx) << '\n';
                    //cout << i - dy << ' ' << q << "\n";
				}
			}
		}
	}
	void print() {
		cout << h << ' ' << w << "\n";
		for (int i = 0; i < h; ++i) {
			for (int q = 0; q < w; ++q)
				cout << (m[i][q] ? '*' : '.');
			cout << "\n";
		}
	}
};

Pic p1, p2, p3;

pii sub(pii a, pii b) {
	return mp(a.first - b.first, a.second - b.second);
}

pii add(pii a, pii b) {
	return mp(a.first + b.first, a.second + b.second);
}

Pic cmpTmp;

bool cmp(Pic& p1, Pic& p2) {
	cmpTmp.construct(p1, p2, sub(p1.getF(), p2.getF()));
	return cmpTmp.getF() == mp(-1, -1);
}

void print_(pair<int, int> p) {
	cout << p.second << ' ' << p.first << "\n";
}

int main() {
	freopen("kids.in", "r", stdin);
	freopen("kids.out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	p1.read();
	p2.read();
	p3.read();
	Pic tmp;
	tmp.construct(p1, p2, sub(p1.getF(), p2.getF()));
	//tmp.print();
	if (cmp(tmp, p3)) {
		cout << "YES\n";
		print_(sub(p1.getF(), p2.getF())); 
        return 0;
	}
	tmp.construct(p3, p1, sub(p3.getF(), p1.getF()));
	pii shift = sub(p3.getF(), p1.getF());
	shift.first = max(shift.first, 0);
	shift.second = max(shift.second, 0);
	//tmp.print();
	if (cmp(tmp, p2)) {
		cout << "YES\n";
		print_(sub(sub(tmp.getF(), p2.getF()), shift));
		return 0;
	}
	tmp.construct(p3, p2, sub(p3.getF(), p2.getF()));
	shift = sub(p3.getF(), p2.getF());
	shift.first = max(shift.first, 0);
	shift.second = max(shift.second, 0);
	//tmp.print();
	if (cmp(tmp, p1)) {
		cout << "YES\n";
		//cout << p2.getF().first << ' ' << p2.getF().second << "\n";
		//cout << tmp.getF().first << ' ' << tmp.getF().second << "\n";
		print_(add(sub(p1.getF(), tmp.getF()), shift));
		return 0;
	}
	cout << "NO\n";
    //tmp.print();
}

/*

3 3
..*
.*.
*.*
3 3
**.
..*
.*.
5 2
.*
*.
**
.*
*.

*/