#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<cstdio>
#include<algorithm>
#include<set>
#include<map>
#include<string>
#include<cstring>
#include<queue>
#include<functional>
#include<cassert>
#include <sstream>

using namespace std;
typedef long long ll;
typedef long long lint;
const int MINN = -(1 << 15);
const int MAXN = (1 << 15) - 1;
const int SUM = MAXN - MINN + 1;
bool any;
bool x[SUM];
int brackets[SUM + 1];

void print_slash()
{
	if (!any)
		return;
	cout << " ||\n";
}

bool add_seg(int l, int r)
{
	if (!(l <= r))
		return false;
	l = max(0, l);
	r = min(SUM - 1, r);
	brackets[l]++;
	brackets[r + 1]--;
	return true;
}

void add_ray(int i, bool is_gr)
{
	if (is_gr)
		add_seg(i, SUM - 1);
	else
		add_seg(0, i);
}

bool add(string &s)
{
	bool ray = s.find('&') == -1;
	int n = s.length();
	istringstream ss(s);
	string t = " ";
	bool is_gr = false, is_gr1 = false;
	while (!isdigit(t[0]) && t[0] != '-')
	{
		ss >> t;
		if (t.find('>') != -1)
			is_gr = true;
	}
	int l = atoi(t.c_str()) - MINN;
	if (ray)
	{
		add_ray(l, is_gr);
		return true;
	}
	t = " ";
	while (!isdigit(t[0]) && t[0] != '-')
		ss >> t;

	int r = atoi(t.c_str()) - MINN;
	return add_seg(l, r);
}

void print_ray(pair <int, int> s)
{
	if (s.first != MINN)
		cout << "x >= " << s.first;
	else
		cout << "x <= " << s.second;
}


int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);
#endif
	string str;
	while (getline(cin, str))
	{
		if (!add(str))
		{
			cout << "false\n";
			return 0;
		}
		if (str.back() != '|')
			break;
	}
	int balance = 0;
	for (int i = 0; i < SUM; i++) {
		balance += brackets[i];
		if (balance > 0)
			x[i] = true;
	}
	bool seg = false;
	vector <pair <int, int> > v;
	for (int i = 0; i < SUM; ++i)
	{
		if (x[i] && !seg)
		{
			v.emplace_back(i + MINN, MAXN);
			seg = true;
		}
		if (seg && !x[i])
		{
			v[v.size() - 1].second = i - 1 + MINN;
			seg = false;
		}
	}
	int n = v.size();
	if (n == 0)
	{
		cout << "false\n";
		return 0;
	}
	if (v[0].first == MINN && v[0].second == MAXN)
	{
		cout << "true\n";
		return 0;
	}

	for (int i = 0; i < n; ++i)
	{
		if (v[i].first != MINN && v[i].second != MAXN)
			cout << "x >= " << v[i].first << " && " << "x <= " << v[i].second;
		else
			print_ray(v[i]);
		if (i != n - 1)
			cout << " ||";
		cout << "\n";
	}

}