#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<cstdio>
#include<algorithm>
#include<set>
#include<map>
#include<string>
#include<cstring>
#include<queue>
#include<functional>
#include<cassert>

using namespace std;
#define left dffgjhygfj
#define right dfhgtrpofjpfjk
typedef long long ll;
typedef long long lint;
const int MAXN = 10100;
const double eps = 1e-8;

bool eq(double a, double b)
{
	return abs(a - b) < eps;
}
bool ls(double a, double b)
{
	return a < b && !eq(a, b);
}
bool lseq(double a, double b)
{
	return a < b || eq(a, b);
}

int n, w, h, m;

double left[MAXN], right[MAXN];
double x[MAXN], y[MAXN];
int cnt[MAXN];
int prefcnt[MAXN];
double prefx[MAXN], prefy[MAXN];
bool deleted[MAXN / 2][MAXN];

void init()
{
	for (int i = h - 1; i >= 0; --i)
	{
		x[i] = y[i] = prefx[i] = prefy[i] = n / 2.;
		cnt[i] = n;
		prefcnt[i] = (h - i) * n;
		left[i] = 0;
		right[i] = n;
	}
}

int upd_lvl(int l, int k, int inc)
{
	for (int i = k + inc;; i += inc)
		if (!deleted[l][i])
			return i;
}

bool upd(int l, int k)
{
	deleted[l][k] = true;
	if (eq(right[l] - left[l], 1) && cnt[l + 1] != 0)
		return false;
	if (eq(left[l], k))
		left[l] = upd_lvl(l, k, 1);
	if (eq(right[l], k + 1))
		right[l] = upd_lvl(l, k, -1) + 1;
	auto & c = x[l];
	if (l & 1)
		c = y[l];
	c *= cnt[l];
	cnt[l]--;
	if (cnt[l] == 0)
	{
		x[l] = 0;
		y[l] = 0;
		prefx[l] = 0;
		prefy[l] = 0;
		prefcnt[l] = 0;
		return true;
	}
	c -= (k + 0.5);
	c /= cnt[l];
	return true;
}

void upd_ms(int l)
{
	prefcnt[l] = prefcnt[l + 1] + cnt[l];
	if (prefcnt[l] == 0)
		return;
	prefx[l] = (prefx[l + 1] * prefcnt[l + 1] + x[l] * cnt[l]) / prefcnt[l];
	prefy[l] = (prefy[l + 1] * prefcnt[l + 1] + y[l] * cnt[l]) / prefcnt[l];
}

bool fall(int l)
{
	if (l == h - 1)
		return false;
	upd_ms(l + 1);
	if (prefcnt[l + 1] == 0)
		return false;
	auto c = prefx[l + 1];
	if (l & 1)
		c = prefy[l + 1];
	return !(ls(left[l], c) && ls(c, right[l]));
}

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
#endif
	scanf("%d%d%d%d", &n, &w, &h, &m);
	init();

	for (int ind = 0; ind < m; ++ind)
	{
		int l, k;
		scanf("%d%d", &l, &k);
		--l;
		--k;
		if (!upd(l, k))
		{
			printf("yes\n%d\n", ind + 1);
			return 0;
		}
		for (int i = l; i >= 0; --i)
			if (fall(i))
			{
				printf("yes\n%d\n", ind + 1);
				return 0;
			}
	}
	printf("no\n");

}