#include <iostream>
#include <iomanip>
#include <string>
#include <set>
#include <vector>
#include <sstream>

using namespace std;

inline void prntBag(const vector<string>& b){
	if (b.size() == 1){
		cout << b[0];
		return;
	}
	for (const string& s : b)
		cout << *s.begin();
	cout << " (";
	bool prntd = false;
	for (const string& s : b){
		if (prntd) cout << " ";
		prntd = true;
		cout << s;
	}
	cout << ")";
}

inline bool isLetter(const char c){
	return c >= 'a' && c <= 'z' || c >= 'A' && c <= 'Z';
}

inline bool isgood(const string& s){
	if (s.size() == 1) return false;
	if (islower(s[0])) return false;
	for (int i = 1; i < s.size(); ++i)
		if (isupper(s[i]))
			return false;
	return true;
}

inline void procLine(const string& s){
	vector<string> tokens;
	int inword = false;
	for (char c : s){
		if (isLetter(c)){
			if (!inword) tokens.emplace_back();
			inword = true;
			tokens.back().push_back(c);
		}
		else {
			tokens.push_back(string(1, c));
			inword = false;
		}
	}
	for (int i = 0; i < tokens.size();){
		if (!isLetter(tokens[i][0])){
			cout << tokens[i++];
			continue;
		}
		if (!isgood(tokens[i])){
			cout << tokens[i++];
			continue;
		}
		vector<string> bag;
		while (true)
		{
			bag.push_back(tokens[i++]);
			if (i == tokens.size() || tokens[i] != " ") break;
			if (i + 1 < tokens.size() && isgood(tokens[i + 1]))
				++i;
			else
				break;
		}
		prntBag(bag);
	}
	cout << endl;
}


int main(){
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
	vector<string> ss;
	string s;
	while (getline(cin, s))
		ss.push_back(s);
	for (const string & t : ss)
		procLine(t);
	return 0;
}