#include <iostream>
#include <iomanip>
#include <string>
#include <set>
#include <vector>
#include <algorithm>
#include <sstream>

using namespace std;
typedef long double ld;
typedef long long ll;
const int N = 5010;
ld Fx[N], Fy[N];
ll sumM[N];
template<typename T>
inline T getSum(const int pos, const T* F) //[0 pos];
{
	T res = 0;
	for (int i = pos; i > 0; i -= i & -i)
		res += F[i];
	return res;
}
template<typename T>
inline void add(const int pos, const T val, T* F){
	for (int i = pos; i < N; i += i & -i)
		F[i] += val;
}
template<typename T>
inline T getSum(const int l, const int r, const T* F){  //[l, r]
	return getSum(r, F) - getSum(l - 1, F);
}
set<int> has[N];

int n, w, h, m;
pair<ld, ld> getCord(const int ch, const int k){
	ld x = k + 0.5, y = (ld)n / 2;
	if (ch % 2 == 0)
		swap(x, y);
	return make_pair(x, y);
}
const ld EPS = 1e-7;
inline bool isBreak(){
	int ch, ck; cin >> ch >> ck;
	--ck;
	add(ch, -1LL, sumM);
	pair<ld, ld> coord = getCord(ch, ck);
	add(ch, -coord.first, Fx);
	add(ch, -coord.second, Fy);
	ll mUp = getSum(ch + 1, h, sumM);
	has[ch].erase(ck);
	if (mUp == 0)
		return false;
	if (has[ch].size() == 0)
		return true;
	const ld lp = *has[ch].begin();
	const ld rp = *has[ch].rbegin() + 1;
	pair<ld, ld> cM = make_pair(getSum(ch + 1, h, Fx) / mUp, getSum(ch + 1, h, Fy) / mUp);
	const ld pos = ((ck % 2 == 1) ? cM.first : cM.second);
	if (std::abs(lp - pos) < EPS || std::abs(rp - pos) < EPS) return true;
	return !(lp <= pos && pos <= rp);
}

int main(){
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> w >> h >> m;
	for (int i = 1; i <= h; ++i){
		const ld mm = (ld)(n) * n / 2;
		add(i, mm, Fx);
		add(i, mm, Fy);
	}
	for (int i = 0; i < n; ++i)
		has[0].insert(i);
	for (int i = 1; i <= h; ++i){
		has[i] = has[0];
		add(i, (ll)n, sumM);
	}
	for (int i = 1; i <= m; ++i){
		if (isBreak())
		{
			cout << "yes" << endl << i << endl;
			return 0;
		}
	}
	cout << "no" << endl;
	return 0;
}