#include <iostream>
#include <iomanip>
#include <string>
#include <set>
#include <vector>
#include <algorithm>
#include <sstream>

using namespace std;
//typedef long double ld;
typedef long long ll;
const int N = 5010;
ll Fx[N], Fy[N];
ll sumM[N];
template<typename T>
inline T getSum(const int pos, const T* F) //[0 pos];
{
	T res = 0;
	for (int i = pos; i > 0; i -= i & -i)
		res += F[i];
	return res;
}
template<typename T>
inline void add(const int pos, const T val, T* F){
	for (int i = pos; i < N; i += i & -i)
		F[i] += val;
}
template<typename T>
inline T getSum(const int l, const int r, const T* F){  //[l, r]
	return getSum(r, F) - getSum(l - 1, F);
}
set<pair<int, int> > removed[N];
int n, w, h, m;

inline void remEl(set<pair<int, int> >& removed, int elem){
	if (removed.size() == 0){
		removed.emplace(elem, elem);
		return;
	}
	auto itN = removed.upper_bound(make_pair(elem, 0));
	if (itN != removed.end() && itN->first == elem + 1){
		auto pN = *itN;
		if (itN != removed.begin()){
			auto itP = itN; --itN;
			auto pP = *itP;
			if (pP.second + 1 == elem){
				auto ins = make_pair(pP.first, pN.second);
				removed.erase(itN);
				removed.erase(itP);
				removed.insert(ins);
			}
		}		
		--pN.first;
		removed.erase(itN);
		removed.insert(pN);
		return;
	}
	if (itN == removed.begin()){
		removed.emplace(elem, elem);
		return;
	}
	auto itP = itN; --itN;
	auto pP = *itP;
	if (pP.second + 1 == elem){
		pP.second++;
		removed.erase(itP);
		removed.insert(pP);
		return;
	}
	removed.emplace(elem, elem);
}

inline int getL(const set<pair<int, int> >& removed){
	if (removed.size() == 0) return 0;
	return removed.begin()->second + 1;
}
inline int getR(const set<pair<int, int> >& removed){
	if (removed.size() == 0) return n - 1;
	return removed.rbegin()->first - 1;
}

pair<ll, ll> getCord(const int ch, const int k){
	ll x = 2 * (ll)k + 1, y = n;
	if (ch % 2 == 0)
		swap(x, y);
	return make_pair(x, y);
}


inline bool isBreak(int ch, int ck){
	--ck;
	add(ch, -1LL, sumM);
	pair<ll, ll> coord = getCord(ch, ck);
	add(ch, -coord.first, Fx);
	add(ch, -coord.second, Fy);
	remEl(removed[ch], ck);
	for (int ih = 1; ih  < h; ++ih){
		ll mUp = getSum(ih + 1, h + 1, sumM);
		if (removed[ih].size() == n)
			return true;
		const ll lp = (getL(removed[ih])) * 2LL;
		const ll rp = (getR(removed[ih]) + 1) * 2LL;
		pair<ll, ll> cM = make_pair(getSum(ih + 1, h + 1, Fx), getSum(ih + 1, h + 1, Fy));
		const ll pos = ((ih % 2 == 1) ? cM.first : cM.second);
		if (!(lp * mUp < pos && pos < rp * mUp))
			return true;
	}
	return false;	
}

int main(){
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);;
	cin >> n >> w >> h >> m;

	for (int i = 1; i <= h; ++i){
		const ll mm = (ll)(n)* n;
		add(i, mm, Fx);
		add(i, mm, Fy);
	}
	for (int i = 1; i <= h; ++i){
		add(i, (ll)n, sumM);
	}

	for (int i = 1; i <= m; ++i){
		int ch, ck; cin >> ch >> ck;
		if (isBreak(ch, ck))
		{
			cout << "yes" << endl << i << endl;
			return 0;
		}
	}
	cout << "no" << endl;
	return 0;
}