#include <iostream>
#include <cmath>
#include <cstdio>
#include <algorithm>
#include <string>

//using namespace std;

const int MAX = 1000;
const int INF = 1000000;
const double EPS = 1e-9;

std::string abbr[120];
int abbr_len = 0;

bool is_cap(const std::string &str) {
	if (str.length() == 1) return false;
	if (str[0] < 'A' || str[0] > 'Z') return false;

	for (int i = 1; i < str.length(); ++i) {
		if (str[i] < 'a' || str[i] > 'z')
			return false;
	}
	return true;
}

bool is_ch(const char &c) {
	return (c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z');
}

void print_abbr() {
	if (abbr_len == 0) return;
	if (abbr_len == 1) {
		std::cout << abbr[0];
		abbr_len = 0;
		return;
	}
	for (int i = 0; i < abbr_len; ++i) {
		std::cout << abbr[i][0];
	}
	std::cout << " (";
	for (int i = 0; i < abbr_len; ++i) {
		std::cout << abbr[i];
		if (i < abbr_len - 1)
			std::cout << ' ';
	}
	std::cout << ")";
	abbr_len = 0;
}

void next_t(const std::string &line, int &itr, bool &is_del) {
	is_del = false;
	if (itr + 1 < line.length() && line[itr] == ' ' && is_ch(line[itr + 1])) {
		is_del = true;
	}
	if (itr == 0 && is_ch(line[itr])) {
		is_del = true;
	}

	if (!is_del) {
		print_abbr();
	}

	int jt = itr;
	int et = itr;
	for ( ; jt < line.length() && !is_ch(line[jt]); ++jt);
	if (jt < line.length()) {
		for (et = jt; et < line.length() && is_ch(line[et]); ++et);
		std::string str = line.substr(jt, et - jt);
		if ((is_del || abbr_len == 0) && is_cap(str)) {
			if (abbr_len == 0) {
				std::string pre = line.substr(itr, jt - itr);
				std::cout << pre;
			}
			abbr[abbr_len++] = str;
			if (et == line.length())
				print_abbr();			
		} else {
			print_abbr();
			str = line.substr(itr, et - itr);
			std::cout << str;			
		}
		itr = et;
	} else {
		print_abbr();
		std::cout << line.c_str() + itr;
		itr = line.length();
		return;
	}
}

int main() {
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);

	std::string line;
	int start;
	bool is_dr;

	while (std::getline(std::cin, line)) {
		start = 0;
		while (start < line.length()) {
			next_t(line, start, is_dr);
		}

		std::cout << "\n";
	}

}
