#include <iostream>
#include <iomanip>
#include <cmath>
#include <cstdio>
#include <algorithm>
#include <string>
#include <vector>
#include <map>

using namespace std;

const int MAX = 100100;
const int INF = 1000000000;
const double EPS = 1e-9;

map<int, int> nums;
pair<int, int> num_cnt[MAX];
pair<int, int> num_arr[MAX];
pair<int, int> queues[MAX];
int outp[MAX];
int last;
int n, q;
int size;

int main() {
	freopen("expect.in", "r", stdin);
	freopen("expect.out", "w", stdout);
	cin >> n >> q;

	int cur_sum = 0, prevt = 0;
	for (int i = 0; i < n; ++i) {
		char c;
		int curt, num;
		cin >> c >> curt >> num;

		if (cur_sum < 0) {
			if (nums.find(cur_sum) == nums.end()) {
				nums[cur_sum] = curt - prevt;
			}
			else {
				nums[cur_sum] += curt - prevt;
			}
		}

		if (c == '-') cur_sum -= num;
		else cur_sum += num;
		prevt = curt;
	}

	map<int, int>::reverse_iterator it;
	for (size = 0, it = nums.rbegin(); it != nums.rend(); ++it, ++size) {
		num_arr[size].first = num_cnt[size].first = (*it).first;
		num_arr[size].second = num_cnt[size].second = (*it).second;
	}

	for (int i = size - 2; i >= 0; --i) {
		num_cnt[i].second = num_cnt[i].second + num_cnt[i + 1].second;
	}

	for (int i = size - 2; i >= 0; --i) {
		int sm = -num_arr[i + 1].first + num_arr[i].first;
		num_arr[i].second = num_arr[i].second + num_arr[i + 1].second + num_cnt[i + 1].second * sm;
	}

	for (int i = 0; i < q; ++i) {
		cin >> queues[i].first;
		queues[i].second = i;
	}

	sort(queues, queues + q);

	int itr = 0;
	for (int i = 0; i < q; ++i) {
		int ij = queues[i].second;
		int rsum = queues[i].first;

		if (cur_sum < 0 && rsum < abs(cur_sum)) {
			outp[ij] = -1;
			continue;
		}

		for (; itr < size && rsum >= -num_arr[itr].first; ++itr);
		if (itr == size) {
			outp[ij] = 0;
		} else {
			int mul = -num_arr[itr].first - rsum - 1;
			outp[ij] = num_arr[itr].second + num_cnt[itr].second * mul;
		}
	}

	for (int i = 0; i < q; ++i) {
		if (outp[i] == -1) {
			cout << "INFINITY\n";
		} else {
			cout << outp[i] << "\n";
		}
	}
}
