#include <iostream>
#include <cmath>
#include <cstdio>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

const int MAX = 1000;
const int INF = 1000000;
const double EPS = 1e-9;

int minNum = -32768,
maxNum = 32767;
vector<pair<int, int>> vec;

int main() {
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);

	string line;

	while (getline(cin, line)) {
		string sign = line.substr(2, 2);

		int pos = 5;
		int number = 0;
		int s = 1;
		if (line[pos] == '-') {
			s *= -1;
			++pos;
		}
		
		for (;line[pos] != ' ' && pos != line.size(); ++pos) {
			number *= 10;
			number += line[pos] - '0';
		}
		number *= s;

		if (line.size() - pos > 4) {
			pos += 9;
			int number2 = 0;

			s = 1;
			if (line[pos] == '-') {
				s = -1;
				++pos;
			}

			for (; line[pos] != ' ' && pos != line.size(); ++pos) {
				number2 *= 10;
				number2 += line[pos] - '0';
			}
			number2 *= s;


			if (number <= number2) {
				vec.push_back(make_pair(number, number2));
			}
		}
		else {
			if (sign == ">=") {
				vec.push_back(make_pair(number, maxNum));
			}
			else {
				vec.push_back(make_pair(minNum, number));
			}
		}
	}

	if (!vec.size()) {
		cout << "false" << endl;
		return 0;
	}


	sort(vec.begin(), vec.end());

	int minN = vec[0].first, maxN = vec[0].second;
	for (int i = 1; i < vec.size(); ++i) {
		if (vec[i].first <= maxN + 1) {
			maxN = max(maxN, vec[i].second);
		}
		else {
			if (minN != minNum) {
				cout << "x >= " << minN << " && ";
			}
			cout << "x <= " << maxN << " ||" << endl;

			minN = vec[i].first;
			maxN = vec[i].second;
		}
	}

	if (minN == minNum && maxN == maxNum) {

		if (maxN == maxNum) {
			cout << "true" << endl;
		}
		else {
			cout << "x <= " << maxNum << endl;
		}
		
		return 0;
	}

	if (maxN == maxNum) {
		cout << "x >= " << minN << endl;
		return 0;
	}

	cout << "x >= " << minN << " && x <= " << maxN << endl;
}


/*
x >= 5 && x <= 10 ||
x >= 7 && x <= 20 ||
x <= 2 ||
x >= 21 && x <= 25 ||
x >= 8 && x <= 10 ||
x >= 100

x >= 10 && x <= 0

x <= 10 ||
x >= 0

x >= -32768

*/