#include <iostream>
#include <iomanip>
#include <cmath>
#include <cstdio>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <set>

using namespace std;

const int MAX = 5100;
const int INF = 1000000000;
const double EPS = 1e-9;

double up_summ[MAX];
double all_summ[MAX];
int l[MAX];
int r[MAX];
set<int> edg[MAX];
int n, w;
int h, m;

int main() {
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
	cin >> n >> w;
	cin >> h >> m;

	all_summ[h - 1] = 0.;
	up_summ[h - 1] = 0.;

	double lmass = (n / 2.0 * (n - 1)) + n / 2.0;

	for (int i = h - 2; i >= 0; --i) {
		all_summ[i] = all_summ[i + 1] + n * n;
		up_summ[i] = up_summ[i + 1] + lmass * n;

		l[i] = 0;
		r[i] = n - 1;
	}

	for (int i = 0; i < m; ++i) {
		int li, k;
		cin >> li >> k;
		li--;
		k--;

		double massc = up_summ[li] / all_summ[li];

		if (k != l[li] && k != r[li]) {
			edg[li].insert(k);
		} else {
			if (k == l[li]) {
				++l[li];
				if (edg[li].size() > 0) {
					while ((*edg[li].begin()) == l[li]) {
						++l[li];
						int num = *edg[li].rbegin();
						edg[li].erase(num);
					}
				}
			} else {
				++r[li];
				if (edg[li].size() > 0) {
					while ((*edg[li].rbegin()) == r[li]) {
						++r[li];
						int num = *edg[li].rbegin();
						edg[li].erase(num);
					}
				}
			}

			if (fabs(massc - l[li]) < EPS || massc < l[li]) {
				cout << "yes\n" << i + 1 << endl;
				return 0;
			}
			if (fabs(massc - (r[li] + 1)) < EPS || massc > r[li] + 1) {
				cout << "yes\n" << i + 1 << endl;
				return 0;
			}
		}

		for (int j = li - 1; j >= 0; --j) {
			if ((li - j) & 1) {
				up_summ[j] -= lmass;
				all_summ[j] -= n;
			} else {
				up_summ[j] -= (k - 0.5) * n;
				all_summ[j] -= n;

				if (fabs(massc - l[j]) < EPS  || massc < l[j]) {
					cout << "yes\n" << i + 1 << endl;
					return 0;
				}
				if (fabs(massc - (r[j] + 1)) < EPS || massc > r[j] + 1) {
					cout << "yes\n" << i + 1 << endl;
					return 0;
				}
			}
		}
	}

	cout << "no\n" << endl;
}
