#include <bits/stdc++.h>
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define pw(x) (1ll << x)
#define db(x) cerr << #x << " = " << x << endl
#define db2(x, y) cerr << "(" << #x << ", " << #y << ") = (" << x << ", " << y << ")" << endl

using namespace std;
typedef long long ll;
const int N = 8e6 + 10;
const int M = 1e6;

struct Node {
    vector<int> id;
    int go[2];
    Node() {
        clear();
    }
    void clear() {
        id.clear();
        memset(go, -1, sizeof(go));
    }
};

vector<int> e[N];
vector<int> g[N];
int curEdge;
int n;

void addE(int v, int u) {
    //cerr << v << " -> " << u << endl;
    e[v].pb(u);
    g[u].pb(v);
}

struct Tree {
    vector<int> vertId;
    //vector<int> tmp;
    int type;
    
    void init(vector<int> &id, int _type) {
        type = _type;
        //tmp = id;
        //db2(id.size(), n * 2);
        //assert((int)id.size() == n * 2);
        vertId.clear();
        vertId.resize(n * 8);
        build(0, 0, n * 2, id);
    } 
    void build(int v, int tl, int tr, vector<int> &id) {
        if (tl + 1 == tr) {
            vertId[v] = id[tl];
            return;
        }
        vertId[v] = curEdge++;
        build(v * 2 + 1, tl, (tl + tr) / 2, id);
        build(v * 2 + 2, (tl + tr) / 2, tr, id);
        if (type == 1) {
            addE(vertId[v], vertId[v * 2 + 1]);
            addE(vertId[v], vertId[v * 2 + 2]);
        }
        else {
            addE(vertId[v * 2 + 1], vertId[v]);
            addE(vertId[v * 2 + 2], vertId[v]);
        }
    }

    void addSeg(int v, int tl, int tr, int l, int r, int from) {
        //cerr << "v tl tr l r: " << v << " " << tl << " " << tr << " " << l << " " << r << endl;
        /*if (v == 0) {
            cerr << "superEdge: " << from << " ->  ";
            for (int i = l; i < r; i++)
                cerr << tmp[i] << " ";
            cerr << endl;
        }*/

        if (tr <= l || r <= tl) return;
        if (l <= tl && tr <= r) {
            if (type == 1) {
                addE(from, vertId[v]);
            }
            else {
                addE(vertId[v], from);
            }
            return;
        }
        addSeg(v * 2 + 1, tl, (tl + tr) / 2, l, r, from);
        addSeg(v * 2 + 2, (tl + tr) / 2, tr, l, r, from);
    }
};

string s[M];
Node data[M];
int cur;
int tmr;
int tin[N];
int tout[N];
bool use[N];
vector<int> euler;
int color[N];
vector<int> st;
int sert[M];

Tree eReal;
Tree eIm;


int findQ(string & ss) {
    for (int i = 0; i < (int)ss.size(); i++)
        if (ss[i] == '?')
            return i;
    return -1;
}

void read() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
}

void add(string &t, int id) {
    int v = 0;  
    for (int i = 0; i < (int)t.size(); i++) {
        int ch = t[i] - '0'; 
        if (data[v].go[ch] == -1) {
            data[cur].clear();
            data[v].go[ch] = cur++;
        }
        v = data[v].go[ch];
    }
    //db(v);
    data[v].id.pb(id);
}

void dfs0(int v) {
    tin[v] = tmr;
    for (auto x: data[v].id) {
        euler.pb(x);
    }
    tmr += data[v].id.size();
    for (int i = 0; i < 2; i++)
        if (data[v].go[i] != -1) {
            dfs0(data[v].go[i]);
        }
    tout[v] = tmr;
}

void dfs1(int v) {
    for (int i = 0; i < (int)data[v].id.size(); i++) {
        int me = data[v].id[i];
        eIm.addSeg(0, 0, n * 2, tin[v], tin[v] + i, me); /// ??? 
        eIm.addSeg(0, 0, n * 2, tin[v] + i + 1, tout[v], me); /// ??? 

        //cerr << "e Real" << endl;
        eReal.addSeg(0, 0, n * 2, tin[v], tin[v] + i, me ^ 1); /// ??? 
        eReal.addSeg(0, 0, n * 2, tin[v] + i + 1, tout[v], me ^ 1); /// ??? 
    }
    for (int i = 0; i < 2; i++) {
        if (data[v].go[i] != -1) {
            dfs1(data[v].go[i]);
        }
    }
}

void dfs2(int v) {
    use[v] = 1;
    for (auto u: e[v])
        if (!use[u]) 
            dfs2(u);
    st.pb(v);
}

void dfs3(int v, int cc) {
    color[v] = cc;
    //cerr << "v: " << v << "  ";
    //for (auto u: g[v])
        //cerr << u << " "; 
    //cerr << endl;
    for (auto u: g[v]) {
        if (color[u] == -1) {
            //db2(u, cc);
            dfs3(u, cc);
        }
    }
}

bool solve() {
    data[0].clear();

    tmr = 0;
    for (int i = 0; i < n * 8; i++) {
        use[i] = 0;
        e[i].clear();
        g[i].clear();
    }


    curEdge = n * 2;
    euler.clear();
    st.clear();
    cur = 1;
    for (int i = 0; i < n; i++) {
        int pos = findQ(s[i]);
        if (pos == -1) {
            char old = s[i][0];
            s[i][0] = '0';
            add(s[i], i * 2);
            s[i][0] = '1';
            add(s[i], i * 2 + 1);

            s[i][0] = old;

            if (old == '1') {
                addE(i * 2, i * 2 + 1);
            }
            else {
                addE(i * 2 + 1, i * 2);
            }
        }
        else {
            s[i][pos] = '0';
            add(s[i], i * 2);
            s[i][pos] = '1';
            add(s[i], i * 2 + 1);

            s[i][pos] = '?';
        } 
    } 
    /*for (int v = 0; v < cur; v++) {
        cerr << v << ": ";
        cerr << data[v].go[0] << " " << data[v].go[1] << " ---------- ";
        cerr << "id: ";
        for (auto x: data[v].id)
            cerr << x << " ";
        cerr << endl;

    }*/

    //db(cur);
    // add Edge for no 
    

    dfs0(0);
    //db(curEdge);
    eReal.init(euler, 0);
    for (auto & x: euler)
        x ^= 1;

    //db(curEdge);
    eIm.init(euler, 1);
    for (auto & x: euler)
        x ^= 1;
    //db(curEdge);

    /*for (auto x: euler)
        cerr << x << " ";
    cerr << endl;*/

    //exit(0);

    //cerr << "======================" << endl;
    dfs1(0);


    /*for (int i = 0; i < curEdge; i++) {
        cerr << i << ": ";
        for (auto u: e[i])
            cerr << u << " ";
        cerr << endl;
    }*/

    /*db(g[0].size());
    for (int i = 0; i < curEdge; i++) {
        cerr << i << ": ";
        for (auto u: g[i])
            cerr << u << " ";
        cerr << endl;
    }*/

    
    for (int i = 0; i < curEdge; i++)
        use[i] = 0;
    st.clear();
    for (int i = 0; i < curEdge; i++) {
        if (!use[i])
            dfs2(i);
    }
    reverse(all(st));

    for (int i = 0; i < curEdge; i++)
        color[i] = -1;

    int cc = 0;
    /*cerr << "st: ";
    for (auto x: st)
        cerr << x << " ";
    cerr << endl;*/
    for (auto v: st) {
        if (color[v] == -1) {
            //db2(v, cc);
            dfs3(v, cc);
            cc++;
        } 
    }
    /*cerr << "color: ";
    for (int i = 0; i < curEdge; i++)
        cerr << color[i] << " ";
    cerr << endl;*/


    for (int i = 0; i < n; i++) {
        if (color[i * 2] == color[i * 2 + 1]) {
            return 0; 
        }
    } 
    for (int i = 0; i < n; i++) {
        use[i] = 0;
        sert[i] = 0;
    }

    for (int i = 0; i < n; i++) {
        //db2(color[i * 2], color[i * 2 + 1]);
        if (color[i * 2] > color[i * 2 + 1]) {
            sert[i] = 0;
        } 
        else {
            sert[i] = 1;
        }
    } 
    //for (int i = 0; i < n; i++)
        //cerr << sert[i] << " ";
    //cerr << endl;


    /*for (int i = 0; i < curEdge; i++) {
        if (st[i] < n * 2) {
            int v = st[i] / 2;
            if (!use[v]) {
                use[v] = 1;
                sert[v] = v % 2;
            }
        }
    } */
    return 1;
}



bool stupid() {
    for (int mask = 0; mask < pw(n); mask++) {
        vector<string> g;
        for (int i = 0; i < n; i++)
            sert[i] = ((mask >> i) & 1);
      
    } 
    return 0;
}

void printAns(bool res) {
    if (res) {
        puts("YES");
        for (int i = 0; i < n; i++) {
            string tmp = s[i]; 
            int pos = findQ(s[i]);
            if (pos != -1)
                tmp[pos] = sert[i] + '0';
            cout << tmp << "\n"; 
        }
    }
    else {
        puts("NO");
    }
}

void genTest() {
    //int T = 5;
    n = rand() % 5 + 1;
    n = 1e3;
    for (int i = -1; i < n; i++) {
        //int len = rand() % T + 1;
        int len = 100;
        s[i] = "";
        for (int j = 0; j < len; j++) {
            s[i] += rand() % 2 + '0';          
        }
        if (rand() % 2) {
            int pos = rand() % len;
            s[i][pos] = '?';
        }
    }
}

void printTest() {
    cout << n << endl;
    for (int i = 0; i < n; i++)
        cout << s[i] << endl;

}

void stress() {
    for (int tt = 0; ; tt++) {
        db(tt);
        genTest();
        //printTest();
        //db("HHH");
        printAns(solve());
        //db(r1);
        cerr << clock() * 1.0 / CLOCKS_PER_SEC << endl;
        return;
        //db("YYY");
        //auto r2 = solve();
        //db("ZZZ");
        //db2(r1, r2);

        //assert(r1 == r2);
    }
}

int main() {
#ifdef HOME
    freopen("in", "r", stdin);
#else
    assert(freopen("binary.in", "r", stdin));
    assert(freopen("binary.out", "w", stdout));
#endif
    if (1) {
        read();
        printAns(solve());
        //printAns(stupid());
    }
    else {
        stress();
    }
    


    return 0;
}



