#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cstring>

using namespace std;

const int MAXN = 300000 + 100;

string op[MAXN];
int t[MAXN], cn[MAXN], n;
pair<int, int> e[MAXN];
int inQueue, avail, m;
long long sumSuffEP[MAXN], sumSuffSec[MAXN];

int main () {
	freopen("expect.in", "r", stdin);
	freopen("expect.out", "w", stdout);
	cin >> n >> m;
	for(int i = 1; i <= n; i++) {
		cin >> op[i] >> t[i] >> cn[i];
	}
	inQueue = 0;
	avail = 0;
	for(int i = 1; i <= n; i++) {
		if (op[i] == "+") {
			avail += cn[i];
			if (inQueue > 0) {
				int decQ = min(inQueue, avail);
				inQueue -= decQ;
				avail -= decQ;
			}			
		} else {
			if (avail >= cn[i]) {
				avail -= cn[i];
			} else {
				inQueue += cn[i] - avail;
				avail = 0;
			}
		}
		e[i] = make_pair(inQueue, t[i + 1] - t[i]);
	}
	sort(e + 1, e + n + 1);
	sumSuffEP[n] = e[n].first * 1LL * e[n].second;
	sumSuffSec[n] = e[n].second;
	for(int i = n-1; i >= 1; i--) {
		sumSuffEP[i] = sumSuffEP[i+1]+e[i].first*1LL*e[i].second;
		sumSuffSec[i] = sumSuffSec[i+1]+e[i].second;
	}
	for(int i = 1; i <= m; i++) {
		int xi;
		cin >> xi;
		if (xi < inQueue) {
			cout << "INFINITY" << endl;
			continue;
		}
		if (xi >= e[n].first) {
			cout << 0 << endl;
			continue;
		}
		int l = 1, r = n;
		while (l < r) {
			int mid = (l + r) / 2;
			if (e[mid].first <= xi) l = mid + 1; else r = mid;
		}
		cout << sumSuffEP[l] - sumSuffSec[l] * 1LL * xi << endl;
	}
	return 0;
}