#include <algorithm>
#include <iostream>
#include <cmath>
#include <fstream>
#include <string>
#include <vector>

using namespace std;

const int maxN = (int)1e5 + 100;
const int C = 32768;

string a[maxN];
int l, r, use[maxN];

int toInt(string s) {
	int val = 0;
	int zn;
	if (s[0] == '-') zn = -1; else zn = 1;
	for (int i = 0; i < s.size(); ++i) {
		if (s[i] >= '0' && s[i] <= '9') val = val * 10 + s[i] - '0';
	}
	return val * zn;
}

void update(int ind1, int ind2) {
	if (a[ind1] == ">=") l = max(l, toInt(a[ind2])); else
		r = min(r, toInt(a[ind2]));
}

void solve(int i, int j) {
	l = -32768, r = 32767;
	update(i + 1, i + 2);
	if (i + 5 <= j) {
		update(i + 5, i + 6);
	}
	for (int i = l; i <= r; ++i) {
		use[i + C] = true;
	}
	//cerr << l << " " << r << endl;
}

vector<pair<int, int> > ans;

int main() {
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);
	string s;
	int cnt = 0;
	while (cin >> s) {
		++cnt;
		a[cnt] = s;
	}
	for (int val = -32768; val <= 32767; ++val) {
		use[val + C] = 0;
	}
	int i = 1;
	while (i <= cnt) {
		int j = i;
		while (j <= cnt && a[j] != "||") ++j; --j;
		solve(i, j);
		i = j + 2;
	}
	bool used = false;
	int counter = 0;
	for (int i = -32768; i <= 32767; ++i) {
		if (use[i + C] == 1) {
			used = true;
			++counter;
		}
	}
	if (!used) {
		cout << "false" << endl;
		return 0;
	}
	if (counter == 32767 + 32768 + 1) {
		cout << "true" << endl;
		return 0;
	}
	int l = -32768;
	while (l <= 32767) {
		if (use[l + C] == 0) ++l; else {
			int r = l;
			while (r <= 32767 && use[r + C] == 1) ++r; --r;
			ans.push_back(make_pair(l, r));
			l = r + 1;
		}
	}
	for (int i = 0; i < ans.size(); ++i) {
		if (ans[i].first == -32768) {
			cout << "x <= " << ans[i].second;
		} else
		if (ans[i].second == 32767) {
			cout << "x >= " << ans[i].first;
		}
		else {
			cout << "x >= " << ans[i].first << " && x <= " << ans[i].second;
		}
		if (i + 1 != ans.size()) cout << " ||";
		cout << endl;
	}
	return 0;
}