#include <algorithm>
#include <iostream>
#include <cmath>
#include <fstream>
#include <string>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;

const int maxN = 5000 + 100;

ll cnt[maxN], sumX[maxN], sumY[maxN];
int ne[maxN][maxN + maxN], pre[maxN][maxN + maxN];
ll h, m, n, w;

ll sumArithm(ll a, ll b) {
	ll cnt = (b - a) / 2 + 1;
	return cnt * (a + b) / 2;
}

void rem(int h, int num) {
	int _pre = pre[h][num];
	int _ne = ne[h][num];
	ne[h][_pre] = _ne;
	pre[h][_ne] = _pre;
	--cnt[h];
	if (h % 2 == 1) {
		sumX[h] -= n;
		sumY[h] -= (num - 1) * 2 + 1;
	}
	else {
		sumX[h] -= (num - 1) * 2 + 1;
		sumY[h] -= n;
	}
}

bool inRectangle(ll x1, ll y1, ll x2, ll y2, ll x, ll y) {
	if (x <= x1 || x >= x2) return false;
	if (y <= y1 || y >= y2) return false;
	return true;
}

bool goodIndex(int l, int r, int v, int v2) {
	if (abs(v - v2) <= 1000) return true;
	if (v <= 1000 && r - v <= 1000) return true;
	return false;
}

bool collapse(int cur) {
	int counter = 0;
	ll xx = 0, yy = 0;
	for (int i = h; i >= 1; --i) {
		if (cnt[i] == 0 && counter > 0) return true;		
		if (cnt[i] == 0) continue;
		int startIndex = ne[i][0], finishIndex = pre[i][n + 1];
		ll x1, y1, x2, y2;
		if (i % 2 == 1) {
			x1 = 0, x2 = 2 * n;
			y1 = startIndex * 2 - 2;
			y2 = finishIndex * 2;
		}
		else {
			x1 = startIndex * 2 - 2;
			x2 = finishIndex * 2;
			y1 = 0, y2 = 2 * n;
		}
		bool ok = false;
		if (counter == 0) ok = true;
		if (i > cur) ok = true;
		if (cnt[i] == n) ok = true;
		if (goodIndex(1, h, i, cur) && !ok && counter > 0 && inRectangle(x1 * counter, y1 * counter, x2 * counter, y2 * counter, xx, yy)) {
			ok = true;
		}
		if (!ok) return true;
		counter += cnt[i];
		xx += sumX[i];
		yy += sumY[i];
	}
	return false;
}

int main() {
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
	cin >> n >> w;
	cin >> h >> m;
	w = 2;
	for (int i = 1; i <= h; ++i) {
		cnt[i] = n;
		ne[i][0] = 1;
		pre[i][n + 1] = n;
		for (int j = 1; j <= n; ++j) {
			ne[i][j] = j + 1;
			pre[i][j] = j - 1;
		}
		sumX[i] = 0, sumY[i] = 0;
		if (i % 2 == 0) {
			sumX[i] = n * n;
			sumY[i] = sumArithm(1, 2 * n - 1);
		}
		else {
			sumX[i] = sumArithm(1, 2 * n - 1);
			sumY[i] = n * n;
		}
	}
	for (int i = 1; i <= m; ++i) {
		ll l, k;
		cin >> l >> k;
		rem(l, k);
		if (collapse(l)) {
			cout << "yes" << endl;
			cout << i << endl;
			return 0;
		}
	}
	cout << "no" << endl;
	return 0;
}