#include <algorithm>
#include <iostream>
#include <cmath>
#include <fstream>
#include <string>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;
typedef double ld;

const int maxN = 5000 + 100;

ll cnt[maxN];
ld sumX[maxN], sumY[maxN];
int ne[maxN][maxN + maxN], pre[maxN][maxN + maxN];
ll h, m, n, w;

ll sumArithm(ll a, ll b) {
	ll cnt = (b - a) / 2 + 1;
	return cnt * (a + b) / 2;
}

void rem(int h, int num) {
	int _pre = pre[h][num];
	int _ne = ne[h][num];
	ne[h][_pre] = _ne;
	pre[h][_ne] = _pre;
	--cnt[h];
	if (h % 2 == 0) {
		sumX[h] -= w * n / 2;
		sumY[h] -= (num - 1) * w + w / 2;
	}
	else {
		sumX[h] -= (num - 1) * w + w / 2;
		sumY[h] -= w * n / 2;
	}
}

const ld eps = 1e-3;

bool inRectangle(ld x1, ld y1, ld x2, ld y2, ld x, ld y) {
	if (abs(x1 - x) < eps || abs(y1 - y) < eps || abs(x2 - x) < eps || abs(y2 - y) < eps) return false;
	if (x < x1 || x > x2) return false;
	if (y < y1 || y > y2) return false;
	return true;
}

bool collapse(int l) {
	int counter = 0;
	ld xx = 0, yy = 0;
	for (int i = h; i >= 1; --i) {
		if (cnt[i] == 0 && counter > 0) return true;
		if (cnt[i] == 0) continue;
		int startIndex = ne[i][0], finishIndex = pre[i][n + 1];
		ll x1, y1, x2, y2;
		if (i % 2 == 0) {
			x1 = 0, x2 = w * n;
			y1 = startIndex * w - w;
			y2 = finishIndex * w;
		}
		else {
			x1 = startIndex * w - w;
			x2 = finishIndex * w;
			y1 = 0, y2 = w * n;
		}
		bool ok = false;
		if (counter == 0) ok = true;
		if (i >= l + 1) ok = true;
		if (ok == false && counter > 0 && inRectangle(x1 * (ld)counter, y1 * (ld)counter, x2 * (ld)counter, y2 * (ld)counter, xx, yy)) {
			ok = true;
		}
		if (!ok) return true;
		counter += cnt[i];
		xx += (ld)sumX[i];
		yy += (ld)sumY[i];
	}
	return false;
}

int main() {
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
	cin >> n >> w;
	cin >> h >> m;
	w *= 2;
	for (int i = 1; i <= h; ++i) {
		cnt[i] = n;
		ne[i][0] = 1;
		pre[i][n + 1] = n;
		for (int j = 1; j <= n; ++j) {
			ne[i][j] = j + 1;
			pre[i][j] = j - 1;
		}
		sumX[i] = 0, sumY[i] = 0;
		if (i % 2 == 0) {
			sumX[i] = w * n / 2 * n;
			sumY[i] = sumArithm(1, 2 * n - 1) * w / 2;
		}
		else {
			sumX[i] = sumArithm(1, 2 * n - 1) * w / 2;
			sumY[i] = (w * n) / 2 * n;
		}
	}
	for (int i = 1; i <= m; ++i) {
		ll l, k;
		cin >> l >> k;
		rem(l, k);
		if (collapse(l)) {
			cout << "yes" << endl;
			cout << i << endl;
			return 0;
		}
	}
	cout << "no" << endl;
	return 0;
}