#include <algorithm>
#include <iostream>
#include <cmath>
#include <fstream>
#include <string>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;
typedef vector<vector<int> > vv;

const int maxN = 2000 + 100;

vector<vector<int> > a, b, c;
int n1, n2, n3, m1, m2, m3, l1, r1, l2, r2, deltaX, deltaY;

vector<vector<int> >  build(vector<vector<int> > a) {	
	l1 = a.size(), r1 = a[0].size(), l2 = -1, r2 = -1;
	for (int i = 0; i < a.size(); ++i) {
		for (int j = 0; j < a[0].size(); ++j) {
			if (a[i][j] == 1) l1 = min(l1, i), r1 = min(r1, j), l2 = max(l2, i), r2 = max(r2, j);
		}
	}
	vector<vector<int> > ans;	
	for (int i = l1; i <= l2; ++i) {
		vector<int> empty;
		ans.push_back(empty);
		for (int j = r1; j <= r2; ++j) ans[i - l1].push_back(a[i][j]);
	}
	return ans;
}

vector<vector<int> > klad(vector<vector<int> > a, vector<vector<int> > b, int sx, int sy) {
	vector<vector<int> > ans;	
	vector<int> empty;
	int N = max((int)a.size(), (int)b.size() + (int)sx) - min(0, (int)sx);
	int M = max((int)a[0].size(), (int)b[0].size() + sy) - min((int)0, sy);	
	for (int j = 0; j < M; ++j) empty.push_back(0);
	deltaX = max(0, -sx);
	deltaY = max(0, -sy);
	for (int i = 0; i < N; ++i) {
		ans.push_back(empty);	
	}	
	for (int x = 0; x < a.size(); ++x) {
		for (int y = 0; y < a[0].size(); ++y) {
			ans[x + deltaX][y + deltaY] = a[x][y];
		}
	}
	for (int x = 0; x < b.size(); ++x) {
		for (int y = 0; y < b[0].size(); ++y) {
			ans[x + deltaX + sx][y + deltaY + sy] ^= b[x][y];
		}
	}
	ans = build(ans);
	return ans;
}

int get(vv & a) {
	for (int i = 0; i < a[0].size(); ++i) {
		if (a[0][i] != 0) return i;
	}
	return -1;
}

int main() {
	freopen("kids.in", "r", stdin);
	freopen("kids.out", "w", stdout);
	vector<int> empty;
	cin >> n1 >> m1;
	string s;
	getline(cin, s);
	for (int i = 0; i < n1; ++i) {
		string s;
		getline(cin, s);
		a.push_back(empty);
		for (int j = 1; j <= m1; ++j) {
			if (s[j - 1] == '.') a[i].push_back(0); else a[i].push_back(1);
		}
	}
	cin >> n2 >> m2;
	getline(cin, s);
	for (int i = 0; i < n2; ++i) {
		string s;
		getline(cin, s);
		b.push_back(empty);
		for (int j = 1; j <= m2; ++j) {
			if (s[j - 1] == '.') b[i].push_back(0); else b[i].push_back(1);
		}
	}
	cin >> n3 >> m3;
	getline(cin, s); 
	for (int i = 0; i < n3; ++i) {
		string s;
		getline(cin, s);
		c.push_back(empty);
		for (int j = 1; j <= m3; ++j) {
			if (s[j - 1] == '.') c[i].push_back(0); else c[i].push_back(1);
		}
	}
	a = build(a);
	b = build(b);
	c = build(c);
	int indexA = get(a);
	int indexB = get(b);	
	vv d = klad(a, b, 0, indexB - indexA);
	if (d == c) {
		cout << "YES" << endl;
		cout << 0 << " " << indexB - indexA << endl;
		return 0;
	}	
	int X = (int)b.size();
	for (int i = -X; i <= X + 1000; ++i) {
		vv d = klad(a, c, 0, i);		
		if (d == b) {
			cout << "YES" << endl;
			cout << r1 - deltaY << " " << l1 - deltaX << endl;
			return 0;
		}
	}
	cout << "NO" << endl;
	return 0;
}