#include <iostream>
#include <string>  
#include <vector>

using namespace std;

int const MIN = -32768;
int const MAX = 32767;

int used[MAX - MIN + 10];

bool is_digit(char c) {
	return c >= '0' && c <= '9';
}

int main() {

	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);

	string s;

	while (getline(cin, s)) {
		if (s.empty()) break;
		int ok = 0;
		for (auto i : s) if (i == '&') ok = 1;
		if (ok) {
			int le, ri, sgn;
			le = ri = 0;
			int j = 5;
			if (s[j] == '-') sgn = 1, j++;
			else sgn = 0;
			while (is_digit(s[j])) {
				le = le * 10 + s[j] - '0';
				j++;
			}
			if (sgn) le = -le;
			j += 9;
			if (s[j] == '-') sgn = 1, j++;
			else sgn = 0;
			while (is_digit(s[j])) {
				ri = ri * 10 + s[j] - '0';
				j++;
			}
			if (sgn) ri = -ri;
			//cout << le << " .. " << ri << "\n";
			le -= MIN;
			ri -= MIN;
			if (le <= ri) {
				used[le]++;
				used[ri + 1]--;
			}
		}
		else {
			if (s[2] == '>') {
				int le = 0;
				int j = 5;
				int sgn;
				if (s[j] == '-') sgn = 1, j++;
				else sgn = 0;
				while (is_digit(s[j])) {
					le = le * 10 + s[j] - '0';
					j++;
				}
				if (sgn) le = -le;
				//cout << le << " .. ";
				le -= MIN;
				used[le]++;
			} else {
				int ri = 0;
				int j = 5;
				int sgn;
				if (s[j] == '-') sgn = 1, j++;
				else sgn = 0;
				while (is_digit(s[j])) {
					ri = ri * 10 + s[j] - '0';
					j++;
				}
				if (sgn) ri = -ri;
				//cout << " .. " << ri << "\n";
				ri -= MIN;
				used[0]++;
				used[ri + 1]--;
			}
		}
	}

	for (int i = 1; i < MAX - MIN + 1; i++) {
		used[i] += used[i - 1];
	}

	int cnt = 0;

	for (int j = MIN; j <= MAX; j++) {
		cnt += !!used[j - MIN];
	}

	if (cnt == 0) {
		cout << "false\n";
		return 0;
	}

	if (cnt == MAX - MIN + 1) {
		cout << "true\n";
		return 0;
	}

	vector< pair< int, int > > res;

	for (int i = MIN; i <= MAX; i++) {
		if (!used[i - MIN]) continue;
		int j = i;
		while (j <= MAX && used[j - MIN]) j++;
		j--;
		res.push_back(make_pair(i, j));
		i = j;
	}

	for (int it = 0; it < (int)res.size(); it++) {
		if (res[it].first == MIN) {
			cout << "x <= " << res[it].second;
		}
		else if (res[it].second == MAX) {
			cout << "x >= " << res[it].first;
		}
		else {
			cout << "x >= " << res[it].first << " && x <= " << res[it].second;
		}
		if (it + 1 == (int)res.size()) break;
		else cout << " ||\n";
	}

	return 0;
}