#include <iostream>
#include <vector>
#include <string>

#include <cstdio>

using namespace std;

const string filename = "abbreviation";

const int li = -32768, ri = 32767;

bool iscap (char c)
{
    return 'A' <= c && c <= 'Z';
}

bool issm (char c)
{
    return 'a' <= c && c <= 'z';
}

bool isgood (const string &s)
{
    for (int i = 0; i < s.size (); i++)
    {
        if (s[i] == '\n' || s[i] == ',' || s[i] == '.')
            return false;

        if (i > 1 && s[i] == ' ' && s[i - 1] == ' ')
            return false;
    }

    int words = 0;

    for (int l = 0, r; l < s.size (); l = r + 1)
    {
        for (r = l; r < s.size () && s[r] != ' '; r++);

        if (r > l)
        {
            words++;

            int cap = 0, sm = 0;

            for (int i = l; i < r; i++)
                if (iscap (s[i]))
                    cap++;
                else
                    sm++;

            if (cap != 1 || sm == 0 || !iscap (s[l]))
                return false;
        }
    }

    return true;
}

void out (const string &s)
{
    for (auto it : s)
        if (iscap (it))
            cout << it;
}

int main ()
{
    ios_base::sync_with_stdio (false);
    cin.tie (NULL);

    freopen ((filename + ".in").c_str (), "r", stdin);
    freopen ((filename + ".out").c_str (), "w", stdout);

    vector<string> text (1);

    cin.unsetf (ios_base::skipws);

    while (true)
    {
        char c;

        cin >> c;

        if (cin.eof ())
            break;

        text.back ().push_back (c);

        if (c == ' ')
        {
            if (text.back ().size () > 1 && text.back ()[text.back ().size () - 2] == ' ')
            {
                text.back ().pop_back ();
                text.back ().pop_back ();
                text.push_back ("  ");
                text.push_back ("");
            }
        }
        else if (c == ',' || c == '.' || c == '\n')
        {
            text.back ().pop_back ();
            text.push_back (string ("") + c);
            text.push_back ("");
        }
    }

    for (auto str : text)
    {
        while (!str.empty () && str.front () == ' ')
        {
            cout << ' ';
            str = str.substr (1);
        }

        int kost = 0;

        while (!str.empty () && str.back () == ' ')
        {
            kost++;
            str.pop_back ();
        }

        if (str.size () < 3)
        {
            cout << str;
            continue;
        }

        vector<int> sp (1, -1);

        for (int i = 0; i < str.size (); i++)
            if (str[i] == ' ')
                sp.push_back (i);
        sp.push_back (str.size ());

        int pos = 0, r;
        while (pos < sp.size () - 1)
        {
            for (r = pos + 2; r < sp.size () && isgood (str.substr (sp[pos] + 1, sp[r] - sp[pos] - 1)); r++);

            r--;

            if (r == pos + 1)
            {
                r = pos + 1;
                cout << str.substr (sp[pos] + 1, sp[r] - sp[pos]);
            }
            else
            {
                out (str.substr (sp[pos] + 1, sp[r] - sp[pos] - 1));
                cout << " (" << str.substr (sp[pos] + 1, sp[r] - sp[pos] - 1)
                    << (r == sp.size () - 1 ? ")" : ") ");
            }

            pos = r;
        }

        for (int i = 0; i < kost; i++)
            cout << ' ';
    }

    return 0;
}
