#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

#include <cstdio>

using namespace std;

const string filename = "jenga";

int main ()
{
    ios_base::sync_with_stdio (false);
    cin.tie (NULL);

    freopen ((filename + ".in").c_str (), "r", stdin);
    freopen ((filename + ".out").c_str (), "w", stdout);

    int n, w;

    cin >> w >> n;

    int h, q;

    cin >> h >> q;

    n = h;

    vector<pair<int, int>> bor (n, make_pair (0, w));
    vector<vector<int>> ex (n, vector<int> (w));
    vector<int> cnt (n);
    vector<double> x (n), y (n);

    for (int i = 0; i < cnt.size (); i++)
    {
        cnt[i] = (cnt.size () - i - 1) * w;
        y[i] = x[i] = w / 2.0 * cnt[i];
    }

    for (auto &it : ex)
        for (int i = 0; i < it.size (); i++)
            it[i] = i;

    for (int i = 0; i < q; i++)
    {
        int l, p;

        cin >> l >> p;
        l--;
        p--;

        ex[l].erase (lower_bound (ex[l].begin (), ex[l].end (), p));

        if (l != ex.size () - 1 && ex.empty ())
        {
            cout << "yes" << endl;
            cout << i + 1 << endl;

            return 0;
        }

        if (!ex.empty ())
        {
            bor[l].first = ex[l].front ();
            bor[l].second = ex[l].back () + 1;

            if (cnt[l] > 0 && (bor[l].first * (long long)cnt[l] >= (l % 2 == 0 ? x : y)[l] ||
                bor[l].second * (long long)cnt[l] <= (l % 2 == 0 ? x : y)[l]))
            {
                cout << "yes" << endl;
                cout << i + 1 << endl;

                return 0;
            }

            for (int i = 0; i < l; i++)
            {
                cnt[i]--;
                (i % 2 == 0 ? x : y)[i] -= p + 0.5;
                (i % 2 == 0 ? y : x)[i] -= w / 2.0;

                if (bor[i].first * (long long)cnt[i] >= (i % 2 == 0 ? x : y)[i] ||
                    bor[i].second * (long long)cnt[i] <= (i % 2 == 0 ? x : y)[i])
                {
                    cout << "yes" << endl;
                    cout << i + 1 << endl;

                    return 0;
                }
            }
        }
        else
            ex.pop_back ();
    }

    cout << "no" << endl;

    return 0;
}
