#include <bits/stdc++.h>
using namespace std;

const int maxh = 5001;
const int maxn = 10001;

char all[maxh][maxn];

int cnt_lvl[maxh];

pair<int, int> mass[maxh];

pair<pair<int, int>, pair<int, int> > hull[maxh];

void print(pair<int, int> t)
{
    cout << t.first << " " << t.second << endl;
}

bool check(pair<int, int> _bl, pair<int, int> _tr, long long x, pair<long long, long long> test)
{
    pair<long long, long long> bl = _bl;
    pair<long long, long long> tr = _tr;
    bl.first *= x;
    bl.second *= x;

    tr.first *= x;
    tr.second *= x;
    return (test.first > bl.first && test.first < tr.first) && (test.second > bl.second && test.second < tr.second);
}

bool eba(int h, int n)
{
    pair<long long, long long> summ = make_pair(0, 0);
    long long taken = 0;
    for(int i = h; i >= 1; --i)
    {
        if(taken != 0)
        {
            if(cnt_lvl[i] == 0) return 1;
            if(!check(hull[i].first, hull[i].second, taken, summ)) return 1;
        }
        summ.first += mass[i].first;
        summ.second += mass[i].second;
        taken += cnt_lvl[i];
    }
    return 0;
}

void update_hull(int lvl, int n, int w = 2)
{
    int left = -1, right = -1;
    for(int i = 1; i <= n; ++i)
    {
        if(all[lvl][i] == 1)
        {
            left = i;
            break;
        }
    }
    for(int i = n; i >= 1; --i)
    {
        if(all[lvl][i] == 1)
        {
            right = i;
            break;
        }
    }
    if(left == -1)
        return;
    if(lvl % 2 == 1)
    {
        hull[lvl].first = make_pair(w * (left - 1), 0);
        hull[lvl].second = make_pair(w * right, n * w);
    }
    else
    {
        hull[lvl].first = make_pair(0, w * (left - 1));
        hull[lvl].second = make_pair(n * w, w * right);
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    ifstream cin("jenga.in");
    ofstream cout("jenga.out");
    int n, w, h, m;
    cin >> n >> w >> h >> m;
    w = 2;
    for(int i = 1; i <= h; ++i)
    {
        for(int j = 1; j <= n; ++j)
            all[i][j] = 1;
        cnt_lvl[i] = n;
        mass[i] = make_pair(0, 0);
        for(int j = 1; j <= n; ++j)
        {
            pair<int, int> add = make_pair(w * (j - 1) + w / 2, n * w / 2);
            if(i % 2 == 0) swap(add.first, add.second);
            mass[i].first += add.first;
            mass[i].second += add.second;
        }
        hull[i] = make_pair(make_pair(0, 0), make_pair(n * w, n * w));
    }
    for(int i = 0; i < m; ++i)
    {
        int lvl, ind;
        cin >> lvl >> ind;
        cnt_lvl[lvl]--;
        pair<int, int> test = make_pair(w * (ind - 1) + w / 2, n * w / 2);
        if(lvl % 2 == 0) swap(test.first, test.second);
        mass[lvl].first -= test.first;
        mass[lvl].second -= test.second;
        all[lvl][ind] = 0;
        update_hull(lvl, n);
        if(eba(h, n))
        {
            cout << "yes" << endl;
            cout << i + 1 << endl;
            return 0;
        }
    }
    cout << "no" << endl;
    return 0;
}
