#include <iostream>
#include <vector>
#include <algorithm>
#include <string> 
#include <iomanip>

using namespace std;

#define REP(i, n) for (int i = 0; i < n; ++i)
#define DB(x) cerr << #x << ": " << x << endl;

using LL = long long; 

int n, m;

struct Neg
{
  Neg(LL val, LL cost)
    : val(val)
    , cost(cost)
  { }

  Neg() {}

  LL val;
  LL cost;
};

bool operator < (const Neg& lhs, const Neg& rhs) {
  return lhs.val < rhs.val;
}

int main() {
  freopen("expect.in", "r", stdin); 
  freopen("expect.out", "w", stdout); 
  int n, q;
  cin >> q >> n;
  char c;
  LL curVal = 0;
  vector<Neg> neg;
  LL tPrev = 0;
  REP(i, q) {
    LL t, k;
    cin >> c >> t >> k;
    if (curVal < 0) {
      neg.emplace_back(-curVal, t - tPrev);
    }
    int sign = (c == '+') ? +1 : -1;
    curVal += sign * k;
    tPrev = t;
  }
  LL barrier = -curVal;

  sort(neg.begin(), neg.end());

  vector<pair<LL, int>> balances(n);
  REP(i, n) {
    LL startBal;
    cin >> startBal;
    balances[i].first = startBal;
    balances[i].second = i;
  }
  sort(balances.begin(), balances.end());

  LL curCost = 0;
  LL sumCost = 0;
  for (const auto& curNeg : neg) {
    curCost += curNeg.val * curNeg.cost;
    sumCost += curNeg.cost;
  }

  vector<LL> ans(n);

  int curPos = 0;

  LL pBal = 0;
  REP(i, n) {
    LL bal = balances[i].first;
    int id = balances[i].second;
    if (bal < barrier) {
      ans[id] = -1;
      continue;
    }

    while (curPos < static_cast<int>(neg.size()) && neg[curPos].val <= bal) {
      LL val = neg[curPos].val;
      LL cost = neg[curPos].cost;
      curCost -= cost * (val - pBal);
      sumCost -= cost;
      ++curPos;
    }
    curCost -= sumCost * (bal - pBal);
    pBal = bal;
    ans[id] = curCost;
  }

  REP(i, n) {
    if (ans[i] == -1) {
      cout << "INFINITY" << endl;
    } else {
      cout << ans[i] << endl;
    }
  }

	return 0;
}
