#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <queue>
using namespace std;

const int INF = 1000 * 1000 * 1000 + 1;

#define TASK "hard" 

vector < pair < int, int > > v;
vector < pair < int, int > > ans;
string s;


pair < int, int > getSegment(string s)
{
	int j = 2;
	pair <int, int > ans = make_pair(-INF, INF - 1);
	int sign1 = (s.substr(j, 2) == ">=" ? 1 : 0);
	j = 5;
	int value = 0;
	bool neg = false;
	if (s[j] == '-')
	{
		neg = true;
		j++;
	}
	while (j < s.size() && s[j] >= '0' && s[j] <= '9')
	{
		value = value * 10 + s[j] - '0';
		j++;
	}
	j++;
	if (neg)
		value *= -1;
	if (sign1)
		ans.first = value;
	else
		ans.second = value;
	if (j < s.size() && s[j] == '&')
	{
		j = j + 5;
		int sign2 = (s.substr(j, 2) == "<=" ? 0 : 1);
		j += 3;
		neg = false;
		if (s[j] == '-')
		{
			neg = true;
			j++;
		}
		value = 0;
		while (j < s.size() && s[j] >= '0' && s[j] <= '9')
		{
			value = value * 10 + s[j] - '0';
			j++;
		}
		if (neg)
			value *= -1;
		if (sign2)
			ans.first = value;
		else
			ans.second = value;
	}
	return ans;
}



void printSegment(int l, int r, bool last)
{
	if (l == -INF)
	{
		printf("x <= %d", r);
		if (!last)
			printf(" ||\n");
		return;
	}
	if (r == INF - 1)
	{
		printf("x >= %d", l);
		if (!last)
			printf(" ||\n");
		return;
	}
	printf("x >= %d && x <= %d", l, r);
	if (!last)
		printf(" ||\n");
	return;
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	while (getline(cin, s))
	{
		pair < int, int > seg = getSegment(s);
		if (seg.first <= seg.second)
		{
			v.push_back(seg);
		}
		if (s[(int)s.size() - 1] != '|')
			break;
	}
	if (v.size() == 0)
	{
		printf("false");
		return 0;
	}
	sort(v.begin(), v.end());
	int l = v[0].first, r = v[0].second;
	for (int i = 1; i < v.size(); ++i)
	{
		if (v[i].first <= r + 1)
		{
			r = max(r, v[i].second);
		}
		else
		{
			ans.push_back(make_pair(l, r));
			l = v[i].first, r = v[i].second;
		}
	}
	ans.push_back(make_pair(l, r));
	if (ans.size() == 1 && ans[0].first == -INF && ans[0].second == INF - 1)
	{
		printf("true\n");
		return 0;
	}
	for (int i = 0; i < ans.size(); ++i)
	{
		printSegment(ans[i].first, ans[i].second, i == (int)ans.size() - 1);
	}
	return 0;
}