#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <queue>
using namespace std;

#define TASK "jenga" 
#define int64 long long
#define mp make_pair

const int64 INF = 6e18;
const int N = 10100;

int n, w, h, m, cnt[N], l[N], r[N];
int64 sumMX[N], sumMY[N];
bool s[N][N];

int getMX(int lvl, int k)
{
	if (lvl & 1) return 2 * (k - 1) * w + w;
	return n * w;
}

int getMY(int lvl, int k)
{
	if (!(lvl & 1)) return 2 * (k - 1) * w + w;
	return n * w;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	scanf("%d%d", &n, &w);
	scanf("%d%d", &h, &m);
	memset(s, true, sizeof(s));
	for (int i = 1; i <= h; i++)
	{
		for (int j = 1; j <= n; j++)
		{
			sumMX[i] += getMX(i, j);
			sumMY[i] += getMY(i, j);
			cnt[i]++;
		}
		l[i] = 0;
		r[i] = n * w;
	}
	for (int i = 1; i <= m; i++)
	{
		int lvl, k;
		scanf("%d%d", &lvl, &k);
		cnt[lvl]--;
		sumMX[lvl] -= getMX(lvl, k);
		sumMY[lvl] -= getMY(lvl, k);
		s[lvl][k] = false;
		l[lvl] = -1;
		r[lvl] = -1;
		for (int j = 1; j <= n; j++)
		{
			if (s[lvl][j])
			{
				l[lvl] = w * (j - 1);
				break;
			}
		}
		for (int j = n; j >= 1; j--)
		{
			if (s[lvl][j])
			{
				r[lvl] = n * w - (n - j) * w;
				break;
			}
		}
		int64 sumx = 0, sumy = 0, cntc = 0;
		int htmp = -1;
		for (int j = h; j >= 1; j--)
		{
			if (cnt[j] != 0)
			{
				htmp = j;
				break;
			}
		}
		for (int j = htmp; j >= 2; j--)
		{
			sumx += sumMX[j];
			sumy += sumMY[j];
			cntc += cnt[j];
			if (l[j - 1] == -1)
			{
				cout << "yes" << endl;
				cout << i;
				return 0;
			}
			if ((j - 1) & 1)  //check
			{
				if (sumx <= 2ll * cntc * l[j - 1] || sumx >= 2ll * cntc * r[j - 1])
				{
					cout << "yes" << endl;
					cout << i;
					return 0;
				}
			}
			else
			{
				if (sumy <= 2 * cntc * l[j - 1] || sumy >= 2 * cntc * r[j - 1])
				{
					cout << "yes" << endl;
					cout << i;
					return 0;
				}
			}
		}
	}
	cout << "no";
	return 0;
}