#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <string>
#include <cstring>
#include <cassert>

using namespace std;


#define fst first
#define snd second
#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back

template<typename T>
T abs(T x) {
	return x > 0 ? x : -x;
}

template<typename T>
T sqr(T x) {
	return x * x;
}

template<typename U, typename V>
ostream& operator << (ostream &s, const pair<U, V> &x) {
	return s << "(" << x.fst << ", " << x.snd << ")";
}

template<typename T>
ostream& operator << (ostream &s, const vector<T> &x) {
	s << "[";
	for (auto y : x) {
		s << y << ", ";
	}
	s << "]";
	return s;
}

const int m = 2;
const ll mods[m] = { 1000000007, 1000000009 };
const ll base[m] = { 43, 73 };

ll bpow(ll x, ll n, ll md) {
	ll res = 1;
	while (n) {
		if (n & 1) {
			res = res * x % md;
		}
		x = x * x % md;
		n >>= 1;
	}
	return res;
}

struct H {
	ll a[m];
	H() {
		fill(a, a + m, 0);
	}

	H shift() const {
		H res;
		for (int i = 0; i < m; i++) {
			res.a[i] = a[i] * base[i] % mods[i];
		}
		return res;
	}

	H(ll x) {
		for (int i = 0; i < m; i++) {
			a[i] = x % mods[i];
		}
	}

	H operator + (const H &rhs) const {
		H res;
		for (int i = 0; i < m; i++) {
			res.a[i] = (a[i] + rhs.a[i]) % mods[i];
		}
		return res;
	}
	
	bool operator < (const H &rhs) const {
		for (int i = 0; i < m; i++) {
			if (a[i] != rhs.a[i]) {
				return a[i] < rhs.a[i];
			}
		}
		return false;
	}
};

const int maxn = 10e6 + 12345;

char tmp[maxn];

map<H, int> hh;

vector<int> g[maxn];
vector<int> gt[maxn];

int used[maxn];
vector<int> order;

void dfs(int v) {
	used[v] = 1;
	for (int to : g[v]) {
		if (!used[to]) {
			dfs(to);
		}
	}
	order.pb(v);
}

int comp[maxn];
void mark(int v, int cc) {
	comp[v] = cc;
	for (int to : g[v]) {
		if (comp[to] == -1) {
			mark(to, cc);
		}
	}
}

const int start = 2e6 + 125;
int ptr = start;
int getNxt() {
	return ptr++;
}

int get(H h) {
	int id = hh.size();
	if (hh.count(h) == 0) {
		hh[h] = id;
	}
	return hh[h];
}

vector<int> eqCl[maxn];
vector<int> eqClSuff[maxn], eqClPref[maxn];

void add(int u, int v) {
	g[u].pb(v);
	gt[v].pb(u);
}

int main() {
#ifdef LOCAL
	freopen("a.in", "r", stdin);
#else
	freopen("cactus.in", "r", stdin);
	freopen("cactus.out", "w", stdout);
#endif

	int n;
	scanf("%d\n", &n);

	vector<vector<string>> a(n, vector<string>(2));
	for (int i = 0; i < n; i++) {
		scanf("%s", tmp);
		string s(tmp);

		auto s0 = s, s1 = s;

		for (int j = 0; j < s.size(); j++) {
			if (s[j] == '?') {
				s0[j] = '0';
				s1[j] = '1';
			}
		
		}

		a[i][0] = s0;
		a[i][1] = s1;
	}


	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 2; j++) {
			H res;
			for (int h = 0; h < a[i][j].size(); h++) {
				res = res.shift() + H(a[i][j][h]);
			}

			eqCl[get(res)].pb(2 * (2 * i + j));
		}
	}

	for (int i = 0; i < hh.size(); i++) {
		sort(eqCl[i].begin(), eqCl[i].end());

		eqClSuff[i].resize(eqCl[i].size());
		eqClPref[i].resize(eqCl[i].size());

		for (int j = 0; j < eqCl[i].size(); j++) {
			eqClPref[i][j] = getNxt();

			add(eqClPref[i][j], eqCl[i][j]);
			if (j) {
				add(eqClPref[i][j], eqClPref[i][j - 1]);
			}
		}

		for (int j = (int)eqCl[i].size() - 1; j >= 0; j--) {
			eqClSuff[i][j] = getNxt();
			add(eqClSuff[i][j], eqCl[i][j]);
			if (j + 1 < eqCl[i].size()) {
				add(eqClSuff[i][j], eqClSuff[i][j + 1]);
			}
		}
	}

	
	for (int i = 0; i < n; i++) {
		if (a[i][0] == a[i][1]) {
			add((2 * i + 0) * 2, (2 * i + 1) * 2 + 1);
			add((2 * i + 1) * 2 + 1, (2 * i + 0) * 2 + 0);
		}
		else {
			add((2 * i + 0) * 2, (2 * i + 1) * 2 + 1);
			add((2 * i + 1) * 2, (2 * i + 0) * 2 + 1);
		}
		for (int j = 0; j < 2; j++) {
			if (a[i][0] == a[i][1] && j) {
				continue;
			}

			H res;
			for (int h = 0; h + 1 < a[i][j].size(); h++) {
				res = res.shift() + H(a[i][j][h]);

				if (hh.count(res)) {
					add((2 * i + j) * 2 + 1, eqClPref[get(res)][0]);
				}
			}

			res = res.shift() + H(a[i][j].back());

			if (hh.count(res)) {
				int id = get(res);
				int p = lower_bound(eqCl[id].begin(), eqCl[id].end(), 2 * (2 * i + j)) - eqCl[id].begin();

				if (p) {
					add((2 * i + j) * 2 + 1, eqClPref[id][p - 1]);
				}

				if (p + 1 < eqCl[id].size()) {
					add((2 * i + j) * 2 + 1, eqClSuff[id][p + 1]);
				}
			}
		}
	}

	

	for (int i = 0; i < maxn; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}

	

	fill(comp, comp + maxn, -1);
	reverse(order.begin(), order.end());
	int cc = 0;
	for (int v : order) {
		if (comp[v] == -1) {
			mark(v, cc++);
		}
	}


//	cout << a << endl;

	vector<string> ans;
	for (int i = 0; i < n; i++) {
		if (comp[2 * (2 * i + 0)] > comp[2 * (2 * i + 0) + 1]) {
			ans.pb(a[i][0]);
			continue;
		}

		if (comp[2 * (2 * i + 1)] > comp[2 * (2 * i + 1) + 1]) {
			ans.pb(a[i][1]);
			continue;
		}

		cout << "NO" << endl;
		return 0;
	}
	printf("YES\n");
	for (auto s : ans) {
		printf("%s\n", s.c_str());
	}
	
	return 0;
}