#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <string>
#include <cstring>
#include <cassert>

using namespace std;


#define fst first
#define snd second
#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back

template<typename T>
T abs(T x) {
	return x > 0 ? x : -x;
}

template<typename T>
T sqr(T x) {
	return x * x;
}

template<typename U, typename V>
ostream& operator << (ostream &s, const pair<U, V> &x) {
	return s << "(" << x.fst << ", " << x.snd << ")";
}

template<typename T>
ostream& operator << (ostream &s, const vector<T> &x) {
	s << "[";
	for (auto y : x) {
		s << y << ", ";
	}
	s << "]";
	return s;
}

const int maxn = 1e6 + 5;

vector<pair<int, int>> g[maxn];
int used[maxn];
int cycleId[maxn];
vector<vector<int>> cycles;
vector<int> cyclesH[maxn];
int pr[maxn];
int prE[maxn];

void dfs(int v, int p) {
	used[v] = 1;
	for (auto to : g[v]) {
		if (to.fst == p) {
			continue;
		}

		if (cycleId[to.snd] != -1) {
			continue;
		}

		if (used[to.fst]) {
			vector<int> c;
			int u = v;
			while (u != to.fst) {
				c.pb(u);
				cycleId[prE[u]] = cycles.size();
				u = pr[u];
			}
			c.pb(to.fst);
			cycleId[to.snd] = cycles.size();
			cyclesH[to.fst].pb(cycles.size());
			cycles.pb(c);
		}
		else {
			pr[to.fst] = v;
			prE[to.fst] = to.snd;
			dfs(to.fst, v);
		}
	}
}

vector<pair<pair<int, int>, pair<int, int>>> ans;

void join(int a, int b) {
	ans.pb(mp(mp(0, 0), mp(a, b)));
}

void recolor(int a, int c1, int c2) {
	ans.pb(mp(mp(1, a), mp(c1, c2)));
}

void connect(int a, int c1, int c2) {
	ans.pb(mp(mp(2, a), mp(c1, c2)));
}



void rec(int v, int p) {
	for (auto to : g[v]) {
		if (to.fst == p) {
			continue;
		}
		if (cycleId[to.snd] == -1) {
			rec(to.fst, v);
			join(to.fst, v);
			connect(to.fst, 3, 1);
			recolor(to.fst, 3, 2);
		}
	}

	for (auto id : cyclesH[v]) {
		auto c = cycles[id];
		c.pop_back();

		int prv = 1;
		for (int i = 0; i + 1 < c.size(); i++) {
			int u = c[i];

			rec(u, (i == 0 ? v : c[i - 1]));

			join(u, v);
			connect(v, 3, prv);
			if (prv == 4) {
				recolor(v, 4, 2);
			}
			prv = 4;
			recolor(v, 3, 4);
		}

		rec(c.back(), -1);
		join(v, c.back());
		connect(v, 3, 1);
		connect(v, 3, 4);
		recolor(v, 4, 2);
		recolor(v, 3, 2);
	}

	recolor(v, 1, 3);
}

int main() {
#ifdef LOCAL
	freopen("a.in", "r", stdin);
#else
	freopen("cactus.in", "r", stdin);
	freopen("cactus.out", "w", stdout);
#endif

	int n, m;
	scanf("%d %d", &n, &m);

	int id = 0;
	for (int i = 0; i < m; i++) {
		int k;
		scanf("%d", &k);

		vector<int> p(k);
		for (int j = 0; j < k; j++) {
			scanf("%d", &p[j]);
		}

		for (int j = 0; j + 1 < k; j++) {
			int u = p[j], v = p[j + 1];
			g[u].pb(mp(v, id));
			g[v].pb(mp(u, id));
			id++;
		}
	}

	fill(cycleId, cycleId + maxn, -1);

	dfs(1, -1);


	rec(1, -1);

	printf("%d\n", ans.size());

	assert(ans.size() < 1e6);

	for (auto x : ans) {
		if (x.fst.fst == 0) {
			printf("j %d %d\n", x.snd.fst, x.snd.snd);
		}
		else if (x.fst.fst == 1) {
			printf("r %d %d %d\n", x.fst.snd, x.snd.fst, x.snd.snd);
		}
		else {
			printf("c %d %d %d\n", x.fst.snd, x.snd.fst, x.snd.snd);
		}
	}

	
	

	return 0;
}