#include<string>
#include<vector>
#include<fstream>
using namespace std;


vector<string> getTokens(string line) {
	vector<string> ret;

	string cur;
	for(char c : line) {
		if( ('a' <= c && c <= 'z') || ('A' <= c && c <= 'Z') ) {
			cur.push_back(c);
		}
		else {
			if(cur != "") {
				ret.push_back(cur);
				cur = "";
			}

			ret.push_back(string(1, c));
		}
	}
	if(cur != "")
		ret.push_back(cur);

	return ret;
}


bool capitalized(string s) {
	if(s[0] < 'A' || s[0] > 'Z')
		return false;

	if(s.size() < 2)
		return false;

	for(int i=1;i<(int)s.size();i++)
		if(s[i] < 'a' || s[i] > 'z')
			return false;

	return true;
}




int main() {
	ifstream in("abbreviation.in");
	ofstream out("abbreviation.out");

	string line;
	while(getline(in, line) ) {
		vector<string> tokens = getTokens(line);

		for(int i=0;i<(int)tokens.size();i++) {
			if(i+2 < (int)tokens.size() && capitalized(tokens[i]) && tokens[i+1] == " " && capitalized(tokens[i+2]) ) {
				int j = i+4;
				while(j < (int)tokens.size() && tokens[j-1] == " " && capitalized(tokens[j]) )
					j+=2;
				j--;

				for(int c=i; c<j; c+=2)
					out << tokens[c][0];
				out << " (" << tokens[i];
				for(int c=i+2; c < j; c+=2)
					out << ' ' << tokens[c];
				out << ")";
				i = j-1;
			}
			else {
				out << tokens[i];
			}

		}
		out << '\n';
	}

	return 0;
}



