#include<fstream>
#include<vector>
#include<algorithm>
#define f first
#define s second
using namespace std;

struct Query {
	int cycle;
	bool type;
	int val;
};

bool operator<(Query l, Query r) {
	return l.cycle < r.cycle;
}


int main() {
	ifstream in("expect.in");
	ofstream out("expect.out");

	int n, q;
	in >> n >> q;

	vector<pair<int, int> > give, take;
	int giveSum = 0, takeSum = 0;
	int start = 0;

	for(int i=0;i<n;i++) {
		char c;
		in >> c;
		int t, k;
		in >> t >> k;

		if(c == '+') {
			give.push_back({t, k});
			giveSum += k;
		}
		else {
			take.push_back({t, k});
			takeSum += k;
		}
	}

	if(takeSum > giveSum) {
		start = takeSum - giveSum;

		int left = start, ind = 0;
		while(ind < (int)take.size() && take[ind].s <= left) {
			left -= take[ind].s;
			ind++;
		}

		take = vector<pair<int, int> >(take.begin()+ind, take.end());
		if(take.size() > 0)
			take[0].s -= left;

		takeSum = giveSum;
	}
	else {
		int left = giveSum - takeSum;

		while(left > 0) {
			int mn = min(left, give.back().s);
			left -= mn;
			give.back().s -= mn;

			if(give.back().s == 0)
				give.pop_back();
		}
		giveSum = takeSum;
	}


	long long toAdd = 0, total = 0;
	for(auto c : give)
		total += 1LL * c.f * c.s;
	for(auto c : take)
		total -= 1LL * c.f * c.s;

	//Now finally generate the queries
	vector<Query> query;

	//First the take drops
	{
		int tstart = 0, gstart = 0;
		for(int i=0, j=0; i < (int)take.size();tstart += take[i++].s) {
			while(j < (int)give.size() && take[i].f >= give[j].f) {
				gstart += give[j].s;
				j++;
			}

			query.push_back({tstart - gstart, 0, take[i].f});
			query.push_back({tstart - gstart + take[i].s, 0, -take[i].f});
		}
	}

	//Now the give drops
	{
		int tstart = takeSum, gstart = giveSum;
		for(int i=give.size()-1, j = take.size()-1; i >= 0; gstart -= give[i--].s) {
			while(j >= 0 && give[i].f <= take[j].f) {
				tstart -= take[j--].s;
			}

			query.push_back({tstart - gstart, 0, -give[i].f});
			query.push_back({tstart - gstart + give[i].s, 0, give[i].f});
		}
	}


	for(int i=0;i<q;i++) {
		int b;
		in >> b;
		query.push_back({b-start, 1, i});
	}

	sort(query.begin(), query.end() );
	vector<long long> result(q);

	int ctime = 0;

	for(auto cq : query) {
		int ntime = cq.cycle;
		total += toAdd * (ntime - ctime);
		ctime = ntime;

		if(cq.type == 0) {
			toAdd += cq.val;
		}
		else {
			if(ctime < 0)
				result[cq.val] = -1;
			else
				result[cq.val] = total;
		}
	}

	for(auto c : result) {
		if(c == -1)
			out << "INFINITY\n";
		else
			out << c << '\n';
	}

	return 0;
}