#include<fstream>
#include<vector>
#include<algorithm>
#define f first
#define s second
using namespace std;

struct Area {
	vector<vector<bool> > data;
	int n, m;

	void init(vector<vector<bool> > base) {
		int cn = base.size(), cm = base[0].size();
		int lx = cm, ly = cn, rx = 0, ry = 0;

		for(int i=0;i<cn;i++)
			for(int j=0;j<cm;j++)
				if(base[i][j]) {
					lx = min(lx, j);
					ly = min(ly, i);
					rx = max(rx, j);
					ry = max(ry, i);
				}

		lx = 0;
		ly = 0;
		rx = cm-1;
		ry = cn-1;

		if(lx > rx) {
			n = 0, m = 0;
			return;
		}

		data = vector<vector<bool> > (ry-ly+1, vector<bool>(rx-lx+1));

		for(int i=ly;i<=ry;i++)
			for(int j=lx; j <= rx; j++) {
				data[i-ly][j-lx] = base[i][j];
			}
		n = ry - ly + 1;
		m = rx - lx + 1;
	}

	pair<int, int> getUl() {
		for(int i=0;i<n;i++)
			for(int j=0;j<m;j++)
				if(data[i][j])
					return {j, i};
		return {-1, -1};
	}
};

pair<int, int> operator+(pair<int, int> l, pair<int, int> r) {
	return {l.f + r.f, l.s + r.s};
}
pair<int, int> operator-(pair<int, int> l, pair<int, int> r) {
	return {l.f - r.f, l.s - r.s};
}

Area combine(Area l, Area r, pair<int, int> d) {
	int ldx = max(0, -d.f);
	int ldy = max(0, -d.s);
	int rdx = max(0, d.f);
	int rdy = max(0, d.s);

	int n = max(l.n + ldy, r.n + rdy);
	int m = max(l.m + ldx, r.m + rdx);

	vector<vector<bool> > base(n, vector<bool>(m, false) );

	for(int i=0;i<l.n;i++)
		for(int j=0;j<l.m;j++)
			base[i+ldy][j+ldx] = (base[i+ldy][j+ldx] ^ l.data[i][j]);

	for(int i=0;i<r.n;i++)
		for(int j=0;j<r.m;j++)
			base[i+rdy][j+rdx] = (base[i+rdy][j+rdx] ^ r.data[i][j]);

	Area ret;
	ret.init(base);
	return ret;
}





int main() {
	ifstream in("kids.in");
	ofstream out("kids.out");
	
	Area a[3];
	for(int ind=0;ind<3;ind++) {
		int h, w;
		in >> h >> w;

		vector<vector<bool> > base(h, vector<bool>(w, false) );

		for(int i=0;i<h;i++)
			for(int j=0;j<w;j++) {
				char c;
				in >> c;
				base[i][j] = (c == '*');
			}
		
		a[ind].init(base);
	}

	//First place A and then B
	{
		pair<int, int> m1 = a[2].getUl() - a[0].getUl();
		Area c = combine(a[2], a[0], m1);
		m1 = {max(0, m1.f), max(0, m1.s)};

		pair<int, int> m2 = c.getUl() - a[1].getUl();
		c = combine(c, a[1], m2);

		if(c.getUl().f == -1) {
			out << "YES\n";
			pair<int, int> mov = m2 - m1;
			out << mov.f << ' ' << mov.s << '\n';
			return 0;
		}
	}
	//Next place B and then A
	{
		pair<int, int> m1 = a[2].getUl() - a[1].getUl();
		Area c = combine(a[2], a[1], m1);
		m1 = {max(0, m1.f), max(0, m1.s)};

		pair<int, int> m2 = c.getUl() - a[0].getUl();
		c = combine(c, a[0], m2);
		if (c.getUl().f == -1) {
			out << "YES\n";
			pair<int, int> mov = m1 - m2;
			out << mov.f << ' ' << mov.s << '\n';
			return 0;
		}
	}
	//Finally place their xor
	{
		pair<int, int> m1 = a[0].getUl() - a[1].getUl();
		Area c = combine(a[0], a[1], m1);

		pair<int, int> m2 = a[2].getUl() - c.getUl();
		c = combine(a[2], c, m2);

		if (c.getUl().f == -1) {
			out << "YES\n";
			out << m1.f << ' ' << m1.s << '\n';
		}
	}

	out << "NO\n";

	return 0;
}