import java.io.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.StringTokenizer;

public class Main {

    public static void main(String[] args) throws IOException {
	    new Main().solve();
    }

    String file = "hard";
    void solve() throws IOException {


        Reader in = new Reader(file+".in");
        PrintWriter out = new PrintWriter(new FileOutputStream(file+".out"));
        String line;
        int minv = -32768;
        int maxv = 32767;
        boolean correct = false;
        StringTokenizer tok;
        ArrayList<Pair> pairs = new ArrayList<>();
        boolean left = false;
        while ((line = in.nextLine()) != null) {
            if (line.equals("")) break;
            tok = new StringTokenizer(line," ");
            int a = minv;
            int b = maxv;
            int val = 0;
            while (tok.hasMoreTokens()) {
                String tmp = tok.nextToken();
                if (tmp.equals(">=")) {
                    left = true;
                }
                if (tmp.equals("<=")) {
                    left = false;
                }
                try {
                    val = Integer.valueOf(tmp);
                    if (left) a = val; else b = val;
                } catch (Exception e) {}
            }
            //if (a <= b)
                pairs.add(new Pair(a,b));
        }

        Collections.sort(pairs);
        ArrayList<Pair> ans = new ArrayList<>();
        String ansline = "";
        int l = pairs.get(0).a;
        int r = pairs.get(0).b;
        for (int i = 1; i < pairs.size(); i++) {
            Pair p = pairs.get(i);
//            System.out.println(l+" "+r+" "+p.a+" "+p.b+" "+(p.a-r));
            if (p.a - r <= 1) {
                if (p.b > r) r = p.b;
            } else {
                if (l <= r) {
                    ans.add(new Pair(l,r));
                    if (l == minv && r == maxv) correct = true;
                }
                l = p.a;
                r = p.b;
            }
        }

        if (l <= r) {
            ans.add(new Pair(l,r));
            if (l == minv && r == maxv) correct = true;
        }

//        System.out.println(ans.size());
        if (ans.size() == 0) {
            out.println("false");
        } else {
            if (correct) {
                out.println("true");
            } else {
                for (int i = 0; i < ans.size(); i++) {
                    Pair pr = ans.get(i);
                    String str = "";
//                    if (pr.a == minv && pr.b == minv) {
//                        str = "x >= "+pr.a+" && x <= "+pr.b;
//                    } else if (pr.a == maxv && pr.b == maxv) {
//                        str = "x >= "+pr.a+" && x <= "+pr.b;
//                    } else
                        if (pr.a == minv) {
                        str = "x <= "+pr.b;
                    } else if (pr.b == maxv) {
                        str = "x >= "+pr.a;
                    } else {
                        str = "x >= "+pr.a+" && x <= "+pr.b;
                    }
                    if (i != ans.size()-1) {
                        str += " ||";
                    }
                    out.println(str);
                }
            }
        }

        out.flush();
        out.close();
    }

    class Pair implements Comparable<Pair> {
        int a;
        int b;

        Pair(int a, int b) {
            this.a = a;
            this.b = b;
        }

        @Override
        public int compareTo(Pair o) {
            if (a != o.a) return Integer.compare(a,o.a);
            return Integer.compare(b,o.b);
        }
    }

    class Reader {
        BufferedReader in;
        StringTokenizer tok;
        Reader(String file) throws IOException{
            in = new BufferedReader(new FileReader(file));

        }

        String next() throws IOException {
            while (tok == null && !tok.hasMoreElements()) {
                tok = new StringTokenizer(in.readLine());
            }
            return tok.nextToken();
        }

        int nextInt() throws IOException {
            return Integer.valueOf(next());
        }

        double nextDouble() throws IOException {
            return Double.valueOf(next());
        }

        String nextLine() throws IOException {
            return in.readLine();
        }

    }
}
