#define _CRT_SECURE_NO_DEPRECATE
#pragma comment(linker, "/STACK:100000000000")

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>
#include <sstream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <stack>
#include <queue>
#include <deque>
#include <list>
#include <iomanip>
#include <climits>
#include <algorithm>
#include <cmath>

typedef long long ll;
typedef std::pair<int, int> pii;
typedef std::pair<ll, ll> pll;
typedef std::pair<double, double> pdd;

#define fori(N) for(int i = 0;i<(N);i++)
#define fori1(N) for(int i = 1;i<=(N);i++)
#define forj(N) for(int j = 0;j<(N);j++)
#define forj1(N) for(int j = 1;j<=(N);j++)
#define fork(N) for(int k = 0;k<(N);k++)
#define fork1(N) for(int k = 1;k<=(N);k++)
#define mp make_pair

 #define File "cactus"
using namespace std;
#if defined(_DEBUG) || defined(_RELEASE)
const int maxn = 1000;
const int maxm = 1000;
#else
const int maxm = 51000;
const int maxn = 500000;
#endif
int n, m;
vector<int>inCycles[maxm];
map<int, int>edges[maxm];
vector<int>cycles[maxn];
int cyclesCount;
int curStack[maxm];
int stackSize;
bool vis[maxm];
bool popped[maxm];
void find_cycles(int a, int parent){
	if (popped[a])return;
	if (vis[a]){
		int prev = a;
		int i = stackSize - 1;
		cyclesCount++;
		cycles[cyclesCount - 1].push_back(a);
		while (curStack[i] != a){
			int x = curStack[i];
			edges[x][prev] = edges[prev][x] = cyclesCount - 1;
			cycles[cyclesCount - 1].push_back(x);
			prev = x;
			i--;
		}
		i++;
		int x = curStack[i];
		edges[a][x] = edges[x][a] = cyclesCount - 1;



		return;
	}
	vis[a] = 1;
	curStack[stackSize++] = a;
	for (map<int, int>::iterator it = edges[a].begin(); it != edges[a].end(); it++){
		if (it->first == parent)continue;
		find_cycles(it->first, a);
	}
	popped[a] = 1;
	stackSize--;
}
struct operation{
	int type;
	int a, b, c;
};

vector<operation>answer;

void color(int a, int b, int c){
	operation now;
	now.type = 1;
	now.a = a;
	now.b = b;
	now.c = c;
	answer.push_back(now);

}
void join(int a, int b){
	operation now;
	now.type = 2;
	now.a = a;
	now.b = b;
	answer.push_back(now);
}
void connect(int a, int b, int c){
	operation now;
	now.type = 3;
	now.a = a;
	now.b = b;
	now.c = c;
	answer.push_back(now);

}
void connectEdge(int a, int exCycle, int exVert);

void connectCycle(int a, int cyc){
	vector<int> &curCycle = cycles[cyc];
	int k = curCycle.size();
	fori(k){
		if (curCycle[i] == a)continue;
		connectEdge(curCycle[i], cyc, -1);
	}
	int pos = 0;
	while (curCycle[pos] != a)pos++;
	int cur = (pos + 1) % k;
	color(curCycle[cur], 2, 4);
	int cur2 = (cur + 1) % k;
	join(curCycle[cur], curCycle[cur2]);
	connect(curCycle[cur], 2, 4);
	color(curCycle[cur], 2, 3);

	for (cur2 = (cur2 + 1) % k; cur2 != pos; cur2 = (cur2 + 1) % k){
		cur = (cur + 1) % k;
		int x = curCycle[cur];
		int y = curCycle[cur2];
		join(x, y);
		connect(x, 2, 3);
		color(x, 3, 1);
		color(x, 2, 3);
	}
	int x = (pos + 1) % k;
	x = curCycle[x];
	color(x, 3, 2);
	color(x, 4, 2);
	//for (int i = pos + 1; i != a; i = (i+1)%k)c




}

void connectEdge(int a, int exCycle, int exVert){
	for (map<int, int>::iterator it = edges[a].begin(); it != edges[a].end(); it++){
		if (it->second == -1 && it->first != exVert)connectEdge(it->first, -1, a);
	}

	fori(inCycles[a].size()){
		if (inCycles[a][i] == exCycle)continue;
		int curCycle = inCycles[a][i];
		connectCycle(a, curCycle);
	}
	color(a, 1, 4);

	for (map<int, int>::iterator it = edges[a].begin(); it != edges[a].end(); it++){
		if (it->second == -1 && it->first != exVert){
			join(a, it->first);
		}
	}

	fori(inCycles[a].size()){
		if (inCycles[a][i] == exCycle)continue;
		int curCycle = inCycles[a][i];
		int j = 0;
		while (cycles[curCycle][j] == a)j++;
		join(a, cycles[curCycle][j]);
	}
	connect(a, 2, 4);
	color(a, 2, 1);
	color(a, 4, 2);
}


int main() {
#if defined(_DEBUG) || defined(_RELEASE)
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#else
	freopen(File".in", "r", stdin); freopen(File".out", "w", stdout);
#endif
	cin >> n >> m;
	fori(m){
		int c; cin >> c;
		int prev; cin >> prev;
		forj(c - 1){
			int a; cin >> a;
			edges[a][prev] = edges[prev][a] = -1;
			prev = a;

		}
	}
	find_cycles(1, -1);
	fori(cyclesCount)forj(cycles[i].size())
		inCycles[cycles[i][j]].push_back(i);

	connectEdge(1, -1, -1);
	cout << answer.size() << "\n";
	fori(answer.size()){
		operation now = answer[i];
		if (now.type == 1){
			cout << "r " << now.a << " " << now.b << " " << now.c << "\n";
		}
		else if (now.type == 2){
			cout << "j " << now.a << " " << now.b << "\n";
		}
		else{
			cout << "c " << now.a << " " << now.b << " " << now.c << "\n";
		}
	}

	exit(0);
	return 0;
}