#define _CRT_SECURE_NO_DEPRECATE
#pragma comment(linker, "/STACK:100000000000")

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>
#include <sstream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <stack>
#include <queue>
#include <deque>
#include <list>
#include <iomanip>
#include <climits>
#include <algorithm>
#include <cmath>

typedef long long ll;
typedef std::pair<int, int> pii;
typedef std::pair<ll, ll> pll;
typedef std::pair<double, double> pdd;

#define fori(N) for(int i = 0;i<(N);i++)
#define fori1(N) for(int i = 1;i<=(N);i++)
#define forj(N) for(int j = 0;j<(N);j++)
#define forj1(N) for(int j = 1;j<=(N);j++)
#define fork(N) for(int k = 0;k<(N);k++)
#define fork1(N) for(int k = 1;k<=(N);k++)
#define mp make_pair

#define File "jenga"
using namespace std;

#if defined(_DEBUG) || defined(_RELEASE)
const int maxn = 50;
const int maxm = 60;
#else
const int maxn = 5100;
const int maxm = 11000;
#endif

ll n, h, m;

ll levelX[maxm];
ll levelY[maxm];
ll cnt[maxm];
bool isIn[maxm][maxn];
ll minX[maxm];
ll maxX[maxm];
ll minY[maxm];
ll maxY[maxm];

void calcLevel(int y) {
	levelX[y] = 0;
	levelY[y] = 0;
	cnt[y] = 0;
	minX[y] = minY[y] = n * 10000000LL;
	maxX[y] = maxY[y] = -1000000000LL;
	if (y % 2 == 0) {
		minY[y] = 0;
		maxY[y] = n * 2;
		for (int i = 0; i < n; i++) {
			if (isIn[y][i]) {
				levelY[y] += n;
				levelX[y] += i * 2 + 1;
				cnt[y]++;
				if (minX[y] > 2 * i)
					minX[y] = 2 * i;
				if (maxX[y] < 2 * i + 2)
					maxX[y] = 2 * i + 2;
			}
		}
	}
	else {
		minX[y] = 0;
		maxX[y] = n * 2;
		for (int i = 0; i < n; i++) {
			if (isIn[y][i]) {
				levelY[y] += i * 2 + 1;
				levelX[y] += n;
				cnt[y]++;
				if (minY[y] > 2 * i)
					minY[y] = 2 * i;
				if (maxY[y] < 2 * i + 2)
					maxY[y] = 2 * i + 2;
			}
		}
	}
}

bool checkCollapse() {
	ll totx = 0, toty = 0, totcnt = 0;
	for (int y = h - 1; y >= 0; y--) {
		if (totcnt > 0) {
			if (cnt[y] == 0)
				return true;
			ll mnx = minX[y] * totcnt;
			ll mxx = maxX[y] * totcnt;
			ll mny = minY[y] * totcnt;
			ll mxy = maxY[y] * totcnt;
			if (totx >= mxx || totx <= mnx || toty >= mxy || toty <= mny) {
				return true;
			}
		}
		totx += levelX[y];
		toty += levelY[y];
		totcnt += cnt[y];
	}
	return false;
}

int main() {
#if defined(_DEBUG) || defined(_RELEASE)
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#else
	freopen(File".in", "r", stdin); freopen(File".out", "w", stdout);
#endif

	int w;
	cin >> n >> w >> h >> m;

	fori(h) {
		forj(n) isIn[i][j] = true;
		calcLevel(i);
	}

	fori(m) {
		ll y, x;
		cin >> y >> x;
		--y; --x;

		isIn[y][x] = false;
		calcLevel(y);
		if (checkCollapse()) {
			cout << "yes\n" << (i + 1);
			return 0;
		}
	}

	cout << "no" << endl;

	return 0;
}