#define _CRT_SECURE_NO_DEPRECATE
#pragma comment(linker, "/STACK:100000000000")

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>
#include <sstream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <stack>
#include <queue>
#include <deque>
#include <list>
#include <iomanip>
#include <climits>
#include <algorithm>
#include <cmath>

typedef long long ll;
typedef std::pair<int, int> pii;
typedef std::pair<ll, ll> pll;
typedef std::pair<double, double> pdd;

#define fori(N) for(int i = 0;i<(N);i++)
#define fori1(N) for(int i = 1;i<=(N);i++)
#define forj(N) for(int j = 0;j<(N);j++)
#define forj1(N) for(int j = 1;j<=(N);j++)
#define fork(N) for(int k = 0;k<(N);k++)
#define fork1(N) for(int k = 1;k<=(N);k++)
#define mp make_pair

#define File "kids"
using namespace std;

#if defined(_DEBUG) || defined(_RELEASE)
const int maxn = 50;
const int maxm = 60;
#else
const int maxn = 1000;
const int maxm = 11000;
#endif

char buf[maxn][maxn];

struct thing {
	int offx, offy;
	char b[maxn][maxn];
	int w;
	int h;
	int firstRow, lastRow, firstCol, lastCol;
};

bool rowHasStar(int row, int w) {
	fori(w) if (buf[i][row] == '*') return true;
	return false;
}

bool colHasStar(int col, int h) {
	fori(h) if (buf[col][i] == '*') return true;
	return false;
}

bool hasStar(int w, int h) {
	fori(w) if (colHasStar(i, h)) return true;
	return false;
}

thing createThing(int w, int h) {
	int firstRow = 0;
	int lastRow = h - 1;
	int firstCol = 0;
	int lastCol = w - 1;
	while (!rowHasStar(firstRow, w)) firstRow++;
	while (!rowHasStar(lastRow, w)) lastRow--;
	while (!colHasStar(firstCol, h)) firstCol++;
	while (!colHasStar(lastCol, h)) lastCol--;

	thing t;
	t.offx = firstCol;
	t.offy = firstRow;

	t.w = (lastCol - firstCol + 1);
	t.h = (lastRow - firstRow + 1);
	fori(t.w) {
		forj(t.h) {
			t.b[i][j] = buf[i + firstCol][j + firstRow];
		}
	}

	t.firstRow = t.firstCol = t.lastRow = t.lastCol = 0;
	while (t.b[t.firstRow][0] != '*') t.firstRow++;
	while (t.b[0][t.firstCol] != '*') t.firstCol++;
	while (t.b[t.lastRow][t.h - 1] != '*') t.lastRow++;
	while (t.b[t.w - 1][t.lastCol] != '*') t.lastCol++;

	return t;
}

bool isGood;

pii draw(thing &t1, thing &t2, int shiftx, int shifty, thing &expected) {
	isGood = true;
	int x1 = 0, y1 = 0, x2 = 0, y2 = 0;
	if (shiftx >= 0)
		x2 += shiftx;
	else
		x1 -= shiftx;
	if (shifty >= 0)
		y2 += shifty;
	else
		y2 -= shifty;
	fori(maxn) forj(maxn) buf[i][j] = '.';

	for (int x = 0; x < t1.w; x++) {
		for (int y = 0; y < t1.h; y++) {
			buf[x1 + x][y1 + y] = t1.b[x][y];
		}
	}

	for (int x = 0; x < t2.w; x++) {
		for (int y = 0; y < t2.h; y++) {
			int xx = x2 + x;
			int yy = y2 + y;
			if (buf[xx][yy] == t2.b[x][y])
				buf[xx][yy] = '.';
			else
				buf[xx][yy] = '*';
		}
	}

	int firstRow = 0;
	int lastRow = maxn - 1;
	int firstCol = 0;
	int lastCol = maxn - 1;
	while (firstRow < maxn && !rowHasStar(firstRow, maxn)) firstRow++;
	while (lastRow > -1 && !rowHasStar(lastRow, maxn)) lastRow--;
	while (firstCol < maxn && !colHasStar(firstCol, maxn)) firstCol++;
	while (lastCol > -1 && !colHasStar(lastCol, maxn)) lastCol--;

	if (firstRow > lastRow)
		return mp(-1, -1);

	if ((lastRow - firstRow + 1) != expected.h)
	{
		isGood = false;
		return mp(0, 0);
	}

	if ((lastCol - firstCol + 1) != expected.w)
	{
		isGood = false;
		return mp(0, 0);
	}

	for (int x = 0; x < expected.w; x++)
		for (int y = 0; y < expected.h; y++)
			if (buf[x + firstCol][y + firstRow] != expected.b[x][y])
			{
				isGood = false;
				return mp(0, 0);
			}

	if (shiftx < 0) firstCol += shiftx;
	if (shifty < 0) firstRow += shifty;
	isGood = true;
	return mp(firstCol, firstRow);
}

void ansNo() {
	cout << "NO";
	exit(0);
}

void ans(int x, int y) {
	cout << "YES\n";
	cout << x << " " << y << endl;
	exit(0);
}

int main() {
#if defined(_DEBUG) || defined(_RELEASE)
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#else
	freopen(File".in", "r", stdin); freopen(File".out", "w", stdout);
#endif

	thing in1, in2, out;

	int w, h;

	cin >> h >> w;
	forj(h) fori(w) cin >> buf[i][j];
	in1 = createThing(w, h);

	cin >> h >> w;
	forj(h) fori(w) cin >> buf[i][j];
	in2 = createThing(w, h);

	cin >> h >> w;
	forj(h) fori(w) cin >> buf[i][j];
	if (!hasStar(w, h)) {
		if (in1.w != in2.w || in1.h != in2.h)
			ansNo();
		fori(in1.w)
			forj(in1.h) {
				if (in1.b[i][j] != in2.b[i][j])
					ansNo();
			}

		cout << "YES\n";
		cout << (in1.offx - in2.offx) << " " << (in1.offy - in2.offy);
		exit(0);
	}

	out = createThing(w, h);

	if (out.h > in1.h && out.h > in2.h) {
		int x1 = out.firstRow - in1.firstRow;
		int x2 = out.lastRow - in2.lastRow;
		pii res = draw(in1, in2, x2 - x1, out.h - in1.h, out);
		if (isGood) {
			ans((in1.offx - in2.offx) + x2 - x1, (in1.offy - in2.offy) + out.h - in1.h);
		}

		x1 = out.firstRow - in1.lastRow;
		x2 = out.lastRow - in2.firstRow;
		res = draw(in1, in2, x2 - x1, in1.h - out.h, out);
		if (isGood) {
			ans((in1.offx - in2.offx) + x2 - x1, (in1.offy - in2.offy) + in1.h - out.h);
		}

		ansNo();
	}

	if (out.w > in1.w && out.w > in2.w) {
		int y1 = out.firstCol - in1.firstCol;
		int y2 = out.lastCol - in2.lastCol;
		pii res = draw(in1, in2, out.w - in1.w, y2 - y1, out);
		if (isGood) {
			ans((in1.offx - in2.offx) + out.w - in1.w, (in1.offy - in2.offy) + y2 - y1);
		}

		y1 = out.firstCol - in1.lastCol;
		y2 = out.lastCol - in2.firstCol;
		res = draw(in1, in2, in1.w - out.w, y2 - y1, out);
		if (isGood) {
			ans((in1.offx - in2.offx) + in1.w - out.w, (in1.offy - in2.offy) + y2 - y1);
		}

		ansNo();
	}

	/*if (in1.w < in2.w) swap(in1, in2);
	if (out.w < in1.w) {
		int shidty = out.firstCol - in1.firstCol;
		pii res = draw(in1, in2, out.w - in1.w, y2 - y1, out);
		if (isGood) {
			ans((in1.offx - in2.offx) + out.w - in1.w, (in1.offy - in2.offy) + y2 - y1);
		}

		y1 = out.firstCol - in1.lastCol;
		y2 = out.lastCol - in2.firstCol;
		res = draw(in1, in2, in1.w - out.w, y2 - y1, out);
		if (isGood) {
			ans((in1.offx - in2.offx) + in1.w - out.w, (in1.offy - in2.offy) + y2 - y1);
		}

		ansNo();
	}*/

	cout << "shit" << endl;
	exit(1);

	return 0;
}