#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const int MIN = -32768;
const int MAX = 32767;


struct seg {
    int l;
    int r;

    seg(int l = 0, int r = 0) : l(l), r(r) {}

    bool operator < (const seg a) const {
        return l < a.l;
    }
};

bool is_correct(seg a) {
    return a.l <= a.r;
}

bool is_intersect(seg a, seg b) {
    int l = max(a.l, b.l);
    int r = min(a.r, b.r);
    return l <= r + 1;
}

seg unite(seg a, seg b) {
    return seg(min(a.l, b.l), max(a.r, b.r));
}

void print(seg a) {
    if (a.l == MIN && a.r == MAX) {
        cout << "true\n";
        return;
    }
    if (a.l == MIN) {
        cout << "x <= " << a.r << " ";
        return;
    }
    if (a.r == MAX) {
        cout << "x >= " << a.l << " ";
        return;
    }
    cout << "x >= " << a.l << " && x <= " << a.r << " ";
    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    freopen("hard.in", "r", stdin);
    freopen("hard.out", "w", stdout);
    vector<seg> segments;
    segments.push_back(seg(MIN, MAX));
    string s;
    int tmp;
    while (cin >> s) {
        if (s == "||") {
            segments.push_back(seg(MIN, MAX));
            continue;
        }
        if (s == "<=") {
            cin >> tmp;
            segments[segments.size() - 1].r = min(segments[segments.size() - 1].r, tmp);
            continue;
        }
        if (s == ">=") {
            cin >> tmp;
            segments[segments.size() - 1].l = max(segments[segments.size() - 1].l, tmp);
            continue;
        }
    }
    vector<seg> segms;
    for (int i = 0; i < segments.size(); i++)
        if (is_correct(segments[i]))
            segms.push_back(segments[i]);
    sort(segms.begin(), segms.end());
    vector<seg> ans;
    for (int i = 0; i < segms.size(); i++) {
        if (ans.empty() || !is_intersect(ans[ans.size() - 1], segms[i]))
            ans.push_back(segms[i]);
        else {
            ans[ans.size() - 1] = unite(ans[ans.size() - 1], segms[i]);
        }
    }
    if (ans.size() == 0)
    {
        cout << "false\n";
        return 0;
    }
    for (int i = 0; i < ans.size(); i++) {
        print(ans[i]);
        if (i != ans.size() - 1)
            cout << "||\n";
    }
    return 0;
}
