#include <iostream>
#include <cstdio>

using namespace std;

long long n, w, h, m;

struct Point
{
	double X, Y;
	Point operator *(double num)
	{
		Point ans;
		ans.X = X * num;
		ans.Y = Y * num;
		return ans;
	}
	Point operator -(Point p1)
	{
		Point ans;
		ans.X = X - p1.X;
		ans.Y = Y - p1.Y;
		return ans;
	}
};

struct _Level_
{
	long long X_Min, X_Max, Y_Min, Y_Max;
	long long Number, Number_Here;
	Point center;
};

const int Max = 5555;
_Level_ lvl[Max];

void update_min_max(long long id_lvl, long long id)
{
	long long X0_Min, X0_Max, Y0_Min, Y0_Max;
	if (id_lvl % 2 == 1)
	{
		X0_Min = (id - 1) * w;
		X0_Max = id * w;
		Y0_Min = n * w;
		Y0_Max = n * w;
	}
	else
	{
		Y0_Min = (id - 1) * w;
		Y0_Max = id * w;
		X0_Min = n * w;
		X0_Max = n * w;
	}
	if (X0_Min == lvl[id_lvl].X_Min)
		lvl[id_lvl].X_Min += w;
	if (X0_Max == lvl[id_lvl].X_Max)
		lvl[id_lvl].X_Max -= w;
	if (Y0_Min == lvl[id_lvl].Y_Min)
		lvl[id_lvl].Y_Min += w;
	if (Y0_Max == lvl[id_lvl].Y_Max)
		lvl[id_lvl].Y_Max -= w;
	return;
}

void build()
{
	lvl[h + 1].Number = 0;
	for (int i = h; i >= 1; i--)
	{
		lvl[i].X_Min = 0;
		lvl[i].X_Max = n * w;
		lvl[i].Y_Min = 0;
		lvl[i].Y_Max = n * w;
		lvl[i].Number = lvl[i + 1].Number + n;
		lvl[i].Number_Here = n;
		lvl[i].center.X = ((n * w) * 1.0) / 2.0;
		lvl[i].center.Y = ((n * w) * 1.0) / 2.0;
	}
	return;
}

bool check(int id)
{
	double X0 = lvl[id].center.X;
	double Y0 = lvl[id].center.Y;
	if (lvl[id - 1].X_Min < X0 && X0 < lvl[id - 1].X_Max &&
		lvl[id - 1].Y_Min < Y0 && Y0 < lvl[id - 1].Y_Max)
		return true;
	return false;
}

Point get_center(int Id_lvl, int id)
{
	Point ans;
	if (Id_lvl % 2 == 1)
	{
		ans.Y = ((n * w) * 1.0) / 2.0;
		ans.X = ((id * w + (id - 1) * w) * 1.0) / 2.0;
	}
	else
	{
		ans.X = ((n * w) * 1.0) / 2.0;
		ans.Y = ((id * w + (id - 1) * w) * 1.0) / 2.0;
	}
	return ans;
}

void update(int id, Point c)
{
	double Num = lvl[id].Number;
	Point p1 = c * (1.0 / (Num * 1.0));
	Point p2 = lvl[id].center - p1;
	Point p3 = p2 * (Num * 1.0);
	Point p4 = p3 * (1 / (Num * 1.0 - 1.0));
	lvl[id].center = p4;
	lvl[id].Number--;
	return;
}

int main()
{
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
	cin >> n >> w >> h >> m;
	build();
	for (int i = 1; i <= m; i++)
	{
		long long Id_level, Id;
		cin >> Id_level >> Id;
		lvl[Id_level].Number_Here--;
		if (lvl[Id_level].Number_Here == 0)
		{
			if (Id_level == h)
			{
				h--;
				Point cm = get_center(Id_level, Id);
				for (int j = Id_level - 1; j >= 1; j--)
				{
					update(j, cm);
				}
				for (int j = h; j >= 2; j--)
				{
					if (!check(j))
					{
						cout << "yes" << endl;
						cout << i << endl;
						return 0;
					}
				}
				continue;
			}
			else
			{
				cout << "yes" << endl;
				cout << i << endl;
				return 0;
			}
		}
		update_min_max(Id_level, Id);
		Point cm = get_center(Id_level, Id);
		for (int j = Id_level; j >= 1; j--)
		{
			update(j, cm);
		}
		for (int j = h; j >= 2; j--)
		{
			if (!check(j))
			{
				cout << "yes" << endl;
				cout << i << endl;
				return 0;
			}
		}
	}
	cout << "no" << endl;
	return 0;
}