#include <iostream>
#include <cstdio>
#include <set>

using namespace std;

int n, w, h, m;
set <int> ID;

struct Point
{
	double X, Y;
	Point operator *(double num)
	{
		Point ans;
		ans.X = X * num;
		ans.Y = Y * num;
		return ans;
	}
	Point operator -(Point p1)
	{
		Point ans;
		ans.X = X - p1.X;
		ans.Y = Y - p1.Y;
		return ans;
	}
};

struct _Level_
{
	int MIN, MAX;
	int X_Min, X_Max, Y_Min, Y_Max;
	int Number, Number_Here;
	Point center;
	set <int> Id;
};

const int Max = 5555;
_Level_ lvl[Max];

inline void update_min_max(int id_lvl, int id)
{
	int X0_Min, X0_Max, Y0_Min, Y0_Max;
	lvl[id_lvl].Id.erase(id);
	if (id == lvl[id_lvl].MIN || id == lvl[id_lvl].MAX)
	{
		set <int>::iterator it = lvl[id_lvl].Id.begin();
		int Id_Min, Id_Max;
		Id_Min = (*it);
		it = lvl[id_lvl].Id.end();
		it--;
		Id_Max = (*it);

		if (id_lvl % 2 == 1)
		{
			lvl[id_lvl].MIN = Id_Min;
			lvl[id_lvl].MAX = Id_Max;
			lvl[id_lvl].X_Min = (Id_Min - 1) * w;
			lvl[id_lvl].X_Max = Id_Max * w;
		}
		else
		{
			lvl[id_lvl].MIN = Id_Min;
			lvl[id_lvl].MAX = Id_Max;
			lvl[id_lvl].Y_Min = (Id_Min - 1) * w;
			lvl[id_lvl].Y_Max = Id_Max * w;
		}
	}
	return;
}

void build()
{
	lvl[h + 1].Number = 0;
	for (int i = h; i >= 1; i--)
	{
		lvl[i].MIN = 1;
		lvl[i].MAX = n;
		lvl[i].X_Min = 0;
		lvl[i].X_Max = n * w;
		lvl[i].Y_Min = 0;
		lvl[i].Y_Max = n * w;
		lvl[i].Number = lvl[i + 1].Number + n;
		lvl[i].Number_Here = n;
		lvl[i].center.X = ((n * w) * 1.0) / 2.0;
		lvl[i].center.Y = ((n * w) * 1.0) / 2.0;
		lvl[i].Id = ID;
	}
	return;
}

inline bool check(int id)
{
	double X0 = lvl[id].center.X;
	double Y0 = lvl[id].center.Y;
	double eps = 0.0000000001;
	if (lvl[id - 1].X_Min + eps < X0 && X0 < lvl[id - 1].X_Max - eps &&
		lvl[id - 1].Y_Min + eps < Y0 && Y0 < lvl[id - 1].Y_Max - eps)
		return true;
	return false;
}

Point get_center(int Id_lvl, int id)
{
	Point ans;
	if (Id_lvl % 2 == 1)
	{
		ans.Y = ((n * w) * 1.0) / 2.0;
		ans.X = ((id * w + (id - 1) * w) * 1.0) / 2.0;
	}
	else
	{
		ans.X = ((n * w) * 1.0) / 2.0;
		ans.Y = ((id * w + (id - 1) * w) * 1.0) / 2.0;
	}
	return ans;
}

void update(int id, Point c)
{
	double Num = lvl[id].Number;
	Point p1 = lvl[id].center * (Num * 1.0);
	Point p2 = p1 - c;
	Point p3 = p2 * (1.0 / (Num * 1.0 - 1.0));
	lvl[id].center = p3;
	lvl[id].Number--;
	return;
}

int main()
{
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
	ios_base::sync_with_stdio(0);
	cin.tie(nullptr);
	cin >> n >> w >> h >> m;
	for (int i = 1; i <= n; i++)
	{
		ID.insert(i);
	}
	w = 1;
	build();
	for (int i = 1; i <= m; i++)
	{
		int Id_level, Id;
		cin >> Id_level >> Id;
		lvl[Id_level].Number_Here--;
		if (lvl[Id_level].Number_Here == 0)
		{
			if (Id_level == h)
			{
				h--;
				Point cm = get_center(Id_level, Id);
				for (int j = Id_level - 1; j >= 1; j--)
				{
					update(j, cm);
				}
				for (int j = h; j >= 2; j--)
				{
					if (!check(j))
					{
						cout << "yes" << endl;
						cout << i << endl;
						return 0;
					}
				}
				continue;
			}
			else
			{
				cout << "yes" << endl;
				cout << i << endl;
				return 0;
			}
		}
		update_min_max(Id_level, Id);
		Point cm = get_center(Id_level, Id);
		for (int j = Id_level; j >= 1; j--)
		{
			update(j, cm);
		}
		for (int j = h; j >= 2; j--)
		{
			if (!check(j))
			{
				cout << "yes" << endl;
				cout << i << endl;
				return 0;
			}
		}
	}
	cout << "no" << endl;
	return 0;
}