#include <cstdio>
#include <vector>
#include <set>
#include <iostream>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <memory.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

#define FILE_NAME "binary"

#define forn(i, n) for (int i = 0; i < (int) n; ++i)
#define ford(i, n) for (int i = (int) n - 1; i >= 0; --i)
#define pb push_back
#define mp(x, y) make_pair(x, y)
#define sz(c) ((int) (c).size())
#define all(c) (c).begin(), (c).end()
#define fst first 
#define snd second

const int MAXN = 5e5 + 10;
const int A = 2;

void run() {
  puts("NO");
  exit(0);
}

int n;
string s[MAXN];
int pos[MAXN];

bool read() {
  if  (scanf("%d\n", &n) < 1) {
    return 0;
  }
  forn(i, n) {
    static char t[MAXN];
    gets(t);
    s[i] = string(t);
    pos[i] = -1;
    forn(j, sz(s[i])) {
      if (s[i][j] == '?') {
        pos[i] = j;
      }
    }
  }
  return 1;
}

struct Node {
  pair<Node*, bool> to[2];
  vi ids;

  Node() {
    forn(c, A) {
      to[c] = mp(nullptr, 0);
    }
  }
};

Node* root;

int nodes;
int id_node[MAXN];
vi g[2 * MAXN];
vi gt[2 * MAXN];

// x1 || x2
void add_cond(int x1, int x2) {
  g[x1 ^ 1].pb(x2);
  gt[x2].pb(x1 ^ 1);

  g[x2 ^ 1].pb(x1);
  gt[x1].pb(x2 ^ 1);

  /*
  if  (x1 & 1) {
    printf("not ");
  }
  printf("%d || ", x1 / 2);
  if  (x2 & 1) {
    printf("not ");
  }
  printf("%d\n", x2 / 2);
  */
}

void add_edges(int i, int j) {
  assert(i != j);
  if  (pos[i] > pos[j]) {
    swap(i, j);
  }
  static int cnt = 0;
  ++cnt;

  if  (cnt > 1.6e7) {
    run();
  }

//  printf("add edges %d %d\n", i, j);
  if  (pos[i] == -1) {
    if  (pos[j] == -1) {
      run();
    }
    if  (pos[j] >= sz(s[i])) {
      run();
    }
    if (s[i][pos[j]] == '0') {
      add_cond(2 * id_node[j], 2 * id_node[j]);
    } else {
      add_cond(2 * id_node[j] + 1, 2 * id_node[j] + 1);
    }
  } else {
    if  (pos[j] >= sz(s[i])) {
      if  (s[j][pos[i]] == '0') {
        add_cond(2 * id_node[i], 2 * id_node[i]);
      } else {
        add_cond(2 * id_node[i] + 1, 2 * id_node[i] + 1);
      }
    } else {
      if  (pos[i] != pos[j]) {
        int x1 = 2 * id_node[i];
        if (s[j][pos[i]] == '1') {
          ++x1;
        }
        int x2 = 2 * id_node[j];
        if  (s[i][pos[j]] == '1') {
          ++x2;
        }
        add_cond(x1, x2);
      } else {
        add_cond(2 * id_node[i], 2 * id_node[j]);
        add_cond(2 * id_node[i] + 1, 2 * id_node[j] + 1);
      }
    }
  }
}

bool add_string(int id) {
  bool was_q = 0;
  int cnt_after = 0;
  Node* v = root;
  forn(i, sz(s[id])) {
    int c = s[id][i] - '0';
    if  (!v->to[c].fst) {
      v->to[c] = mp(new Node(), 0);
    }
    if  (i == pos[id]) {
      v->to[c].snd = 1;
    }
    was_q |= v->to[c].snd;
    v = v->to[c].fst;
    if  (was_q) {
      cnt_after += sz(v->ids);
    }
    for (int other : v->ids) {
      add_edges(id, other);
    }
  }
  
//  if  (cnt_after > 3) return 0;

  v->ids.pb(id);
  return 1;
}

bool was[MAXN];
int comp[MAXN];

void dfs1(int v, vi& order) {
  was[v] = 1;
  for (int to : g[v]) {
    if  (!was[to]) {
      dfs1(to, order);
    }
  }
  order.pb(v);
}

void dfs2(int v) {
  for (int to : gt[v]) {
    if  (comp[to] == -1) {
      comp[to] = comp[v];
      dfs2(to);
    }
  }
}

void solve() {
  if (n > 4e4) {
    run();
  }

  nodes = 0;
  forn(i, n) {
    if  (pos[i] != -1) {
      id_node[i] = nodes++;
    } else {
      id_node[i] = -1;
    }
  }

  vi perm(n);
  forn(i, n) perm[i] = i;
  sort(all(perm), [&](int i, int j) { return sz(s[i]) < sz(s[j]); });

  root = new Node();
  forn(i_, n) {
    int i = perm[i_];
    if  (pos[i] == -1) {
      if  (!add_string(i)) {
        run();
      }
    } else {
      s[i][pos[i]] = '0';
      if  (!add_string(i)) {
        run();
      }
      s[i][pos[i]] = '1';
      if  (!add_string(i)) {
        run();
      }
      s[i][pos[i]] = '?';
    }
  }

//  forn(i, n) {
//    printf("s=%s, id_node=%d\n", s[i].data(), id_node[i]);  
//  }

/*
  forn(v, 2 * nodes) {
    for (int to : g[v]) {
      if  (v & 1) {
        printf("not ");
      }
      printf("%d -> ", v / 2);
      if (to & 1) {
        printf("not ");
      }
      printf("%d\n", to / 2);
    }
  }
*/

  memset (was, 0, sizeof was);
  vi order;
  forn(v, 2 * nodes) {
    if  (!was[v]) {
      dfs1(v, order);
    }
  }
  assert(sz(order) == 2 * nodes);
  reverse(all(order));

  /*
  puts("order:");
  for (int v : order) {
    printf("%d ", v);
  }
  puts("");
  */

  memset (comp, -1, sizeof comp);
  int comps = 0;
  for (int v : order) {
    if (comp[v] == -1) {
      comp[v] = comps++;
      dfs2(v);
    }
  }

  forn(v, nodes) {
    if  (comp[v * 2] == comp[v * 2 + 1]) {
      run();
    }
  }

  puts("YES");
  forn(i, n) {
    if  (pos[i] != -1) {
      int val = -1;
      int v = id_node[i];
      if  (comp[v * 2] < comp[v * 2 + 1]) {
        val = 0;  
      } else {
        val = 1;
      }
      s[i][pos[i]] = '0' + val;
    }
    printf("%s\n", s[i].data());
  }
}

int main() {
#ifdef LOCAL
  freopen(FILE_NAME ".in", "r", stdin);
  freopen(FILE_NAME ".out", "w", stdout);
#else 
  freopen(FILE_NAME ".in", "r", stdin);
  freopen(FILE_NAME ".out", "w", stdout);
#endif

  while (read()) {
    solve();

    break;
  }

  return 0;
}

/*
add edges 2 1
1 || 0
not 1 || not 0
add edges 2 1
1 || 0
not 1 || not 0
add edges 0 1
0 || 0
s=0000, id_node=-1
s=?0, id_node=0
s=?01, id_node=1
s=01, id_node=-1
0 -> not 1
0 -> not 1
not 0 -> 1
not 0 -> 1
not 0 -> 0
not 0 -> 0
1 -> not 0
1 -> not 0
not 1 -> 0
not 1 -> 0
YES
0000
00
101
01

*/
