#include <cstdio>
#include <vector>
#include <set>
#include <iostream>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <memory.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef vector<pii> vii;

#define FILE_NAME "expect"

#define forn(i, n) for (int i = 0; i < (int) n; ++i)
#define ford(i, n) for (int i = (int) n - 1; i >= 0; --i)
#define pb push_back
#define mp(x, y) make_pair(x, y)
#define sz(c) ((int) (c).size())
#define all(c) (c).begin(), (c).end()
#define fst first 
#define snd second

int n;

bool read() {
  if  (cin >> n) {
    return 1;
  }
  return 0;
}

void solve() {
  int q;
  cin >> q;

  vector<char> tp(n);
  vi t(n), k(n);

  vii pref(n);

  const int inf = (int)1e9 + 10;

  for (int i = 0; i < n; i++)
  {         
    cin >> tp[i] >> t[i] >> k[i];
  }

  for (int i = 0; i < n; i++)
  {
    pref[i].first = (i == 0 ? 0 : pref[i - 1].first) + (tp[i] == '-' ? k[i] : -k[i]);
    pref[i].snd = (i == n - 1 ? inf : t[i + 1] - t[i]); 
  }

  const int last_pref = pref.back().first;
                            
  vii query(q);           
  sort(all(pref));

  vector<ll> sum(sz(pref));
  vector<ll> tms(sz(pref));
  for (int i = n  - 1; i >= 0; i--)
  {
    sum[i] = (i + 1 == n ? 0 : sum[i + 1]) + (ll)pref[i].first * (ll)pref[i].snd;
    tms[i] = (i + 1 == n ? 0 : tms[i + 1]) + (ll)pref[i].snd; 
  }

  for (int i = 0; i < q; i++)
  {
    cin >> query[i].first;
    query[i].second = i;

                       
    const int b = query[i].first;
    if (last_pref > b)
      cout << "INFINITY\n";
    else
    {             
      int pos = lower_bound(all(pref), mp(b, -1)) - pref.begin();
      ll ans = 0;
      if (pos != n)
      {
        ans += sum[pos] - b * tms[pos];
      } 
      cout << ans << '\n';
    }
  }    
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

#ifdef LOCAL
  assert(freopen(FILE_NAME ".in", "r", stdin));
  assert(freopen(FILE_NAME ".out", "w", stdout));
#else 
  freopen(FILE_NAME ".in", "r", stdin);
  freopen(FILE_NAME ".out", "w", stdout);
#endif

  while (read()) {
    solve();
  }

  return 0;
}
