#include <cstdio>
#include <vector>
#include <set>
#include <iostream>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <memory.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

#define FILE_NAME "hard"

#define forn(i, n) for (int i = 0; i < (int) n; ++i)
#define ford(i, n) for (int i = (int) n - 1; i >= 0; --i)
#define pb push_back
#define mp(x, y) make_pair(x, y)
#define sz(c) ((int) (c).size())
#define all(c) (c).begin(), (c).end()
#define fst first 
#define snd second

const int L = - (1 << 15);
const int R = (1 << 15) - 1;

int n;

void skip(int& pos, const string& s) {
  while (pos < sz(s) && isspace(s[pos])) {
    ++pos;
  }
}

int read_num(int& pos, const string& s) {
  int res = 0;
  skip(pos, s);
  bool neg = s[pos] == '-';
  if (neg) ++pos;
  while (pos < sz(s) && isdigit(s[pos])) {
    res = res * 10 + (s[pos] - '0');
    ++pos;
  }
  return neg ? -res : res;
}

bool read_comp(int& pos, const string& s) {
  skip(pos, s);
  bool res = s[pos] == '<';
  pos += 2;
  return res;
}

void read_var(int& pos, const string& s) {
  skip(pos, s);
  assert(s[pos] == 'x');
  ++pos;
}

bool read_op(int& pos, const string& s) {
  skip(pos, s);
  if (pos >= sz(s) || s[pos] != '&') {
    return 0;
  }
  pos += 2;
  return 1;
}

bool ok[R - L + 1];

bool read() {
  memset (ok, 0, sizeof ok);
  string s;
  while (getline(cin, s)) {
//    cout << "s: " << s << endl;
    int pos = 0;
    read_var(pos, s);
    bool is_less = read_comp(pos, s);
    int num = read_num(pos, s);
    if  (read_op(pos, s)) {
      read_var(pos, s);
      bool is_less2 = read_comp(pos, s);
      int num2 = read_num(pos, s);
      assert(!is_less);
      assert(is_less2);
      for (int i = num; i <= num2; ++i) {
        ok[i - L] = 1;
      }
//      printf("fill [%d, %d]\n", num, num2);
    } else {
      // x <= num
      if  (is_less) {
        for (int i = L; i <= num; ++i) {
          ok[i - L] = 1;
        }
      } else {
        // x >= num
        for (int i = num; i <= R; ++i) {
          ok[i - L] = 1;
        }
      }
    }
  }
  return 1;
}

void solve() {
  vector<pii> segs;
  for (int i = L; i <= R; ++i) {
    if  (!ok[i - L]) {
      continue;
    }
    int r = i;
    while (r <= R && ok[r - L]) {
      ++r;
    }
//    printf("i = %d, r = %d\n", i, r);
    segs.pb(mp(i, r - 1));
    i = r;
  }  

  if (segs.empty()) {
    puts("false");
    return;
  }

  if (sz(segs) == 1 && segs[0].fst == L && segs[0].snd == R) {
    puts("true");
    return;
  }

  forn(i, sz(segs)) {
    auto s = segs[i];
    int l = s.fst;
    int r = s.snd;
 //   printf("l = %d, r = %d\n", l, r);
    if  (l == L) {
      printf("x <= %d", r);
    } else if (r == R) {
      printf("x >= %d", l);
    } else {
      printf("x >= %d && x <= %d", l, r);
    }
    if  (i + 1 == sz(segs)) {
      puts("");
    } else {
      printf(" ||\n");
    }
  }                  
}

int main() {
#ifdef LOCAL
  freopen(FILE_NAME ".in", "r", stdin);
//  freopen(FILE_NAME ".out", "w", stdout);
#else 
  freopen(FILE_NAME ".in", "r", stdin);
  freopen(FILE_NAME ".out", "w", stdout);
#endif

  while (read()) {
    solve();

    break;
  }

  return 0;
}
