#include <cstdio>
#include <vector>
#include <set>
#include <iostream>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <cstring>
using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

#define FILE_NAME "jenga"

#define forn(i, n) for (int i = 0; i < (int) n; ++i)
#define ford(i, n) for (int i = (int) n - 1; i >= 0; --i)
#define pb push_back
#define mp(x, y) make_pair(x, y)
#define sz(c) ((int) (c).size())
#define all(c) (c).begin(), (c).end()

int n, w;
int h, m;


const int maxn = 10500;
int sumx[maxn], sumy[maxn], sum[maxn];
int lb[maxn], rb[maxn];
vector<int> deleted[maxn];
bool read() {
  if (!(cin >> n >> w)) return 0;
  w = 2;
  cin >> h >> m;
  return 1;
}

pii getCenter(int l, int k)
{
   pii r = mp(k*2 + 1, n);
   if (l % 2 == 0) swap(r.first, r.second);
   return r;
}

void recalc(int l) {
   vector<bool> g(n,1);
   for (int i : deleted[l])
       g[i] = 0;
   for (int i = 0; i < n; i++)
      if (g[i]) {lb[l] = i; break;}
   for (int j = n-1; j >= 0; j--)
      if (g[j]) {rb[l] = j; break;}
 //  cout << "l=" << l << endl;
 //  cout << "[" << lb[l] << "," << rb[l] << "]" << endl;
}

void solve() {
   for (int i = 1; i <= h; i++)
   {
      sumx[i] = sumy[i] = sum[i] = 0;
      for (int j = 0; j < n; j++)
      {
          pii g = getCenter(i, j);
          sumx[i] += g.first;
          sumy[i] += g.second;
          sum[i]++;
      }
      deleted[i].clear();
      lb[i] = 0;
      rb[i] = n-1;
   }

  // cout << "h=" << h << endl;
  // cout << "n=" << n << endl;
   for (int i = 0; i < m; i++) {
     int l,k;
     cin >> l >> k;
     k--;
     pii g = getCenter(l,k);
     sumx[l] -= g.first;
     sumy[l] -= g.second;
     sum[l]--;
     deleted[l].push_back(k);
     recalc(l);
     ll msumx = 0;
     ll msumy = 0;
     ll msum = 0;
     for (int j = h; j >= 1; j--) {
        int lx = lb[j]*2;
        int rx = rb[j]*2+2;
        int ly = 0;
        int ry = 2*n;
        if (j % 2 == 0) {swap(lx, ly); swap(rx, ry);}
      //  cout << "h=" << h << endl;
      //  cout << "[" << lx << ".." << rx << "]  [" << ly << ".." << ry << "]" << endl;
      //  cout << msumx << "/" << msum << "  " << msumy << "/" << msum << endl;
        if (j < h) {
           // lx <= msumx / msum <= rx
           bool okx = (ll)lx * msum < msumx && msumx < (ll)rx * msum;
           // ly <= msumy / msum <= ry
           bool oky = (ll)ly * msum < msumy && msumy < (ll)ry * msum;
           if (!okx || !oky) {
              cout << "yes" << endl;
              cout << i+1 << endl;
              return;
           }
        }
        msumx += (ll)sumx[j];
        msumy += (ll)sumy[j];
        msum += (ll)sum[j];
     }  
   }
   cout << "no" << endl;
}

int main() {
#ifdef LOCAL
  //freopen(FILE_NAME ".in", "r", stdin);
  //freopen(FILE_NAME ".out", "w", stdout);
#else 
  freopen(FILE_NAME ".in", "r", stdin);
  freopen(FILE_NAME ".out", "w", stdout);
#endif
  read();
  solve();
  return 0;
}


/*
h=2
[0..4]  [0..4]
0/0  0/0
h=2
[2..4]  [0..4]
4/2  4/2
no
*/