#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <string>
#include <list>
#include <sstream>

using namespace std;



#define INF 2000000000
#define EPS 1e-9


void solve();
void solve2();

int main()
{

	solve();
}
#define int long long





void solve()
{
#ifndef HOME
	string task = "foreign";
	ifstream cin(task + ".in");
	ofstream cout(task + ".out");
#else
	ifstream cin("input.txt");
#endif

	string s;
	cin >> s;
	int n = s.size();
	int* w = new int[n];
	w[0] = (s[0] == 'W');
	for (int i = 1; i < n; i++)
		w[i] = w[i - 1] + (s[i] == 'W');
	int* c = new int[n];
	c[0] = (s[0] == 'C');
	for (int i = 1; i < n; i++)
		c[i] = c[i - 1] + (s[i] == 'C');
	int sum = 0;
	if (s[0] == 'C')
		for (int i = 0; i < n; i++)
			sum += w[i];
	else
		for (int i = 0; i < n; i++)
			sum += c[i];
	double res = sum * 1.0 / n;
	int* prefw = new int[n];
	prefw[n - 1] = w[n - 1];
	for (int i = n - 2; i >= 0; i--)
		prefw[i] = prefw[i + 1] + w[i];
	int* prefc = new int[n];
	prefc[n - 1] = c[n - 1];
	for (int i = n - 2; i >= 0; i--)
		prefc[i] = prefc[i + 1] + c[i];
	for (int i = 1; i < n; i++)
	{
		int q = ((n - i) * (n - i + 1));
		if (s[i] == 'C')
			sum = prefw[i] - (n - i) * w[i];
		else
			sum = prefc[i] - (n - i) * c[i];
		res += sum * 1.0 / q;
	}
	cout << fixed << setprecision(10) << res;
#ifdef HOME
	system("pause");
#endif

}


void solve2()
{
#ifndef HOME
	string task = "jenga";
	ifstream cin(task + ".in");
	ofstream cout(task + ".out");
#else
	ifstream cin("input.txt");
#endif

	
	int n, w, h, m;
	cin >> n >> w >> h >> m;

	vector <double> avg(h, w*n/2.);
	vector <set <int> > hull(h);
	for (int i = 0; i < h; i++)
		for (int j = 0; j < n; j++)
			hull[i].insert(hull[i].end(), j);

	bool fl = false;
	int top = h - 1;
	for (int i = 0; i < m && !fl; i++)
	{
		int l, k;
		cin >> l >> k;
		l--;
		k--;

		double avg_avg = 0;
		int cnt = 0;
		for (int j = l + 2; j < h; j += 2, cnt++)
			avg_avg += avg[j];
		if (cnt)
			avg_avg /= cnt;

		hull[l].erase(k);
		if (hull[l].size() == 0)
		{
			if (top == l)
				top--;
			else
			{
				cout << "yes\n" << i + 1;
				fl = true;
				break;
			}
		}
		
		avg[l] = 0;
		for (auto it : hull[l])
			avg[l] += w / 2.*(2*it + 1);
		avg[l] /= hull[l].size();

		int le = *hull[l].begin(),
			ri = *hull[l].rbegin();

		if (!(le*w + EPS <= avg_avg && avg_avg <= (ri + 1)*w - EPS))
		{
			cout << "yes\n" << i + 1;
			fl = true;
		}

	}

	if (!fl)
		cout << "no";


	cout << endl;
#ifdef HOME
	system("pause");
#endif

}
