#pragma region header
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <complex>
#include <random>
#include <cmath>
#include <ctime>
#include <cstring>
using namespace std;

#pragma comment(linker, "/STACK:16000000")
typedef long long ll;
typedef pair<int, int> pii;

#ifdef LOCAL
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) (void)0
#endif
#pragma endregion

const int N = 100500;
string s;

bool is_let(char c)
{
	return 'a' <= c && c <= 'z';
}

bool is_abbr(int pos)
{
	return (pos == 0 || (!is_let(s[pos - 1]) && !isupper(s[pos - 1]))) && pos + 1 < s.size() && isupper(s[pos]) && is_let(s[pos + 1]);
}

int ab_len(int pos)
{
	if (!is_abbr(pos))
		return -1;

	int len = 1;
	for (++pos; pos < s.size() && is_let(s[pos]); ++pos)
		++len;
	if (pos < s.size() && isupper(s[pos]))
		return -1;
	return len;
}

void solve()
{
	ios_base::sync_with_stdio(false);
	while (getline(cin, s))
	{
		for (int i = 0; i < s.size();)
		{
			vector<string> abbs;
			int len = ab_len(i);
			if (len == -1 || i + len >= s.size() || s[i + len] != ' ' || ab_len(i + len + 1) == -1)
			{
				cout << s[i];
				++i;
				continue;
			}
			int j = i;
			while (true)
			{
				int len = ab_len(j);
				abbs.push_back(s.substr(j, len));
				j += len;
				if (j + 1 < s.size() && s[j] == ' ' && ab_len(j + 1) != -1)
					++j;
				else
					break;
			}
			for (auto abb : abbs)
				cout << abb[0];
			cout << ' ';
			cout << '(';
			cout << abbs[0];
			for (int k = 1; k < abbs.size(); ++k)
				cout << ' ' << abbs[k];
			cout << ')';
			i = j;
		}
		cout << endl;
	}
}

void main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
#endif

	solve();

	eprintf("\n\ntime: %.3lf\n", (double)clock() / CLOCKS_PER_SEC);
}