#pragma region header
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <complex>
#include <random>
#include <cmath>
#include <ctime>
#include <cstring>
using namespace std;

#pragma comment(linker, "/STACK:16000000")
typedef long long ll;
typedef pair<int, int> pii;

#ifdef LOCAL
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) (void)0
#endif
#pragma endregion

const int N = 1e5 + 10;
int n, q;
pii ques[N];
ll ans[N];
char buf[10];

void solve()
{
	scanf("%d%d", &n, &q);
	vector<pii> segs;
	int now = 0;
	int bal = 0;
	segs.emplace_back(0, 0);
	for (int i = 0; i < n; ++i)
	{
		int t, k;
		scanf("%s%d%d", buf, &t, &k);
		if (buf[0] == '-')
			k = -k;
		segs.back().second = t - now;
		now = t;
		bal += k;
		segs.emplace_back(bal, 0);
	}
	sort(segs.begin(), segs.end());

	for (int i = 0; i < q; ++i)
	{
		scanf("%d", &ques[i].first);
		ques[i].second = i;
	}
	sort(ques, ques + q);
	ll wait = 0;
	ll sumt = 0;
	for (auto s : segs)
	{
		wait += (ll)s.first * s.second;
		sumt += s.second;
	}
	for (int i = 0; i < q; ++i)
	{
		int ind = ques[i].second;
		int b = ques[i].first;
		if (bal + b < 0)
		{
			ans[ind] = -1;
			continue;
		}
		while (segs.size() > 0 && segs.back().first + b >= 0)
		{
			wait -= (ll)segs.back().first * segs.back().second;
			sumt -= segs.back().second;
			segs.pop_back();
		}
		ans[ind] = -(wait + b * sumt);
	}

	for (int i = 0; i < q; ++i)
		if (ans[i] == -1)
			puts("INFINITY");
		else
			printf("%lld\n", ans[i]);
}

void main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	freopen("expect.in", "r", stdin);
	freopen("expect.out", "w", stdout);
#endif

	solve();

	eprintf("\n\ntime: %.3lf\n", (double)clock() / CLOCKS_PER_SEC);
}