#pragma region header
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <complex>
#include <random>
#include <cmath>
#include <ctime>
#include <cstring>
using namespace std;

#pragma comment(linker, "/STACK:16000000")
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#ifdef LOCAL
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) (void)0
#endif
#pragma endregion

const int N = 1000500;
char s[N];
ld dp[N];
int c[N], w[N];

void solve()
{
	scanf("%s", s);
	int n = strlen(s);

	for (int i = 0; i < n; i++)
	{
		if (i > 0)
		{
			c[i] = c[i - 1];
			w[i] = w[i - 1];
		}

		if (s[i] == 'C')
			c[i]++;
		else
			w[i]++;
	}

	int ways = 0;
	ld sumc = c[n - 1];
	ld sumw = w[n - 1];
	for (int i = n - 1; i >= 0; i--)
	{
		ways++;

		if (s[i] == 'C')
		{
			dp[i] = sumc / ways;
			if (i > 0)
				dp[i] -= c[i - 1];
		}
		else
		{
			dp[i] = sumw / ways;
			if (i > 0)
				dp[i] -= w[i - 1];
		}

		sumc += dp[i] + (i == 0 ? 0 : c[i - 1]);
		sumw += dp[i] + (i == 0 ? 0 : w[i - 1]);

		//printf("%d %.2lf %.2lf\n", i, sumc, sumw);
	}
/*
	for (int i = 0; i < n; i++)
		eprintf("%.2lf ", dp[i]);
	eprintf("\n");*/

	double res = n - dp[0];
	printf("%.15lf\n", res);
}

int main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	freopen("foreign.in", "r", stdin);
	freopen("foreign.out", "w", stdout);
#endif

	/*
	WCC:
	2 4.00 1.00
	1 6.00 4.00
	0 7.33 5.33
	1.33 2.00 1.00
	1.333333333333333

	CWCC
	3 6.00 0.00
	2 9.00 3.00
	1 11.00 4.00
	0 13.75 6.75
	2.75 1.00 2.00 1.00
	2.750000000000000
	*/

	solve();

	eprintf("\n\ntime: %.3lf\n", (double)clock() / CLOCKS_PER_SEC);
}