#pragma region header
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <complex>
#include <random>
#include <cmath>
#include <ctime>
#include <cstring>
using namespace std;

#pragma comment(linker, "/STACK:16000000")
typedef long long ll;
typedef pair<int, int> pii;

#ifdef LOCAL
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) (void)0
#endif
#pragma endregion

const int N = 100500;

char buf[N];
string scan_line()
{
	if (gets(buf) == nullptr)
		return "";
	return string(buf);
}

const int NEG_INF = -32768;
const int POS_INF = 32767;
int sum[N];

void process_seg(int l, int r)
{
	l += NEG_INF;
	r += NEG_INF;
	if (l == NEG_INF && r == POS_INF)
		puts("true");
	else if (l == NEG_INF)
		printf("x <= %d", r);
	else if (r == POS_INF)
		printf("x >= %d", l);
	else
		printf("x >= %d && x <= %d", l, r);
}

void solve()
{
	string line;
	while ((line = scan_line()) != "")
	{
		while (line.back() == '|' || line.back() == ' ')
			line.pop_back();
		int and_pos = line.find('&');
		int left = NEG_INF, right = POS_INF;
		if (and_pos == string::npos)
		{
			int eq_pos = line.find('=');
			int lim;
			sscanf(line.c_str() + eq_pos + 1, "%d", &lim);
			if (line[eq_pos - 1] == '>')
				left = lim;
			else
				right = lim;
		}
		else
		{
			int eq_pos = line.find('=');
			sscanf(line.c_str() + eq_pos + 1, "%d", &left);
			eq_pos = line.find('=', eq_pos + 1);
			sscanf(line.c_str() + eq_pos + 1, "%d", &right);
		}
		if (left > right)
		{
			puts("false");
			return;
		}
		sum[left - NEG_INF]++;
		sum[right + 1 - NEG_INF]--;
	}

	int cur = 0;
	for (int i = 0; i < N; i++)
	{
		cur += sum[i];
		sum[i] = cur;
	}

	bool any = false;
	int pos = -1;
	for (int i = 0; i <= N; i++)
	{
		if (i == N || sum[i] == 0)
		{
			if (pos != -1)
			{
				if (any)
					printf(" ||\n");
				any = true;
				process_seg(pos, i - 1);
			}
			pos = -1;
		}
		else if (pos == -1)
			pos = i;
	}

	if (!any)
		puts("false");
}

void main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);
#endif

	solve();

	eprintf("\n\ntime: %.3lf\n", (double)clock() / CLOCKS_PER_SEC);
}