#pragma region header
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <complex>
#include <random>
#include <cmath>
#include <ctime>
#include <cstring>
using namespace std;

#pragma comment(linker, "/STACK:16000000")
typedef long long ll;
typedef pair<int, int> pii;

#ifdef LOCAL
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) (void)0
#endif
#pragma endregion

const int N = 1e3 + 10;
const int C = 3;
int n[C], m[C];
char f[C][N][N];
vector<pii> vs[C];

bool check_equal(vector<pii>& f, vector<pii>& s)
{
	if (f.size() != s.size())
		return false;
	if (f.size() == 0)
		return true;
	int dx = s[0].first - f[0].first, dy = s[0].second - f[0].second;
	for (int i = 0; i < f.size(); ++i)
	{
		int x1 = f[i].first;
		int y1 = f[i].second;
		int x2 = s[i].first;
		int y2 = s[i].second;
		if (x1 + dx != x2 || y1 + dy != y2)
			return false;
	}
	return true;
}

vector<pii> xor(vector<pii> f, vector<pii>& s)
{
	if (f.empty())
		return s;
	if (s.empty())
		return f;
	int dx = f[0].first - s[0].first;
	int dy = f[0].second - s[0].second;
	for (auto p : s)
		f.emplace_back(p.first + dx, p.second + dy);
	sort(f.begin(), f.end());
	vector<pii> res;
	for (auto p : f)
		if (res.size() == 0 || res.back() != p)
			res.push_back(p);
		else
			res.pop_back();
	return res;
}

bool check(int i1, int i2, int i3)
{
	auto v = xor(vs[i1], vs[i2]);
	return check_equal(v, vs[i3]);
}

void solve()
{
	for (int c = 0; c < C; ++c)
	{
		scanf("%d%d", &n[c], &m[c]);
		for (int i = 0; i < n[c]; ++i)
		{
			scanf("%s", f[c][i]);
			for (int j = 0; j < m[c]; ++j)
				if (f[c][i][j] == '*')
					vs[c].emplace_back(i, j);
		}
	}
	if (check(0, 1, 2))
	{
		puts("YES");
		int dx = vs[1][0].first - vs[0][0].first;
		int dy = vs[1][0].second - vs[0][0].second;
		swap(dx, dy);
		printf("%d %d\n", -dx, -dy);
		return;
	}
	if (check(0, 2, 1))
	{
		puts("YES");
		auto v = xor(vs[0], vs[2]);
		int dx = v[0].first - vs[1][0].first;
		int dy = v[0].second - vs[1][0].second;
		swap(dx, dy);
		printf("%d %d\n", dx, dy);
		return;
	}
	if (check(1, 2, 0))
	{
		puts("YES");
		auto v = xor(vs[1], vs[2]);
		int dx = v[0].first - vs[0][0].first;
		int dy = v[0].second - vs[0][0].second;
		swap(dx, dy);
		printf("%d %d\n", -dx, -dy);
		return;
	}
	puts("NO");
}

void main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	freopen("kids.in", "r", stdin);
	freopen("kids.out", "w", stdout);
#endif

	solve();

	eprintf("\n\ntime: %.3lf\n", (double)clock() / CLOCKS_PER_SEC);
}