#pragma region header
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <complex>
#include <random>
#include <cmath>
#include <ctime>
#include <cstring>
using namespace std;

#pragma comment(linker, "/STACK:16000000")
typedef long long ll;
typedef pair<int, int> pii;

#ifdef LOCAL
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) (void)0
#endif
#pragma endregion

#ifndef LOCAL
const int S = 3000;
#else
const int S = 3000;
#endif
const ll LINF = (ll)2e18;

ll add(ll x, ll y)
{
	return min(LINF, x + y);
}
void add_to(ll &x, ll y)
{
	x = add(x, y);
}
ll mul(ll x, ll y)
{
	double c0 = (double)x * y;
	if (c0 > 2 * LINF)
		return LINF;
	return min(LINF, x * y);
}

int primes[S], psz;
int primes_len[S];
ll dp_sum[S][S], dp_cnt[S][S];
ll a, b;
string answer;
ll start_idx;

bool is_prime(int x)
{
	for (int i = 2; i * i <= x; i++)
		if (x % i == 0)
			return false;
	return true;
}

int get_len(int x)
{
	int len = 0;
	while (x > 0)
	{
		len++;
		x /= 10;
	}
	return len;
}

vector<int> path;

string create_group()
{
	string res = ", [";
	bool any = false;
	for (int p : path)
	{
		if (any)
			res += ", ";
		any = true;
		res += to_string(primes[p]);
	}
	return res + "]";
}

ll gen(ll pass, int sum, int p, int pref_len)
{
	if (sum < 0)
		return pass;

	if (pass > b)
		return pass;

	if (dp_cnt[p][sum] == 0)
		return pass;

	ll will_be = add(pass, add(dp_sum[p][sum], mul(pref_len, dp_cnt[p][sum])));
	if (will_be <= a)
		return will_be;

	if (p == psz)
	{
		if (answer == "")
			start_idx = pass;
		answer += create_group();
		return will_be;
	}

	path.push_back(p);
	pass = gen(pass, sum - primes[p], p + 1, pref_len + primes_len[p] + 2);
	path.pop_back();

	pass = gen(pass, sum, p + 1, pref_len);

	return pass;
}

void solve()
{
	for (int i = 2; i < S; i++)
	{
		if (is_prime(i))
		{
			primes_len[psz] = get_len(i);
			primes[psz++] = i;
		}
	}

	dp_sum[psz][0] = 2;
	dp_cnt[psz][0] = 1;

	for (int i = psz; i > 0; i--)
	{
		for (int s = 0; s < S; s++)
		{
			add_to(dp_sum[i - 1][s], dp_sum[i][s]);
			add_to(dp_cnt[i - 1][s], dp_cnt[i][s]);

			add_to(dp_sum[i - 1][s + primes[i - 1]],
				add(dp_sum[i][s], mul(dp_cnt[i][s], primes_len[i - 1] + 2)));
			add_to(dp_cnt[i - 1][s + primes[i - 1]], dp_cnt[i][s]);
		}
	}

	scanf("%lld%lld", &a, &b);
	a++; b++;

	int s = 1;
	ll pass = 0;
	while (add(pass, dp_sum[0][s]) <= a)
	{
		add_to(pass, dp_sum[0][s]);
		s++;
	}

	while (pass <= b)
	{
		pass = gen(pass, s, 0, 0);
		s++;
	}

	answer = answer.substr(a - start_idx, b - a + 1);
	printf("%s\n", answer.c_str());
}

void main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("list.in", "r", stdin);
	freopen("list.out", "w", stdout);
#endif

	solve();

	eprintf("\n\ntime: %.3lf\n", (double)clock() / CLOCKS_PER_SEC);
}