#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <string>
#include <vector>
using namespace std;

bool isCap(char c)
{
	return c >= 'A' && c <= 'Z';
}

bool isCapWord(string &s)
{
	if (!isalpha(s[0])) return false;
	if (!isCap(s[0])) return false;
	if (s.size() < 2) return false;
	for (int i = 1; i < s.size(); ++i)
		if (isCap(s[i])) return false;
	return true;
}

void printAbbr(vector<string> &caps)
{
	for (auto t : caps)
		cout << t[0];
	cout << " (";
	for (int i = 0; i < (int)caps.size() - 1; i++)
		cout << caps[i] << ' ';
	cout << caps.back() << ')';
}

void solve()
{
	string s;
	while (getline(cin, s))
	{
		vector<string> parts;
		int pos = 0;
		while (pos < s.size())
		{
			string part;
			if (isalpha(s[pos]))
				while (pos < s.size() && isalpha(s[pos]))
					part += s[pos++];
			else
				while (pos < s.size() && !isalpha(s[pos]))
					part += s[pos++];
			parts.push_back(part);
		}
		for (int i = 0; i < parts.size(); ++i)
		{
			if (isCapWord(parts[i]))
			{
				vector<string> caps;
				caps.push_back(parts[i]);
				while (i + 2 < parts.size() && parts[i + 1] == " " && isCapWord(parts[i + 2]))
				{
					caps.push_back(parts[i + 2]);
					i += 2;
				}
				if (caps.size() == 1)
					cout << caps[0];
				else
				{
					for (auto t : caps)
						cout << t[0];
					cout << " (" << caps[0];
					for (int j = 1; j < caps.size(); ++j)
						cout << ' ' << caps[j];
					cout << ")";
				}
			}
			else cout << parts[i];
		}
		cout << endl;
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
#endif
	solve();
	return 0;
}