#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <string>
#include <set>
#include <vector>
using namespace std;

typedef long double ld;
typedef long long ll;

const ld EPS = 1e-12;

void solve()
{
	int n, w;
	scanf("%d %d", &n, &w);
	int h, m;
	scanf("%d %d", &h, &m);
	vector<ll> weight(h + 2);
	vector<ld> xc(h + 2, 1ll * w*n / 2.0);
	vector<ld> yc(h + 2, 1ll * w*n / 2.0);
	ll wblock = 1;
	ll wlevel = n*wblock;
	for (int i = h; i > 0; --i)
		weight[i] = weight[i + 1] + wlevel;
	vector<set<int> > seta(h + 2);
	vector<ld> minX(h + 2, 0), maxX(h + 2, 1ll * w*n), minY(h + 2, 0), maxY(h + 2, 1ll * w*n);
	for (int step = 0; step<m; ++step)
	{
		int l, k;
		scanf("%d %d", &l, &k);
		seta[l].insert(k);
		int left = 1;
		auto iter = seta[l].begin();
		while (iter != seta[l].end() && left == *iter)
			left++, iter++;
		auto iter2 = seta[l].rbegin();
		int right = n;
		while (iter2 != seta[l].rend() && right == *iter2)
			right--, iter2++;
		if (left > right && weight[l + 1]>0)
		{
			printf("yes\n%d\n", step + 1);
			return;
		}
		if (l % 2 == 1)
		{
			minX[l] = 1ll * (left - 1)*w;
			maxX[l] = 1ll * right * w;
		}
		else
		{
			minY[l] = 1ll * (left - 1)*w;
			maxY[l] = 1ll * right * w;
		}

		ld x = (l % 2 == 1) ? (1ll * (k - 1)*w + w / 2.0) : (1ll * w*n / 2.0);
		ld y = (l % 2 == 1) ? (1ll * w*n / 2.0) : (1ll * (k - 1)*w + w / 2.0);
		for (int i = l; i > 0; i--)
		{
			if (weight[i + 1]>0 && (xc[i + 1]<minX[i] + EPS || xc[i + 1]>maxX[i] - EPS || yc[i + 1]<minY[i] + EPS || yc[i + 1]>maxY[i] - EPS))
			{
				printf("yes\n%d\n", step + 1);
				return;
			}

			xc[i] = (xc[i] * weight[i] - x*wblock) / (weight[i] - wblock);
			yc[i] = (yc[i] * weight[i] - y*wblock) / (weight[i] - wblock);
			weight[i] -= wblock;
		}
	}
	printf("no");
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
#endif
	solve();
	return 0;
}