#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <string>
#include <set>
#include <map>
using namespace std;

#define mp make_pair

const long long INF = 1000ll * 1000 * 1000 * 1000 * 1000 * 100;

const long long MAXN = 100100;

long long time_deltas[MAXN];
long long size[MAXN];

vector<pair<long long, long long> > e;
map<long long, long long> a;
vector<pair<long long, long long>> query;
vector<long long> result;

inline long long sum(const long long &a, const long long &b) {
	if (a == INF || b == INF) {
		return INF;
	}
	return a + b;
}

int main() {
	freopen("expect.in", "r", stdin);
	freopen("expect.out", "w", stdout);

	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	long long n, q;
	cin >> n >> q;

	e.reserve(n);
	for (long long i = 0; i < n; i++) {
		string cmd;
		long long t, delta;
		cin >> cmd >> t >> delta;
		if (cmd == "+") {
			delta *= -1;
		}
		e.push_back(make_pair(t, delta));
	}
	sort(e.begin(), e.end());

	for (long long i = 0; i < n; i++) {
		if (i < n - 1)
			time_deltas[i] = e[i + 1].first - e[i].first;
		else
			time_deltas[i] = INF;
    }

    long long cur_count = 0;
	for (long long i = 0; i < e.size(); i++) {
		cur_count += e[i].second;
		a[cur_count] = sum(a[cur_count], time_deltas[i]);
    }

	long long c = 0;
	for (map<long long, long long>::reverse_iterator it = a.rbegin(); it != a.rend(); it++) {
		c = sum(c, it->second);
		it->second = c;
	}

	query.resize(q);
	result.resize(q);
	for (long long i = 0; i < q; i++) {
		cin >> query[i].first;
		query[i].second = i;
    }
	sort(query.rbegin(), query.rend());

	long long ans = 0;
	map<long long, long long>::reverse_iterator it = a.rbegin();
	for (long long i = 0; i < query.size(); i++) {
		long long need = query[i].first;
		while (it != a.rend() && it->first > need) {
			ans = sum(ans, it->second);
			it++;
		}
		result[query[i].second] = ans;
    }
	for (long long i = 0; i < result.size(); i++) {
		if (result[i] == INF) {
			cout << "INFINITY\n";
		}
		else {
			cout << result[i] << '\n';
		}
	}
}