#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <string>
#include <set>
#include <map>
using namespace std;

#define mp make_pair

const long long MAXN = 100100;
const long long INF = 1000ll * 1000 * 1000 * 1000 * 1000;

vector<pair<int, int>> query;
vector<long long> result;
vector<int> t;
vector<int> size;
map<int, long long> a;

inline long long sum(const long long &a, const long long &b) {
	if (a == INF || b == INF) {
		return INF;
	}
	return a + b;
}

int main() {
	freopen("expect.in", "r", stdin);
	freopen("expect.out", "w", stdout);

	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	long long n, q;
	cin >> n >> q;

	t.resize(n);
	size.resize(n);
	int cur_size = 0;
	for (int i = 0; i < n; i++) {
		string cmd;
		int time, delta;
		cin >> cmd >> time >> delta;
		if (cmd == "+") {
			delta *= -1;
		}
		cur_size += delta;
		size[i] = cur_size;
		t[i] = time;
    }
	int last_size = size.back();
	for (int i = 0; i < n; i++) {
		long long time_delta;
		if (i == n - 1) {
			time_delta = INF;
		}
		else {
			time_delta = t[i + 1] - t[i];
		}
		a[size[i]] = sum(a[size[i]], time_delta);
    }

	query.resize(q);
	result.resize(q);
	for (int i = 0; i < q; i++) {
		cin >> query[i].first;
		query[i].second = i;
    }

	sort(query.rbegin(), query.rend());
	map<int, long long>::reverse_iterator it = a.rbegin();
	long long cur_sum_k = 0;
	long long cur_sum = 0;
	for (int i = 0; i < q; i++) {
		int need = query[i].first;
        
		if (need < last_size) {
			result[query[i].second] = INF;
			continue;
		}

		while (it != a.rend() && it->first > need) {
			cur_sum += it->second;
			cur_sum_k += it->first * it->second;
			it++;
		}

		result[query[i].second] = cur_sum_k - need * cur_sum;
	}

	for (int i = 0; i < result.size(); i++) {
		if (result[i] == INF) {
			cout << "INFINITY\n";
		}
		else {
			cout << result[i] << endl;
		}
	}
}