#include <vector>
#include <algorithm>
#include <string>
#include <iostream>
#include <set>

using namespace std;

const int MAXN = 10010;
const int MAXH = 5010;

long long n, w;
long long h, m;

long long sum[MAXH];
long long cnt[MAXH];
int removed[MAXH][MAXN];
int first_left[MAXH];
int first_right[MAXH];

bool have_failure(bool deb = true) {
	long long sum_delta[2] = { 0, 0 };
	long long sum_count = 0;
	for (int i = h - 1; i >= 0; i--) {
		if (i != h - 1) {
			if (sum_delta[i % 2] <= first_left[i] * w * sum_count) {
				return true;
			}
			if (sum_delta[i % 2] >= (first_right[i] * w + w) * sum_count) {
				return true;
			}
		}
		sum_count += cnt[i];
		sum_delta[1 - (i % 2)] += cnt[i] * n * w / 2;
		sum_delta[i % 2] += sum[i];
    }
	return false;
}

int main()
{
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);

	cin >> n >> w;
	cin >> h >> m;
	w *= 2;

	memset(removed, 0, sizeof(removed));
	for (int i = 0; i < h; i++) {
		cnt[i] = n;
		sum[i] = n * w / 2 * n;
		first_left[i] = 0;
		first_right[i] = n - 1;
    }

	for (int i = 0; i < m; i++) {
		long long l, k;
		cin >> l >> k;
		l--, k--;

		sum[l] -= k * w + w / 2;
		cnt[l] -= 1;
		removed[l][k] = true;
		for (; first_right[l] >= 0 && removed[l][first_right[l]]; first_right[l]--) {};
		for (; first_left[l] < n && removed[l][first_left[l]]; first_left[l]++) {};

		if (l == h - 1 && (first_right[l] == -1 || first_left[l] == n)) {
			h--;
			continue;
		}

		if ((first_right[l] == -1 || first_left[l] == n) || have_failure()) {
			cout << "yes\n" << i + 1;
			return 0;
		}
    }
	have_failure(true);
	cout << "no";
	return 0;
}
