import java.io.*;
import java.util.StringTokenizer;

/**
 * Created by neerc on 04.12.2016.
 */
public class TaskH {
    PrintWriter out;
    BufferedReader in;
    StringTokenizer st;

    public static void main(String[] args) throws IOException {
        TaskH solve = new TaskH();
        solve.open();
        solve.solve();
        solve.close();
    }

    final int MIN = -32768;
    final int PLUS = 32768;
    final int MAX = 32767;
    final int SIZE = 32768 * 2;
    final String smaller = "<=";
    final String greater = ">=";
    final String and = "&&";
    final String or = "||";
    boolean[] count = new boolean[SIZE];

    private void solve() throws IOException {
        while (hasMoreTokens()) {
            String tmp = nextToken(); // x;
            String sign = nextToken(); // sign;
            int val = nextInt(); // value;
            int left = MIN;
            int right = MAX;
            if (sign.equals(smaller)) {
                right = val;
            } else {
                left = val;
            }

            String delim = nextToken();
            if (delim == null || delim.equals(or)) {
                if (left > right) {
                    continue;
                }
                update(left, right);
                continue;
            } else {
                tmp = nextToken(); //x;
                sign = nextToken(); //sign;
                right = nextInt(); // value;
                if (left > right) {
                    tmp = nextToken();
                    continue;
                }
                update(left, right);
                tmp = nextToken();
            }

        }

        boolean haveZero = false;
        boolean haveOnes = false;
        for (boolean b : count) {
            if (!b) {
                haveZero = true;
            } else haveOnes = true;

        }
        if (!haveZero) {
            out.println(true);
            return;
        }

        if (!haveOnes) {
            out.println(false);
            return;
        }
        StringBuilder answer = new StringBuilder();
        int lineInd = 0;
        int curStart = -1, curFin = 0;
        for (int i = 0; i < SIZE; i++) {
            while (i < SIZE && !count[i]) i++;
            if (i == SIZE) break;
            curStart = i;
            while (i < SIZE && count[i]) i++;
            curFin = i;
            if (lineInd > 0) answer.append(" ||\n");
            if (curStart > 0) answer.append("x >= ").append(curStart - PLUS);
            if (curFin != SIZE) {
                curFin--;
                if (curStart > 0) answer.append(" && ");
                answer.append("x <= ").append(curFin - PLUS);
            }
            lineInd++;
        }
        answer.append("\n");
        out.println(answer);
    }

    private void update(int left, int right) {
        for (int i = left; i <= right; i++) {
            count[i + PLUS] = true;
        }
    }

    private void close() {
        out.flush();
    }

    private void open() throws IOException {
        in = new BufferedReader(new FileReader("hard.in"));
        out = new PrintWriter(new FileWriter("hard.out"));
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    private String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            String line = in.readLine();
            if (line == null) return null;
            st = new StringTokenizer(line);
        }
        return st.nextToken();
    }

    private boolean hasMoreTokens() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            String line = in.readLine();
            if (line == null) return false;
            st = new StringTokenizer(line);
        }
        return true;
    }
}
