import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

/**
 * Created by neerc on 04.12.2016.
 */
public class TaskJ {
    PrintWriter out;
    BufferedReader in;
    StringTokenizer st;

    public static void main(String[] args) throws IOException {
        TaskJ solve = new TaskJ();
        solve.open();
        solve.solve();
        solve.close();
    }


    class Level {
        boolean[] items;
        double x_top, y_top, x_bottom, y_bottom;
        boolean reversed;
        int start, finish;
        int m;

        public Level(int n, boolean reversed) {
            items = new boolean[n];
            Arrays.fill(items, true);
            this.reversed = reversed;
            start = 0;
            finish = n - 1;
            x_top = 0;
            x_bottom = n;
            for (int i = 0; i < n; i++) {
                x_top += (i + 1.0 / 2);
            }
            y_top = n;
            y_bottom = 2;
            m = n;
        }

        public void updateLevel(int pos) {
            if (start == pos) start++;
            if (finish == pos) finish--;
            x_bottom--;
            x_top -= (pos + 1.0 / 2);
            m--;
        }

        public double getX() {
            return x_top / x_bottom;
        }

        public double getY() {
            return y_top / y_bottom;
        }

    }

    private void solve() throws IOException {
        int n = nextInt(), w = nextInt();
        int h = nextInt(), m = nextInt();

        Level[] levels = new Level[h];
        boolean reversed = false;
        for (int i = 0; i < h; i++) {
            levels[i] = new Level(n, reversed);
            reversed = !reversed;
        }

        for (int i = 0; i < m; i++) {
            int level = nextInt() - 1;
            int pos = nextInt() - 1;
            levels[level].updateLevel(pos);

            double x_top = 0, y_top = 0;
            long x_bottom = 0, y_bottom = 0;
            boolean fall = false;
            for (int checkLevel = h - 1; checkLevel >= 1; checkLevel--) {
                Level addLevel = levels[checkLevel];
                Level prevLevel = levels[checkLevel - 1];
                if (addLevel.m == 0) continue;
                if (!addLevel.reversed) {
                    x_top += addLevel.m * addLevel.getX();
                    x_bottom += addLevel.m;
                    y_top += addLevel.m * addLevel.getY();
                    y_bottom += addLevel.m;
                } else {
                    y_top += addLevel.m * addLevel.getX();
                    y_bottom += addLevel.m;
                    x_top += addLevel.m * addLevel.getY();
                    x_bottom += addLevel.m;
                }

                double curX = x_top / x_bottom;
                double curY = y_top / y_bottom;

                if (!prevLevel.reversed) {
                    if (!(curX > prevLevel.start && curX < prevLevel.finish)) { // TODO: EPS
                        fall = true;
                        break;
                    }
                } else {
                    if (!(curY > prevLevel.start && curY < prevLevel.finish)) {// TODO: EPS
                        fall = true;
                        break;
                    }
                }
            }

            if (fall) {
                out.println("yes");
                out.println(i + 1);
                return;
            }

        }

        out.println("no");
    }


    private void close() {
        out.flush();
    }

    private void open() throws IOException {
        in = new BufferedReader(new FileReader("jenga.in"));
        out = new PrintWriter(new FileWriter("jenga.out"));
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    private String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            String line = in.readLine();
            if (line == null) return null;
            st = new StringTokenizer(line);
        }
        return st.nextToken();
    }

    private boolean hasMoreTokens() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            String line = in.readLine();
            if (line == null) return false;
            st = new StringTokenizer(line);
        }
        return true;
    }
}
