import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

/**
 * Created by neerc on 04.12.2016.
 */
public class A {

    BufferedReader in;
    PrintWriter out;
    StringTokenizer tok = new StringTokenizer("");

    void init() throws FileNotFoundException {
        String filename = "abbreviation";
        if (filename.isEmpty()) throw new RuntimeException();
        try {
            in = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");
        } catch (Exception e) {
            in = new BufferedReader(new FileReader(filename + ".in"));
            out = new PrintWriter(filename + ".out");
        }
    }

    String readLine() {
        try {
            return in.readLine();
        } catch (Exception e) {
            return null;
        }
    }

    String readString() {
        try {

            while (!tok.hasMoreTokens()) {
                tok = new StringTokenizer(readLine());
            }
            return tok.nextToken();
        } catch (Exception e) {
            return null;
        }
    }

    char[] readCharArray() {
        String nextLine = readLine();
        return (nextLine == null ? null : nextLine.toCharArray());
    }

    int readInt() {
        return Integer.parseInt(readString());
    }

    void run() {
        try {
            init();
            solve();
            in.close();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }

    public static void main(String[] args) {
        new A().run();
    }

    class Word {
        String before;
        String word;
        boolean isCapital;

        Word(String before, String word) {
            this.before = before;
            this.word = word;
            this.isCapital = isCapitalWord(word);
        }
    }

    boolean isCapitalWord(String word) {
        if (word.isEmpty() || word.length() == 1) return false;
        if (!Character.isUpperCase(word.charAt(0))) return false;

        for (int i = 1; i < word.length(); ++i) {
            if (!Character.isLowerCase(word.charAt(i))) return false;
        }

        return true;
    }

    final String GOOD_BEFORES = " ";

    void solve() {
        while (true) {
            char[] s = readCharArray();
            if (s == null) break;

            String before = "";
            String curWord = "";

            List<Word> words = new ArrayList<>();

            for (char ch : s) {
                if (Character.isLetter(ch)) {
                    curWord += ch;
                } else {
                    words.add(new Word(before, curWord));

                    before = "" + ch;
                    curWord = "";
                }
            }

            words.add(new Word(before, curWord));
            words.add(new Word("", ""));

            StringBuilder answer = new StringBuilder();

            List<Word> capitalWords = new ArrayList<>();
            for (Word word : words) {
                if (word.isCapital) {
                    if (capitalWords.size() == 0) {
                        capitalWords.add(word);
                    } else {
                        boolean goodBefore = word.before.isEmpty() || GOOD_BEFORES.contains(word.before);
                        if (goodBefore) capitalWords.add(word);
                        else {
                            printAbr(answer, capitalWords);
                            capitalWords.clear();

                            capitalWords.add(word);
                        }
                    }
                } else {
                    printAbr(answer, capitalWords);
                    capitalWords.clear();

                    addWord(answer, word);
                }
            }

            out.println(answer.toString());
        }
    }

    void printAbr(StringBuilder answer, List<Word> capitalWords) {
        if (capitalWords.size() > 1) {
            answer.append(capitalWords.get(0).before);
            capitalWords.get(0).before = "";

            for (Word capitalWord : capitalWords) {
                answer.append(capitalWord.word.charAt(0));
            }

            answer.append(" ");

            answer.append("(");
            for (Word capitalWord : capitalWords) {
                addWord(answer, capitalWord);
            }
            answer.append(")");
        } else {
            for (Word capitalWord : capitalWords) {
                addWord(answer, capitalWord);
            }
        }
    }

    void addWord(StringBuilder answer, Word word) {
        answer.append(word.before);
        answer.append(word.word);
    }
}
