import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.TreeMap;

/**
 * Created by neerc on 04.12.2016.
 */
public class E {

    BufferedReader in;
    PrintWriter out;
    StringTokenizer tok = new StringTokenizer("");

    void init() throws FileNotFoundException {
        String filename = "expect";
        if (filename.isEmpty()) throw new RuntimeException();
        try {
            in = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");
        } catch (Exception e) {
            in = new BufferedReader(new FileReader(filename + ".in"));
            out = new PrintWriter(filename + ".out");
        }
    }

    String readString() {
        try {

            while (!tok.hasMoreTokens()) {
                tok = new StringTokenizer(in.readLine());
            }
            return tok.nextToken();
        } catch (Exception e) {
            return null;
        }
    }

    int readInt() {
        return Integer.parseInt(readString());
    }

    void run() {
        try {
            init();
            solve();
            in.close();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }

    public static void main(String[] args) {
        new E().run();
    }


    void solve() {
        int n = readInt();
        int q = readInt();
        long last = 0;
        int lt = 0;
        TreeMap<Long, Long> map = new TreeMap<>();
        for (int i = 0; i < n; i++) {
            char type = readString().charAt(0);
            int t = readInt();
            int k = readInt();
            map.put(last, map.getOrDefault(last, 0L) + t - lt);
            if (type == '+') {
                last += k;
            } else {
                last -= k;
            }
            lt = t;
        }
        TreeMap<Long, Long> answer = new TreeMap<>();
        Map.Entry<Long, Long> prev = null;
        TreeMap<Long, Long> suffix = new TreeMap<>();
        long pans = 0;
        long length = 0;
        for (Map.Entry<Long, Long> e : map.entrySet()) {
            long ans = pans;
            if (prev != null) {
                ans += length * Math.abs(prev.getKey() - e.getKey());
            }
            answer.put(e.getKey(), ans);
            pans = ans;
            prev = e;
            length += e.getValue();
            suffix.put(e.getKey(), length);
        }
        while (q-- > 0) {
            int x = readInt();
            if (-x > last) {
                out.println("INFINITY");
                continue;
            }
            Map.Entry<Long, Long> lastAnsEntry = answer.floorEntry(-1L * x);
            Map.Entry<Long, Long> lastSimpleEntry = suffix.floorEntry(-1L * x);
            if (lastAnsEntry == null) {
                out.println(0);
                continue;
            }
            long result = lastAnsEntry.getValue();
            result += lastSimpleEntry.getValue() * Math.abs(lastSimpleEntry.getKey() - (-x));
            out.println(result);
        }

    }
}
