import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

/**
 * Created by neerc on 04.12.2016.
 */
public class F {

    BufferedReader in;
    PrintWriter out;
    StringTokenizer tok = new StringTokenizer("");

    void init() throws FileNotFoundException {
        String filename = "foreign";
        if (filename.isEmpty()) throw new RuntimeException();
        try {
            in = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");
        } catch (Exception e) {
            in = new BufferedReader(new FileReader(filename + ".in"));
            out = new PrintWriter(filename + ".out");
        }
    }

    String readString() {
        try {

            while (!tok.hasMoreTokens()) {
                tok = new StringTokenizer(in.readLine());
            }
            return tok.nextToken();
        } catch (Exception e) {
            return null;
        }
    }

    int readInt() {
        return Integer.parseInt(readString());
    }

    void run() {
        try {
            init();
            solve();
            in.close();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }

    public static void main(String[] args) {
        new F().run();
    }

    void solve() {
        char[] a = readString().toCharArray();
        double[] answer = new double[a.length];
        double[] suffixAns = new double[a.length];
        long cCnt = 0;
        long wCnt = 0;
        for (int i = a.length - 1; i >= 0; i--) {
            long cntOpposite = a[i] == 'C' ? wCnt : cCnt;
            int len = a.length - i;

            double firstPart = 1d * cntOpposite;
            double secondPart = i == a.length - 1 ? 0 : suffixAns[i + 1];
            answer[i] = (firstPart + secondPart) / len;
            suffixAns[i] = answer[i];
            if (i + 1 < a.length) suffixAns[i] += suffixAns[i + 1];
            if (a[i] == 'C') {
                cCnt += len;
            } else {
                wCnt += len;
            }
        }
        out.println(answer[0]);
    }
}
