import java.io.*;
import java.util.ArrayList;
import java.util.StringTokenizer;

/**
 * Created by neerc on 04.12.2016.
 */
public class H {

    BufferedReader in;
    PrintWriter out;
    StringTokenizer tok = new StringTokenizer("");

    void init() throws FileNotFoundException {
        String filename = "hard";
        if (filename.isEmpty()) throw new RuntimeException();
        try {
            in = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");
        } catch (Exception e) {
            in = new BufferedReader(new FileReader(filename + ".in"));
            out = new PrintWriter(filename + ".out");
        }
    }

    String readString() {
        try {

            while (!tok.hasMoreTokens()) {
                tok = new StringTokenizer(in.readLine());
            }
            return tok.nextToken();
        } catch (Exception e) {
            return null;
        }
    }

    int readInt() {
        return Integer.parseInt(readString());
    }

    void run() {
        try {
            init();
            solve();
            in.close();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }

    public static void main(String[] args) {
        new H().run();
    }

    void solve() throws IOException {
        int SIZE = 32768 * 2;
        int PREF = 32768;
        boolean[] allowed = new boolean[SIZE];
        while (true) {
            String s = in.readLine();
            if (s == null) break;
            StringTokenizer tokenizer = new StringTokenizer(s);
            if (tokenizer.countTokens() <= 4) {
                tokenizer.nextToken();
                String exp = tokenizer.nextToken();
                int value = Integer.parseInt(tokenizer.nextToken());
                int l, r;
                if (">=".equals(exp)) {
                    l = value + PREF;
                    r = allowed.length - 1;
                } else {
                    l = 0;
                    r = value + PREF;
                }
                for (int x = l; x <= r; x++) {
                    allowed[x] = true;
                }
            } else {
                tokenizer.nextToken();
                tokenizer.nextToken();
                int l = Integer.parseInt(tokenizer.nextToken()) + PREF;
                tokenizer.nextToken();
                tokenizer.nextToken();
                tokenizer.nextToken();
                int r = Integer.parseInt(tokenizer.nextToken()) + PREF;
                for (int x = l; x <= r; x++) {
                    allowed[x] = true;
                }
            }
        }

        boolean allTrue = true;
        boolean allFalse = true;
        for (boolean x : allowed) {
            if (!x) allTrue = false;
            if (x) allFalse = false;
        }

        if (allTrue) {
            out.println("true");
            return;
        }
        if (allFalse) {
            out.println("false");
        }

        ArrayList<String> list = new ArrayList<>();

        for (int i = 0; i < allowed.length; i++) {
            if (allowed[i]) {
                int was = i;
                while (i < allowed.length && allowed[i]) i++;
                list.add(getExp(was - PREF, i - PREF - 1));
                i--;
            }
        }
        for (int i = 0; i < list.size(); i++) {
            out.print(list.get(i));
            if (i != list.size() - 1) out.print(" ||");
            out.println();
        }
    }

    String getExp(int l, int r) {
        if (l == -32768) return "x <= " + r;
        if (r == 32767) return "x >= " + l;
        return "x >= " + l + " && x <= " + r;
    }
}
