import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;

/**
 * Created by neerc on 04.12.2016.
 */
public class J {

    BufferedReader in;
    PrintWriter out;
    StringTokenizer tok = new StringTokenizer("");

    void init() throws FileNotFoundException {
        String filename = "jenga";
        if (filename.isEmpty()) throw new RuntimeException();
        try {
            in = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");
        } catch (Exception e) {
            in = new BufferedReader(new FileReader(filename + ".in"));
            out = new PrintWriter(filename + ".out");
        }
    }

    String readString() {
        try {

            while (!tok.hasMoreTokens()) {
                tok = new StringTokenizer(in.readLine());
            }
            return tok.nextToken();
        } catch (Exception e) {
            return null;
        }
    }

    int readInt() {
        return Integer.parseInt(readString());
    }

    void run() {
        try {
            init();
            solve();
            in.close();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }

    public static void main(String[] args) {
        new J().run();
    }

    void solve() {
        int n = readInt();
        long w = readInt() * 2; // TODO is * 2 correct???

        int h = readInt();
        int m = readInt();

        int[] sizes = new int[h];
        Arrays.fill(sizes, n);

        long[] xSums = new long[h];
        long[] ySums = new long[h];

        Arrays.fill(xSums, w * n * n / 2);
        Arrays.fill(ySums, w * n * n / 2);

        TreeMap<Long, Long>[] xs = new TreeMap[h];
        TreeMap<Long, Long>[] ys = new TreeMap[h];

        for (int i = 0; i < h; ++i) {
            xs[i] = new TreeMap<>();
            ys[i] = new TreeMap<>();

            xs[i].put(0L, n * w);
            ys[i].put(0L, n * w);
        }

        for (int it = 0; it < m; ++it) {
            int layer = readInt() - 1;
            int index = readInt() - 1;

            sizes[layer]--;

            if (layer % 2 == 0) {
                xSums[layer] -= (w * index + w / 2);
                ySums[layer] -= w * n / 2;
                extract(xs[layer], index, w);
            } else {
                ySums[layer] -= (w * index + w / 2);
                xSums[layer] -= w * n / 2;
                extract(ys[layer], index, w);
            }

            long totalSize = 0;
            long totalXSum = 0, totalYSum = 0;

            for (int i = h - 1; i > 0; --i) {
                totalSize += sizes[i];

                totalXSum += xSums[i];
                totalYSum += ySums[i];

                if (totalSize == 0) {
                    continue;
                }

                int prev = i - 1;

                if (sizes[prev] == 0) {
                    out.println("yes");
                    out.println(it + 1);
                    return;
                }

                long minX = xs[prev].firstKey();
                long maxX = xs[prev].lastEntry().getValue();

                long minY = ys[prev].firstKey();
                long maxY = ys[prev].lastEntry().getValue();

                if (!contains(minX, maxX, totalXSum, totalSize)
                        ||
                    !contains(minY, maxY, totalYSum, totalSize)) {
                    out.println("yes");
                    out.println(it + 1);
                    return;
                }
            }
        }

        out.println("no");
    }

    void extract(TreeMap<Long, Long> segments, int index, long w) {
        long curStart = w * index, curEnd = curStart + w;

        Long start = segments.floorKey(curStart);
        Long end = segments.remove(start);

        if (start < curStart) {
            segments.put(start, curStart);
        }

        if (curEnd < end) {
            segments.put(curEnd, end);
        }
    }

    boolean contains(long floor, long ceil, long numerator, long denominator) {
        return (floor * denominator < numerator && numerator < ceil * denominator);
    }
}
