#include <stdio.h>
#include <iostream>
#include <string>
#include <sstream>
#include <vector>
#include <map>
#include <iomanip>
#include <set>

using namespace std;

int n, w;
int h, m;

long long sx[5007];
long long sy[5007];
long long cnt[5007];

set<long long> XY[5007];

void init(int h) {
	long long x = 0 + n * (n - 1) + n;
	long long y = x;

	sx[h] = x;
	sy[h] = y;
	cnt[h] = n;

	for (int i = 1; i <= n; i++)
		XY[h].insert(i);
}

pair<long long, long long> getmin(int h) {
	long long x = *XY[h].begin() - 1;
	long long y = 0;

	if (!(h & 1)) swap(x, y);

	return make_pair(x, y);
}

pair<long long, long long> getmax(int h) {
	long long x = *XY[h].rbegin();
	long long y = n;

	if (!(h & 1)) swap(x, y);

	return make_pair(x, y);
}

void remove(int h, int i) {
	long long x = (i - 1) + (i);
	long long y = 0 + n;

	if (!(h & 1)) swap(x, y);

	sx[h] -= x;
	sy[h] -= y;
	cnt[h]--;

	XY[h].erase(i);
}

bool check(int h, long long x, long long y, long long c) {
	if (c == 0) return true;
	if (cnt[h] == 0) return false;

	pair<int, int> minxy = getmin(h);
	pair<int, int> maxxy = getmax(h);

	long long x1 = minxy.first * c * 2;
	long long y1 = minxy.second * c * 2;

	long long x2 = maxxy.first * c * 2;
	long long y2 = maxxy.second * c * 2;

	return
		x1 < x && x < x2 &&
		y1 < y && y < y2;
}

bool check() {
	long long x = 0;
	long long y = 0;
	long long c = 0;

	for (int i = h; i > 1; i--) {
		x += sx[i];
		y += sy[i];
		c += cnt[i];

		if (!check(i - 1, x, y, c))
			return false;
	}

	return true;
}

int main() {
	#ifdef RSATU2
	freopen("in.txt", "rt", stdin);
	freopen("out.txt", "wt", stdout);
	#else
	#define FILENAME "jenga"
	freopen(FILENAME".in", "r", stdin);
	freopen(FILENAME".out", "w", stdout);
	#endif

	cin >> n >> w;
	cin >> h >> m;

	for (int i = 1; i <= h; i++)
		init(i);

	for (int i = 1; i <= m; i++) {
		int a, b; cin >> a >> b;
		
		remove(a, b);

		if (!check()) {
			cout << "yes" << endl;
			cout << i;
			return 0;
		}
	}

	cout << "no";

	return 0;
}