//#pragma comment(linker, "/STACK:10000000")
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <string>
#include <stack>
#include <deque>
#include <map>
#include <set>
#include <ctime>
#include <cmath>
#define mp(a, b) make_pair(a, b)
typedef long long ll;

using namespace std;
const int MAXN = 10000 + 10;
const double EPS = 1e-9;

struct Centre
{
	double x, y;
	ll m;
	Centre() : x(0), y(0), m(0) {}
	Centre(double _x, double _y, ll _m) : x(_x), y(_y), m(_m) {}

};

Centre centre[MAXN];
int n, w, h, m;
set <int> deleted[MAXN];
int best_left[MAXN];
int best_right[MAXN];


Centre my_merge(Centre a, Centre b)
{
	double nm = a.m + b.m;
	double nx = (a.x * a.m + b.x * b.m) / nm;
	double ny = (a.y * a.m + b.y * b.m) / nm;
	return Centre(nx, ny, nm);
}

double get_coord(int num)
{
	return num - (double)n / 2. - 0.5;
}

bool fail(int lvl, Centre centre)
{
	if (deleted[lvl].size() == n)
		return true;

	while (deleted[lvl].find(best_left[lvl]) != deleted[lvl].end())
		best_left[lvl]++;
	
    while (deleted[lvl].find(best_right[lvl]) != deleted[lvl].end())
		best_right[lvl]--;

	if (lvl % 2 == 0)
	{
		return centre.x - EPS < get_coord(best_left[lvl]) - 0.5 || centre.x + EPS > get_coord(best_right[lvl]) + 0.5;
	}
	else
	{
		return centre.y - EPS < get_coord(best_left[lvl]) - 0.5 || centre.y + EPS > get_coord(best_right[lvl]) + 0.5;
	}
}

int main() {
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);

	cin >> n >> w >> h >> m;
	
	for (int lvl = 1; lvl <= h; lvl++)
		best_left[lvl] = 1, best_right[lvl] = n;

	for (int lvl = 1; lvl <= h; lvl++)
		centre[lvl].m = n, centre[lvl].x = 0, centre[lvl].y = 0;


	for (int i = 0; i < m; i++)
	{
		int lvl, num;
		cin >> lvl >> num;
		
		deleted[lvl].insert(num);
		Centre cur;
		if (lvl % 2 == 1)
		{
			cur = Centre(0., get_coord(num), -1.);
		}
		else
		{
			cur = Centre(get_coord(num), 0., -1.);
		}
		centre[lvl] = my_merge(centre[lvl], cur);
		
		cur = centre[h];
		cur.m = 0;

        for (int j = h; j != 0; j--)
		{
			if (fail(j, cur))
			{
				cout << "yes\n";
				cout << i + 1;
				return 0;
			}
			cur = my_merge(cur, centre[j]);
		}
		//cout << cur.x << ' ' << cur.y << ' ' << cur.m << '\n';  

	}

	cout << "no";

	return 0;
}