#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef long long i64;
#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define sz(x) ((int) (x).size())
 
#define NAME "binary"
 
const int maxn = 500500;
const int maxk = 9000100;
 
char tmp[maxn];
string s[maxn];
 
int to[2 * maxn][2];
int pr[2 * maxn];
vector<int> a[2 * maxn];
int nodes = 2;
int shift;
const int root = 1;
 
vector<int> g[maxk];
void addEdge(int u, int v) {
    assert(u < maxk && v < maxk);
    g[u].push_back(v);
    g[v ^ 1].push_back(u ^ 1);
}
 
void addS(int id) {
    forn (iter, 2) {
        int u = root;
        for (auto c: s[id]) {
            int g = c - '0';
            if (c == '?')
                g = iter;
            if (!to[u][g]) {
                to[u][g] = nodes++;
                pr[to[u][g]] = u;
            }
            u = to[u][g];
        }
        a[u].push_back(id * 2 + iter);
    }
}
 
void build(int n) {
    shift = nodes;
    int N = nodes;
    nodes += n;
    forn (i, N) {
        int s = sz(a[i]);
        int p0 = nodes++; //prefix 0
        for (int j = 1; j <= s; ++j) {
            int u = nodes++;
            addEdge(u * 2, (u - 1) * 2);
            addEdge(u * 2, (shift * 2 + a[i][j - 1]) ^ 1);
        }
        int s0 = nodes++; //suffix 0
        reverse(a[i].begin(), a[i].end());
        for (int j = 1; j <= s; ++j) {
            int u = nodes++;
            addEdge(u * 2, (u - 1) * 2);
            addEdge(u * 2, (shift * 2 + a[i][j - 1]) ^ 1);
        }
        reverse(a[i].begin(), a[i].end());
 
        addEdge(i * 2, (p0 + s) * 2);
        if (i != 0 && i != root) {
            addEdge(p0 * 2, pr[i] * 2);
            addEdge(s0 * 2, pr[i] * 2);
        }
        forn (j, s) {
            addEdge(shift * 2 + a[i][j], (p0 + j) * 2);
            addEdge(shift * 2 + a[i][j], (s0 + (s-j-1)) * 2);
        }
    }
}
 
bool used[maxk];
int col[maxk];
int res[maxk];
 
vector<int> ord;
vector<int> st;
bool inS[maxk];
int in[maxk];
int up[maxk];
int timer, COL;

void dfs(int u) {
    used[u] = true;
    up[u] = in[u] = timer++;

    st.push_back(u);
    inS[u] = true;

    for (int v: g[u]) {
        if (used[v]) {
            if (inS[v]) {
                up[u] = min(up[u], in[v]);
            }
        } else {
            dfs(v);
            up[u] = min(up[u], up[v]);
        }
    }
    ord.push_back(u);

    if (up[u] == in[u]) {
        while (!st.empty() && st.back() != u) {
            col[st.back()] = COL;
            st.pop_back();
        }
        assert(!st.empty());
        col[u] = COL;
        st.pop_back();
        inS[u] = false;
        ++COL;
    }
}

void markBad(int u) {
    used[u] = true;
    res[u / 2] = (u % 2);
    for (int v: g[u]) {
        if (!used[v])
            markBad(v);
    }
}
 
void check(int u, int bad) {
    assert(u != bad);
    used[u] = true;
    for (int v: g[u]) {
        if (!used[v])
            check(v, bad);
    }
}

bool twosat(int n) {
    forn (i, n) {
        for (int j: g[i])
            assert(j > 0 && j < n);
    }
 
    fill(used, used + n, false);
    forn (i, n)
        if (!used[i])
            dfs(i);
    fill(used, used + n, false);
    forn (i, n / 2)
        if (col[i * 2] == col[i * 2 + 1])
            return false;
    fill(used, used + n, false);
    fill(res, res + n, -1);

    for (int u: ord) {
        if (res[u / 2] == -1)
            markBad(u);
    }
#ifdef LOCAL
    /*
    forn (i, n / 2)
        assert(res[i] != -1);
    forn (i, n / 2) {
        //cerr << "r " << res[i] << '\n';
        fill(used, used + n, false);
        check(i * 2 + res[i], (i * 2 + res[i]) ^ 1);
    }
    */
#endif
    return true;
}
 
int main() {
#ifdef LOCAL
    assert(freopen("b.in", "r", stdin));
#else
    assert(freopen(NAME ".in", "r", stdin));
    assert(freopen(NAME ".out", "w", stdout));
#endif
    int n;
    cin >> n;
    forn (i, n) {
        scanf("%s", tmp);
        s[i] = tmp;
        addS(i);
    }
    build(n);
    if (!twosat(nodes * 2)) {
        cout << "NO\n";
        return 0;
    }
    cout << "YES\n";
    forn (i, n) {
        int ans = res[i + shift];
        assert(ans != -1);
        int pos = 0;
        while (pos < sz(s[i]) && s[i][pos] != '?')
            ++pos;
        if (pos < sz(s[i]))
            s[i][pos] = ans + '0';
        cout << s[i] << '\n';
    }
}
