#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef long long i64;
#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define sz(x) ((int) (x).size())
typedef vector<int> vi;
#define se second
#define fi first
#define pb push_back
typedef pair<int, int> pii;

#define NAME "cactus"

const int maxn = 100500;

int n, m;
vi e0[maxn];
vi e[maxn];
vi oth[maxn];
int h[maxn];
multiset<pii> es;
multiset<pii> gen;
const int ROOT = 0;

int comp[maxn];
int col[maxn];

vector<string> res;
char buf[100];
void join(int u, int v) {
    sprintf(buf, "j %d %d", u+1, v+1);
    res.pb(buf);
#ifdef LOCAL
    int cu = comp[u];
    int cv = comp[v];
    forn(i, n) if (comp[i] == cu) comp[i] = cv;
#endif
}

void recolor(int v, int c1, int c2) {
    sprintf(buf, "r %d %d %d", v+1, c1, c2);
    res.pb(buf);
#ifdef LOCAL
    forn(i, n) if (comp[i] == comp[v] && col[i] == c1) col[i] = c2;
#endif
}

void connect(int v, int c1, int c2) {
    sprintf(buf, "c %d %d %d", v+1, c1, c2);
    res.pb(buf);
    //cerr << buf << endl;
#ifdef LOCAL
    forn(i, n) if (comp[v] == comp[i]) {
        forn(j, n) if (comp[v] == comp[j] && i != j) {
            if (col[i] == c1 && col[j] == c2) {
                gen.insert({min(i, j), max(i, j)});
                //cerr << "add edge " << i+1 << " " << j+1 << endl;
            }
        }
    }
#endif
}

void scan() {
    int np;
    scanf("%d%d", &n, &np);
    forn(III, np) {
        int k;
        scanf("%d", &k);
        int x = -1;
        forn(i, k) {
            int y;
            scanf("%d", &y);
            --y;
            if (x != -1) {
                e0[x].pb(y);
                e0[y].pb(x);
#ifdef LOCAL
                es.insert({min(x, y), max(x, y)});
#endif
            }
            x = y;
        }
    }
}

int b[maxn];
void dfs0(int v, int anc) {
    b[v] = 1;
    for (int to: e0[v]) {
        if (b[to]) {
            if (to == anc) continue;
            if (h[to] < h[v]) {
                oth[v].pb(to);
                ////cerr << "edge up " << v << " " << to << endl;
            }
        } else {
            e[v].pb(to);
            //cerr << "edge " << v << " " << to << endl;
            h[to] = h[v] + 1;
            dfs0(to, v);
        }
    }
}

// return value: -1 or hup
int dfs2(int v) {
    recolor(v, 1, 4);

    int hup = -1;

    for (int to: e[v]) {
        int up = dfs2(to);

        // add edge (v, to)
        join(v, to);
        connect(v, 2, 4);

        if (up == h[v]) {
            connect(v, 3, 4);
            recolor(v, 3, 1);
            recolor(v, 2, 1);
        } else if (up != -1) {
            assert(up < h[v]);
            if (!oth[to].empty()) {
                //assert(up == oth[to][0]);
                recolor(v, 2, 3);
            } else {
                recolor(v, 2, 1);
            }
            assert(hup == -1);
            hup = up;
        } else {
            // recolor to 2->1
            recolor(v, 2, 1);
        }

    }

    if (!oth[v].empty()) {
        assert(hup == -1);
        hup = h[oth[v][0]];
    }

    recolor(v, 4, 2);

    //cerr << "v = " << v << ", hup = " << hup << endl;
    return hup;
}

void solve() {
    dfs0(ROOT%n, -1);

    forn(i, n) {
        assert(oth[i].size() <= 1u);
        if (!oth[i].empty()) {
            assert(h[i] > h[oth[i][0]]);
        }
    }

    dfs2(ROOT%n);

    cout << res.size() << "\n";
    for (const auto& s: res) {
        cout << s << "\n";
    }

    /*
    cout << "orig edges\n";
    for (auto x: es) cout << x.fi+1 << " " << x.se+1 << endl;
    cout << "gened edges\n";
    for (auto x: gen) cout << x.fi+1 << " " << x.se+1 << endl;

    if (es != gen) {
        cout << "WA" << endl;
    }
    */
}

int main() {
#ifdef LOCAL
    assert(freopen("c.in", "r", stdin));
    //assert(freopen("c.out", "w", stdout));
#else
    assert(freopen(NAME ".in", "r", stdin));
    assert(freopen(NAME ".out", "w", stdout));
#endif

    scan();
    forn(i, n) {
        comp[i] = i;
        col[i] = 1;
    }
    solve();

}
