#include <string>
#include <iostream>
#include <vector>
#include <fstream>

using namespace std;

ifstream fin("abbreviation.in");
ofstream fout("abbreviation.out");

bool isCapitalized(string & s, int a, int b) {
    if (b - a < 2) {
        return false;
    }

    if (islower(s[a])) {
        return false;
    }

    for (int i = a + 1; i < b; ++i) {
        if (isupper(s[i])) {
            return false;
        }
    }

    return true;
}

void printSubstr(string & s, int a, int b) {
    for (int i = a; i < b; ++i) {
        fout << s[i];
    }
}

// is there single space and next word exists?
bool goToNextWord(string & s, int & k) {
    int countNonAlpha = 0;
    while (k < s.size() && !isalpha(s[k])) {
        ++k;
        ++countNonAlpha;
    }
    return countNonAlpha == 1 && k != s.size();
}

struct word {
    int a,b,c;

    word(int a, int b, int c): a(a), b(b), c(c) {}
};

void printAbbrev(string & s, vector<word> & abbrev) {
    if (abbrev.size() == 0) {

    } else if (abbrev.size() == 1) {
        printSubstr(s, abbrev[0].a, abbrev[0].c);
    } else {
        for (int i = 0; i < abbrev.size(); ++i) {
            fout << s[abbrev[i].a];
        }
        fout << " (";
        for (int i = 0; i < abbrev.size(); ++i) {
            auto w = abbrev[i];
            printSubstr(s, w.a, w.b);
            if (i == abbrev.size()-1) {
                fout << ")";
            } else {
                fout << " ";
            }
        }

        auto w = abbrev[abbrev.size()-1];
        printSubstr(s, w.b, w.c);
    }
}

bool readNextWord(string & s, int & a, int & b, int & c) {
    a = c;
    if (a >= s.size()) return false;
    b = a;
    while (b < s.size() && isalpha(s[b])) {
        ++b;
    }
    c = b;
    while (c < s.size() && !isalpha(s[c])) {
        ++c;
    }
    return true;
}

int main() {

    string s;
    while (getline(fin, s)) {
        int a = -1, b = -1 , c = 0;
        bool canAddNextWord = true;

        vector<word> abbrev;

        while (readNextWord(s, a,b,c)) {
            bool isCap = isCapitalized(s, a, b);
            if (isCap && canAddNextWord) {
                //fout << "adding ";
                //printSubstr(s, a, b);
                //fout << "!" << endl;

                abbrev.emplace_back(a,b,c);
                canAddNextWord = (c - b == 1 && s[b] == ' ');
                if (!canAddNextWord) {
                    printAbbrev(s, abbrev);
                    abbrev.clear();
                    canAddNextWord = true;
                }
            } else {
                //fout << "bump ";
                //printSubstr(s, a, b);
                //fout << "!" << endl;

                printAbbrev(s, abbrev);
                abbrev.clear();
                printSubstr(s, a, c);
                canAddNextWord = true;
            }
        }

        printAbbrev(s, abbrev);

        fout << endl;
    }
    return 0;
}
