#include <string>
#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>

using namespace std;

ifstream fin("foreign.in");
ofstream fout("foreign.out");

typedef long long ll;

long double solve(string & s) {
    int n = s.size();
    vector<long double> f(n+1);
    f[n] = 0;

    vector<ll> countWBeforeNotIncl(n+1);
    vector<ll> countWBeforeNotInclSum(n+1);

    vector<ll> countCBeforeNotIncl(n+1);
    vector<ll> countCBeforeNotInclSum(n+1);

    countWBeforeNotIncl[0] = 0;
    for (int i = 1; i <= n; ++i) {
        countWBeforeNotIncl[i] = countWBeforeNotIncl[i-1] + (s[i-1] == 'W');
        countWBeforeNotInclSum[i] = countWBeforeNotInclSum[i-1] + countWBeforeNotIncl[i];
    }

    countCBeforeNotIncl[0] = 0;
    for (int i = 1; i <= n; ++i) {
        countCBeforeNotIncl[i] = countCBeforeNotIncl[i-1] + (s[i-1] == 'C');
        countCBeforeNotInclSum[i] = countCBeforeNotInclSum[i-1] + countCBeforeNotIncl[i];
    }

    vector<long double> fCum(n+1);

    for (int i = n-1; i >= 0; --i) {
        f[i] = 0;
        if (s[i] == 'C') {
            //for (int j = 1; j <= n-i; ++j) {
                //cout << "k = " << i << ", f[i] += " << count(s.begin(), s.begin() + j + 1, 'W') << endl;
                //f[i] += countWBeforeNotIncl[i+j] - countWBeforeNotIncl[i];
            //}
            f[i] += (countWBeforeNotInclSum[n] - countWBeforeNotInclSum[i]) - (n-i)*(countWBeforeNotIncl[i]);
            f[i] += fCum[i+1];
        } else {
            //for (int j = 1; j <= n-i; ++j) {
                //cout << "f[i] += " << count(s.begin(), s.begin() + j + 1, 'C') << endl;
                //f[i] += j - (countWBeforeNotIncl[i+j] - countWBeforeNotIncl[i]);
            //}
            f[i] += (countCBeforeNotInclSum[n] - countCBeforeNotInclSum[i]) - (n-i)*(countCBeforeNotIncl[i]);
            f[i] += fCum[i+1];
        }

        f[i] *= 1.0L / (n-i);
        fCum[i] = fCum[i+1] + f[i];
    }

    return f[0];
}

int main() {

    string s;
    getline(fin, s);
    //reverse(s.begin(), s.end());

    cout << solve(s) << endl;

    return 0;
}
